 /*+------------------------------------------------------------------*/
 /*                                                                   */
 /*  Microsoft Windows                                                */
 /*  Copyright (C) Microsoft Corporation, 1998-1999.                  */
 /*                                                                   */
 /*  File:       guiddef.cpy                                          */
 /*                                                                   */
 /*  Contents:   GUID definition                                      */
 /*                                                                   */
 /*-------------------------------------------------------------------*/

 %dcl #GUIDDEF_H_ char ext;
 %if #GUIDDEF_H_ = '' %then %do;
 %#GUIDDEF_H_ = 'Y';

 %dcl GUID_DEFINED char ext;
 %if GUID_DEFINED = '' %then %do;
 %GUID_DEFINED = 'Y';
 define structure
   1 GUID,
     2 Data1 type DWORD,
     2 Data2 type WORD,
     2 Data3 type WORD,
     2 Data4 (8) char;
 %end;

 /* we do not distinguish INITGUID case here */
 %DEFINE_GUID: proc (name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8)
               returns (char);
   dcl (name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8) char;
   /* When structure INITs are supported, replace with: */
   /* return ('dcl ' || name || ' type GUID static external init (' ||*/
   /*            l  || ',' || w1 || ',' || w2 || ', (' ||             */
   /*            b1 || ',' || b2 || ',' || b3 || ',' || b4 || ',' ||  */
   /*            b5 || ',' || b6 || ',' || b7 || ',' || b8 || '))'    */
   /* In the meantime we have to use: */
   return ('dcl 1 ' || name || ' static external, ' ||
                  '2 Data1 type DWORD init (' || l  || '), ' ||
                  '2 Data2 type  WORD init (' || w1 || '), ' ||
                  '2 Data3 type  WORD init (' || w2 || '), ' ||
                  '2 Data4 (8)   char init (' ||
            b1 || ',' || b2 || ',' || b3 || ',' || b4 || ',' ||
            b5 || ',' || b6 || ',' || b7 || ',' || b8 || ')');
 %end DEFINE_GUID;
 %dcl DEFINE_GUID entry;

 %DEFINE_OLEGUID: proc (name, l, w1, w2) returns (char);
   dcl (name, l, w1, w2) char;

   return (DEFINE_GUID (name, l, w1, w2,
                        '''C0''x', '''00''x', '''00''x', '''00''x',
                        '''00''x', '''00''x', '''00''x', '''46''x'));
 %end DEFINE_OLEGUID;
 %dcl DEFINE_OLEGUID entry;


 %dcl #_LPGUID_DEFINED__ char ext;
 %if #_LPGUID_DEFINED__ = '' %then %do;
 %#_LPGUID_DEFINED__ = 'Y';
 define alias LPGUID  handle GUID;
 %end;

 %dcl #_LPCGUID_DEFINED__ char ext;
 %if #_LPCGUID_DEFINED__ = '' %then %do;
 %#_LPCGUID_DEFINED__ = 'Y';
 define alias LPCGUID handle GUID;
 %end;

 %dcl #_IID_DEFINED__ char ext;
 %if #_IID_DEFINED__ = '' %then %do;
 %#_IID_DEFINED__ = 'Y';

 define alias   IID type   GUID;
 define alias LPIID handle IID;
 %dcl IID_NULL char ext; %IID_NULL='GUID_NULL';     /* in cguid.cpy */

 IsEqualIID: proc (riid1, riid2)
             returns (bit (1) byvalue)
             options (inline reorder) internal;
   dcl (riid1, riid2) type IID;
   return (IsEqualGUID (riid1, riid2));
 end IsEqualIID;

 define alias   CLSID type   GUID;
 define alias LPCLSID handle CLSID;
 %dcl CLSID_NULL char ext; %CLSID_NULL='GUID_NULL'; /* in cguid.cpy */

 IsEqualCLSID: proc (rclsid1, rclsid2)
               returns (bit (1) byvalue)
               options (inline reorder) internal;
   dcl (rclsid1, rclsid2) type CLSID;
   return (IsEqualGUID (rclsid1, rclsid2));
 end IsEqualCLSID;

 define alias   FMTID type   GUID;
 define alias LPFMTID handle FMTID;
 %dcl FMTID_NULL char ext; %FMTID_NULL='GUID_NULL'; /* in cguid.cpy */

 IsEqualFMTID: proc (rfmtid1, rfmtid2)
               returns (bit (1) byvalue)
               options (inline reorder) internal;
   dcl (rfmtid1, rfmtid2) type FMTID;
   return (IsEqualGUID (rfmtid1, rfmtid2));
 end IsEqualFMTID;


 %dcl #REFGUID_DEFINED char ext;
 %if #REFGUID_DEFINED = '' %then %do;
 %#REFGUID_DEFINED = 'Y';
 %dcl REFGUID char ext;
 %REFGUID = 'GUID byaddr nonasgn';
 %end;

 %dcl #REFIID_DEFINED char ext;
 %if #REFIID_DEFINED = '' %then %do;
 %#REFIID_DEFINED = 'Y';
 %dcl REFIID char ext;
 %REFIID='IID byaddr nonasgn';
 %end;

 %dcl #REFCLSID_DEFINED char ext;
 %if #REFCLSID_DEFINED = '' %then %do;
 %#REFCLSID_DEFINED = 'Y';
 %dcl REFCLSID char ext;
 %REFCLSID='CLSID byaddr nonasgn';
 %end;

 %dcl #REFFMTID_DEFINED char ext;
 %if #REFFMTID_DEFINED = '' %then %do;
 %#REFFMTID_DEFINED = 'Y';
 %dcl REFFMTID char ext;
 %REFFMTID='FMTID byaddr nonasgn';
 %end;

 %end; /* !__IID_DEFINED__ */

 %dcl #SYS_GUID_OPERATORS_ char ext;
 %if #SYS_GUID_OPERATORS_ = '' %then %do;
 %#SYS_GUID_OPERATORS_ = 'Y';

 /* following used for C mapping, but pointless in PL/I */
 InlineIsEqualGUID: proc (rguid1, rguid2)
                    returns (bit (1) byvalue)
                    options (inline reorder) internal;
   dcl (rguid1, rguid2) type REFGUID;
   dcl all builtin;
   return (rguid1.data1 = rguid2.data1 &
           rguid1.data2 = rguid2.data2 &
           rguid1.data3 = rguid2.data3 &
           all (rguid1.data4 = rguid2.data4));
 end InlineIsEqualGUID;

 IsEqualGUID: proc (rguid1, rguid2)
              returns (bit (1) byvalue)
              options (inline reorder) internal;
   dcl (rguid1, rguid2) type REFGUID;
   dcl compare builtin;
   return (compare (addr (rguid1), addr (rguid2), size(: GUID :)) = 0);
 end IsEqualGUID;

 /* Can't define operators for = and ^= in PL/I */

 %end; /* _SYS_GUID_OPERATORS_ */
 %end; /* _GUIDDEF_H_ */

