 /* ++ BUILD Version: 0006                                            */
 /*    -- Increment this if a change has global effects               */
 /*                                                                   */
 /* Copyright 1992 - 1998 Microsoft Corporation                       */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*   lmat.cpy                                                        */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*   This file contains structures, function prototypes, and         */
 /*   definitions for the schedule service API-s.                     */
 /*                                                                   */
 /* Environment:                                                      */
 /*                                                                   */
 /*   User Mode - Win32                                               */
 /*   Portable to any flat, 32-bit environment. (Uses Win32 typedefs.)*/
 /*                                                                   */
 /* Notes:                                                            */
 /*                                                                   */
 /*   You must include NETCONS.CPY before this file, since this file  */
 /*   depends on values defined in NETCONS.CPY.                       */
 /*                                                                   */
 /* Revision History:                                                 */
 /*                                                                   */
 /* --                                                                */

 %dcl #LMAT_ char ext;
 %if #LMAT_ = '' %then %do;
 %#LMAT_ = 'Y';


 /* The following bits are used with Flags field in structures below. */


 /* Do we exec programs for this job periodically (/EVERY switch)     */
 /* or one time (/NEXT switch).                                       */

 dcl JOB_RUN_PERIODICALLY type UCHAR value('01'xn); /* set if EVERY   */


 /* Was there an error last time we tried to exec a program on behalf */
 /* ofthis job. This flag is meaningful on output only!               */

 dcl JOB_EXEC_ERROR       type UCHAR value('02'xn); /* set if error   */


 /* Will this job run today or tomorrow.                              */
 /* This flag is meaningful on output only!                           */

 dcl JOB_RUNS_TODAY       type UCHAR value('04'xn); /* set if today   */


 /* Add current day of the month to DaysOfMonth input.                */
 /* This flag is meaningful on input only!                            */

 dcl JOB_ADD_CURRENT_DATE type UCHAR value('08'xn);
                                        /* set if to add current date */


 /* Will this job be run interactively or not. Windows NT 3.1 does    */
 /* not know about this bit, i.e. it submits interactive jobs only.   */

 dcl JOB_NONINTERACTIVE   type UCHAR value('10'xn);
                                            /* set for noninteractive */


 dcl JOB_INPUT_FLAGS      type UCHAR value(ior (JOB_RUN_PERIODICALLY,
                                                JOB_ADD_CURRENT_DATE,
                                                JOB_NONINTERACTIVE));

 dcl JOB_OUTPUT_FLAGS     type UCHAR value(ior (JOB_RUN_PERIODICALLY,
                                                JOB_EXEC_ERROR,
                                                JOB_RUNS_TODAY,
                                                JOB_NONINTERACTIVE));

 define structure
   1 AT_INFO,
     2 JobTime     type DWORD,
     2 DaysOfMonth type DWORD,
     2 DaysOfWeek  type UCHAR,
     2 Flags       type UCHAR,
     2 Command     type LPWSTR;
 define alias  PAT_INFO handle AT_INFO;
 define alias LPAT_INFO handle AT_INFO;

 define structure
   1 AT_ENUM,
     2 JobId       type DWORD,
     2 JobTime     type DWORD,
     2 DaysOfMonth type DWORD,
     2 DaysOfWeek  type UCHAR,
     2 Flags       type UCHAR,
     2 Command     type LPWSTR;
 define alias  PAT_ENUM handle AT_ENUM;
 define alias LPAT_ENUM handle AT_ENUM;

 dcl NetScheduleJobAdd
     entry (WCHAR (*) varz byaddr nonasgn optional,
            type LPBYTE,
            type DWORD byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetScheduleJobAdd');

 dcl NetScheduleJobDel
     entry (WCHAR (*) varz byaddr nonasgn optional,
            type DWORD,
            type DWORD)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetScheduleJobDel');

 dcl NetScheduleJobEnum
     entry (WCHAR (*) varz byaddr nonasgn optional,
            type LPBYTE byaddr,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD byaddr optional)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetScheduleJobEnum');

 dcl NetScheduleJobGetInfo
     entry (WCHAR (*) varz byaddr nonasgn optional,
            type DWORD,
            type LPBYTE byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetScheduleJobGetInfo');

 %end; /* _LMAT_ */
