 /* ++ BUILD Version: 0003                                            */
 /*    -- Increment this if a change has global effects               */
 /*                                                                   */
 /* Copyright 1991-1998 Microsoft Corporation                         */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*   lmaudit.cpy                                                     */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*   This module defines the API function prototypes and data        */
 /*   structures for the following groups of NT API functions:        */
 /*       NetAudit                                                    */
 /*                                                                   */
 /* Environment:                                                      */
 /*                                                                   */
 /*   User Mode - Win32                                               */
 /*                                                                   */
 /* Notes:                                                            */
 /*                                                                   */
 /*   You must include NETCONS.CPY before this file, since this file  */
 /*   depends on values defined in NETCONS.CPY.                       */
 /*                                                                   */
 /* --                                                                */

 %dcl #LMAUDIT_ char ext;
 %if #LMAUDIT_ = '' %then %do;
 %#LMAUDIT_ = 'Y';


 %dcl #LMHLOGDEFINED_ char ext;
 %if #LMHLOGDEFINED_ = '' %then %do;
 %#LMHLOGDEFINED_ = 'Y';

 /* Warning: Microsoft call this HLOG,         */
 /* but this conflicts with HLOG in pdh.cpy.   */
 /* Accordingly this is renamed to LMHLOG here */

 define structure
   1 LMHLOG,
     2 time       type DWORD,
     2 last_flags type DWORD,
     2 offset     type DWORD,
     2 rec_offset type DWORD;
 define alias  PLMHLOG handle LMHLOG;
 define alias LPLMHLOG handle LMHLOG;

 dcl LOGFLAGS_FORWARD  fixed bin(31) value(0);
 dcl LOGFLAGS_BACKWARD fixed bin(15) value('1'xn);
 dcl LOGFLAGS_SEEK     fixed bin(15) value('2'xn);

 %end;


 /* Function Prototypes - Audit */

 dcl NetAuditClear
     entry (WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional)
                 /* WARNING: buggy support before LM 2.0C!! */
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetAuditClear');

 dcl NetAuditRead
     entry (WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
                 /* WARNING: buggy support before LM 2.0C!! */
            type LPLMHLOG,
            type DWORD,
            type DWORD byaddr optional,
            type DWORD,
            type DWORD,
            type LPBYTE byaddr,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetAuditRead');

 dcl NetAuditWrite
     entry (type DWORD,
            type LPBYTE,
            type DWORD,
            WCHAR(*) varz byaddr nonasgn optional,
            type LPBYTE)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetAuditWrite');


 /* Data Structures - Audit */

 define structure
   1 AUDIT_ENTRY,
     2 ae_len         type DWORD,
     2 ae_reserved    type DWORD,
     2 ae_time        type DWORD,
     2 ae_type        type DWORD,
     2 ae_data_offset type DWORD, /* Offset from beginning address */
                                  /* of audit_entry                */
     2 ae_data_size   type DWORD; /* byte count of ae_data area    */
                                  /* (not incl pad).               */
 define alias  PAUDIT_ENTRY handle AUDIT_ENTRY;
 define alias LPAUDIT_ENTRY handle AUDIT_ENTRY;

 /* Temporary to let users ifdef on this struct layout. */
 %dcl REVISED_AUDIT_ENTRY_STRUCT char ext;
 %REVISED_AUDIT_ENTRY_STRUCT = 'Y';

 define structure
   1 AE_SRVSTATUS,
     2 ae_sv_status type DWORD;
 define alias  PAE_SRVSTATUS handle AE_SRVSTATUS;
 define alias LPAE_SRVSTATUS handle AE_SRVSTATUS;

 define structure
   1 AE_SESSLOGON,
     2 ae_so_compname  type DWORD,
     2 ae_so_username  type DWORD,
     2 ae_so_privilege type DWORD;
 define alias  PAE_SESSLOGON handle AE_SESSLOGON;
 define alias LPAE_SESSLOGON handle AE_SESSLOGON;

 define structure
   1 AE_SESSLOGOFF,
     2 ae_sf_compname type DWORD,
     2 ae_sf_username type DWORD,
     2 ae_sf_reason   type DWORD;
 define alias  PAE_SESSLOGOFF handle AE_SESSLOGOFF;
 define alias LPAE_SESSLOGOFF handle AE_SESSLOGOFF;

 define structure
   1 AE_SESSPWERR,
     2 ae_sp_compname type DWORD,
     2 ae_sp_username type DWORD;
 define alias  PAE_SESSPWERR handle AE_SESSPWERR;
 define alias LPAE_SESSPWERR handle AE_SESSPWERR;

 define structure
   1 AE_CONNSTART,
     2 ae_ct_compname type DWORD,
     2 ae_ct_username type DWORD,
     2 ae_ct_netname  type DWORD,
     2 ae_ct_connid   type DWORD;
 define alias  PAE_CONNSTART handle AE_CONNSTART;
 define alias LPAE_CONNSTART handle AE_CONNSTART;

 define structure
   1 AE_CONNSTOP,
     2 ae_cp_compname type DWORD,
     2 ae_cp_username type DWORD,
     2 ae_cp_netname  type DWORD,
     2 ae_cp_connid   type DWORD,
     2 ae_cp_reason   type DWORD;
 define alias  PAE_CONNSTOP handle AE_CONNSTOP;
 define alias LPAE_CONNSTOP handle AE_CONNSTOP;

 define structure
   1 AE_CONNREJ,
     2 ae_cr_compname type DWORD,
     2 ae_cr_username type DWORD,
     2 ae_cr_netname  type DWORD,
     2 ae_cr_reason   type DWORD;
 define alias  PAE_CONNREJ handle AE_CONNREJ;
 define alias LPAE_CONNREJ handle AE_CONNREJ;

 define structure
   1 AE_RESACCESS,
     2 ae_ra_compname   type DWORD,
     2 ae_ra_username   type DWORD,
     2 ae_ra_resname    type DWORD,
     2 ae_ra_operation  type DWORD,
     2 ae_ra_returncode type DWORD,
     2 ae_ra_restype    type DWORD,
     2 ae_ra_fileid     type DWORD;
 define alias  PAE_RESACCESS handle AE_RESACCESS;
 define alias LPAE_RESACCESS handle AE_RESACCESS;

 define structure
   1 AE_RESACCESSREJ,
     2 ae_rr_compname type DWORD,
     2 ae_rr_username type DWORD,
     2 ae_rr_resname type DWORD,
     2 ae_rr_operation type DWORD;
 define alias  PAE_RESACCESSREJ handle AE_RESACCESSREJ;
 define alias LPAE_RESACCESSREJ handle AE_RESACCESSREJ;

 define structure
   1 AE_CLOSEFILE,
     2 ae_cf_compname type DWORD,
     2 ae_cf_username type DWORD,
     2 ae_cf_resname  type DWORD,
     2 ae_cf_fileid   type DWORD,
     2 ae_cf_duration type DWORD,
     2 ae_cf_reason   type DWORD;
 define alias  PAE_CLOSEFILE handle AE_CLOSEFILE;
 define alias LPAE_CLOSEFILE handle AE_CLOSEFILE;

 define structure
   1 AE_SERVICESTAT,
     2 ae_ss_compname  type DWORD,
     2 ae_ss_username  type DWORD,
     2 ae_ss_svcname   type DWORD,
     2 ae_ss_status    type DWORD,
     2 ae_ss_code      type DWORD,
     2 ae_ss_text      type DWORD,
     2 ae_ss_returnval type DWORD;
 define alias  PAE_SERVICESTAT handle AE_SERVICESTAT;
 define alias LPAE_SERVICESTAT handle AE_SERVICESTAT;

 define structure
   1 AE_ACLMOD,
     2 ae_am_compname type DWORD,
     2 ae_am_username type DWORD,
     2 ae_am_resname  type DWORD,
     2 ae_am_action   type DWORD,
     2 ae_am_datalen  type DWORD;
 define alias  PAE_ACLMOD handle AE_ACLMOD;
 define alias LPAE_ACLMOD handle AE_ACLMOD;

 define structure
   1 AE_UASMOD,
     2 ae_um_compname type DWORD,
     2 ae_um_username type DWORD,
     2 ae_um_resname  type DWORD,
     2 ae_um_rectype  type DWORD,
     2 ae_um_action   type DWORD,
     2 ae_um_datalen  type DWORD;
 define alias  PAE_UASMOD handle AE_UASMOD;
 define alias LPAE_UASMOD handle AE_UASMOD;

 define structure
   1 AE_NETLOGON,
     2 ae_no_compname  type DWORD,
     2 ae_no_username  type DWORD,
     2 ae_no_privilege type DWORD,
     2 ae_no_authflags type DWORD;
 define alias  PAE_NETLOGON handle AE_NETLOGON;
 define alias LPAE_NETLOGON handle AE_NETLOGON;

 define structure
   1 AE_NETLOGOFF,
     2 ae_nf_compname  type DWORD,
     2 ae_nf_username  type DWORD,
     2 ae_nf_reserved1 type DWORD,
     2 ae_nf_reserved2 type DWORD;
 define alias  PAE_NETLOGOFF handle AE_NETLOGOFF;
 define alias LPAE_NETLOGOFF handle AE_NETLOGOFF;

 define structure
   1 AE_ACCLIM,
     2 ae_al_compname type DWORD,
     2 ae_al_username type DWORD,
     2 ae_al_resname  type DWORD,
     2 ae_al_limit    type DWORD;
 define alias  PAE_ACCLIM handle AE_ACCLIM;
 define alias LPAE_ACCLIM handle AE_ACCLIM;

 dcl ACTION_LOCKOUT     fixed bin(31) value(00);
 dcl ACTION_ADMINUNLOCK fixed bin(31) value(01);

 define structure
   1 AE_LOCKOUT,
     2 ae_lk_compname type DWORD,/* Ptr to computername of client.  */
     2 ae_lk_username type DWORD,/* Ptr to username of client       */
                                 /* (NULL if same as computername). */
     2 ae_lk_action   type DWORD,/* Action taken on account: */
                                 /* 0 means locked out, 1 means not. */
     2 ae_lk_bad_pw_count type DWORD;/* Bad password count at the  */
                                 /* time of lockout. */
 define alias  PAE_LOCKOUT handle AE_LOCKOUT;
 define alias LPAE_LOCKOUT handle AE_LOCKOUT;

 define structure
   1 AE_GENERIC,
     2 ae_ge_msgfile type DWORD,
     2 ae_ge_msgnum  type DWORD,
     2 ae_ge_params  type DWORD,
     2 ae_ge_param1  type DWORD,
     2 ae_ge_param2  type DWORD,
     2 ae_ge_param3  type DWORD,
     2 ae_ge_param4  type DWORD,
     2 ae_ge_param5  type DWORD,
     2 ae_ge_param6  type DWORD,
     2 ae_ge_param7  type DWORD,
     2 ae_ge_param8  type DWORD,
     2 ae_ge_param9  type DWORD;
 define alias  PAE_GENERIC handle AE_GENERIC;
 define alias LPAE_GENERIC handle AE_GENERIC;

 /* Special Values and Constants - Audit */

 /* Audit entry types (field ae_type in audit_entry). */

 dcl AE_SRVSTATUS       fixed bin(31) value(0);
 dcl AE_SESSLOGON       fixed bin(31) value(1);
 dcl AE_SESSLOGOFF      fixed bin(31) value(2);
 dcl AE_SESSPWERR       fixed bin(31) value(3);
 dcl AE_CONNSTART       fixed bin(31) value(4);
 dcl AE_CONNSTOP        fixed bin(31) value(5);
 dcl AE_CONNREJ         fixed bin(31) value(6);
 dcl AE_RESACCESS       fixed bin(31) value(7);
 dcl AE_RESACCESSREJ    fixed bin(31) value(8);
 dcl AE_CLOSEFILE       fixed bin(31) value(9);
 dcl AE_SERVICESTAT     fixed bin(31) value(11);
 dcl AE_ACLMOD          fixed bin(31) value(12);
 dcl AE_UASMOD          fixed bin(31) value(13);
 dcl AE_NETLOGON        fixed bin(31) value(14);
 dcl AE_NETLOGOFF       fixed bin(31) value(15);
 dcl AE_NETLOGDENIED    fixed bin(31) value(16);
 dcl AE_ACCLIMITEXCD    fixed bin(31) value(17);
 dcl AE_RESACCESS2      fixed bin(31) value(18);
 dcl AE_ACLMODFAIL      fixed bin(31) value(19);
 dcl AE_LOCKOUT         fixed bin(31) value(20);
 dcl AE_GENERIC_TYPE    fixed bin(31) value(21);

 /* Values for ae_ss_status field of ae_srvstatus. */

 dcl AE_SRVSTART        fixed bin(31) value(0);
 dcl AE_SRVPAUSED       fixed bin(31) value(1);
 dcl AE_SRVCONT         fixed bin(31) value(2);
 dcl AE_SRVSTOP         fixed bin(31) value(3);


 /* Values for ae_so_privilege field of ae_sesslogon. */

 dcl AE_GUEST           fixed bin(31) value(0);
 dcl AE_USER            fixed bin(31) value(1);
 dcl AE_ADMIN           fixed bin(31) value(2);


 /* Values for various ae_XX_reason fields. */

 dcl AE_NORMAL          fixed bin(31) value(0);
 dcl AE_USERLIMIT       fixed bin(31) value(0);
 dcl AE_GENERAL         fixed bin(31) value(0);
 dcl AE_ERROR           fixed bin(31) value(1);
 dcl AE_SESSDIS         fixed bin(31) value(1);
 dcl AE_BADPW           fixed bin(31) value(1);
 dcl AE_AUTODIS         fixed bin(31) value(2);
 dcl AE_UNSHARE         fixed bin(31) value(2);
 dcl AE_ADMINPRIVREQD   fixed bin(31) value(2);
 dcl AE_ADMINDIS        fixed bin(31) value(3);
 dcl AE_NOACCESSPERM    fixed bin(31) value(3);
 dcl AE_ACCRESTRICT     fixed bin(31) value(4);

 dcl AE_NORMAL_CLOSE    fixed bin(31) value(0);
 dcl AE_SES_CLOSE       fixed bin(31) value(1);
 dcl AE_ADMIN_CLOSE     fixed bin(31) value(2);


 /* Values for xx_subreason fields. */

 dcl AE_LIM_UNKNOWN     fixed bin(31) value(0);
 dcl AE_LIM_LOGONHOURS  fixed bin(31) value(1);
 dcl AE_LIM_EXPIRED     fixed bin(31) value(2);
 dcl AE_LIM_INVAL_WKSTA fixed bin(31) value(3);
 dcl AE_LIM_DISABLED    fixed bin(31) value(4);
 dcl AE_LIM_DELETED     fixed bin(31) value(5);


 /* Values for xx_action fields */

 dcl AE_MOD             fixed bin(31) value(0);
 dcl AE_DELETE          fixed bin(31) value(1);
 dcl AE_ADD             fixed bin(31) value(2);


 /* Types of UAS record for um_rectype field */

 dcl AE_UAS_USER        fixed bin(31) value(0);
 dcl AE_UAS_GROUP       fixed bin(31) value(1);
 dcl AE_UAS_MODALS      fixed bin(31) value(2);


 /* Bitmasks for auditing events */

 dcl SVAUD_SERVICE       fixed bin(31) value('1'xn);
 dcl SVAUD_GOODSESSLOGON fixed bin(31) value('6'xn);
 dcl SVAUD_BADSESSLOGON  fixed bin(31) value('18'xn);
 dcl SVAUD_SESSLOGON     fixed bin(31) value(ior(SVAUD_GOODSESSLOGON,
                                                 SVAUD_BADSESSLOGON));
 dcl SVAUD_GOODNETLOGON  fixed bin(31) value('60'xn);
 dcl SVAUD_BADNETLOGON   fixed bin(31) value('180'xn);
 dcl SVAUD_NETLOGON      fixed bin(31) value(ior(SVAUD_GOODNETLOGON,
                                                 SVAUD_BADNETLOGON));
 dcl SVAUD_LOGON         fixed bin(31) value(ior(SVAUD_NETLOGON,
                                                 SVAUD_SESSLOGON));
 dcl SVAUD_GOODUSE       fixed bin(31) value('600'xn);
 dcl SVAUD_BADUSE        fixed bin(31) value('1800'xn);
 dcl SVAUD_USE           fixed bin(31) value(ior(SVAUD_GOODUSE,
                                                 SVAUD_BADUSE));
 dcl SVAUD_USERLIST      fixed bin(31) value('2000'xn);
 dcl SVAUD_PERMISSIONS   fixed bin(31) value('4000'xn);
 dcl SVAUD_RESOURCE      fixed bin(31) value('8000'xn);
 dcl SVAUD_LOGONLIM      fixed bin(31) value('00010000'xn);


 /* Resource access audit bitmasks. */

 dcl AA_AUDIT_ALL fixed bin(31) value('0001'xn);
 dcl AA_A_OWNER   fixed bin(31) value('0004'xn);
 dcl AA_CLOSE     fixed bin(31) value('0008'xn);
 dcl AA_S_OPEN    fixed bin(31) value('0010'xn);
 dcl AA_S_WRITE   fixed bin(31) value('0020'xn);
 dcl AA_S_CREATE  fixed bin(31) value('0020'xn);
 dcl AA_S_DELETE  fixed bin(31) value('0040'xn);
 dcl AA_S_ACL     fixed bin(31) value('0080'xn);
 dcl AA_S_ALL	  fixed bin(31) value(ior(AA_S_OPEN,   AA_S_WRITE,
                                          AA_S_DELETE, AA_S_ACL));
 dcl AA_F_OPEN    fixed bin(31) value('0100'xn);
 dcl AA_F_WRITE   fixed bin(31) value('0200'xn);
 dcl AA_F_CREATE  fixed bin(31) value('0200'xn);
 dcl AA_F_DELETE  fixed bin(31) value('0400'xn);
 dcl AA_F_ACL     fixed bin(31) value('0800'xn);
 dcl AA_F_ALL	  fixed bin(31) value(ior(AA_F_OPEN,   AA_F_WRITE,
                                          AA_F_DELETE, AA_F_ACL));

 /* Pinball-specific */

 dcl AA_A_OPEN    fixed bin(31) value('1000'xn);
 dcl AA_A_WRITE   fixed bin(31) value('2000'xn);
 dcl AA_A_CREATE  fixed bin(31) value('2000'xn);
 dcl AA_A_DELETE  fixed bin(31) value('4000'xn);
 dcl AA_A_ACL     fixed bin(31) value('8000'xn);
 dcl AA_A_ALL	  fixed bin(31) value(ior(AA_F_OPEN,   AA_F_WRITE,
                                          AA_F_DELETE, AA_F_ACL));

 %end; /* _LMAUDIT_ */
