 /* ++ BUILD Version: 0003                                            */
 /*    -- Increment this if a change has global effects               */
 /*                                                                   */
 /* Copyright 1990 - 1999 Microsoft Corporation                       */
 /*                                                                   */
 /*                                                                   */
 /*   LMCONS.CPY (was NETCONS.CPY in LM 2.x)                          */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*   This file contains constants used throughout the LAN Manager    */
 /*   API header files.  It should be included in any source file     */
 /*   that is going to include other LAN Manager API header files or  */
 /*   call a LAN Manager API.                                         */
 /*                                                                   */
 /*   NOTE:  Lengths of strings are given as the maximum lengths of   */
 /*   the string in characters (not bytes). This does not include     */
 /*   space for the terminating 0-characters. When allocating space   */
 /*   for such an item, use the form:                                 */
 /*                                                                   */
 /*   dcl username TCHAR(UNLEN) varz                                  */
 /*                                                                   */
 /*   Definitions of the form LN20_* define those values in effect    */
 /*   for LanMan 2.0.                                                 */
 /*                                                                   */
 /*--                                                                 */

 /*NOINC*/
 %dcl NETCONS_INCLUDED char ext;
 %if NETCONS_INCLUDED = '' %then %do;
 %NETCONS_INCLUDED = 'Y';
 /*INC*/

 /* String Lengths for various LanMan names */

 %dcl #CNLEN char ext;
 %if #CNLEN = '' %then %do;
 %#CNLEN = 'Y';
 dcl CNLEN        fixed bin(31) value(15);
     /* Computer name length */
 dcl UNCLEN       fixed bin(31) value(CNLEN+2);
     /* UNC computer name length */
 %end;

 dcl LM20_CNLEN   fixed bin(31) value(15);
     /* LM 2.0 Computer name length */
 dcl LM20_UNCLEN  fixed bin(31) value(LM20_CNLEN+2);
     /* LM 2.0 UNC computer name length */

 dcl DNLEN        fixed bin(31) value(CNLEN);
     /* Maximum domain name length */
 dcl LM20_DNLEN   fixed bin(31) value(LM20_CNLEN);
     /* LM 2.0 Maximum domain name length */

 dcl NNLEN        fixed bin(31) value(80);
     /* Net name length (share name) */
 dcl LM20_NNLEN   fixed bin(31) value(12);
    /* LM 2.0 Net name length */

 dcl RMLEN        fixed bin(31) value(UNCLEN+1+NNLEN);
     /* Max remote name length */
 dcl LM20_RMLEN   fixed bin(31) value(LM20_UNCLEN+1+LM20_NNLEN);
    /* LM 2.0 Max remote name length */

 dcl SNLEN        fixed bin(31) value(80);
     /* Service name length */
 dcl LM20_SNLEN   fixed bin(31) value(15);
     /* LM 2.0 Service name length */
 dcl STXTLEN      fixed bin(31) value(256);
     /* Service text length */
 dcl LM20_STXTLEN fixed bin(31) value(63);
     /* LM 2.0 Service text length */

 dcl PATHLEN      fixed bin(31) value(256);
     /* Max. path (not including drive name) */
 dcl LM20_PATHLEN fixed bin(31) value(256);
     /* LM 2.0 Max. path */

 dcl DEVLEN       fixed bin(31) value(80);
     /* Device name length */
 dcl LM20_DEVLEN  fixed bin(31) value(8);
     /* LM 2.0 Device name length */

 dcl EVLEN        fixed bin(31) value(16);
     /* Event name length */

 /* User, Group and Password lengths */

 dcl UNLEN        fixed bin(31) value(256);
     /* Maximum user name length */
 dcl LM20_UNLEN   fixed bin(31) value(20);
     /* LM 2.0 Maximum user name length */

 dcl GNLEN        fixed bin(31) value(UNLEN);
     /* Group name */
 dcl LM20_GNLEN   fixed bin(31) value(LM20_UNLEN);
     /* LM 2.0 Group name */

 dcl PWLEN        fixed bin(31) value(256);
     /* Maximum password length */
 dcl LM20_PWLEN   fixed bin(31) value(14);
     /* LM 2.0 Maximum password length */

 dcl SHPWLEN      fixed bin(31) value(8);
     /* Share password length (bytes) */

 dcl CLTYPE_LEN   fixed bin(31) value(12);
    /* Length of client type string */

 dcl MAXCOMMENTSZ fixed bin(31) value(256);
     /* Multipurpose comment length */
 dcl LM20_MAXCOMMENTSZ fixed bin(31) value(48);
     /* LM 2.0 Multipurpose comment length */

 dcl QNLEN        fixed bin(31) value(NNLEN);
     /* Queue name maximum length */
 dcl LM20_QNLEN   fixed bin(31) value(LM20_NNLEN);
     /* LM 2.0 Queue name maximum length */

 /* The ALERTSZ and MAXDEVENTRIES defines have not yet been NT'ized. */
 /* Whoever ports these components should change these values        */
 /* appropriately.                                                   */

 dcl ALERTSZ       fixed bin(31) value(128);
     /* size of alert string in server */
 dcl MAXDEVENTRIES fixed bin(31) value(4*8); /* C: sizeof (int)*8 */
     /* Max number of device entries */

 /* We use int bitmap to represent */

 dcl NETBIOS_NAME_LEN fixed bin(31) value(16);
     /* NetBIOS net name (bytes) */

 /* Value to be used with APIs which have a "preferred maximum length"*/
 /* parameter. This value indicates that the API should just allocate */
 /* "as much as it takes."                                            */

 dcl MAX_PREFERRED_LENGTH type DWORD value(iunsigned(bin(-1,31)));

 /*        Constants used with encryption */

 dcl CRYPT_KEY_LEN      fixed bin(31) value(7);
 dcl CRYPT_TXT_LEN      fixed bin(31) value(8);
 dcl ENCRYPTED_PWLEN    fixed bin(31) value(16);
 dcl SESSION_PWLEN      fixed bin(31) value(24);
 dcl SESSION_CRYPT_KLEN fixed bin(31) value(21);

 /*  Value to be used with SetInfo calls to allow setting of all */
 /*  settable parameters (parmnum zero option)                   */

 %dcl #PARMNUM_ALL char ext;
 %if #PARMNUM_ALL = '' %then %do;
 %#PARMNUM_ALL = 'Y';
 dcl PARMNUM_ALL fixed bin(31) value(0);
 %end;

 dcl PARM_ERROR_UNKNOWN     type DWORD value(iunsigned(bin(-1,31)));
 dcl PARM_ERROR_NONE        type DWORD value(0);
 dcl PARMNUM_BASE_INFOLEVEL type DWORD value(1000);

 %dcl MSTR char; %MSTR = 'WCHAR(*) varz';
 define alias  LMSTR type LPWSTR;
 define alias LMCSTR type LPCWSTR;

 /* Message File Names */

 dcl MESSAGE_FILENAME  TCHAR value('NETMSG');
 dcl OS2MSG_FILENAME   TCHAR value('BASE');
 dcl HELP_MSG_FILENAME TCHAR value('NETH');

 /* The backup message file named here is a duplicate of net.msg.     */
 /* It is not shipped with the product, but is used at buildtime to   */
 /* msgbind certain messages to netapi.dll and some of the services.  */
 /* This allows for OEMs to modify the message text in net.msg and    */
 /* have those changes show up. Only in case there is an error in     */
 /* retrieving the messages from net.msg do we then get the bound     */
 /* messages out of bak.msg (really out of the message segment).      */

 dcl BACKUP_MSG_FILENAME TCHAR value('BAK.MSG');

 /**END_INTERNAL**/

 /* Keywords used in Function Prototypes */

 define alias NET_API_STATUS type DWORD;
 define alias API_RET_TYPE   type NET_API_STATUS;
    /* Old value: do not use */

 %dcl NET_API_FUNCTION char ext;
 %NET_API_FUNCTION = 'options (byvalue linkage(stdcall) nodescriptor)';


 /* The platform ID indicates the levels to use for platform-specific */
 /* information.                                                      */


 dcl PLATFORM_ID_DOS fixed bin(31) value(300);
 dcl PLATFORM_ID_OS2 fixed bin(31) value(400);
 dcl PLATFORM_ID_NT  fixed bin(31) value(500);
 dcl PLATFORM_ID_OSF fixed bin(31) value(600);
 dcl PLATFORM_ID_VMS fixed bin(31) value(700);

 /*  There message numbers assigned to different LANMAN components   */
 /*  are as defined below.                                           */
 /*                                                                  */
 /*    lmerr.cpy:        2100 - 2999     NERR_BASE                   */
 /*    alertmsg.cpy:     3000 - 3049     ALERT_BASE                  */
 /*    lmsvc.cpy:        3050 - 3099     SERVICE_BASE                */
 /*    lmerrlog.cpy:     3100 - 3299     ERRLOG_BASE                 */
 /*    msgtext.cpy:      3300 - 3499     MTXT_BASE                   */
 /*    apperr.cpy:       3500 - 3999     APPERR_BASE                 */
 /*    apperrfs.cpy:     4000 - 4299     APPERRFS_BASE               */
 /*    apperr2.cpy:      4300 - 5299     APPERR2_BASE                */
 /*    ncberr.cpy:       5300 - 5499     NRCERR_BASE                 */
 /*    alertmsg.cpy:     5500 - 5599     ALERT2_BASE                 */
 /*    lmsvc.cpy:        5600 - 5699     SERVICE2_BASE               */
 /*    lmerrlog.cpy:     5700 - 5799     ERRLOG2_BASE                */

 dcl MIN_LANMAN_MESSAGE_ID fixed bin(31) value(2100); /* = NERR_BASE */
 dcl MAX_LANMAN_MESSAGE_ID fixed bin(31) value(5799);

 /*NOINC*/
 %end; /* NETCONS_INCLUDED */
 /*INC*/
