 /*++ BUILD Version: 0001                                             */
 /*   -- Increment this if a change has global effects                */
 /*                                                                   */
 /* Copyright 1991-1998 Microsoft Corporation                         */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*   lmremutl.cpy                                                    */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*   This file contains structures, function prototypes, and         */
 /*   definitions for the NetRemote API.                              */
 /*                                                                   */
 /* Environment:                                                      */
 /*                                                                   */
 /*   User Mode - Win32                                               */
 /*   Portable to any flat, 32-bit environment. (Uses Win32 typedefs.)*/
 /*                                                                   */
 /* --                                                                */

 %dcl #LMREMUTL_ char ext;
 %if #LMREMUTL_ = '' %then %do;
 %#LMREMUTL_ = 'Y';

 /* Type Definitions */

 %dcl DESC_CHAR char ext;
 %dcl DESC_CHAR_UNICODE char ext;
 %if DESC_CHAR_UNICODE = '' %then %do;
 %DESC_CHAR = 'char';
 %end; %else %do;
 %DESC_CHAR = 'WCHAR';
 %end; /* DESC_CHAR_UNICODE is defined */

 define alias LPDESC pointer;


 /* Function Prototypes */

 dcl NetRemoteTOD
     entry (WCHAR (*) varz byaddr nonasgn,
            type LPBYTE byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetRemoteTOD');

 dcl NetRemoteComputerSupports
     entry (WCHAR (*) varz byaddr nonasgn optional,
                               /* Must start with "\\". */
            type DWORD,        /* Set SUPPORTS_ bits wanted. */
            type DWORD byaddr) /* Supported features, masked. */
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetRemoteComputerSupports');

 dcl RxRemoteApi
     entry (type DWORD,
            WCHAR (*) varz byaddr nonasgn, /* Required, with \\name. */
            DESC_CHAR (*) varz byaddr,
            DESC_CHAR (*) varz byaddr optional,
            DESC_CHAR (*) varz byaddr optional,
            DESC_CHAR (*) varz byaddr optional,
            DESC_CHAR (*) varz byaddr optional,
            DESC_CHAR (*) varz byaddr optional,
            DESC_CHAR (*) varz byaddr optional,
            type DWORD list) /* rest of API's arguments */
     returns (type NET_API_STATUS byvalue optional)
     options (byvalue nodescriptor) external ('RxRemoteApi');


 /*  Data Structures */

 define structure
   1 TIME_OF_DAY_INFO,
     2 tod_elapsedt  type DWORD,
     2 tod_msecs     type DWORD,
     2 tod_hours     type DWORD,
     2 tod_mins      type DWORD,
     2 tod_secs      type DWORD,
     2 tod_hunds     type DWORD,
     2 tod_timezone  type LONG,
     2 tod_tinterval type DWORD,
     2 tod_day       type DWORD,
     2 tod_month     type DWORD,
     2 tod_year      type DWORD,
     2 tod_weekday   type DWORD;
 define alias  PTIME_OF_DAY_INFO handle TIME_OF_DAY_INFO;
 define alias LPTIME_OF_DAY_INFO handle TIME_OF_DAY_INFO;


 /* Special Values and Constants */

 /* Mask bits for use with NetRemoteComputerSupports: */

 dcl SUPPORTS_REMOTE_ADMIN_PROTOCOL fixed bin(31) value('00000002'xn);
 dcl SUPPORTS_RPC                   fixed bin(31) value('00000004'xn);
 dcl SUPPORTS_SAM_PROTOCOL          fixed bin(31) value('00000008'xn);
 dcl SUPPORTS_UNICODE               fixed bin(31) value('00000010'xn);
 dcl SUPPORTS_LOCAL                 fixed bin(31) value('00000020'xn);
 dcl SUPPORTS_ANY                   fixed bin(31) value('FFFFFFFF'xn);

 /* Flag bits for RxRemoteApi: */

 dcl NO_PERMISSION_REQUIRED         fixed bin(31) value('00000001'xn);
     /* set if use NULL session */
 dcl ALLOCATE_RESPONSE              fixed bin(31) value('00000002'xn);
     /* set if RxRemoteApi allocates response buffer */
 dcl USE_SPECIFIC_TRANSPORT         fixed bin(31) value('80000000'xn);

 %end; /*_LMREMUTL_ */
