 /* ++                                                                */
 /*                                                                   */
 /* Copyright (c) 1991-1998 Microsoft Corporation                     */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*   rpcdce.cpy                                                      */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*   This module contains the DCE RPC runtime APIs.                  */
 /*                                                                   */
 /* --                                                                */

 %dcl #_RPCDCE_H__ char ext;
 %if #_RPCDCE_H__ = '' %then %do;
 %#_RPCDCE_H__ = 'Y';

 %dcl RPC_UNICODE_SUPPORTED char ext;
 %dcl UNICODE char ext;

 /* define alias small   char                   */
 /* define alias byte    fixed bin (7) signed   */
 /* define alias boolean fixed bin (8) unsigned */

 define alias RPC_BINDING_HANDLE   type I_RPC_HANDLE;
 define alias handle_t             type RPC_BINDING_HANDLE;
 define alias rpc_binding_handle_t type RPC_BINDING_HANDLE;

 %dcl GUID_DEFINED char ext;
 %if GUID_DEFINED = '' %then %do;
 %GUID_DEFINED = 'Y';
 define structure
   1 GUID,
     2 Data1 fixed bin(31) ,
     2 Data2 unsigned fixed bin(16) ,
     2 Data3 unsigned fixed bin(16) ,
     2 Data4 char(8);
 %end; /* GUID_DEFINED */

 %dcl UUID_DEFINED char ext;
 %if UUID_DEFINED = '' %then %do;
 %UUID_DEFINED = 'Y';
 define alias UUID   type GUID;
 define alias uuid_t type UUID;
 %end;

 define structure
   1 RPC_BINDING_VECTOR,
     2 Count        fixed bin(31) ,
     2 BindingH (1) type RPC_BINDING_HANDLE; /* actually REFER */
 define alias rpc_binding_vector_t type RPC_BINDING_VECTOR;

 define structure
   1 UUID_VECTOR,
     2 Count    fixed bin(31) ,
     2 Uuid (1) handle UUID; /* actually REFER */
 define alias uuid_vector_t type UUID_VECTOR;

 define alias RPC_IF_HANDLE pointer;

 %dcl IFID_DEFINED char ext;
 %if IFID_DEFINED = '' %then %do;
 %IFID_DEFINED = 'Y';
 define structure
   1 RPC_IF_ID,
     2 Uuid      type UUID,
     2 VersMajor unsigned fixed bin(16) ,
     2 VersMinor unsigned fixed bin(16) ;
 %end;

 dcl RPC_C_BINDING_INFINITE_TIMEOUT     fixed bin(31) value(10);
 dcl RPC_C_BINDING_MIN_TIMEOUT          fixed bin(31) value(0);
 dcl RPC_C_BINDING_DEFAULT_TIMEOUT      fixed bin(31) value(5);
 dcl RPC_C_BINDING_MAX_TIMEOUT          fixed bin(31) value(9);

 dcl RPC_C_CANCEL_INFINITE_TIMEOUT      fixed bin(31) value(-1);

 dcl RPC_C_LISTEN_MAX_CALLS_DEFAULT     fixed bin(31) value(1234);
 dcl RPC_C_PROTSEQ_MAX_REQS_DEFAULT     fixed bin(31) value(10);

 /* RPC_POLICY EndpointFlags. */
 dcl RPC_C_BIND_TO_ALL_NICS             fixed bin(31) value(1);
 dcl RPC_C_USE_INTERNET_PORT            fixed bin(15) value('1'xn);
 dcl RPC_C_USE_INTRANET_PORT            fixed bin(15) value('2'xn);
 dcl RPC_C_DONT_FAIL                    fixed bin(15) value('4'xn);

 /* RPC_POLICY EndpointFlags specific to the Falcon/RPC transport: */
 dcl RPC_C_MQ_TEMPORARY                 fixed bin(15) value('0000'xn);
 dcl RPC_C_MQ_PERMANENT                 fixed bin(15) value('0001'xn);
 dcl RPC_C_MQ_CLEAR_ON_OPEN             fixed bin(15) value('0002'xn);
 dcl RPC_C_MQ_USE_EXISTING_SECURITY     fixed bin(15) value('0004'xn);
 dcl RPC_C_MQ_AUTHN_LEVEL_NONE          fixed bin(15) value('0000'xn);
 dcl RPC_C_MQ_AUTHN_LEVEL_PKT_INTEGRITY fixed bin(15) value('0008'xn)
 ;
 dcl RPC_C_MQ_AUTHN_LEVEL_PKT_PRIVACY   fixed bin(15) value('0010'xn);

 /* Client: RpcBindingSetOption() values for the Falcon/RPC transport:*/
 dcl RPC_C_OPT_MQ_DELIVERY              fixed bin(31) value(1);
 dcl RPC_C_OPT_MQ_PRIORITY              fixed bin(31) value(2);
 dcl RPC_C_OPT_MQ_JOURNAL               fixed bin(31) value(3);
 dcl RPC_C_OPT_MQ_ACKNOWLEDGE           fixed bin(31) value(4);
 dcl RPC_C_OPT_MQ_AUTHN_SERVICE         fixed bin(31) value(5);
 dcl RPC_C_OPT_MQ_AUTHN_LEVEL           fixed bin(31) value(6);
 dcl RPC_C_OPT_MQ_TIME_TO_REACH_QUEUE   fixed bin(31) value(7);
 dcl RPC_C_OPT_MQ_TIME_TO_BE_RECEIVED   fixed bin(31) value(8);
 dcl RPC_C_OPT_BINDING_NONCAUSAL        fixed bin(31) value(9);
 dcl RPC_C_OPT_MAX_OPTIONS              fixed bin(31) value(10);

 dcl RPC_C_MQ_EXPRESS                   fixed bin(31) value(0);
     /* Client: RPC_C_MQ_DELIVERY. */
 dcl RPC_C_MQ_RECOVERABLE               fixed bin(31) value(1);

 dcl RPC_C_MQ_JOURNAL_NONE              fixed bin(31) value(0);
     /* Client: RPC_C_MQ_JOURNAL. */
 dcl RPC_C_MQ_JOURNAL_DEADLETTER        fixed bin(31) value(1);
 dcl RPC_C_MQ_JOURNAL_ALWAYS            fixed bin(31) value(2);

 /* flags for RpcServerInqAuthClientEx */

 dcl RPC_C_FULL_CERT_CHAIN              fixed bin(15) value('0001'xn);

 %if RPC_UNICODE_SUPPORTED ^= '' %then %do;
 define structure
   1 RPC_PROTSEQ_VECTORA,
     2 Count       fixed bin(31),
     2 Protseq (1) pointer; /* actually REFER */

 define structure
   1 RPC_PROTSEQ_VECTORW,
     2 Count       fixed bin(31),
     2 Protseq (1) pointer; /* actually REFER */

 %if UNICODE ^= '' %then %do;
 define alias RPC_PROTSEQ_VECTOR type RPC_PROTSEQ_VECTORW;
 %end; %else %do;
 define alias RPC_PROTSEQ_VECTOR type RPC_PROTSEQ_VECTORA;
 %end; /* UNICODE */

 %end; %else %do;

 define structure
   1 RPC_PROTSEQ_VECTOR,
     2 Count       fixed bin(31),
     2 Protseq (1) pointer; /* actually REFER */

 %end; /* RPC_UNICODE_SUPPORTED */

 define structure
   1 RPC_POLICY,
     2 Length        fixed bin(31) ,
     2 EndpointFlags fixed bin(31) ,
     2 NICFlags      fixed bin(31) ;
 define alias PRPC_POLICY handle RPC_POLICY;


 /* original omits the "address" and incorporates in the usage */
 define alias RPC_OBJECT_INQ_FN
        entry (type UUID byaddr,
               type UUID byaddr,
               type RPC_STATUS byaddr)
        limited #_RPC_USER;

 define alias RPC_IF_CALLBACK_FN
        entry (type RPC_IF_HANDLE,
               pointer)
        returns (type RPC_STATUS byvalue optional)
        limited RPC_ENTRY;

 define structure
   1 RPC_STATS_VECTOR,
     2 Count     fixed bin(31),
     2 Stats (1) fixed bin(31); /* actually REFER */

 dcl RPC_C_STATS_CALLS_IN  fixed bin(31) value(0);
 dcl RPC_C_STATS_CALLS_OUT fixed bin(31) value(1);
 dcl RPC_C_STATS_PKTS_IN   fixed bin(31) value(2);
 dcl RPC_C_STATS_PKTS_OUT  fixed bin(31) value(3);

 define structure
   1 RPC_IF_ID_VECTOR,
     2 Count    fixed bin(31),
     2 IfId (1) handle RPC_IF_ID; /* actually REFER */

 /* client */
 dcl RpcBindingCopy
     entry (type RPC_BINDING_HANDLE,
            type RPC_BINDING_HANDLE byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcBindingCopy');

 /* client */
 dcl RpcBindingFree
     entry (type RPC_BINDING_HANDLE byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcBindingFree');

 /* client */
 dcl RpcBindingSetOption
     entry (type RPC_BINDING_HANDLE,
            fixed bin(31),
            type ULONG_PTR)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcBindingSetOption');

 /* client */
 dcl RpcBindingInqOption
     entry (type RPC_BINDING_HANDLE,
            fixed bin(31),
            type ULONG_PTR byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcBindingInqOption');

 /* client */

 %if RPC_UNICODE_SUPPORTED ^= '' %then %do;

 dcl RpcBindingFromStringBindingA
     entry (char(*) varz byaddr,
            type RPC_BINDING_HANDLE byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcBindingFromStringBindingA');


 dcl RpcBindingFromStringBindingW
     entry (WCHAR(*) varz byaddr,
            type RPC_BINDING_HANDLE byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcBindingFromStringBindingW');


 %dcl RpcBindingFromStringBinding char ext;
 %if UNICODE ^= '' %then %do;
   %RpcBindingFromStringBinding='RpcBindingFromStringBindingW';
 %end; %else %do;
   %RpcBindingFromStringBinding='RpcBindingFromStringBindingA';
 %end; /* UNICODE */

 %end; %else %do;

 dcl RpcBindingFromStringBinding
     entry (char(*) varz byaddr,
            type RPC_BINDING_HANDLE byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcBindingFromStringBinding');

 %end; /* RPC_UNICODE_SUPPORTED */

 /* client */
 dcl RpcSsGetContextBinding
     entry (pointer,
            type RPC_BINDING_HANDLE byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcSsGetContextBinding');

 /* client/server */
 dcl RpcBindingInqObject
     entry (type RPC_BINDING_HANDLE,
            type UUID byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcBindingInqObject');

 /* client */
 dcl RpcBindingReset
     entry (type RPC_BINDING_HANDLE)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcBindingReset');

 /* RpcBindingServerFromClient : UNSUPPORTED */
 /* RpcBindingSetAuthInfo */

 /* client */
 dcl RpcBindingSetObject
     entry (type RPC_BINDING_HANDLE,
            type UUID byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcBindingSetObject');

 /* client/server */
 dcl RpcMgmtInqDefaultProtectLevel
     entry (fixed bin(31),
            fixed bin(31) byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcMgmtInqDefaultProtectLevel');

 /* client/server */

 %if RPC_UNICODE_SUPPORTED ^= '' %then %do;

 dcl RpcBindingToStringBindingA
     entry (type RPC_BINDING_HANDLE,
            pointer byaddr) /* to char(*) varz byaddr */
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcBindingToStringBindingA');

 dcl RpcBindingToStringBindingW
     entry (type RPC_BINDING_HANDLE,
            pointer byaddr) /* to WCHAR(*) varz byaddr */
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcBindingToStringBindingW');

 %dcl RpcBindingToStringBinding char ext;
 %if UNICODE ^= '' %then %do;
   %RpcBindingToStringBinding='RpcBindingToStringBindingW';
 %end; %else %do;
   %RpcBindingToStringBinding='RpcBindingToStringBindingA';
 %end;  /* UNICODE */

 %end; %else %do;

 dcl RpcBindingToStringBinding
     entry (type RPC_BINDING_HANDLE,
            pointer byaddr) /* to char(*) varz byaddr */
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcBindingToStringBinding');

 %end; /* RPC_UNICODE_SUPPORTED */

 /* client/server */
 dcl RpcBindingVectorFree
     entry (handle RPC_BINDING_VECTOR byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcBindingVectorFree');

 /* client/server */

 %if RPC_UNICODE_SUPPORTED ^= '' %then %do;

 dcl RpcStringBindingComposeA
     entry (char(*) varz byaddr optional,
            char(*) varz byaddr optional,
            char(*) varz byaddr optional,
            char(*) varz byaddr optional,
            char(*) varz byaddr optional,
            pointer byaddr) /* to char(*) varz */
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcStringBindingComposeA');

 dcl RpcStringBindingComposeW
     entry (WCHAR(*) varz byaddr optional,
            WCHAR(*) varz byaddr optional,
            WCHAR(*) varz byaddr optional,
            WCHAR(*) varz byaddr optional,
            WCHAR(*) varz byaddr optional,
            pointer byaddr) /* to WCHAR(*) varz */
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcStringBindingComposeW');

 %dcl RpcStringBindingCompose char ext;
 %if UNICODE ^= '' %then %do;
   %RpcStringBindingCompose='RpcStringBindingComposeW';
 %end; %else %do;
   %RpcStringBindingCompose='RpcStringBindingComposeA';
 %end; /* UNICODE */

 %end; %else %do;

 dcl RpcStringBindingCompose
     entry (char(*) varz byaddr optional,
            char(*) varz byaddr optional,
            char(*) varz byaddr optional,
            char(*) varz byaddr optional,
            char(*) varz byaddr optional,
            pointer byaddr) /* to char(*) varz */
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcStringBindingCompose');

 %end; /* RPC_UNICODE_SUPPORTED */

 /* client/server */

 %if RPC_UNICODE_SUPPORTED ^= '' %then %do;

 dcl RpcStringBindingParseA
     entry (char(*) varz byaddr,
            pointer byaddr, /* to char(*) varz */
            pointer byaddr, /* to char(*) varz */
            pointer byaddr, /* to char(*) varz */
            pointer byaddr, /* to char(*) varz */
            pointer byaddr) /* to char(*) varz */
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcStringBindingParseA');

 dcl RpcStringBindingParseW
     entry (WCHAR(*) varz byaddr,
            pointer byaddr, /* to WCHAR(*) varz */
            pointer byaddr, /* to WCHAR(*) varz */
            pointer byaddr, /* to WCHAR(*) varz */
            pointer byaddr, /* to WCHAR(*) varz */
            pointer byaddr) /* to WCHAR(*) varz */
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcStringBindingParseW');

 %dcl RpcStringBindingParse char ext;
 %if UNICODE ^= '' %then %do;
   %RpcStringBindingParse='RpcStringBindingParseW';
 %end; %else %do;
   %RpcStringBindingParse='RpcStringBindingParseA';
 %end; /* UNICODE */

 %end; %else %do;

 dcl RpcStringBindingParse
     entry (char(*) varz byaddr,
            pointer byaddr, /* to char(*) varz */
            pointer byaddr, /* to char(*) varz */
            pointer byaddr, /* to char(*) varz */
            pointer byaddr, /* to char(*) varz */
            pointer byaddr) /* to char(*) varz */
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcStringBindingParse');

 %end; /* RPC_UNICODE_SUPPORTED */

 /* client/server */

 %if RPC_UNICODE_SUPPORTED ^= '' %then %do;

 dcl RpcStringFreeA
     entry (pointer byaddr) /* to char(*) varz */
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcStringFreeA');

 dcl RpcStringFreeW
     entry (pointer byaddr) /* to WCHAR(*) varz */
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcStringFreeW');

 %dcl RpcStringFree char ext;
 %if UNICODE ^= '' %then %do;
   %RpcStringFree='RpcStringFreeW';
 %end; %else %do;
   %RpcStringFree='RpcStringFreeA';
 %end; /* UNICODE */

 %end; %else %do;

 dcl RpcStringFree
     entry (pointer byaddr) /* to char(*) varz */
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcStringFree');

 %end; /* RPC_UNICODE_SUPPORTED */

 /* client/server */
 dcl RpcIfInqId
     entry (type RPC_IF_HANDLE,
            type RPC_IF_ID byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcIfInqId');

 /* client/server */

 %if RPC_UNICODE_SUPPORTED ^= '' %then %do;

 dcl RpcNetworkIsProtseqValidA
     entry (char(*) varz byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcNetworkIsProtseqValidA');

 dcl RpcNetworkIsProtseqValidW
     entry (WCHAR(*) varz byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcNetworkIsProtseqValidW');

 %dcl RpcNetworkIsProtseqValid char ext;
 %if UNICODE ^= '' %then %do;
   %RpcNetworkIsProtseqValid='RpcNetworkIsProtseqValidW';
 %end; %else %do;
   %RpcNetworkIsProtseqValid='RpcNetworkIsProtseqValidA';
 %end; /* UNICODE */

 %end; %else %do;

 dcl RpcNetworkIsProtseqValid
     entry (char(*) varz byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcNetworkIsProtseqValid');

 %end; /* RPC_UNICODE_SUPPORTED */

 /* client */
 dcl RpcMgmtInqComTimeout
     entry (type RPC_BINDING_HANDLE,
            fixed bin(31) byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcMgmtInqComTimeout');

 /* client */
 dcl RpcMgmtSetComTimeout
     entry (type RPC_BINDING_HANDLE,
            fixed bin(31))
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcMgmtSetComTimeout');

 /* client */
 dcl RpcMgmtSetCancelTimeout
     entry (fixed bin(31))
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcMgmtSetCancelTimeout');

 /* server */

 %if RPC_UNICODE_SUPPORTED ^= '' %then %do;

 dcl RpcNetworkInqProtseqsA
     entry (handle RPC_PROTSEQ_VECTORA byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcNetworkInqProtseqsA');

 dcl RpcNetworkInqProtseqsW
     entry (handle RPC_PROTSEQ_VECTORW byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcNetworkInqProtseqsW');

 %dcl RpcNetworkInqProtseqs char ext;
 %if UNICODE ^= '' %then %do;
   %RpcNetworkInqProtseqs='RpcNetworkInqProtseqsW';
 %end; %else %do;
   %RpcNetworkInqProtseqs='RpcNetworkInqProtseqsA';
 %end; /* UNICODE */

 %end; %else %do;

 dcl RpcNetworkInqProtseqs
     entry (handle RPC_PROTSEQ_VECTOR byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcNetworkInqProtseqs');

 %end; /* RPC_UNICODE_SUPPORTED */

 /* server */
 dcl RpcObjectInqType
     entry (type UUID byaddr,
            type UUID byaddr optional)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcObjectInqType');

 /* server */
 dcl RpcObjectSetInqFn
     entry (type RPC_OBJECT_INQ_FN)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcObjectSetInqFn');

 /* server */
 dcl RpcObjectSetType
     entry (type UUID byaddr,
            type UUID byaddr optional)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcObjectSetType');

 /* server */

 %if RPC_UNICODE_SUPPORTED ^= '' %then %do;

 dcl RpcProtseqVectorFreeA
     entry (handle RPC_PROTSEQ_VECTORA byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcProtseqVectorFreeA');

 dcl RpcProtseqVectorFreeW
     entry (handle RPC_PROTSEQ_VECTORW byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcProtseqVectorFreeW');

 %dcl RpcProtseqVectorFree char ext;
 %if UNICODE ^= '' %then %do;
   %RpcProtseqVectorFree='RpcProtseqVectorFreeW';
 %end; %else %do;
   %RpcProtseqVectorFree='RpcProtseqVectorFreeA';
 %end; /* UNICODE */

 %end; %else %do;

 dcl RpcProtseqVectorFree
     entry (handle RPC_PROTSEQ_VECTOR byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcProtseqVectorFree');

 %end; /* RPC_UNICODE_SUPPORTED */

 /* server */
 dcl RpcServerInqBindings
     entry (handle RPC_BINDING_VECTOR byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerInqBindings');

 /* server */
 dcl RpcServerInqIf
     entry (type RPC_IF_HANDLE,
            type UUID byaddr optional,
            pointer byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerInqIf');

 /* server */
 dcl RpcServerListen
     entry (fixed bin(31),
            fixed bin(31),
            fixed bin(31))
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerListen');

 /* server */
 dcl RpcServerRegisterIf
     entry (type RPC_IF_HANDLE,
            type UUID byaddr optional,
            pointer)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerRegisterIf');

 /* server */
 dcl RpcServerRegisterIfEx
     entry (type RPC_IF_HANDLE,
            type UUID byaddr optional,
            pointer,
            fixed bin(31),
            fixed bin(31),
            type RPC_IF_CALLBACK_FN)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerRegisterIfEx');

 /* server */
 dcl RpcServerRegisterIf2
     entry (type RPC_IF_HANDLE,
            type UUID byaddr optional,
            pointer,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            type RPC_IF_CALLBACK_FN)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerRegisterIf2');


 /* server */
 dcl RpcServerUnregisterIf
     entry (type RPC_IF_HANDLE,
            type UUID byaddr optional,
            fixed bin(31))
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerUnregisterIf');

 /* server */
 dcl RpcServerUseAllProtseqs
     entry (fixed bin(31),
            pointer)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerUseAllProtseqs');

 /* server */
 dcl RpcServerUseAllProtseqsEx
     entry (fixed bin(31),
            pointer,
            type PRPC_POLICY)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerUseAllProtseqsEx');

 /* server */
 dcl RpcServerUseAllProtseqsIf
     entry (fixed bin(31),
            type RPC_IF_HANDLE,
            pointer)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerUseAllProtseqsIf');

 /* server */
 dcl RpcServerUseAllProtseqsIfEx
     entry (fixed bin(31),
            type RPC_IF_HANDLE,
            pointer,
            type PRPC_POLICY)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerUseAllProtseqsIfEx');

 /* server */

 %if RPC_UNICODE_SUPPORTED ^= '' %then %do;

 dcl RpcServerUseProtseqA
     entry (char(*) varz byaddr,
            fixed bin(31),
            pointer)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerUseProtseqA');

 dcl RpcServerUseProtseqExA
     entry (char(*) varz byaddr,
            fixed bin(31),
            pointer,
            type PRPC_POLICY)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerUseProtseqExA');

 dcl RpcServerUseProtseqW
     entry (WCHAR(*) varz byaddr,
            fixed bin(31),
            pointer)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerUseProtseqW');

 dcl RpcServerUseProtseqExW
     entry (WCHAR(*) varz byaddr,
            fixed bin(31),
            pointer,
            type PRPC_POLICY)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerUseProtseqExW');

 %dcl RpcServerUseProtseq char ext;
 %dcl RpcServerUseProtseqEx char ext;
 %if UNICODE ^= '' %then %do;
   %RpcServerUseProtseq='RpcServerUseProtseqW';
   %RpcServerUseProtseqEx='RpcServerUseProtseqExW';
 %end; %else %do;
   %RpcServerUseProtseq='RpcServerUseProtseqA';
   %RpcServerUseProtseqEx='RpcServerUseProtseqExA';
 %end; /* UNICODE */

 %end; %else %do;

 dcl RpcServerUseProtseq
     entry (char(*) varz byaddr,
            fixed bin(31),
            pointer)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerUseProtseq');

 dcl RpcServerUseProtseqEx
     entry (char(*) varz byaddr,
            fixed bin(31),
            pointer,
            type PRPC_POLICY)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerUseProtseqEx');

 %end; /* RPC_UNICODE_SUPPORTED */

 /* server */

 %if RPC_UNICODE_SUPPORTED ^= '' %then %do;

 dcl RpcServerUseProtseqEpA
     entry (char(*) varz byaddr,
            fixed bin(31),
            char(*) varz byaddr,
            pointer)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerUseProtseqEpA');

 dcl RpcServerUseProtseqEpExA
     entry (char(*) varz byaddr,
            fixed bin(31),
            char(*) varz byaddr,
            pointer,
            type PRPC_POLICY)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerUseProtseqEpExA');

 dcl RpcServerUseProtseqEpW
     entry (WCHAR(*) varz byaddr,
            fixed bin(31),
            WCHAR(*) varz byaddr,
            pointer)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerUseProtseqEpW');

 dcl RpcServerUseProtseqEpExW
     entry (WCHAR(*) varz byaddr,
            fixed bin(31),
            WCHAR(*) varz byaddr,
            pointer,
            type PRPC_POLICY)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerUseProtseqEpExW');

 %dcl RpcServerUseProtseqEp char ext;
 %dcl RpcServerUseProtseqEpEx char ext;
 %if UNICODE ^= '' %then %do;
   %RpcServerUseProtseqEp='RpcServerUseProtseqEpW';
   %RpcServerUseProtseqEpEx='RpcServerUseProtseqEpExW';
 %end; %else %do;
   %RpcServerUseProtseqEp='RpcServerUseProtseqEpA';
   %RpcServerUseProtseqEpEx='RpcServerUseProtseqEpExA';
 %end; /* UNICODE */

 %end; %else %do;

 dcl RpcServerUseProtseqEp
     entry (char(*) varz byaddr,
            fixed bin(31),
            char(*) varz byaddr,
            pointer)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerUseProtseqEp');

 dcl RpcServerUseProtseqEpEx
     entry (char(*) varz byaddr,
            fixed bin(31),
            char(*) varz byaddr,
            pointer,
            type PRPC_POLICY)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerUseProtseqEpEx');

 %end; /* RPC_UNICODE_SUPPORTED */

 /* server */

 %if RPC_UNICODE_SUPPORTED ^= '' %then %do;

 dcl RpcServerUseProtseqIfA
     entry (char(*) varz byaddr,
            fixed bin(31),
            type RPC_IF_HANDLE,
            pointer)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerUseProtseqIfA');

 dcl RpcServerUseProtseqIfExA
     entry (char(*) varz byaddr,
            fixed bin(31),
            type RPC_IF_HANDLE,
            pointer,
            type PRPC_POLICY)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerUseProtseqIfExA');

 dcl RpcServerUseProtseqIfW
     entry (WCHAR(*) varz byaddr,
            fixed bin(31),
            type RPC_IF_HANDLE,
            pointer)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerUseProtseqIfW');

 dcl RpcServerUseProtseqIfExW
     entry (WCHAR(*) varz byaddr,
            fixed bin(31),
            type RPC_IF_HANDLE,
            pointer,
            type PRPC_POLICY)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerUseProtseqIfExW');

 %dcl RpcServerUseProtseqIf char ext;
 %dcl RpcServerUseProtseqIfEx char ext;
 %if UNICODE ^= '' %then %do;
   %RpcServerUseProtseqIf='RpcServerUseProtseqIfW';
   %RpcServerUseProtseqIfEx='RpcServerUseProtseqIfExW';
 %end; %else %do;
   %RpcServerUseProtseqIf='RpcServerUseProtseqIfA';
   %RpcServerUseProtseqIfEx='RpcServerUseProtseqIfExA';
 %end; /* UNICODE */

 %end; %else %do;

 dcl RpcServerUseProtseqIf
     entry (char(*) varz byaddr,
            fixed bin(31),
            type RPC_IF_HANDLE,
            pointer)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerUseProtseqIf');

 dcl RpcServerUseProtseqIfEx
     entry (char(*) varz byaddr,
            fixed bin(31),
            type RPC_IF_HANDLE,
            pointer,
            type PRPC_POLICY)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerUseProtseqIfEx');

 %end; /* RPC_UNICODE_SUPPORTED */

 /* server */
 dcl RpcMgmtStatsVectorFree
     entry (type RPC_STATS_VECTOR byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcMgmtStatsVectorFree');

 /* server */
 dcl RpcMgmtInqStats
     entry (type RPC_BINDING_HANDLE,
            type RPC_STATS_VECTOR byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcMgmtInqStats');

 /* server */
 dcl RpcMgmtIsServerListening
     entry (type RPC_BINDING_HANDLE)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcMgmtIsServerListening');

 /* server */
 dcl RpcMgmtStopServerListening
     entry (type RPC_BINDING_HANDLE)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcMgmtStopServerListening');

 /* server */
 dcl RpcMgmtWaitServerListen
     entry ()
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcMgmtWaitServerListen');

 /* server */
 dcl RpcMgmtSetServerStackSize
     entry (fixed bin(31))
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcMgmtSetServerStackSize');

 /* server */
 dcl RpcSsDontSerializeContext
     entry ()
     RPCRTAPI RPC_ENTRY external('RpcSsDontSerializeContext');

 /* client */
 dcl RpcMgmtEnableIdleCleanup
     entry ()
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcMgmtEnableIdleCleanup');

 dcl RpcMgmtInqIfIds
     entry (type RPC_BINDING_HANDLE,
            handle RPC_IF_ID_VECTOR byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcMgmtInqIfIds');

 dcl RpcIfIdVectorFree
     entry (handle RPC_IF_ID_VECTOR byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcIfIdVectorFree');

 %if RPC_UNICODE_SUPPORTED ^= '' %then %do;

 dcl RpcMgmtInqServerPrincNameA
     entry (type RPC_BINDING_HANDLE,
            fixed bin(31),
            pointer byaddr) /* to char(*) varz */
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcMgmtInqServerPrincNameA');

 dcl RpcMgmtInqServerPrincNameW
     entry (type RPC_BINDING_HANDLE,
            fixed bin(31),
            pointer byaddr) /* to WCHAR(*) varz */
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcMgmtInqServerPrincNameW');

 %dcl RpcMgmtInqServerPrincName char ext;
 %if UNICODE ^= '' %then %do;
   %RpcMgmtInqServerPrincName='RpcMgmtInqServerPrincNameW';
 %end; %else %do;
   %RpcMgmtInqServerPrincName='RpcMgmtInqServerPrincNameA';
 %end; /* UNICODE */

 %end; %else %do;

 dcl RpcMgmtInqServerPrincName
     entry (type RPC_BINDING_HANDLE,
            fixed bin(31),
            pointer byaddr) /* to char(*) varz */
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcMgmtInqServerPrincName');

 %end; /* RPC_UNICODE_SUPPORTED */


 %if RPC_UNICODE_SUPPORTED ^= '' %then %do;

 dcl RpcServerInqDefaultPrincNameA
     entry (fixed bin(31),
            pointer byaddr) /* to char(*) varz */
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerInqDefaultPrincNameA');

 dcl RpcServerInqDefaultPrincNameW
     entry (fixed bin(31),
            pointer byaddr) /* to WCHAR(*) varz */
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerInqDefaultPrincNameW');

 %dcl RpcServerInqDefaultPrincName char ext;
 %if UNICODE ^= '' %then %do;
   %RpcServerInqDefaultPrincName='RpcServerInqDefaultPrincNameW';
 %end; %else %do;
   %RpcServerInqDefaultPrincName='RpcServerInqDefaultPrincNameA';
 %end; /* UNICODE */

 %end; %else %do;

 dcl RpcServerInqDefaultPrincName
     entry (fixed bin(31),
            pointer byaddr) /* to char(*) varz */
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerInqDefaultPrincName');

 %end; /* RPC_UNICODE_SUPPORTED */

 /* client */
 dcl RpcEpResolveBinding
     entry (type RPC_BINDING_HANDLE,
            type RPC_IF_HANDLE)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcEpResolveBinding');

 /* client */

 %if RPC_UNICODE_SUPPORTED ^= '' %then %do;

 dcl RpcNsBindingInqEntryNameA
     entry (type RPC_BINDING_HANDLE,
            fixed bin(31),
            pointer byaddr) /* to char(*) varz */
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcNsBindingInqEntryNameA');

 dcl RpcNsBindingInqEntryNameW
     entry (type RPC_BINDING_HANDLE,
            fixed bin(31),
            pointer byaddr) /* to WCHAR(*) varz */
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcNsBindingInqEntryNameW');

 %dcl RpcNsBindingInqEntryName char ext;
 %if UNICODE ^= '' %then %do;
   %RpcNsBindingInqEntryName='RpcNsBindingInqEntryNameW';
 %end; %else %do;
   %RpcNsBindingInqEntryName='RpcNsBindingInqEntryNameA';
 %end; /* UNICODE */

 %end; %else %do;

 dcl RpcNsBindingInqEntryName
     entry (type RPC_BINDING_HANDLE,
            fixed bin(31),
            pointer byaddr) /* to char(*) varz */
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcNsBindingInqEntryName');

 %end; /* RPC_UNICODE_SUPPORTED */

 define alias RPC_AUTH_IDENTITY_HANDLE pointer;
 define alias RPC_AUTHZ_HANDLE         pointer;

 dcl RPC_C_AUTHN_LEVEL_DEFAULT            fixed bin(31) value(0);
 dcl RPC_C_AUTHN_LEVEL_NONE               fixed bin(31) value(1);
 dcl RPC_C_AUTHN_LEVEL_CONNECT            fixed bin(31) value(2);
 dcl RPC_C_AUTHN_LEVEL_CALL               fixed bin(31) value(3);
 dcl RPC_C_AUTHN_LEVEL_PKT                fixed bin(31) value(4);
 dcl RPC_C_AUTHN_LEVEL_PKT_INTEGRITY      fixed bin(31) value(5);
 dcl RPC_C_AUTHN_LEVEL_PKT_PRIVACY        fixed bin(31) value(6);

 dcl RPC_C_IMP_LEVEL_DEFAULT              fixed bin(31) value(0);
 dcl RPC_C_IMP_LEVEL_ANONYMOUS            fixed bin(31) value(1);
 dcl RPC_C_IMP_LEVEL_IDENTIFY             fixed bin(31) value(2);
 dcl RPC_C_IMP_LEVEL_IMPERSONATE          fixed bin(31) value(3);
 dcl RPC_C_IMP_LEVEL_DELEGATE             fixed bin(31) value(4);

 dcl RPC_C_QOS_IDENTITY_STATIC            fixed bin(31) value(0);
 dcl RPC_C_QOS_IDENTITY_DYNAMIC           fixed bin(31) value(1);

 dcl RPC_C_QOS_CAPABILITIES_DEFAULT       fixed bin(31) value(0);
 dcl RPC_C_QOS_CAPABILITIES_MUTUAL_AUTH   fixed bin(31) value(1);
 dcl RPC_C_QOS_CAPABILITIES_MAKE_FULLSIC  fixed bin(31) value(2);
 dcl RPC_C_QOS_CAPABILITIES_ANY_AUTHORITY fixed bin(31) value(4);

 dcl RPC_C_PROTECT_LEVEL_DEFAULT          fixed bin(31)
     value(RPC_C_AUTHN_LEVEL_DEFAULT);
 dcl RPC_C_PROTECT_LEVEL_NONE             fixed bin(31)
     value(RPC_C_AUTHN_LEVEL_NONE);
 dcl RPC_C_PROTECT_LEVEL_CONNECT          fixed bin(31)
     value(RPC_C_AUTHN_LEVEL_CONNECT);
 dcl RPC_C_PROTECT_LEVEL_CALL             fixed bin(31)
     value(RPC_C_AUTHN_LEVEL_CALL);
 dcl RPC_C_PROTECT_LEVEL_PKT              fixed bin(31)
     value(RPC_C_AUTHN_LEVEL_PKT);
 dcl RPC_C_PROTECT_LEVEL_PKT_INTEGRITY    fixed bin(31)
     value(RPC_C_AUTHN_LEVEL_PKT_INTEGRITY);
 dcl RPC_C_PROTECT_LEVEL_PKT_PRIVACY      fixed bin(31)
     value(RPC_C_AUTHN_LEVEL_PKT_PRIVACY);

 dcl RPC_C_AUTHN_NONE                 fixed bin(31) value(0);
 dcl RPC_C_AUTHN_DCE_PRIVATE          fixed bin(31) value(1);
 dcl RPC_C_AUTHN_DCE_PUBLIC           fixed bin(31) value(2);
 dcl RPC_C_AUTHN_DEC_PUBLIC           fixed bin(31) value(4);
 dcl RPC_C_AUTHN_GSS_NEGOTIATE        fixed bin(31) value(9);
 dcl RPC_C_AUTHN_WINNT                fixed bin(31) value(10);
 dcl RPC_C_AUTHN_GSS_SCHANNEL         fixed bin(31) value(14);
 dcl RPC_C_AUTHN_GSS_KERBEROS         fixed bin(31) value(16);
 dcl RPC_C_AUTHN_MSN                  fixed bin(31) value(17);
 dcl RPC_C_AUTHN_DPA                  fixed bin(31) value(18);
 dcl RPC_C_AUTHN_MQ                   fixed bin(31) value(100);
 dcl RPC_C_AUTHN_DEFAULT              fixed bin(31) value('FFFFFFFF'xn);


 dcl RPC_C_SECURITY_QOS_VERSION       fixed bin(31) value(1);

 define structure
   1 RPC_SECURITY_QOS,
     2 Version           fixed bin(31) ,
     2 Capabilities      fixed bin(31) ,
     2 IdentityTracking  fixed bin(31) ,
     2 ImpersonationType fixed bin(31) ;
 define alias PRPC_SECURITY_QOS handle RPC_SECURITY_QOS;

 dcl SEC_WINNT_AUTH_IDENTITY_ANSI    fixed bin(15) value('1'xn);
 dcl SEC_WINNT_AUTH_IDENTITY_UNICODE fixed bin(15) value('2'xn);

 define structure
   1 SEC_WINNT_AUTH_IDENTITY_W,
     2 User           pointer,        /* to WCHAR(*) varz */
     2 UserLength     fixed bin(31),
     2 Domain         pointer,        /* to WCHAR(*) varz */
     2 DomainLength   fixed bin(31),
     2 Password       pointer,        /* to WCHAR(*) varz */
     2 PasswordLength fixed bin(31),
     2 Flags          fixed bin(31);
 define alias PSEC_WINNT_AUTH_IDENTITY_W
        handle SEC_WINNT_AUTH_IDENTITY_W;

 define structure
   1 SEC_WINNT_AUTH_IDENTITY_A,
     2 User           pointer,        /* to char(*) varz */
     2 UserLength     fixed bin(31),
     2 Domain         pointer,        /* to char(*) varz */
     2 DomainLength   fixed bin(31),
     2 Password       pointer,        /* to char(*) varz */
     2 PasswordLength fixed bin(31),
     2 Flags          fixed bin(31);

 define alias PSEC_WINNT_AUTH_IDENTITY_A
        handle SEC_WINNT_AUTH_IDENTITY_A;


 %if UNICODE ^= '' %then %do;
 define alias  SEC_WINNT_AUTH_IDENTITY type  SEC_WINNT_AUTH_IDENTITY_W;
 define alias PSEC_WINNT_AUTH_IDENTITY type PSEC_WINNT_AUTH_IDENTITY_W;
 %end; %else %do;
 define alias  SEC_WINNT_AUTH_IDENTITY type  SEC_WINNT_AUTH_IDENTITY_A;
 define alias PSEC_WINNT_AUTH_IDENTITY type PSEC_WINNT_AUTH_IDENTITY_A;
 %end; /* UNICODE */

 dcl RPC_C_AUTHZ_NONE    fixed bin(31) value(0);
 dcl RPC_C_AUTHZ_NAME    fixed bin(31) value(1);
 dcl RPC_C_AUTHZ_DCE     fixed bin(31) value(2);
 dcl RPC_C_AUTHZ_DEFAULT fixed bin(31) value('ffffffff'xn);


 dcl RpcImpersonateClient
     entry (type RPC_BINDING_HANDLE)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcImpersonateClient');

 dcl RpcRevertToSelfEx
     entry (type RPC_BINDING_HANDLE)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcRevertToSelfEx');

 dcl RpcRevertToSelf
     entry ()
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcRevertToSelf');

 %if RPC_UNICODE_SUPPORTED ^= '' %then %do;

 dcl RpcBindingInqAuthClientA
     entry (type RPC_BINDING_HANDLE,
            type RPC_AUTHZ_HANDLE byaddr,
            pointer byaddr optional, /* to char(*) varz */
            fixed bin(31) byaddr optional,
            fixed bin(31) byaddr optional,
            fixed bin(31) byaddr optional)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcBindingInqAuthClientA');

 dcl RpcBindingInqAuthClientW
     entry (type RPC_BINDING_HANDLE,
            type RPC_AUTHZ_HANDLE byaddr,
            pointer byaddr optional, /* to WCHAR(*) varz */
            fixed bin(31) byaddr optional,
            fixed bin(31) byaddr optional,
            fixed bin(31) byaddr optional)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcBindingInqAuthClientW');

 dcl RpcBindingInqAuthClientExA
     entry (type RPC_BINDING_HANDLE,
            type RPC_AUTHZ_HANDLE byaddr,
            pointer byaddr optional, /* to char(*) varz */
            fixed bin(31) byaddr optional,
            fixed bin(31) byaddr optional,
            fixed bin(31) byaddr optional,
            fixed bin(31))
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcBindingInqAuthClientExA');

 dcl RpcBindingInqAuthClientExW
     entry (type RPC_BINDING_HANDLE,
            type RPC_AUTHZ_HANDLE byaddr,
            pointer byaddr optional, /* to WCHAR(*) varz */
            fixed bin(31) byaddr optional,
            fixed bin(31) byaddr optional,
            fixed bin(31) byaddr optional,
            fixed bin(31))
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcBindingInqAuthClientExW');

 dcl RpcBindingInqAuthInfoA
     entry (type RPC_BINDING_HANDLE,
            pointer byaddr optional, /* to char(*) varz */
            fixed bin(31) byaddr optional,
            fixed bin(31) byaddr optional,
            type RPC_AUTH_IDENTITY_HANDLE byaddr optional,
            fixed bin(31) byaddr optional)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcBindingInqAuthInfoA');

 dcl RpcBindingInqAuthInfoW
     entry (type RPC_BINDING_HANDLE,
            pointer byaddr optional, /* to WCHAR(*) varz */
            fixed bin(31) byaddr optional,
            fixed bin(31) byaddr optional,
            type RPC_AUTH_IDENTITY_HANDLE byaddr optional,
            fixed bin(31) byaddr optional)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcBindingInqAuthInfoW');

 dcl RpcBindingSetAuthInfoA
     entry (type RPC_BINDING_HANDLE,
            char(*) varz byaddr,
            fixed bin(31),
            fixed bin(31),
            type RPC_AUTH_IDENTITY_HANDLE,
            fixed bin(31))
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcBindingSetAuthInfoA');

 dcl RpcBindingSetAuthInfoExA
     entry (type RPC_BINDING_HANDLE,
            char(*) varz byaddr,
            fixed bin(31),
            fixed bin(31),
            type RPC_AUTH_IDENTITY_HANDLE,
            fixed bin(31),
            type RPC_SECURITY_QOS byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcBindingSetAuthInfoExA');

 dcl RpcBindingSetAuthInfoW
     entry (type RPC_BINDING_HANDLE,
            WCHAR(*) varz byaddr,
            fixed bin(31),
            fixed bin(31),
            type RPC_AUTH_IDENTITY_HANDLE,
            fixed bin(31))
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcBindingSetAuthInfoW');

 dcl RpcBindingSetAuthInfoExW
     entry (type RPC_BINDING_HANDLE,
            WCHAR(*) varz byaddr,
            fixed bin(31),
            fixed bin(31),
            type RPC_AUTH_IDENTITY_HANDLE,
            fixed bin(31),
            type RPC_SECURITY_QOS byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcBindingSetAuthInfoExW');

 dcl RpcBindingInqAuthInfoExA
     entry (type RPC_BINDING_HANDLE,
            pointer byaddr optional, /* to char(*) varz */
            fixed bin(31) byaddr optional,
            fixed bin(31) byaddr optional,
            type RPC_AUTH_IDENTITY_HANDLE byaddr optional,
            fixed bin(31) byaddr optional,
            fixed bin(31),
            type RPC_SECURITY_QOS byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcBindingInqAuthInfoExA');

 dcl RpcBindingInqAuthInfoExW
     entry (type RPC_BINDING_HANDLE,
            pointer byaddr optional, /* to WCHAR(*) varz */
            fixed bin(31) byaddr optional,
            fixed bin(31) byaddr optional,
            type RPC_AUTH_IDENTITY_HANDLE byaddr optional,
            fixed bin(31) byaddr optional,
            fixed bin(31),
            type RPC_SECURITY_QOS byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcBindingInqAuthInfoExW');

 define alias RPC_AUTH_KEY_RETRIEVAL_FN
        entry (pointer,
               pointer, /* to WCHAR (*) varz */
               fixed bin(31),
               pointer byaddr,
               type RPC_STATUS byaddr)
        limited #_RPC_USER;

 dcl RpcServerRegisterAuthInfoA
     entry (char(*) varz byaddr,
            fixed bin(31),
            type RPC_AUTH_KEY_RETRIEVAL_FN byvalue optional,
            pointer)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerRegisterAuthInfoA');

 dcl RpcServerRegisterAuthInfoW
     entry (WCHAR(*) varz byaddr,
            fixed bin(31),
            type RPC_AUTH_KEY_RETRIEVAL_FN byvalue optional,
            pointer)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerRegisterAuthInfoW');

 %dcl RpcBindingInqAuthClient char ext;
 %dcl RpcBindingInqAuthClientEx char ext;
 %dcl RpcBindingInqAuthInfo char ext;
 %dcl RpcBindingSetAuthInfo char ext;
 %dcl RpcServerRegisterAuthInfo char ext;
 %dcl RpcBindingInqAuthInfoEx char ext;
 %dcl RpcBindingSetAuthInfoEx char ext;
 %if UNICODE ^= '' %then %do;
   %RpcBindingInqAuthClient='RpcBindingInqAuthClientW';
   %RpcBindingInqAuthClientEx='RpcBindingInqAuthClientExW';
   %RpcBindingInqAuthInfo='RpcBindingInqAuthInfoW';
   %RpcBindingSetAuthInfo='RpcBindingSetAuthInfoW';
   %RpcServerRegisterAuthInfo='RpcServerRegisterAuthInfoW';
   %RpcBindingInqAuthInfoEx='RpcBindingInqAuthInfoExW';
   %RpcBindingSetAuthInfoEx='RpcBindingSetAuthInfoExW';
 %end; %else %do;
   %RpcBindingInqAuthClient='RpcBindingInqAuthClientA';
   %RpcBindingInqAuthClientEx='RpcBindingInqAuthClientExA';
   %RpcBindingInqAuthInfo='RpcBindingInqAuthInfoA';
   %RpcBindingSetAuthInfo='RpcBindingSetAuthInfoA';
   %RpcServerRegisterAuthInfo='RpcServerRegisterAuthInfoA';
   %RpcBindingInqAuthInfoEx='RpcBindingInqAuthInfoExA';
   %RpcBindingSetAuthInfoEx='RpcBindingSetAuthInfoExA';
 %end; /* UNICODE */

 %end; %else %do;

 dcl RpcBindingInqAuthClient
     entry (type RPC_BINDING_HANDLE,
            type RPC_AUTHZ_HANDLE byaddr,
            pointer byaddr optional, /* to char(*) varz */
            fixed bin(31) byaddr optional,
            fixed bin(31) byaddr optional,
            fixed bin(31) byaddr optional)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcBindingInqAuthClient');

 dcl RpcBindingInqAuthClientEx
     entry (type RPC_BINDING_HANDLE,
            type RPC_AUTHZ_HANDLE byaddr,
            pointer byaddr optional, /* to char(*) varz */
            fixed bin(31) byaddr optional,
            fixed bin(31) byaddr optional,
            fixed bin(31) byaddr optional,
            fixed bin(31))
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcBindingInqAuthClientEx');

 dcl RpcBindingInqAuthInfo
     entry (type RPC_BINDING_HANDLE,
            pointer byaddr optional, /* to char(*) varz */
            fixed bin(31) byaddr optional,
            fixed bin(31) byaddr optional,
            type RPC_AUTH_IDENTITY_HANDLE byaddr optional,
            fixed bin(31) byaddr optional)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcBindingInqAuthInfo');

 dcl RpcBindingSetAuthInfo
     entry (type RPC_BINDING_HANDLE,
            char (*) varz byaddr,
            fixed bin(31),
            fixed bin(31),
            type RPC_AUTH_IDENTITY_HANDLE,
            fixed bin(31))
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcBindingSetAuthInfo');

 define alias RPC_AUTH_KEY_RETRIEVAL_FN
        entry (pointer,
               pointer, /* to char (*) varz */
               fixed bin(31),
               pointer byaddr,
               type RPC_STATUS byaddr)
        limited #_RPC_USER;

 dcl RpcServerRegisterAuthInfo
     entry (char(*) varz byaddr,
            fixed bin(31),
            type RPC_AUTH_KEY_RETRIEVAL_FN,
            pointer)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerRegisterAuthInfo');

 %end; /* RPC_UNICODE_SUPPORTED */

 define structure
   1 RPC_CLIENT_INFORMATION1,
     2 UserName     pointer, /* to char (*) varz */
     2 ComputerName pointer, /* to char (*) varz */
     2 Privilege    unsigned fixed bin(16) ,
     2 AuthFlags    fixed bin(31);
 define alias PRPC_CLIENT_INFORMATION1 handle RPC_CLIENT_INFORMATION1;


 dcl RpcBindingServerFromClient
     entry (type RPC_BINDING_HANDLE,
            type RPC_BINDING_HANDLE byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcBindingServerFromClient');

 dcl RpcRaiseException
     entry (type RPC_STATUS)
     RPCRTAPI RPC_ENTRY external('RpcRaiseException');

 dcl RpcTestCancel
     entry ()
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcTestCancel');

 dcl RpcServerTestCancel
     entry (type RPC_BINDING_HANDLE)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcServerTestCancel');

 dcl RpcCancelThread
     entry (pointer)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcCancelThread');

 dcl RpcCancelThreadEx
     entry (pointer,
            fixed bin(31))
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcCancelThreadEx');

 /* client/server */
 dcl UuidCreate
     entry (type UUID byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('UuidCreate');

 %if RPC_UNICODE_SUPPORTED ^= '' %then %do;

 /* client/server */
 dcl UuidToStringA
     entry (type UUID byaddr,
            pointer byaddr) /* to char(*) varz */
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('UuidToStringA');

 /* client/server */
 dcl UuidFromStringA
     entry (char(*) varz byaddr,
            type UUID byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('UuidFromStringA');

 /* client/server */
 dcl UuidToStringW
     entry (type UUID byaddr,
            pointer byaddr) /* to WCHAR(*) varz */
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('UuidToStringW');

 /* client/server */
 dcl UuidFromStringW
     entry (WCHAR(*) varz byaddr,
            type UUID byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('UuidFromStringW');

 %dcl UuidFromString char ext;
 %dcl UuidToString char ext;
 %if UNICODE ^= '' %then %do;
   %UuidFromString='UuidFromStringW';
   %UuidToString='UuidToStringW';
 %end; %else %do;
   %UuidFromString='UuidFromStringA';
   %UuidToString='UuidToStringA';
 %end; /* UNICODE */

 %end; %else %do;

 /* client/server */

 dcl UuidToString
     entry (type UUID byaddr,
            pointer byaddr) /* to char(*) varz */
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('UuidToString');

 /* client/server */
 dcl UuidFromString
     entry (char(*) varz byaddr,
            type UUID byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('UuidFromString');

 %end; /* RPC_UNICODE_SUPPORTED */

 dcl UuidCompare
     entry (type UUID byaddr,
            type UUID byaddr,
            type RPC_STATUS byaddr)
     returns (signed fixed bin(31) byvalue optional)
     RPCRTAPI RPC_ENTRY external('UuidCompare');

 dcl UuidCreateNil
     entry (type UUID byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('UuidCreateNil');

 dcl UuidEqual
     entry (type UUID byaddr,
            type UUID byaddr,
            type RPC_STATUS byaddr)
     returns (fixed bin(31) byvalue optional)
     RPCRTAPI RPC_ENTRY external('UuidEqual');

 dcl UuidHash
     entry (type UUID byaddr,
            type RPC_STATUS byaddr)
     returns (unsigned fixed bin(16) byvalue optional)
     RPCRTAPI RPC_ENTRY external('UuidHash');

 dcl UuidIsNil
     entry (type UUID byaddr,
            type RPC_STATUS byaddr)
     returns (fixed bin(31) byvalue optional)
     RPCRTAPI RPC_ENTRY external('UuidIsNil');

 %if RPC_UNICODE_SUPPORTED ^= '' %then %do;

 dcl RpcEpRegisterNoReplaceA
     entry (type RPC_IF_HANDLE,
            type RPC_BINDING_VECTOR byaddr,
            type UUID_VECTOR byaddr,
            char(*) varz byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcEpRegisterNoReplaceA');

 dcl RpcEpRegisterNoReplaceW
     entry (type RPC_IF_HANDLE,
            type RPC_BINDING_VECTOR byaddr,
            type UUID_VECTOR byaddr,
            WCHAR(*) varz byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcEpRegisterNoReplaceW');

 dcl RpcEpRegisterA
     entry (type RPC_IF_HANDLE,
            type RPC_BINDING_VECTOR byaddr,
            type UUID_VECTOR byaddr,
            char(*) varz byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcEpRegisterA');

 dcl RpcEpRegisterW
     entry (type RPC_IF_HANDLE,
            type RPC_BINDING_VECTOR byaddr,
            type UUID_VECTOR byaddr,
            WCHAR(*) varz byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcEpRegisterW');

 %dcl RpcEpRegisterNoReplace char ext;
 %dcl RpcEpRegister char ext;
 %if UNICODE ^= '' %then %do;
   %RpcEpRegisterNoReplace='RpcEpRegisterNoReplaceW';
   %RpcEpRegister='RpcEpRegisterW';
 %end; %else %do;
   %RpcEpRegisterNoReplace='RpcEpRegisterNoReplaceA';
   %RpcEpRegister='RpcEpRegisterA';
 %end; /* UNICODE */

 %end; %else %do;

 dcl RpcEpRegisterNoReplace
     entry (type RPC_IF_HANDLE,
            type RPC_BINDING_VECTOR byaddr,
            type UUID_VECTOR byaddr,
            char(*) varz byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcEpRegisterNoReplace');

 dcl RpcEpRegister
     entry (type RPC_IF_HANDLE,
            type RPC_BINDING_VECTOR byaddr,
            type UUID_VECTOR byaddr,
            char(*) varz byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcEpRegister');

 %end; /* RPC_UNICODE_SUPPORTED */

 dcl RpcEpUnregister
     entry (type RPC_IF_HANDLE,
            type RPC_BINDING_VECTOR byaddr,
            type UUID_VECTOR byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcEpUnregister');

 %if RPC_UNICODE_SUPPORTED ^= '' %then %do;

 dcl DceErrorInqTextA
     entry (type RPC_STATUS,
            char (*) varz byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('DceErrorInqTextA');

 dcl DceErrorInqTextW
     entry (type RPC_STATUS,
            WCHAR (*) varz byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('DceErrorInqTextW');

 %dcl DceErrorInqText char ext;
 %if UNICODE ^= '' %then %do;
   %DceErrorInqText='DceErrorInqTextW';
 %end; %else %do;
   %DceErrorInqText='DceErrorInqTextA';
 %end; /* UNICODE */

 %end; %else %do;

 dcl DceErrorInqText
     entry (type RPC_STATUS,
            char (*) varz byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('DceErrorInqText');

 %end; /* RPC_UNICODE_SUPPORTED */

 dcl DCE_C_ERROR_STRING_LEN fixed bin(31) value(256);

 define alias RPC_EP_INQ_HANDLE pointer; /* to I_RPC_HANDLE */

 dcl RPC_C_EP_ALL_ELTS      fixed bin(31) value(0);
 dcl RPC_C_EP_MATCH_BY_IF   fixed bin(31) value(1);
 dcl RPC_C_EP_MATCH_BY_OBJ  fixed bin(31) value(2);
 dcl RPC_C_EP_MATCH_BY_BOTH fixed bin(31) value(3);

 dcl RPC_C_VERS_ALL         fixed bin(31) value(1);
 dcl RPC_C_VERS_COMPATIBLE  fixed bin(31) value(2);
 dcl RPC_C_VERS_EXACT       fixed bin(31) value(3);
 dcl RPC_C_VERS_MAJOR_ONLY  fixed bin(31) value(4);
 dcl RPC_C_VERS_UPTO        fixed bin(31) value(5);


 dcl RpcMgmtEpEltInqBegin
     entry (type RPC_BINDING_HANDLE,
            fixed bin(31),
            type RPC_IF_ID byaddr optional,
            fixed bin(31),
            type UUID byaddr optional,
            type RPC_EP_INQ_HANDLE byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcMgmtEpEltInqBegin');


 dcl RpcMgmtEpEltInqDone
     entry (type RPC_EP_INQ_HANDLE byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcMgmtEpEltInqDone');

 %if RPC_UNICODE_SUPPORTED ^= '' %then %do;

 dcl RpcMgmtEpEltInqNextA
     entry (type RPC_EP_INQ_HANDLE,
            type RPC_IF_ID byaddr,
            type RPC_BINDING_HANDLE byaddr optional,
            type UUID byaddr optional,
            pointer byaddr optional)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcMgmtEpEltInqNextA');

 dcl RpcMgmtEpEltInqNextW
     entry (type RPC_EP_INQ_HANDLE,
            type RPC_IF_ID byaddr,
            type RPC_BINDING_HANDLE byaddr optional,
            type UUID byaddr optional,
            pointer byaddr optional)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcMgmtEpEltInqNextW');

 %dcl RpcMgmtEpEltInqNext char ext;
 %if UNICODE ^= '' %then %do;
   %RpcMgmtEpEltInqNext='RpcMgmtEpEltInqNextW';
 %end; %else %do;
   %RpcMgmtEpEltInqNext='RpcMgmtEpEltInqNextA';
 %end; /* UNICODE */

 %end; %else %do;

 dcl RpcMgmtEpEltInqNext
     entry (type RPC_EP_INQ_HANDLE,
            type RPC_IF_ID byaddr,
            type RPC_BINDING_HANDLE byaddr,
            pointer byaddr optional)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcMgmtEpEltInqNext');

 %end; /* RPC_UNICODE_SUPPORTED */

 dcl RpcMgmtEpUnregister
     entry (type RPC_BINDING_HANDLE,
            type RPC_IF_ID byaddr,
            type RPC_BINDING_HANDLE,
            type UUID byaddr optional)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcMgmtEpUnregister');

 define alias RPC_MGMT_AUTHORIZATION_FN
        entry (type RPC_BINDING_HANDLE,
               fixed bin(31),
               type RPC_STATUS byaddr)
        returns (fixed bin(31) byvalue optional)
        limited #_RPC_API;

 dcl RPC_C_MGMT_INQ_IF_IDS         fixed bin(31) value(0);
 dcl RPC_C_MGMT_INQ_PRINC_NAME     fixed bin(31) value(1);
 dcl RPC_C_MGMT_INQ_STATS          fixed bin(31) value(2);
 dcl RPC_C_MGMT_IS_SERVER_LISTEN   fixed bin(31) value(3);
 dcl RPC_C_MGMT_STOP_SERVER_LISTEN fixed bin(31) value(4);


 dcl RpcMgmtSetAuthorizationFn
     entry (type RPC_MGMT_AUTHORIZATION_FN)
     returns (type RPC_STATUS byvalue optional)
     RPCRTAPI RPC_ENTRY external('RpcMgmtSetAuthorizationFn');


 dcl RPC_C_PARM_MAX_PACKET_LENGTH   fixed bin(31) value(1);
 dcl RPC_C_PARM_BUFFER_LENGTH       fixed bin(31) value(2);

 dcl RPC_IF_AUTOLISTEN              fixed bin(15) value('0001'xn);
 dcl RPC_IF_OLE                     fixed bin(15) value('0002'xn);
 dcl RPC_IF_ALLOW_UNKNOWN_AUTHORITY fixed bin(15) value('0004'xn);
 dcl RPC_IF_ALLOW_SECURE_ONLY       fixed bin(15) value('0008'xn);

 %include rpcdcep;

 %end; /* __RPCDCE_H__ */
