 /*********************************************************************/
 /*                                                                   */
 /* winerror.cpy -- error code definitions for the Win32 API functions*/
 /*                                                                   */
 /* Copyright (c) 1991-1999, Microsoft Corp. All rights reserved.     */
 /*                                                                   */
 /*********************************************************************/


 %dcl #WINERROR_ char ext;
 %if #WINERROR_ = '' %then %do;
 %#WINERROR_ = 'Y';

 %dcl #WIN32 char ext;
 %if #WIN32 = '' %then %#WIN32 = 'Y'; /* always! */

 /* Values are 32 bit values layed out as follows:                    */
 /*                                                                   */
 /*  3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1                      */
 /*  1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0  */
 /* +---+-+-+-----------------------+-------------------------------+ */
 /* |Sev|C|R|     Facility          |               Code            | */
 /* +---+-+-+-----------------------+-------------------------------+ */
 /*                                                                   */
 /* where                                                             */
 /*      Sev - is the severity code                                   */
 /*          00 - Success                                             */
 /*          01 - Informational                                       */
 /*          10 - Warning                                             */
 /*          11 - Error                                               */
 /*      C - is the Customer code flag                                */
 /*      R - is a reserved bit                                        */
 /*      Facility - is the facility code                              */
 /*      Code - is the facility's status code                         */
 /*                                                                   */
 /* Define the facility codes                                         */

 dcl FACILITY_WINDOWS       fixed bin(16) unsigned value( 8);
 dcl FACILITY_STORAGE       fixed bin(16) unsigned value( 3);
 dcl FACILITY_SSPI          fixed bin(16) unsigned value( 9);
 dcl FACILITY_SCARD         fixed bin(16) unsigned value(16);
 dcl FACILITY_SETUPAPI      fixed bin(16) unsigned value(15);
 dcl FACILITY_SECURITY      fixed bin(16) unsigned value( 9);
 dcl FACILITY_RPC           fixed bin(16) unsigned value( 1);
 dcl FACILITY_WIN32         fixed bin(16) unsigned value( 7);
 dcl FACILITY_CONTROL       fixed bin(16) unsigned value(10);
 dcl FACILITY_NULL          fixed bin(16) unsigned value( 0);
 dcl FACILITY_MSMQ          fixed bin(16) unsigned value(14);
 dcl FACILITY_MEDIASERVER   fixed bin(16) unsigned value(13);
 dcl FACILITY_INTERNET      fixed bin(16) unsigned value(12);
 dcl FACILITY_ITF           fixed bin(16) unsigned value( 4);
 dcl FACILITY_DISPATCH      fixed bin(16) unsigned value( 2);
 dcl FACILITY_COMPLUS       fixed bin(16) unsigned value(17);
 dcl FACILITY_CERT          fixed bin(16) unsigned value(11);
 dcl FACILITY_AAF           fixed bin(16) unsigned value(18);

 /* Define the severity codes                                         */

 /* MessageId: ERROR_SUCCESS                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operation completed successfully.                            */
 /*                                                                   */
 dcl ERROR_SUCCESS                  fixed bin (31) value (0);
 dcl NO_ERROR                       fixed bin (31) value (0);
 dcl SEC_E_OK                       type HRESULT   value ('00000000'xn);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_FUNCTION                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Incorrect function.                                              */
 /*                                                                   */
 dcl ERROR_INVALID_FUNCTION                    fixed bin (31) value (1);

 /*                                                                   */
 /* MessageId: ERROR_FILE_NOT_FOUND                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system cannot find the file specified.                       */
 /*                                                                   */
 dcl ERROR_FILE_NOT_FOUND                        fixed bin(31) value(2);

 /*                                                                   */
 /* MessageId: ERROR_PATH_NOT_FOUND                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system cannot find the path specified.                       */
 /*                                                                   */
 dcl ERROR_PATH_NOT_FOUND                        fixed bin(31) value(3);

 /*                                                                   */
 /* MessageId: ERROR_TOO_MANY_OPEN_FILES                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system cannot open the file.                                 */
 /*                                                                   */
 dcl ERROR_TOO_MANY_OPEN_FILES                   fixed bin(31) value(4);

 /*                                                                   */
 /* MessageId: ERROR_ACCESS_DENIED                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Access is denied.                                                */
 /*                                                                   */
 dcl ERROR_ACCESS_DENIED                         fixed bin(31) value(5);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_HANDLE                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The handle is invalid.                                           */
 /*                                                                   */
 dcl ERROR_INVALID_HANDLE                        fixed bin(31) value(6);

 /*                                                                   */
 /* MessageId: ERROR_ARENA_TRASHED                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*  The storage control blocks were destroyed.                       */
 /*                                                                   */
 dcl ERROR_ARENA_TRASHED                         fixed bin(31) value(7);

 /*                                                                   */
 /* MessageId: ERROR_NOT_ENOUGH_MEMORY                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Not enough storage is available to process this command.         */
 /*                                                                   */
 dcl ERROR_NOT_ENOUGH_MEMORY                     fixed bin(31) value(8);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_BLOCK                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The storage control block address is invalid.                    */
 /*                                                                   */
 dcl ERROR_INVALID_BLOCK                         fixed bin(31) value(9);

 /*                                                                   */
 /* MessageId: ERROR_BAD_ENVIRONMENT                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The environment is incorrect.                                    */
 /*                                                                   */
 dcl ERROR_BAD_ENVIRONMENT                      fixed bin(31) value(10);

 /*                                                                   */
 /* MessageId: ERROR_BAD_FORMAT                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An attempt was made to load a program with an                    */
 /*  incorrect format.                                                */
 /*                                                                   */
 dcl ERROR_BAD_FORMAT                           fixed bin(31) value(11);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_ACCESS                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The access code is invalid.                                      */
 /*                                                                   */
 dcl ERROR_INVALID_ACCESS                       fixed bin(31) value(12);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_DATA                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The data is invalid.                                             */
 /*                                                                   */
 dcl ERROR_INVALID_DATA                         fixed bin(31) value(13);

 /*                                                                   */
 /* MessageId: ERROR_OUTOFMEMORY                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Not enough storage is available to complete this operation.      */
 /*                                                                   */
 dcl ERROR_OUTOFMEMORY                          fixed bin(31) value(14);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_DRIVE                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system cannot find the drive specified.                      */
 /*                                                                   */
 dcl ERROR_INVALID_DRIVE                        fixed bin(31) value(15);

 /*                                                                   */
 /* MessageId: ERROR_CURRENT_DIRECTORY                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The directory cannot be removed.                                 */
 /*                                                                   */
 dcl ERROR_CURRENT_DIRECTORY                    fixed bin(31) value(16);

 /*                                                                   */
 /* MessageId: ERROR_NOT_SAME_DEVICE                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system cannot move the file to a different disk drive.       */
 /*                                                                   */
 dcl ERROR_NOT_SAME_DEVICE                      fixed bin(31) value(17);

 /*                                                                   */
 /* MessageId: ERROR_NO_MORE_FILES                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There are no more files.                                         */
 /*                                                                   */
 dcl ERROR_NO_MORE_FILES                        fixed bin(31) value(18);

 /*                                                                   */
 /* MessageId: ERROR_WRITE_PROTECT                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The media is write protected.                                    */
 /*                                                                   */
 dcl ERROR_WRITE_PROTECT                        fixed bin(31) value(19);

 /*                                                                   */
 /* MessageId: ERROR_BAD_UNIT                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system cannot find the device specified.                     */
 /*                                                                   */
 dcl ERROR_BAD_UNIT                             fixed bin(31) value(20);

 /*                                                                   */
 /* MessageId: ERROR_NOT_READY                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The device is not ready.                                         */
 /*                                                                   */
 dcl ERROR_NOT_READY                            fixed bin(31) value(21);

 /*                                                                   */
 /* MessageId: ERROR_BAD_COMMAND                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The device does not recognize the command.                       */
 /*                                                                   */
 dcl ERROR_BAD_COMMAND                          fixed bin(31) value(22);

 /*                                                                   */
 /* MessageId: ERROR_CRC                                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Data error (cyclic redundancy check)                             */
 /*                                                                   */
 dcl ERROR_CRC                                  fixed bin(31) value(23);

 /*                                                                   */
 /* MessageId: ERROR_BAD_LENGTH                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The program issued a command but the command length is incorrect.*/
 /*                                                                   */
 dcl ERROR_BAD_LENGTH                           fixed bin(31) value(24);

 /*                                                                   */
 /* MessageId: ERROR_SEEK                                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The drive cannot locate a specific area or track on the disk.    */
 /*                                                                   */
 dcl ERROR_SEEK                                 fixed bin(31) value(25);

 /*                                                                   */
 /* MessageId: ERROR_NOT_DOS_DISK                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified disk or diskette cannot be accessed.               */
 /*                                                                   */
 dcl ERROR_NOT_DOS_DISK                         fixed bin(31) value(26);

 /*                                                                   */
 /* MessageId: ERROR_SECTOR_NOT_FOUND                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The drive cannot find the sector requested.                      */
 /*                                                                   */
 dcl ERROR_SECTOR_NOT_FOUND                     fixed bin(31) value(27);

 /*                                                                   */
 /* MessageId: ERROR_OUT_OF_PAPER                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The printer is out of paper.                                     */
 /*                                                                   */
 dcl ERROR_OUT_OF_PAPER                         fixed bin(31) value(28);

 /*                                                                   */
 /* MessageId: ERROR_WRITE_FAULT                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system cannot write to the specified device.                 */
 /*                                                                   */
 dcl ERROR_WRITE_FAULT                          fixed bin(31) value(29);

 /*                                                                   */
 /* MessageId: ERROR_READ_FAULT                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system cannot read from the specified device.                */
 /*                                                                   */
 dcl ERROR_READ_FAULT                           fixed bin(31) value(30);

 /*                                                                   */
 /* MessageId: ERROR_GEN_FAILURE                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A device attached to the system is not functioning.              */
 /*                                                                   */
 dcl ERROR_GEN_FAILURE                          fixed bin(31) value(31);

 /*                                                                   */
 /* MessageId: ERROR_SHARING_VIOLATION                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The process cannot access the file because                       */
 /*  it is being used by another process.                             */
 /*                                                                   */
 dcl ERROR_SHARING_VIOLATION                    fixed bin(31) value(32);

 /*                                                                   */
 /* MessageId: ERROR_LOCK_VIOLATION                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The process cannot access the file because                       */
 /*  another process has locked a portion of the file.                */
 /*                                                                   */
 dcl ERROR_LOCK_VIOLATION                       fixed bin(31) value(33);

 /*                                                                   */
 /* MessageId: ERROR_WRONG_DISK                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The wrong diskette is in the drive.                              */
 /*  Insert %2 (Volume Serial Number: %3) into drive %1.              */
 /*                                                                   */
 dcl ERROR_WRONG_DISK                           fixed bin(31) value(34);

 /*                                                                   */
 /* MessageId: ERROR_SHARING_BUFFER_EXCEEDED                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Too many files opened for sharing.                               */
 /*                                                                   */
 dcl ERROR_SHARING_BUFFER_EXCEEDED              fixed bin(31) value(36);

 /*                                                                   */
 /* MessageId: ERROR_HANDLE_EOF                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Reached end of file.                                             */
 /*                                                                   */
 dcl ERROR_HANDLE_EOF                           fixed bin(31) value(38);

 /*                                                                   */
 /* MessageId: ERROR_HANDLE_DISK_FULL                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The disk is full.                                                */
 /*                                                                   */
 dcl ERROR_HANDLE_DISK_FULL                     fixed bin(31) value(39);

 /*                                                                   */
 /* MessageId: ERROR_NOT_SUPPORTED                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The network request is not supported.                            */
 /*                                                                   */
 dcl ERROR_NOT_SUPPORTED                        fixed bin(31) value(50);

 /*                                                                   */
 /* MessageId: ERROR_REM_NOT_LIST                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The remote computer is not available.                            */
 /*                                                                   */
 dcl ERROR_REM_NOT_LIST                         fixed bin(31) value(51);

 /*                                                                   */
 /* MessageId: ERROR_DUP_NAME                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A duplicate name exists on the network.                          */
 /*                                                                   */
 dcl ERROR_DUP_NAME                             fixed bin(31) value(52);

 /*                                                                   */
 /* MessageId: ERROR_BAD_NETPATH                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The network path was not found.                                  */
 /*                                                                   */
 dcl ERROR_BAD_NETPATH                          fixed bin(31) value(53);

 /*                                                                   */
 /* MessageId: ERROR_NETWORK_BUSY                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The network is busy.                                             */
 /*                                                                   */
 dcl ERROR_NETWORK_BUSY                         fixed bin(31) value(54);

 /*                                                                   */
 /* MessageId: ERROR_DEV_NOT_EXIST                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified network resource or device is no longer available. */
 /*                                                                   */
 dcl ERROR_DEV_NOT_EXIST                        fixed bin(31) value(55);

 /*                                                                   */
 /* MessageId: ERROR_TOO_MANY_CMDS                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The network BIOS command limit has been reached.                 */
 /*                                                                   */
 dcl ERROR_TOO_MANY_CMDS                        fixed bin(31) value(56);

 /*                                                                   */
 /* MessageId: ERROR_ADAP_HDW_ERR                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A network adapter hardware error occurred.                       */
 /*                                                                   */
 dcl ERROR_ADAP_HDW_ERR                         fixed bin(31) value(57);

 /*                                                                   */
 /* MessageId: ERROR_BAD_NET_RESP                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified server cannot perform the requested operation.     */
 /*                                                                   */
 dcl ERROR_BAD_NET_RESP                         fixed bin(31) value(58);

 /*                                                                   */
 /* MessageId: ERROR_UNEXP_NET_ERR                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An unexpected network error occurred.                            */
 /*                                                                   */
 dcl ERROR_UNEXP_NET_ERR                        fixed bin(31) value(59);

 /*                                                                   */
 /* MessageId: ERROR_BAD_REM_ADAP                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The remote adapter is not compatible.                            */
 /*                                                                   */
 dcl ERROR_BAD_REM_ADAP                         fixed bin(31) value(60);

 /*                                                                   */
 /* MessageId: ERROR_PRINTQ_FULL                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The printer queue is full.                                       */
 /*                                                                   */
 dcl ERROR_PRINTQ_FULL                          fixed bin(31) value(61);

 /*                                                                   */
 /* MessageId: ERROR_NO_SPOOL_SPACE                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Space to store the file waiting to be printed is                 */
 /*  not available on the server.                                     */
 /*                                                                   */
 dcl ERROR_NO_SPOOL_SPACE                       fixed bin(31) value(62);

 /*                                                                   */
 /* MessageId: ERROR_PRINT_CANCELLED                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Your file waiting to be printed was deleted.                     */
 /*                                                                   */
 dcl ERROR_PRINT_CANCELLED                      fixed bin(31) value(63);

 /*                                                                   */
 /* MessageId: ERROR_NETNAME_DELETED                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified network name is no longer available.               */
 /*                                                                   */
 dcl ERROR_NETNAME_DELETED                      fixed bin(31) value(64);

 /*                                                                   */
 /* MessageId: ERROR_NETWORK_ACCESS_DENIED                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Network access is denied.                                        */
 /*                                                                   */
 dcl ERROR_NETWORK_ACCESS_DENIED                fixed bin(31) value(65);

 /*                                                                   */
 /* MessageId: ERROR_BAD_DEV_TYPE                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The network resource type is not correct.                        */
 /*                                                                   */
 dcl ERROR_BAD_DEV_TYPE                         fixed bin(31) value(66);

 /*                                                                   */
 /* MessageId: ERROR_BAD_NET_NAME                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The network name cannot be found.                                */
 /*                                                                   */
 dcl ERROR_BAD_NET_NAME                         fixed bin(31) value(67);

 /*                                                                   */
 /* MessageId: ERROR_TOO_MANY_NAMES                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The name limit for the local computer network                    */
 /*  adapter card was exceeded.                                       */
 /*                                                                   */
 dcl ERROR_TOO_MANY_NAMES                       fixed bin(31) value(68);

 /*                                                                   */
 /* MessageId: ERROR_TOO_MANY_SESS                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The network BIOS session limit was exceeded.                     */
 /*                                                                   */
 dcl ERROR_TOO_MANY_SESS                        fixed bin(31) value(69);

 /*                                                                   */
 /* MessageId: ERROR_SHARING_PAUSED                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The remote server has been paused or is in the                   */
 /*  process of being started.                                        */
 /*                                                                   */
 dcl ERROR_SHARING_PAUSED                       fixed bin(31) value(70);

 /*                                                                   */
 /* MessageId: ERROR_REQ_NOT_ACCEP                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No more connections can be made to this remote computer at this  */
 /*  time  because there are already as many connections as the       */
 /*  computer can accept.                                             */
 /*                                                                   */
 dcl ERROR_REQ_NOT_ACCEP                        fixed bin(31) value(71);

 /*                                                                   */
 /* MessageId: ERROR_REDIR_PAUSED                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified printer or disk device has been paused.            */
 /*                                                                   */
 dcl ERROR_REDIR_PAUSED                         fixed bin(31) value(72);

 /*                                                                   */
 /* MessageId: ERROR_FILE_EXISTS                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file exists.                                                 */
 /*                                                                   */
 dcl ERROR_FILE_EXISTS                          fixed bin(31) value(80);

 /*                                                                   */
 /* MessageId: ERROR_CANNOT_MAKE                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The directory or file cannot be created.                         */
 /*                                                                   */
 dcl ERROR_CANNOT_MAKE                          fixed bin(31) value(82);

 /*                                                                   */
 /* MessageId: ERROR_FAIL_I24                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Fail on INT 24                                                   */
 /*                                                                   */
 dcl ERROR_FAIL_I24                             fixed bin(31) value(83);

 /*                                                                   */
 /* MessageId: ERROR_OUT_OF_STRUCTURES                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Storage to process this request is not available.                */
 /*                                                                   */
 dcl ERROR_OUT_OF_STRUCTURES                    fixed bin(31) value(84);

 /*                                                                   */
 /* MessageId: ERROR_ALREADY_ASSIGNED                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The local device name is already in use.                         */
 /*                                                                   */
 dcl ERROR_ALREADY_ASSIGNED                     fixed bin(31) value(85);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_PASSWORD                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified network password is not correct.                   */
 /*                                                                   */
 dcl ERROR_INVALID_PASSWORD                     fixed bin(31) value(86);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_PARAMETER                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The parameter is incorrect.                                      */
 /*                                                                   */
 dcl ERROR_INVALID_PARAMETER                    fixed bin(31) value(87);

 /*                                                                   */
 /* MessageId: ERROR_NET_WRITE_FAULT                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A write fault occurred on the network.                           */
 /*                                                                   */
 dcl ERROR_NET_WRITE_FAULT                      fixed bin(31) value(88);

 /*                                                                   */
 /* MessageId: ERROR_NO_PROC_SLOTS                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system cannot start another process at this time.            */
 /*                                                                   */
 dcl ERROR_NO_PROC_SLOTS                        fixed bin(31) value(89);

 /*                                                                   */
 /* MessageId: ERROR_TOO_MANY_SEMAPHORES                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Cannot create another system semaphore.                          */
 /*                                                                   */
 dcl ERROR_TOO_MANY_SEMAPHORES                 fixed bin(31) value(100);

 /*                                                                   */
 /* MessageId: ERROR_EXCL_SEM_ALREADY_OWNED                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The exclusive semaphore is owned by another process.             */
 /*                                                                   */
 dcl ERROR_EXCL_SEM_ALREADY_OWNED              fixed bin(31) value(101);

 /*                                                                   */
 /* MessageId: ERROR_SEM_IS_SET                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The semaphore is set and cannot be closed.                       */
 /*                                                                   */
 dcl ERROR_SEM_IS_SET                          fixed bin(31) value(102);

 /*                                                                   */
 /* MessageId: ERROR_TOO_MANY_SEM_REQUESTS                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The semaphore cannot be set again.                               */
 /*                                                                   */
 dcl ERROR_TOO_MANY_SEM_REQUESTS               fixed bin(31) value(103);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_AT_INTERRUPT_TIME                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Cannot request exclusive semaphores at interrupt time.           */
 /*                                                                   */
 dcl ERROR_INVALID_AT_INTERRUPT_TIME           fixed bin(31) value(104);

 /*                                                                   */
 /* MessageId: ERROR_SEM_OWNER_DIED                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The previous ownership of this semaphore has ended.              */
 /*                                                                   */
 dcl ERROR_SEM_OWNER_DIED                      fixed bin(31) value(105);

 /*                                                                   */
 /* MessageId: ERROR_SEM_USER_LIMIT                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Insert the diskette for drive %1.                                */
 /*                                                                   */
 dcl ERROR_SEM_USER_LIMIT                      fixed bin(31) value(106);

 /*                                                                   */
 /* MessageId: ERROR_DISK_CHANGE                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Program stopped because alternate diskette was not inserted.     */
 /*                                                                   */
 dcl ERROR_DISK_CHANGE                         fixed bin(31) value(107);

 /*                                                                   */
 /* MessageId: ERROR_DRIVE_LOCKED                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The disk is in use or locked by another process.                 */
 /*                                                                   */
 dcl ERROR_DRIVE_LOCKED                        fixed bin(31) value(108);

 /*                                                                   */
 /* MessageId: ERROR_BROKEN_PIPE                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The pipe has been ended.                                         */
 /*                                                                   */
 dcl ERROR_BROKEN_PIPE                         fixed bin(31) value(109);

 /*                                                                   */
 /* MessageId: ERROR_OPEN_FAILED                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system cannot open thedevice or file specified.              */
 /*                                                                   */
 dcl ERROR_OPEN_FAILED                         fixed bin(31) value(110);

 /*                                                                   */
 /* MessageId: ERROR_BUFFER_OVERFLOW                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file name is too long.                                       */
 /*                                                                   */
 dcl ERROR_BUFFER_OVERFLOW                     fixed bin(31) value(111);

 /*                                                                   */
 /* MessageId: ERROR_DISK_FULL                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There is not enough space on the disk.                           */
 /*                                                                   */
 dcl ERROR_DISK_FULL                           fixed bin(31) value(112);

 /*                                                                   */
 /* MessageId: ERROR_NO_MORE_SEARCH_HANDLES                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No more internal file identifiers available.                     */
 /*                                                                   */
 dcl ERROR_NO_MORE_SEARCH_HANDLES              fixed bin(31) value(113);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_TARGET_HANDLE                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The target internal file identifier is incorrect.                */
 /*                                                                   */
 dcl ERROR_INVALID_TARGET_HANDLE               fixed bin(31) value(114);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_CATEGORY                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The IOCTL call made by the application program is not correct.   */
 /*                                                                   */
 dcl ERROR_INVALID_CATEGORY                    fixed bin(31) value(117);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_VERIFY_SWITCH                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The verify-on-write switch parameter value is not correct.       */
 /*                                                                   */
 dcl ERROR_INVALID_VERIFY_SWITCH               fixed bin(31) value(118);

 /*                                                                   */
 /* MessageId: ERROR_BAD_DRIVER_LEVEL                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system does not support the command requested.               */
 /*                                                                   */
 dcl ERROR_BAD_DRIVER_LEVEL                    fixed bin(31) value(119);

 /*                                                                   */
 /* MessageId: ERROR_CALL_NOT_IMPLEMENTED                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This function is only valid in Win32 mode.                       */
 /*                                                                   */
 dcl ERROR_CALL_NOT_IMPLEMENTED                fixed bin(31) value(120);

 /*                                                                   */
 /* MessageId: ERROR_SEM_TIMEOUT                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The semaphore timeout period has expired.                        */
 /*                                                                   */
 dcl ERROR_SEM_TIMEOUT                         fixed bin(31) value(121);

 /*                                                                   */
 /* MessageId: ERROR_INSUFFICIENT_BUFFER                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The data area passed to a system call is too small.              */
 /*                                                                   */
 dcl ERROR_INSUFFICIENT_BUFFER                 fixed bin(31) value(122);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_NAME                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The filename, directory name, or volume label                    */
 /*  syntax is incorrect.                                             */
 /*                                                                   */
 dcl ERROR_INVALID_NAME                        fixed bin(31) value(123);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_LEVEL                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system call level is not correct.                            */
 /*                                                                   */
 dcl ERROR_INVALID_LEVEL                       fixed bin(31) value(124);

 /*                                                                   */
 /* MessageId: ERROR_NO_VOLUME_LABEL                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The disk has no volume label.                                    */
 /*                                                                   */
 dcl ERROR_NO_VOLUME_LABEL                     fixed bin(31) value(125);

 /*                                                                   */
 /* MessageId: ERROR_MOD_NOT_FOUND                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified module could not be found.                         */
 /*                                                                   */
 dcl ERROR_MOD_NOT_FOUND                       fixed bin(31) value(126);

 /*                                                                   */
 /* MessageId: ERROR_PROC_NOT_FOUND                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified procedure could not be found.                      */
 /*                                                                   */
 dcl ERROR_PROC_NOT_FOUND                      fixed bin(31) value(127);

 /*                                                                   */
 /* MessageId: ERROR_WAIT_NO_CHILDREN                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There are no child processes to wait for.                        */
 /*                                                                   */
 dcl ERROR_WAIT_NO_CHILDREN                    fixed bin(31) value(128);

 /*                                                                   */
 /* MessageId: ERROR_CHILD_NOT_COMPLETE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The %1 application cannot be run in Win32 mode.                  */
 /*                                                                   */
 dcl ERROR_CHILD_NOT_COMPLETE                  fixed bin(31) value(129);

 /*                                                                   */
 /* MessageId: ERROR_DIRECT_ACCESS_HANDLE                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Attempt to use a file handle to an open disk partition for an    */
 /*  operation other than raw disk I/O.                               */
 /*                                                                   */
 dcl ERROR_DIRECT_ACCESS_HANDLE                fixed bin(31) value(130);

 /*                                                                   */
 /* MessageId: ERROR_NEGATIVE_SEEK                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An attempt was made to move the file pointer                     */
 /*  before the beginning of the file.                                */
 /*                                                                   */
 dcl ERROR_NEGATIVE_SEEK                       fixed bin(31) value(131);

 /*                                                                   */
 /* MessageId: ERROR_SEEK_ON_DEVICE                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file pointer cannot be set on the specified device or file.  */
 /*                                                                   */
 dcl ERROR_SEEK_ON_DEVICE                      fixed bin(31) value(132);

 /*                                                                   */
 /* MessageId: ERROR_IS_JOIN_TARGET                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A JOIN or SUBST command cannot be used for a drive that          */
 /*  contains previously joined drives.                               */
 /*                                                                   */
 dcl ERROR_IS_JOIN_TARGET                      fixed bin(31) value(133);

 /*                                                                   */
 /* MessageId: ERROR_IS_JOINED                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An attempt was made to use a JOIN or SUBST command on            */
 /*  a drive that has already been joined.                            */
 /*                                                                   */
 dcl ERROR_IS_JOINED                           fixed bin(31) value(134);

 /*                                                                   */
 /* MessageId: ERROR_IS_SUBSTED                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An attempt was made to use a JOIN or SUBST command on            */
 /*  a drive that has already been substituted.                       */
 /*                                                                   */
 dcl ERROR_IS_SUBSTED                          fixed bin(31) value(135);

 /*                                                                   */
 /* MessageId: ERROR_NOT_JOINED                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system tried to delete the JOIN of a drive                   */
 /*  that is not joined.                                              */
 /*                                                                   */
 dcl ERROR_NOT_JOINED                          fixed bin(31) value(136);

 /*                                                                   */
 /* MessageId: ERROR_NOT_SUBSTED                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system tried to delete the substitution of a drive           */
 /*  that is not substituted.                                         */
 /*                                                                   */
 dcl ERROR_NOT_SUBSTED                         fixed bin(31) value(137);

 /*                                                                   */
 /* MessageId: ERROR_JOIN_TO_JOIN                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system tried to join a drive                                 */
 /*  to a directory on a joined drive.                                */
 /*                                                                   */
 dcl ERROR_JOIN_TO_JOIN                        fixed bin(31) value(138);

 /*                                                                   */
 /* MessageId: ERROR_SUBST_TO_SUBST                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system tried to substitute a drive                           */
 /*  to a directory on a substituted drive.                           */
 /*                                                                   */
 dcl ERROR_SUBST_TO_SUBST                      fixed bin(31) value(139);

 /*                                                                   */
 /* MessageId: ERROR_JOIN_TO_SUBST                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system tried to join a drive                                 */
 /*  to a directory on a substituted drive.                           */
 /*                                                                   */
 dcl ERROR_JOIN_TO_SUBST                       fixed bin(31) value(140);

 /*                                                                   */
 /* MessageId: ERROR_SUBST_TO_JOIN                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system tried to SUBST a drive                                */
 /*  to a directory on a joined drive.                                */
 /*                                                                   */
 dcl ERROR_SUBST_TO_JOIN                       fixed bin(31) value(141);

 /*                                                                   */
 /* MessageId: ERROR_BUSY_DRIVE                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system cannot perform a JOIN or SUBST at this time.          */
 /*                                                                   */
 dcl ERROR_BUSY_DRIVE                          fixed bin(31) value(142);

 /*                                                                   */
 /* MessageId: ERROR_SAME_DRIVE                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system cannot join or substitute a drive                     */
 /*  to or for a directory on the same drive.                         */
 /*                                                                   */
 dcl ERROR_SAME_DRIVE                          fixed bin(31) value(143);

 /*                                                                   */
 /* MessageId: ERROR_DIR_NOT_ROOT                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The directory is not a subdirectory of the root directory.       */
 /*                                                                   */
 dcl ERROR_DIR_NOT_ROOT                        fixed bin(31) value(144);

 /*                                                                   */
 /* MessageId: ERROR_DIR_NOT_EMPTY                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The directory is not empty.                                      */
 /*                                                                   */
 dcl ERROR_DIR_NOT_EMPTY                       fixed bin(31) value(145);

 /*                                                                   */
 /* MessageId: ERROR_IS_SUBST_PATH                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The path specified is being used in a substitute.                */
 /*                                                                   */
 dcl ERROR_IS_SUBST_PATH                       fixed bin(31) value(146);

 /*                                                                   */
 /* MessageId: ERROR_IS_JOIN_PATH                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Not enough resources are available to process this command.      */
 /*                                                                   */
 dcl ERROR_IS_JOIN_PATH                        fixed bin(31) value(147);

 /*                                                                   */
 /* MessageId: ERROR_PATH_BUSY                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The path specified cannot be used at this time.                  */
 /*                                                                   */
 dcl ERROR_PATH_BUSY                           fixed bin(31) value(148);

 /*                                                                   */
 /* MessageId: ERROR_IS_SUBST_TARGET                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An attempt was made to join or substitute a drive for which a    */
 /*  directory on the drive is the target of a previous substitute.   */
 /*                                                                   */
 dcl ERROR_IS_SUBST_TARGET                     fixed bin(31) value(149);

 /*                                                                   */
 /* MessageId: ERROR_SYSTEM_TRACE                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  System trace information was not specified in your               */
 /*  CONFIG.SYS file, or tracing is disallowed.                       */
 /*                                                                   */
 dcl ERROR_SYSTEM_TRACE                        fixed bin(31) value(150);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_EVENT_COUNT                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The number of specified semaphore events for                     */
 /*  DosMuxSemWait is not correct.                                    */
 /*                                                                   */
 dcl ERROR_INVALID_EVENT_COUNT                 fixed bin(31) value(151);

 /*                                                                   */
 /* MessageId: ERROR_TOO_MANY_MUXWAITERS                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DosMuxSemWait did not execute, too many semaphores               */
 /*  are already set.                                                 */
 /*                                                                   */
 dcl ERROR_TOO_MANY_MUXWAITERS                 fixed bin(31) value(152);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_LIST_FORMAT                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The DosMuxSemWait list is not correct.                           */
 /*                                                                   */
 dcl ERROR_INVALID_LIST_FORMAT                 fixed bin(31) value(153);

 /*                                                                   */
 /* MessageId: ERROR_LABEL_TOO_LONG                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The volume label you entered exceeds the label character         */
 /*  limit of the target file system.                                 */
 /*                                                                   */
 dcl ERROR_LABEL_TOO_LONG                      fixed bin(31) value(154);

 /*                                                                   */
 /* MessageId: ERROR_TOO_MANY_TCBS                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Cannot create another thread.                                    */
 /*                                                                   */
 dcl ERROR_TOO_MANY_TCBS                       fixed bin(31) value(155);

 /*                                                                   */
 /* MessageId: ERROR_SIGNAL_REFUSED                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The recipient process has refused the signal.                    */
 /*                                                                   */
 dcl ERROR_SIGNAL_REFUSED                      fixed bin(31) value(156);

 /*                                                                   */
 /* MessageId: ERROR_DISCARDED                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The segment is already discarded and cannot be locked.           */
 /*                                                                   */
 dcl ERROR_DISCARDED                           fixed bin(31) value(157);

 /*                                                                   */
 /* MessageId: ERROR_NOT_LOCKED                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The segment is already unlocked.                                 */
 /*                                                                   */
 dcl ERROR_NOT_LOCKED                          fixed bin(31) value(158);

 /*                                                                   */
 /* MessageId: ERROR_BAD_THREADID_ADDR                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The address for the thread ID is not correct.                    */
 /*                                                                   */
 dcl ERROR_BAD_THREADID_ADDR                   fixed bin(31) value(159);

 /*                                                                   */
 /* MessageId: ERROR_BAD_ARGUMENTS                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The argument string passed to DosExecPgm is not correct.         */
 /*                                                                   */
 dcl ERROR_BAD_ARGUMENTS                       fixed bin(31) value(160);

 /*                                                                   */
 /* MessageId: ERROR_BAD_PATHNAME                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified path is invalid.                                   */
 /*                                                                   */
 dcl ERROR_BAD_PATHNAME                        fixed bin(31) value(161);

 /*                                                                   */
 /* MessageId: ERROR_SIGNAL_PENDING                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A signal is already pending.                                     */
 /*                                                                   */
 dcl ERROR_SIGNAL_PENDING                      fixed bin(31) value(162);

 /*                                                                   */
 /* MessageId: ERROR_MAX_THRDS_REACHED                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No more threads can be created in the system.                    */
 /*                                                                   */
 dcl ERROR_MAX_THRDS_REACHED                   fixed bin(31) value(164);

 /*                                                                   */
 /* MessageId: ERROR_LOCK_FAILED                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to lock a region of a file.                               */
 /*                                                                   */
 dcl ERROR_LOCK_FAILED                         fixed bin(31) value(167);

 /*                                                                   */
 /* MessageId: ERROR_BUSY                                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested resource is in use.                                */
 /*                                                                   */
 dcl ERROR_BUSY                                fixed bin(31) value(170);

 /*                                                                   */
 /* MessageId: ERROR_CANCEL_VIOLATION                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A lock request was not outstanding for                           */
 /*  the supplied cancel region.                                      */
 /*                                                                   */
 dcl ERROR_CANCEL_VIOLATION                    fixed bin(31) value(173);

 /*                                                                   */
 /* MessageId: ERROR_ATOMIC_LOCKS_NOT_SUPPORTED                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file system does not support atomic                          */
 /*  changes to the lock type.                                        */
 /*                                                                   */
 dcl ERROR_ATOMIC_LOCKS_NOT_SUPPORTED          fixed bin(31) value(174);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_SEGMENT_NUMBER                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system detected a segment number that was not correct.       */
 /*                                                                   */
 dcl ERROR_INVALID_SEGMENT_NUMBER              fixed bin(31) value(180);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_ORDINAL                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operating system cannot run %1.                              */
 /*                                                                   */
 dcl ERROR_INVALID_ORDINAL                     fixed bin(31) value(182);

 /*                                                                   */
 /* MessageId: ERROR_ALREADY_EXISTS                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Cannot create a file when that file already exists.              */
 /*                                                                   */
 dcl ERROR_ALREADY_EXISTS                      fixed bin(31) value(183);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_FLAG_NUMBER                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The flag passed is not correct.                                  */
 /*                                                                   */
 dcl ERROR_INVALID_FLAG_NUMBER                 fixed bin(31) value(186);

 /*                                                                   */
 /* MessageId: ERROR_SEM_NOT_FOUND                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified system semaphore name was not found.               */
 /*                                                                   */
 dcl ERROR_SEM_NOT_FOUND                       fixed bin(31) value(187);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_STARTING_CODESEG                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operating system cannot run %1.                              */
 /*                                                                   */
 dcl ERROR_INVALID_STARTING_CODESEG            fixed bin(31) value(188);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_STACKSEG                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operating system cannot run %1.                              */
 /*                                                                   */
 dcl ERROR_INVALID_STACKSEG                    fixed bin(31) value(189);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_MODULETYPE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operating system cannot run %1.                              */
 /*                                                                   */
 dcl ERROR_INVALID_MODULETYPE                  fixed bin(31) value(190);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_EXE_SIGNATURE                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Cannot run %1 in Win32 mode.                                     */
 /*                                                                   */
 dcl ERROR_INVALID_EXE_SIGNATURE               fixed bin(31) value(191);

 /*                                                                   */
 /* MessageId: ERROR_EXE_MARKED_INVALID                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operating system cannot run %1.                              */
 /*                                                                   */
 dcl ERROR_EXE_MARKED_INVALID                  fixed bin(31) value(192);

 /*                                                                   */
 /* MessageId: ERROR_BAD_EXE_FORMAT                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  %1 is not a valid Win32 application.                             */
 /*                                                                   */
 dcl ERROR_BAD_EXE_FORMAT                      fixed bin(31) value(193);

 /*                                                                   */
 /* MessageId: ERROR_ITERATED_DATA_EXCEEDS_64k                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operating system cannot run %1.                              */
 /*                                                                   */
 dcl ERROR_ITERATED_DATA_EXCEEDS_64k           fixed bin(31) value(194);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_MINALLOCSIZE                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operating system cannot run %1 .                             */
 /*                                                                   */
 dcl ERROR_INVALID_MINALLOCSIZE                fixed bin(31) value(195);

 /*                                                                   */
 /* MessageId: ERROR_DYNLINK_FROM_INVALID_RING                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operating system cannot run this application program.        */
 /*                                                                   */
 dcl ERROR_DYNLINK_FROM_INVALID_RING           fixed bin(31) value(196);

 /*                                                                   */
 /* MessageId: ERROR_IOPL_NOT_ENABLED                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operating system is not presently                            */
 /*  configured to run this application.                              */
 /*                                                                   */
 dcl ERROR_IOPL_NOT_ENABLED                    fixed bin(31) value(197);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_SEGDPL                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operating system cannot run %1.                              */
 /*                                                                   */
 dcl ERROR_INVALID_SEGDPL                      fixed bin(31) value(198);

 /*                                                                   */
 /* MessageId: ERROR_AUTODATASEG_EXCEEDS_64k                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operating system cannot run this application program.        */
 /*                                                                   */
 dcl ERROR_AUTODATASEG_EXCEEDS_64k             fixed bin(31) value(199);

 /*                                                                   */
 /* MessageId: ERROR_RING2SEG_MUST_BE_MOVABLE                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The code segment cannot be greater than or equal to 64KB.        */
 /*                                                                   */
 dcl ERROR_RING2SEG_MUST_BE_MOVABLE            fixed bin(31) value(200);

 /*                                                                   */
 /* MessageId: ERROR_RELOC_CHAIN_XEEDS_SEGLIM                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operating system cannot run %1.                              */
 /*                                                                   */
 dcl ERROR_RELOC_CHAIN_XEEDS_SEGLIM            fixed bin(31) value(201);

 /*                                                                   */
 /* MessageId: ERROR_INFLOOP_IN_RELOC_CHAIN                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operating system cannot run %1.                              */
 /*                                                                   */
 dcl ERROR_INFLOOP_IN_RELOC_CHAIN              fixed bin(31) value(202);

 /*                                                                   */
 /* MessageId: ERROR_ENVVAR_NOT_FOUND                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system could not find the environment                        */
 /*  option that was entered.                                         */
 /*                                                                   */
 dcl ERROR_ENVVAR_NOT_FOUND                    fixed bin(31) value(203);

 /*                                                                   */
 /* MessageId: ERROR_NO_SIGNAL_SENT                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No process in the command subtree has a signal handler.          */
 /*                                                                   */
 dcl ERROR_NO_SIGNAL_SENT                      fixed bin(31) value(205);

 /*                                                                   */
 /* MessageId: ERROR_FILENAME_EXCED_RANGE                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The filename or extension is too long.                           */
 /*                                                                   */
 dcl ERROR_FILENAME_EXCED_RANGE                fixed bin(31) value(206);

 /*                                                                   */
 /* MessageId: ERROR_RING2_STACK_IN_USE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The ring 2 stack is in use.                                      */
 /*                                                                   */
 dcl ERROR_RING2_STACK_IN_USE                  fixed bin(31) value(207);

 /*                                                                   */
 /* MessageId: ERROR_META_EXPANSION_TOO_LONG                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The global filename characters, * or ?, are entered incorrectly  */
 /*  or too many global filename characters are specified.            */
 /*                                                                   */
 dcl ERROR_META_EXPANSION_TOO_LONG             fixed bin(31) value(208);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_SIGNAL_NUMBER                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The signal being posted is not correct.                          */
 /*                                                                   */
 dcl ERROR_INVALID_SIGNAL_NUMBER               fixed bin(31) value(209);

 /*                                                                   */
 /* MessageId: ERROR_THREAD_1_INACTIVE                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The signal handler cannot be set.                                */
 /*                                                                   */
 dcl ERROR_THREAD_1_INACTIVE                   fixed bin(31) value(210);

 /*                                                                   */
 /* MessageId: ERROR_LOCKED                                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The segment is locked and cannot be reallocated.                 */
 /*                                                                   */
 dcl ERROR_LOCKED                              fixed bin(31) value(212);

 /*                                                                   */
 /* MessageId: ERROR_TOO_MANY_MODULES                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Too many dynamic link modules are attached to this               */
 /*  program or dynamic link module.                                  */
 /*                                                                   */
 dcl ERROR_TOO_MANY_MODULES                    fixed bin(31) value(214);

 /*                                                                   */
 /* MessageId: ERROR_NESTING_NOT_ALLOWED                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Can't nest calls to LoadModule.                                  */
 /*                                                                   */
 dcl ERROR_NESTING_NOT_ALLOWED                 fixed bin(31) value(215);

 /*                                                                   */
 /* MessageId: ERROR_BAD_PIPE                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The pipe state is invalid.                                       */
 /*                                                                   */
 dcl ERROR_BAD_PIPE                            fixed bin(31) value(230);

 /*                                                                   */
 /* MessageId: ERROR_PIPE_BUSY                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  All pipe instances are busy.                                     */
 /*                                                                   */
 dcl ERROR_PIPE_BUSY                           fixed bin(31) value(231);

 /*                                                                   */
 /* MessageId: ERROR_NO_DATA                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The pipe is being closed.                                        */
 /*                                                                   */
 dcl ERROR_NO_DATA                             fixed bin(31) value(232);

 /*                                                                   */
 /* MessageId: ERROR_PIPE_NOT_CONNECTED                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No process is on the other end of the pipe.                      */
 /*                                                                   */
 dcl ERROR_PIPE_NOT_CONNECTED                  fixed bin(31) value(233);

 /*                                                                   */
 /* MessageId: ERROR_MORE_DATA                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  More data is available.                                          */
 /*                                                                   */
 dcl ERROR_MORE_DATA                           fixed bin(31) value(234);

 /*                                                                   */
 /* MessageId: ERROR_VC_DISCONNECTED                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The session was cancelled.                                       */
 /*                                                                   */
 dcl ERROR_VC_DISCONNECTED                     fixed bin(31) value(240);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_EA_NAME                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified extended attribute name was invalid.               */
 /*                                                                   */
 dcl ERROR_INVALID_EA_NAME                     fixed bin(31) value(254);

 /*                                                                   */
 /* MessageId: ERROR_EA_LIST_INCONSISTENT                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The extended attributes are inconsistent.                        */
 /*                                                                   */
 dcl ERROR_EA_LIST_INCONSISTENT                fixed bin(31) value(255);

 /*                                                                   */
 /* MessageId: ERROR_NO_MORE_ITEMS                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No more data is available.                                       */
 /*                                                                   */
 dcl ERROR_NO_MORE_ITEMS                       fixed bin(31) value(259);

 /*                                                                   */
 /* MessageId: ERROR_CANNOT_COPY                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The Copy API cannot be used.                                     */
 /*                                                                   */
 dcl ERROR_CANNOT_COPY                         fixed bin(31) value(266);

 /*                                                                   */
 /* MessageId: ERROR_DIRECTORY                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The directory name is invalid.                                   */
 /*                                                                   */
 dcl ERROR_DIRECTORY                           fixed bin(31) value(267);

 /*                                                                   */
 /* MessageId: ERROR_EAS_DIDNT_FIT                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The extended attributes did not fit in the buffer.               */
 /*                                                                   */
 dcl ERROR_EAS_DIDNT_FIT                       fixed bin(31) value(275);

 /*                                                                   */
 /* MessageId: ERROR_EA_FILE_CORRUPT                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The extended attribute file on the mounted                       */
 /* file system is corrupt.                                           */
 /*                                                                   */
 dcl ERROR_EA_FILE_CORRUPT                     fixed bin(31) value(276);

 /*                                                                   */
 /* MessageId: ERROR_EA_TABLE_FULL                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The extended attribute table file is full.                       */
 /*                                                                   */
 dcl ERROR_EA_TABLE_FULL                       fixed bin(31) value(277);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_EA_HANDLE                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified extended attribute handle is invalid.              */
 /*                                                                   */
 dcl ERROR_INVALID_EA_HANDLE                   fixed bin(31) value(278);

 /*                                                                   */
 /* MessageId: ERROR_EAS_NOT_SUPPORTED                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The mounted file system does not support extended attributes.    */
 /*                                                                   */
 dcl ERROR_EAS_NOT_SUPPORTED                   fixed bin(31) value(282);

 /*                                                                   */
 /* MessageId: ERROR_NOT_OWNER                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Attempt to release mutex not owned by caller.                    */
 /*                                                                   */
 dcl ERROR_NOT_OWNER                           fixed bin(31) value(288);

 /*                                                                   */
 /* MessageId: ERROR_TOO_MANY_POSTS                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Too many posts were made to a semaphore.                         */
 /*                                                                   */
 dcl ERROR_TOO_MANY_POSTS                      fixed bin(31) value(298);

 /*                                                                   */
 /* MessageId: ERROR_PARTIAL_COPY                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Only part of a Read/WriteProcessMemory request was completed.    */
 /*                                                                   */
 dcl ERROR_PARTIAL_COPY                        fixed bin(31) value(299);

 /*                                                                   */
 /* MessageId: ERROR_OPLOCK_NOT_GRANTED                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Oplock request is denied.                                        */
 /*                                                                   */
 dcl ERROR_OPLOCK_NOT_GRANTED                  fixed bin(31) value(300);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_OPLOCK_PROTOCOL                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An invalid oplock acknowledgment was received by the system.     */
 /*                                                                   */
 dcl ERROR_INVALID_OPLOCK_PROTOCOL             fixed bin(31) value(301);

 /*                                                                   */
 /* MessageId: ERROR_MR_MID_NOT_FOUND                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system cannot find message for message number 0x%1           */
 /*  in message file for %2.                                          */
 /*                                                                   */
 dcl ERROR_MR_MID_NOT_FOUND                    fixed bin(31) value(317);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_ADDRESS                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Attempt to access invalid address.                               */
 /*                                                                   */
 dcl ERROR_INVALID_ADDRESS                     fixed bin(31) value(487);

 /*                                                                   */
 /* MessageId: ERROR_ARITHMETIC_OVERFLOW                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Arithmetic result exceeded 32 bits.                              */
 /*                                                                   */
 dcl ERROR_ARITHMETIC_OVERFLOW                 fixed bin(31) value(534);

 /*                                                                   */
 /* MessageId: ERROR_PIPE_CONNECTED                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There is a process on other end of the pipe.                     */
 /*                                                                   */
 dcl ERROR_PIPE_CONNECTED                      fixed bin(31) value(535);

 /*                                                                   */
 /* MessageId: ERROR_PIPE_LISTENING                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Waiting for a process to open the other end of the pipe.         */
 /*                                                                   */
 dcl ERROR_PIPE_LISTENING                      fixed bin(31) value(536);

 /*                                                                   */
 /* MessageId: ERROR_EA_ACCESS_DENIED                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Access to the extended attribute was denied.                     */
 /*                                                                   */
 dcl ERROR_EA_ACCESS_DENIED                    fixed bin(31) value(994);

 /*                                                                   */
 /* MessageId: ERROR_OPERATION_ABORTED                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The I/O operation has been aborted because                       */
 /*  of either a thread exit or an application request.               */
 /*                                                                   */
 dcl ERROR_OPERATION_ABORTED                   fixed bin(31) value(995);

 /*                                                                   */
 /* MessageId: ERROR_IO_INCOMPLETE                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Overlapped I/O event is not in a signalled state.                */
 /*                                                                   */
 dcl ERROR_IO_INCOMPLETE                       fixed bin(31) value(996);

 /*                                                                   */
 /* MessageId: ERROR_IO_PENDING                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Overlapped I/O operation is in progress.                         */
 /*                                                                   */
 dcl ERROR_IO_PENDING                          fixed bin(31) value(997);

 /*                                                                   */
 /* MessageId: ERROR_NOACCESS                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid access to memory location.                               */
 /*                                                                   */
 dcl ERROR_NOACCESS                            fixed bin(31) value(998);

 /*                                                                   */
 /* MessageId: ERROR_SWAPERROR                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Error performing inpage operation.                               */
 /*                                                                   */
 dcl ERROR_SWAPERROR                           fixed bin(31) value(999);

 /*                                                                   */
 /* MessageId: ERROR_STACK_OVERFLOW                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Recursion too deep, stack overflowed.                            */
 /*                                                                   */
 dcl ERROR_STACK_OVERFLOW                     fixed bin(31) value(1001);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_MESSAGE                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The window cannot act on the sent message.                       */
 /*                                                                   */
 dcl ERROR_INVALID_MESSAGE                    fixed bin(31) value(1002);

 /*                                                                   */
 /* MessageId: ERROR_CAN_NOT_COMPLETE                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Cannot complete this function.                                   */
 /*                                                                   */
 dcl ERROR_CAN_NOT_COMPLETE                   fixed bin(31) value(1003);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_FLAGS                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid flags.                                                   */
 /*                                                                   */
 dcl ERROR_INVALID_FLAGS                     fixed bin(31) value(1004);

 /*                                                                   */
 /* MessageId: ERROR_UNRECOGNIZED_VOLUME                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The volume does not contain a recognized file system.            */
 /*  Please make sure that all required file system drivers           */
 /*  are loaded and that the volume is not corrupt.                   */
 /*                                                                   */
 dcl ERROR_UNRECOGNIZED_VOLUME                fixed bin(31) value(1005);

 /*                                                                   */
 /* MessageId: ERROR_FILE_INVALID                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The volume for a file has been externally altered such that      */
 /*  the opened file is no longer valid.                              */
 /*                                                                   */
 dcl ERROR_FILE_INVALID                       fixed bin(31) value(1006);

 /*                                                                   */
 /* MessageId: ERROR_FULLSCREEN_MODE                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested operation cannot be performed in full-screen mode. */
 /*                                                                   */
 dcl ERROR_FULLSCREEN_MODE                    fixed bin(31) value(1007);

 /*                                                                   */
 /* MessageId: ERROR_NO_TOKEN                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An attempt was made to reference a token that does not exist.    */
 /*                                                                   */
 dcl ERROR_NO_TOKEN                           fixed bin(31) value(1008);

 /*                                                                   */
 /* MessageId: ERROR_BADDB                                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The configuration registry database is corrupt.                  */
 /*                                                                   */
 dcl ERROR_BADDB                              fixed bin(31) value(1009);

 /*                                                                   */
 /* MessageId: ERROR_BADKEY                                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The configuration registry key is invalid.                       */
 /*                                                                   */
 dcl ERROR_BADKEY                             fixed bin(31) value(1010);

 /*                                                                   */
 /* MessageId: ERROR_CANTOPEN                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The configuration registry key could not be opened.              */
 /*                                                                   */
 dcl ERROR_CANTOPEN                           fixed bin(31) value(1011);

 /*                                                                   */
 /* MessageId: ERROR_CANTREAD                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The configuration registry key could not be read.                */
 /*                                                                   */
 dcl ERROR_CANTREAD                           fixed bin(31) value(1012);

 /*                                                                   */
 /* MessageId: ERROR_CANTWRITE                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The configuration registry key could not be written.             */
 /*                                                                   */
 dcl ERROR_CANTWRITE                          fixed bin(31) value(1013);

 /*                                                                   */
 /* MessageId: ERROR_REGISTRY_RECOVERED                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  One of the files in the Registry database had to be recovered    */
 /*  by use of a log or alternate copy.  The recovery was successful. */
 /*                                                                   */
 dcl ERROR_REGISTRY_RECOVERED                 fixed bin(31) value(1014);

 /*                                                                   */
 /* MessageId: ERROR_REGISTRY_CORRUPT                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The Registry is corrupt. The structure of one of the files that  */
 /*  contains Registry data is corrupt, or the system's image of the  */
 /*  file in memory is corrupt, or the file could not be recovered    */
 /*  because the alternate copy or log was absent or corrupt.         */
 /*                                                                   */
 dcl ERROR_REGISTRY_CORRUPT                   fixed bin(31) value(1015);

 /*                                                                   */
 /* MessageId: ERROR_REGISTRY_IO_FAILED                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An I/O operation initiated by the Registry failed unrecoverably  */
 /*  The Registry could not read in, or write out, or flush, one of   */
 /*  the files that contain the system's image of the Registry.       */
 /*                                                                   */
 dcl ERROR_REGISTRY_IO_FAILED                 fixed bin(31) value(1016);

 /*                                                                   */
 /* MessageId: ERROR_NOT_REGISTRY_FILE                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system has attempted to load or restore a file into the      */
 /*  Registry, but the specified file is not in a Registry file       */
 /*  format.                                                          */
 /*                                                                   */
 dcl ERROR_NOT_REGISTRY_FILE                  fixed bin(31) value(1017);

 /*                                                                   */
 /* MessageId: ERROR_KEY_DELETED                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Illegal operation attempted on a Registry key                    */
 /*  which has been marked for deletion.                              */
 /*                                                                   */
 dcl ERROR_KEY_DELETED                        fixed bin(31) value(1018);

 /*                                                                   */
 /* MessageId: ERROR_NO_LOG_SPACE                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  System could not allocate the required space in a Registry log.  */
 /*                                                                   */
 dcl ERROR_NO_LOG_SPACE                       fixed bin(31) value(1019);

 /*                                                                   */
 /* MessageId: ERROR_KEY_HAS_CHILDREN                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Cannot create a symbolic link in a Registry key that already     */
 /*  has subkeys or values.                                           */
 /*                                                                   */
 dcl ERROR_KEY_HAS_CHILDREN                   fixed bin(31) value(1020);

 /*                                                                   */
 /* MessageId: ERROR_CHILD_MUST_BE_VOLATILE                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Cannot create a stable subkey under a volatile parent key.       */
 /*                                                                   */
 dcl ERROR_CHILD_MUST_BE_VOLATILE             fixed bin(31) value(1021);

 /*                                                                   */
 /* MessageId: ERROR_NOTIFY_ENUM_DIR                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A notify change request is being completed and the information   */
 /*  is not being returned in the caller's buffer. The caller now     */
 /*  needs to enumerate the files to find the changes.                */
 /*                                                                   */
 dcl ERROR_NOTIFY_ENUM_DIR                    fixed bin(31) value(1022);

 /*                                                                   */
 /* MessageId: ERROR_DEPENDENT_SERVICES_RUNNING                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A stop control has been sent to a service which                  */
 /*  other running services are dependent on.                         */
 /*                                                                   */
 dcl ERROR_DEPENDENT_SERVICES_RUNNING         fixed bin(31) value(1051);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_SERVICE_CONTROL                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested control is not valid for this service              */
 /*                                                                   */
 dcl ERROR_INVALID_SERVICE_CONTROL            fixed bin(31) value(1052);

 /*                                                                   */
 /* MessageId: ERROR_SERVICE_REQUEST_TIMEOUT                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The service did not respond to the start or control request      */
 /*  in a timely fashion.                                             */
 /*                                                                   */
 dcl ERROR_SERVICE_REQUEST_TIMEOUT            fixed bin(31) value(1053);

 /*                                                                   */
 /* MessageId: ERROR_SERVICE_NO_THREAD                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A thread could not be created for the service.                   */
 /*                                                                   */
 dcl ERROR_SERVICE_NO_THREAD                  fixed bin(31) value(1054);

 /*                                                                   */
 /* MessageId: ERROR_SERVICE_DATABASE_LOCKED                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The service database is locked.                                  */
 /*                                                                   */
 dcl ERROR_SERVICE_DATABASE_LOCKED            fixed bin(31) value(1055);

 /*                                                                   */
 /* MessageId: ERROR_SERVICE_ALREADY_RUNNING                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An instance of the service is already running.                   */
 /*                                                                   */
 dcl ERROR_SERVICE_ALREADY_RUNNING            fixed bin(31) value(1056);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_SERVICE_ACCOUNT                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The account name is invalid or does not exist.                   */
 /*                                                                   */
 dcl ERROR_INVALID_SERVICE_ACCOUNT            fixed bin(31) value(1057);

 /*                                                                   */
 /* MessageId: ERROR_SERVICE_DISABLED                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified service is disabled and cannot be started.         */
 /*                                                                   */
 dcl ERROR_SERVICE_DISABLED                   fixed bin(31) value(1058);

 /*                                                                   */
 /* MessageId: ERROR_CIRCULAR_DEPENDENCY                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Circular service dependency was specified.                       */
 /*                                                                   */
 dcl ERROR_CIRCULAR_DEPENDENCY                fixed bin(31) value(1059);

 /*                                                                   */
 /* MessageId: ERROR_SERVICE_DOES_NOT_EXIST                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified service does not exist as an installed service.    */
 /*                                                                   */
 dcl ERROR_SERVICE_DOES_NOT_EXIST             fixed bin(31) value(1060);

 /*                                                                   */
 /* MessageId: ERROR_SERVICE_CANNOT_ACCEPT_CTRL                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The service cannot accept control messages at this time.         */
 /*                                                                   */
 dcl ERROR_SERVICE_CANNOT_ACCEPT_CTRL         fixed bin(31) value(1061);

 /*                                                                   */
 /* MessageId: ERROR_SERVICE_NOT_ACTIVE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The service has not been started.                                */
 /*                                                                   */
 dcl ERROR_SERVICE_NOT_ACTIVE                 fixed bin(31) value(1062);

 /*                                                                   */
 /* MessageId: ERROR_FAILED_SERVICE_CONTROLLER_CONNECT                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*The service process could not connect to the service controller.   */
 /*                                                                   */
 dcl ERROR_FAILED_SERVICE_CONTROLLER_CONNECT  fixed bin(31) value(1063);

 /*                                                                   */
 /* MessageId: ERROR_EXCEPTION_IN_SERVICE                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An exception occurred in the service when handling               */
 /*  the control request.                                             */
 /*                                                                   */
 dcl ERROR_EXCEPTION_IN_SERVICE               fixed bin(31) value(1064);

 /*                                                                   */
 /* MessageId: ERROR_DATABASE_DOES_NOT_EXIST                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The database specified does not exist.                           */
 /*                                                                   */
 dcl ERROR_DATABASE_DOES_NOT_EXIST            fixed bin(31) value(1065);

 /*                                                                   */
 /* MessageId: ERROR_SERVICE_SPECIFIC_ERROR                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The service has returned a service-specific error code.          */
 /*                                                                   */
 dcl ERROR_SERVICE_SPECIFIC_ERROR             fixed bin(31) value(1066);

 /*                                                                   */
 /* MessageId: ERROR_PROCESS_ABORTED                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The process terminated unexpectedly.                             */
 /*                                                                   */
 dcl ERROR_PROCESS_ABORTED                    fixed bin(31) value(1067);

 /*                                                                   */
 /* MessageId: ERROR_SERVICE_DEPENDENCY_FAIL                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The dependency service or group failed to start.                 */
 /*                                                                   */
 dcl ERROR_SERVICE_DEPENDENCY_FAIL            fixed bin(31) value(1068);

 /*                                                                   */
 /* MessageId: ERROR_SERVICE_LOGON_FAILED                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The service did not start due to a logon failure.                */
 /*                                                                   */
 dcl ERROR_SERVICE_LOGON_FAILED               fixed bin(31) value(1069);

 /*                                                                   */
 /* MessageId: ERROR_SERVICE_START_HANG                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  After starting, the service hung in a start-pending state.       */
 /*                                                                   */
 dcl ERROR_SERVICE_START_HANG                 fixed bin(31) value(1070);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_SERVICE_LOCK                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified service database lock is invalid.                  */
 /*                                                                   */
 dcl ERROR_INVALID_SERVICE_LOCK               fixed bin(31) value(1071);

 /*                                                                   */
 /* MessageId: ERROR_SERVICE_MARKED_FOR_DELETE                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified service has been marked for deletion.              */
 /*                                                                   */
 dcl ERROR_SERVICE_MARKED_FOR_DELETE          fixed bin(31) value(1072);

 /*                                                                   */
 /* MessageId: ERROR_SERVICE_EXISTS                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified service already exists.                            */
 /*                                                                   */
 dcl ERROR_SERVICE_EXISTS                     fixed bin(31) value(1073);

 /*                                                                   */
 /* MessageId: ERROR_ALREADY_RUNNING_LKG                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system is currently running with                             */
 /*  the last-known-good configuration.                               */
 /*                                                                   */
 dcl ERROR_ALREADY_RUNNING_LKG                fixed bin(31) value(1074);

 /*                                                                   */
 /* MessageId: ERROR_SERVICE_DEPENDENCY_DELETED                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The dependency service does not exist or has been marked         */
 /*  for deletion.                                                    */
 /*                                                                   */
 dcl ERROR_SERVICE_DEPENDENCY_DELETED         fixed bin(31) value(1075);

 /*                                                                   */
 /* MessageId: ERROR_BOOT_ALREADY_ACCEPTED                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The current boot has already been accepted for use as            */
 /*  the last-known-good control set.                                 */
 /*                                                                   */
 dcl ERROR_BOOT_ALREADY_ACCEPTED              fixed bin(31) value(1076);

 /*                                                                   */
 /* MessageId: ERROR_SERVICE_NEVER_STARTED                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No attempts to start the service have been made                  */
 /*  since the last boot.                                             */
 /*                                                                   */
 dcl ERROR_SERVICE_NEVER_STARTED              fixed bin(31) value(1077);

 /*                                                                   */
 /* MessageId: ERROR_DUPLICATE_SERVICE_NAME                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The name is already in use as either a service name              */
 /*  or a service display name.                                       */
 /*                                                                   */
 dcl ERROR_DUPLICATE_SERVICE_NAME             fixed bin(31) value(1078);

 /*                                                                   */
 /* MessageId: ERROR_DIFFERENT_SERVICE_ACCOUNT                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The account specified for this service is different from the     */
 /*  account specified for other services running in the same process.*/
 /*                                                                   */
 dcl ERROR_DIFFERENT_SERVICE_ACCOUNT          fixed bin(31) value(1079);

 /*                                                                   */
 /* MessageId: ERROR_CANNOT_DETECT_DRIVER_FAILURE                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Failure actions can only be set for Win32 services, not for      */
 /*  drivers.                                                         */
 /*                                                                   */
 dcl ERROR_CANNOT_DETECT_DRIVER_FAILURE       fixed bin(31) value(1080);

 /*                                                                   */
 /* MessageId: ERROR_CANNOT_DETECT_PROCESS_ABORT                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This service runs in the same process as the service control     */
 /*  manager. Therefore, the service control manager cannot take      */
 /*  action if this service's process terminates unexpectedly.        */
 /*                                                                   */
 dcl ERROR_CANNOT_DETECT_PROCESS_ABORT        fixed bin(31) value(1081);

 /*                                                                   */
 /* MessageId: ERROR_NO_RECOVERY_PROGRAM                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No recovery program has been configured for this service.        */
 /*                                                                   */
 dcl ERROR_NO_RECOVERY_PROGRAM                fixed bin(31) value(1082);

 /*                                                                   */
 /* MessageId: ERROR_END_OF_MEDIA                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The physical end of the tape has been reached.                   */
 /*                                                                   */
 dcl ERROR_END_OF_MEDIA                       fixed bin(31) value(1100);

 /*                                                                   */
 /* MessageId: ERROR_FILEMARK_DETECTED                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A tape access reached a filemark.                                */
 /*                                                                   */
 dcl ERROR_FILEMARK_DETECTED                  fixed bin(31) value(1101);

 /*                                                                   */
 /* MessageId: ERROR_BEGINNING_OF_MEDIA                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Beginning of tape or partition was encountered.                  */
 /*                                                                   */
 dcl ERROR_BEGINNING_OF_MEDIA                 fixed bin(31) value(1102);

 /*                                                                   */
 /* MessageId: ERROR_SETMARK_DETECTED                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A tape access reached the end of a set of files.                 */
 /*                                                                   */
 dcl ERROR_SETMARK_DETECTED                   fixed bin(31) value(1103);

 /*                                                                   */
 /* MessageId: ERROR_NO_DATA_DETECTED                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No more data is on the tape.                                     */
 /*                                                                   */
 dcl ERROR_NO_DATA_DETECTED                   fixed bin(31) value(1104);

 /*                                                                   */
 /* MessageId: ERROR_PARTITION_FAILURE                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Tape could not be partitioned.                                   */
 /*                                                                   */
 dcl ERROR_PARTITION_FAILURE                  fixed bin(31) value(1105);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_BLOCK_LENGTH                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  When accessing a new tape of a multivolume partition,            */
 /*  the current blocksize is incorrect.                              */
 /*                                                                   */
 dcl ERROR_INVALID_BLOCK_LENGTH               fixed bin(31) value(1106);

 /*                                                                   */
 /* MessageId: ERROR_DEVICE_NOT_PARTITIONED                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Tape partition information could not be found                    */
 /*  when loading a tape.                                             */
 /*                                                                   */
 dcl ERROR_DEVICE_NOT_PARTITIONED             fixed bin(31) value(1107);

 /*                                                                   */
 /* MessageId: ERROR_UNABLE_TO_LOCK_MEDIA                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to lock the media eject mechanism.                        */
 /*                                                                   */
 dcl ERROR_UNABLE_TO_LOCK_MEDIA               fixed bin(31) value(1108);

 /*                                                                   */
 /* MessageId: ERROR_UNABLE_TO_UNLOAD_MEDIA                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to unload the media.                                      */
 /*                                                                   */
 dcl ERROR_UNABLE_TO_UNLOAD_MEDIA             fixed bin(31) value(1109);

 /*                                                                   */
 /* MessageId: ERROR_MEDIA_CHANGED                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Media in drive may have changed.                                 */
 /*                                                                   */
 dcl ERROR_MEDIA_CHANGED                      fixed bin(31) value(1110);

 /*                                                                   */
 /* MessageId: ERROR_BUS_RESET                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The I/O bus was reset.                                           */
 /*                                                                   */
 dcl ERROR_BUS_RESET                          fixed bin(31) value(1111);

 /*                                                                   */
 /* MessageId: ERROR_NO_MEDIA_IN_DRIVE                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No media in drive.                                               */
 /*                                                                   */
 dcl ERROR_NO_MEDIA_IN_DRIVE                  fixed bin(31) value(1112);

 /*                                                                   */
 /* MessageId: ERROR_NO_UNICODE_TRANSLATION                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No mapping for the Unicode character exists                      */
 /*  in the target multi-byte code page.                              */
 /*                                                                   */
 dcl ERROR_NO_UNICODE_TRANSLATION             fixed bin(31) value(1113);

 /*                                                                   */
 /* MessageId: ERROR_DLL_INIT_FAILED                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A dynamic link library (DLL) initialization routine failed.      */
 /*                                                                   */
 dcl ERROR_DLL_INIT_FAILED                    fixed bin(31) value(1114);

 /*                                                                   */
 /* MessageId: ERROR_SHUTDOWN_IN_PROGRESS                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A system shutdown is in progress.                                */
 /*                                                                   */
 dcl ERROR_SHUTDOWN_IN_PROGRESS               fixed bin(31) value(1115);

 /*                                                                   */
 /* MessageId: ERROR_NO_SHUTDOWN_IN_PROGRESS                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to abort the system shutdown because no                   */
 /*  shutdown was in progress.                                        */
 /*                                                                   */
 dcl ERROR_NO_SHUTDOWN_IN_PROGRESS            fixed bin(31) value(1116);

 /*                                                                   */
 /* MessageId: ERROR_IO_DEVICE                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The request could not be performed because                       */
 /*  of an I/O device error.                                          */
 /*                                                                   */
 dcl ERROR_IO_DEVICE                          fixed bin(31) value(1117);

 /*                                                                   */
 /* MessageId: ERROR_SERIAL_NO_DEVICE                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No serial device was successfully                                */
 /*  initialized.  The serial driver will unload.                     */
 /*                                                                   */
 dcl ERROR_SERIAL_NO_DEVICE                   fixed bin(31) value(1118);

 /*                                                                   */
 /* MessageId: ERROR_IRQ_BUSY                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to open a device that was sharing an interrupt request    */
 /*  (IRQ) with other devices. At least one other device that uses    */
 /*  that IRQ was already opened.                                     */
 /*                                                                   */
 dcl ERROR_IRQ_BUSY                           fixed bin(31) value(1119);

 /*                                                                   */
 /* MessageId: ERROR_MORE_WRITES                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A serial I/O operation was completed by                          */
 /*  another write to the serial port.                                */
 /*  (The IOCTL_SERIAL_XOFF_COUNTER reached zero.)                    */
 /*                                                                   */
 dcl ERROR_MORE_WRITES                       fixed bin(31) value(1120);

 /*                                                                   */
 /* MessageId: ERROR_COUNTER_TIMEOUT                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A serial I/O operation completed because                         */
 /*  the time-out period expired.                                     */
 /*  (The IOCTL_SERIAL_XOFF_COUNTER did not reach zero.)              */
 /*                                                                   */
 dcl ERROR_COUNTER_TIMEOUT                    fixed bin(31) value(1121);

 /*                                                                   */
 /* MessageId: ERROR_FLOPPY_ID_MARK_NOT_FOUND                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No ID address mark was found on the floppy disk.                 */
 /*                                                                   */
 dcl ERROR_FLOPPY_ID_MARK_NOT_FOUND           fixed bin(31) value(1122);

 /*                                                                   */
 /* MessageId: ERROR_FLOPPY_WRONG_CYLINDER                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Mismatch between the floppy disk sector ID field and the         */
 /*  floppy disk controller track address.                            */
 /*                                                                   */
 dcl ERROR_FLOPPY_WRONG_CYLINDER              fixed bin(31) value(1123);

 /*                                                                   */
 /* MessageId: ERROR_FLOPPY_UNKNOWN_ERROR                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The floppy disk controller reported an error that is not         */
 /*  recognized by the floppy disk driver.                            */
 /*                                                                   */
 dcl ERROR_FLOPPY_UNKNOWN_ERROR               fixed bin(31) value(1124);

 /*                                                                   */
 /* MessageId: ERROR_FLOPPY_BAD_REGISTERS                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The floppy disk controller returned inconsistent results         */
 /*  in its registers.                                                */
 /*                                                                   */
 dcl ERROR_FLOPPY_BAD_REGISTERS              fixed bin(31) value(1125);

 /*                                                                   */
 /* MessageId: ERROR_DISK_RECALIBRATE_FAILED                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  While accessing the hard disk, a recalibrate                     */
 /*  operation failed, even after retries.                            */
 /*                                                                   */
 dcl ERROR_DISK_RECALIBRATE_FAILED            fixed bin(31) value(1126);

 /*                                                                   */
 /* MessageId: ERROR_DISK_OPERATION_FAILED                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  While accessing the hard disk, a disk operation                  */
 /*  failed even after retries.                                       */
 /*                                                                   */
 dcl ERROR_DISK_OPERATION_FAILED              fixed bin(31) value(1127);

 /*                                                                   */
 /* MessageId: ERROR_DISK_RESET_FAILED                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  While accessing the hard disk, a disk                            */
 /*  controller reset was needed, even that failed.                   */
 /*                                                                   */
 dcl ERROR_DISK_RESET_FAILED                  fixed bin(31) value(1128);

 /*                                                                   */
 /* MessageId: ERROR_EOM_OVERFLOW                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Physical end of tape encountered.                                */
 /*                                                                   */
 dcl ERROR_EOM_OVERFLOW                       fixed bin(31) value(1129);

 /*                                                                   */
 /* MessageId: ERROR_NOT_ENOUGH_SERVER_MEMORY                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Not enough server storage is available to process this command.  */
 /*                                                                   */
 dcl ERROR_NOT_ENOUGH_SERVER_MEMORY           fixed bin(31) value(1130);

 /*                                                                   */
 /* MessageId: ERROR_POSSIBLE_DEADLOCK                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A potential deadlock condition has been detected.                */
 /*                                                                   */
 dcl ERROR_POSSIBLE_DEADLOCK                  fixed bin(31) value(1131);

 /*                                                                   */
 /* MessageId: ERROR_MAPPED_ALIGNMENT                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The base address or the file offset specified does not have      */
 /*  the proper alignment.                                            */
 /*                                                                   */
 dcl ERROR_MAPPED_ALIGNMENT                   fixed bin(31) value(1132);

 /*                                                                   */
 /* MessageId: ERROR_SET_POWER_STATE_VETOED                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An attempt to change the system power state was vetoed by        */
 /*  another application or driver.                                   */
 /*                                                                   */
 dcl ERROR_SET_POWER_STATE_VETOED             fixed bin(31) value(1140);

 /*                                                                   */
 /* MessageId: ERROR_SET_POWER_STATE_FAILED                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system BIOS failed an attempt to                             */
 /*  change the system power state.                                   */
 /*                                                                   */
 dcl ERROR_SET_POWER_STATE_FAILED             fixed bin(31) value(1141);

 /*                                                                   */
 /* MessageId: ERROR_TOO_MANY_LINKS                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An attempt was made to create more links on a file than          */
 /*  the file system supports.                                        */
 /*                                                                   */
 dcl ERROR_TOO_MANY_LINKS                     fixed bin(31) value(1142);

 /*                                                                   */
 /* MessageId: ERROR_OLD_WIN_VERSION                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified program requires a newer version of Windows.       */
 /*                                                                   */
 dcl ERROR_OLD_WIN_VERSION                    fixed bin(31) value(1150);

 /*                                                                   */
 /* MessageId: ERROR_APP_WRONG_OS                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified program is not a Windows or MS-DOS program.        */
 /*                                                                   */
 dcl ERROR_APP_WRONG_OS                       fixed bin(31) value(1151);

 /*                                                                   */
 /* MessageId: ERROR_SINGLE_INSTANCE_APP                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Cannot start more than one instance of the specified program.    */
 /*                                                                   */
 dcl ERROR_SINGLE_INSTANCE_APP                fixed bin(31) value(1152);

 /*                                                                   */
 /* MessageId: ERROR_RMODE_APP                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified program was written for                            */
 /*  an older version of Windows.                                     */
 /*                                                                   */
 dcl ERROR_RMODE_APP                          fixed bin(31) value(1153);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_DLL                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  One of the library files needed to run this                      */
 /*  application is damaged.                                          */
 /*                                                                   */
 dcl ERROR_INVALID_DLL                        fixed bin(31) value(1154);

 /*                                                                   */
 /* MessageId: ERROR_NO_ASSOCIATION                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No application is associated with the specified                  */
 /*  file for this operation.                                         */
 /*                                                                   */
 dcl ERROR_NO_ASSOCIATION                     fixed bin(31) value(1155);

 /*                                                                   */
 /* MessageId: ERROR_DDE_FAIL                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An error occurred in sending the command to the application.     */
 /*                                                                   */
 dcl ERROR_DDE_FAIL                           fixed bin(31) value(1156);

 /*                                                                   */
 /* MessageId: ERROR_DLL_NOT_FOUND                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  One of the library files needed to run this application          */
 /*  cannot be found.                                                 */
 /*                                                                   */
 dcl ERROR_DLL_NOT_FOUND                      fixed bin(31) value(1157);

 /*                                                                   */
 /* MessageId: ERROR_NO_MORE_USER_HANDLES                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The current process has used all of its system allowance of      */
 /*  handles for Window Manager objects.                              */
 /*                                                                   */
 dcl ERROR_NO_MORE_USER_HANDLES               fixed bin(31) value(1158);

 /*                                                                   */
 /* MessageId: ERROR_MESSAGE_SYNC_ONLY                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The message can only be used with synchronous operations only.   */
 /*                                                                   */
 dcl ERROR_MESSAGE_SYNC_ONLY                  fixed bin(31) value(1159);

 /*                                                                   */
 /* MessageId: ERROR_SOURCE_ELEMENT_EMPTY                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The indicated source element has no media.                       */
 /*                                                                   */
 dcl ERROR_SOURCE_ELEMENT_EMPTY               fixed bin(31) value(1160);

 /*                                                                   */
 /* MessageId: ERROR_DESTINATION_ELEMENT_FULL                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The indicated destination element already contains media.        */
 /*                                                                   */
 dcl ERROR_DESTINATION_ELEMENT_FULL           fixed bin(31) value(1161);

 /*                                                                   */
 /* MessageId: ERROR_ILLEGAL_ELEMENT_ADDRESS                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The indicated element does not exist.                            */
 /*                                                                   */
 dcl ERROR_ILLEGAL_ELEMENT_ADDRESS            fixed bin(31) value(1162);

 /*                                                                   */
 /* MessageId: ERROR_MAGAZINE_NOT_PRESENT                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The indicated element is part of a magazine that is not present. */
 /*                                                                   */
 dcl ERROR_MAGAZINE_NOT_PRESENT               fixed bin(31) value(1163);

 /*                                                                   */
 /* MessageId: ERROR_DEVICE_REINITIALIZATION_NEEDED                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The indicated device requires reinitialization due to hardware   */
 /*  errors.                                                          */
 /*                                                                   */
 dcl ERROR_DEVICE_REINITIALIZATION_NEEDED     fixed bin(31) value(1164);

 /*                                                                   */
 /* MessageId: ERROR_DEVICE_REQUIRES_CLEANING                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The device has indicated that cleaning is required before        */
 /*  further operations are attempted.                                */
 /*                                                                   */
 dcl ERROR_DEVICE_REQUIRES_CLEANING           fixed bin(31) value(1165);

 /*                                                                   */
 /* MessageId: ERROR_DEVICE_DOOR_OPEN                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The device has indicated that its door is open.                  */
 /*                                                                   */
 dcl ERROR_DEVICE_DOOR_OPEN                   fixed bin(31) value(1166);

 /*                                                                   */
 /* MessageId: ERROR_DEVICE_NOT_CONNECTED                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The device is not connected.                                     */
 /*                                                                   */
 dcl ERROR_DEVICE_NOT_CONNECTED               fixed bin(31) value(1167);

 /*                                                                   */
 /* MessageId: ERROR_NOT_FOUND                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Element not found.                                               */
 /*                                                                   */
 dcl ERROR_NOT_FOUND                          fixed bin(31) value(1168);

 /*                                                                   */
 /* MessageId: ERROR_NO_MATCH                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There was no match for the specified key in the index.           */
 /*                                                                   */
 dcl ERROR_NO_MATCH                           fixed bin(31) value(1169);

 /*                                                                   */
 /* MessageId: ERROR_SET_NOT_FOUND                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The property set specified does not exist on the object.         */
 /*                                                                   */
 dcl ERROR_SET_NOT_FOUND                      fixed bin(31) value(1170);

 /*                                                                   */
 /* MessageId: ERROR_POINT_NOT_FOUND                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The point passed to GetMouseMovePoints is not in the buffer.     */
 /*                                                                   */
 dcl ERROR_POINT_NOT_FOUND                    fixed bin(31) value(1171);

 /*                                                                   */
 /* MessageId: ERROR_NO_TRACKING_SERVICE                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The tracking (workstation) service is not running.               */
 /*                                                                   */
 dcl ERROR_NO_TRACKING_SERVICE                fixed bin(31) value(1172);

 /*                                                                   */
 /* MessageId: ERROR_NO_VOLUME_ID                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The Volume ID could not be found.                                */
 /*                                                                   */
 dcl ERROR_NO_VOLUME_ID                       fixed bin(31) value(1173);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_VLM_OPERATION                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified Very Large Memory (64-bit) operation is invalid.   */
 /*                                                                   */
 dcl ERROR_INVALID_VLM_OPERATION              fixed bin(31) value(1174);

 /*                                                                   */
 /* MessageId: ERROR_UNABLE_TO_REMOVE_REPLACED                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to remove the file to be replaced.                        */
 /*                                                                   */
 dcl ERROR_UNABLE_TO_REMOVE_REPLACED          fixed bin(31) value(1175);

 /*                                                                   */
 /* MessageId: ERROR_UNABLE_TO_MOVE_REPLACEMENT                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to move the replacement file to the file to be replaced.  */
 /* The file to be replaced has retained its original name.           */
 /*                                                                   */
 dcl ERROR_UNABLE_TO_MOVE_REPLACEMENT         fixed bin(31) value(1176);

 /*                                                                   */
 /* MessageId: ERROR_UNABLE_TO_MOVE_REPLACEMENT_2                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to move the replacement file to the file to be replaced.  */
 /*  The file to be replaced has been renamed using the backup name.  */
 /*                                                                   */
 dcl ERROR_UNABLE_TO_MOVE_REPLACEMENT_2       fixed bin(31) value(1177);

 /*                                                                   */
 /* MessageId: ERROR_JOURNAL_DELETE_IN_PROGRESS                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The volume change journal is being deleted.                      */
 /*                                                                   */
 dcl ERROR_JOURNAL_DELETE_IN_PROGRESS         fixed bin(31) value(1178);

 /*                                                                   */
 /* MessageId: ERROR_JOURNAL_NOT_ACTIVE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The volume change journal service is not active.                 */
 /*                                                                   */
 dcl ERROR_JOURNAL_NOT_ACTIVE                 fixed bin(31) value(1179);

 /*                                                                   */
 /* MessageId: ERROR_POTENTIAL_FILE_FOUND                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A file was found, but it may not be the correct file.            */
 /*                                                                   */
 dcl ERROR_POTENTIAL_FILE_FOUND               fixed bin(31) value(1180);

 /*                                                                   */
 /* MessageId: ERROR_JOURNAL_ENTRY_DELETED                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The journal entry has been deleted from the journal.             */
 /*                                                                   */
 dcl ERROR_JOURNAL_ENTRY_DELETED              fixed bin(31) value(1181);

 /*                                                                   */
 /* MessageId: ERROR_BAD_DEVICE                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified device name is invalid.                            */
 /*                                                                   */
 dcl ERROR_BAD_DEVICE                         fixed bin(31) value(1200);

 /*                                                                   */
 /* MessageId: ERROR_CONNECTION_UNAVAIL                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The device is not currently connected                            */
 /*  but it is a remembered connection.                               */
 /*                                                                   */
 dcl ERROR_CONNECTION_UNAVAIL                 fixed bin(31) value(1201);

 /*                                                                   */
 /* MessageId: ERROR_DEVICE_ALREADY_REMEMBERED                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An attempt was made to remember a device that                    */
 /*  had previously been remembered.                                  */
 /*                                                                   */
 dcl ERROR_DEVICE_ALREADY_REMEMBERED          fixed bin(31) value(1202);

 /*                                                                   */
 /* MessageId: ERROR_NO_NET_OR_BAD_PATH                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No network provider accepted the given network path.             */
 /*                                                                   */
 dcl ERROR_NO_NET_OR_BAD_PATH                 fixed bin(31) value(1203);

 /*                                                                   */
 /* MessageId: ERROR_BAD_PROVIDER                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified network provider name is invalid.                  */
 /*                                                                   */
 dcl ERROR_BAD_PROVIDER                       fixed bin(31) value(1204);

 /*                                                                   */
 /* MessageId: ERROR_CANNOT_OPEN_PROFILE                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to open the network connection profile.                   */
 /*                                                                   */
 dcl ERROR_CANNOT_OPEN_PROFILE                fixed bin(31) value(1205);

 /*                                                                   */
 /* MessageId: ERROR_BAD_PROFILE                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The network connection profile is corrupt.                       */
 /*                                                                   */
 dcl ERROR_BAD_PROFILE                        fixed bin(31) value(1206);

 /*                                                                   */
 /* MessageId: ERROR_NOT_CONTAINER                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Cannot enumerate a non-container.                                */
 /*                                                                   */
 dcl ERROR_NOT_CONTAINER                      fixed bin(31) value(1207);

 /*                                                                   */
 /* MessageId: ERROR_EXTENDED_ERROR                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An extended error has occurred.                                  */
 /*                                                                   */
 dcl ERROR_EXTENDED_ERROR                     fixed bin(31) value(1208);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_GROUPNAME                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The format of the specified group name is invalid.               */
 /*                                                                   */
 dcl ERROR_INVALID_GROUPNAME                  fixed bin(31) value(1209);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_COMPUTERNAME                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The format of the specified computer name is invalid.            */
 /*                                                                   */
 dcl ERROR_INVALID_COMPUTERNAME               fixed bin(31) value(1210);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_EVENTNAME                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The format of the specified event name is invalid.               */
 /*                                                                   */
 dcl ERROR_INVALID_EVENTNAME                  fixed bin(31) value(1211);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_DOMAINNAME                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The format of the specified domain name is invalid.              */
 /*                                                                   */
 dcl ERROR_INVALID_DOMAINNAME                 fixed bin(31) value(1212);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_SERVICENAME                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The format of the specified service name is invalid.             */
 /*                                                                   */
 dcl ERROR_INVALID_SERVICENAME                fixed bin(31) value(1213);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_NETNAME                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The format of the specified network name is invalid.             */
 /*                                                                   */
 dcl ERROR_INVALID_NETNAME                    fixed bin(31) value(1214);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_SHARENAME                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The format of the specified share name is invalid.               */
 /*                                                                   */
 dcl ERROR_INVALID_SHARENAME                  fixed bin(31) value(1215);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_PASSWORDNAME                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The format of the specified password is invalid.                 */
 /*                                                                   */
 dcl ERROR_INVALID_PASSWORDNAME               fixed bin(31) value(1216);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_MESSAGENAME                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The format of the specified message name is invalid.             */
 /*                                                                   */
 dcl ERROR_INVALID_MESSAGENAME                fixed bin(31) value(1217);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_MESSAGEDEST                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The format of the specified message destination is invalid.      */
 /*                                                                   */
 dcl ERROR_INVALID_MESSAGEDEST                fixed bin(31) value(1218);

 /*                                                                   */
 /* MessageId: ERROR_SESSION_CREDENTIAL_CONFLICT                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The credentials supplied conflict with an existing               */
 /*  set of credentials.                                              */
 /*                                                                   */
 dcl ERROR_SESSION_CREDENTIAL_CONFLICT        fixed bin(31) value(1219);

 /*                                                                   */
 /* MessageId: ERROR_REMOTE_SESSION_LIMIT_EXCEEDED                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An attempt was made to establish a session to a network server,  */
 /*  but there are already too many sessions established to that      */
 /*  server.                                                          */
 /*                                                                   */
 dcl ERROR_REMOTE_SESSION_LIMIT_EXCEEDED      fixed bin(31) value(1220);

 /*                                                                   */
 /* MessageId: ERROR_DUP_DOMAINNAME                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The workgroup or domain name is already in use by another        */
 /*  computer on the network.                                         */
 /*                                                                   */
 dcl ERROR_DUP_DOMAINNAME                     fixed bin(31) value(1221);

 /*                                                                   */
 /* MessageId: ERROR_NO_NETWORK                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The network is not present or not started.                       */
 /*                                                                   */
 dcl ERROR_NO_NETWORK                         fixed bin(31) value(1222);

 /*                                                                   */
 /* MessageId: ERROR_CANCELLED                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operation was cancelled by the user.                         */
 /*                                                                   */
 dcl ERROR_CANCELLED                          fixed bin(31) value(1223);

 /*                                                                   */
 /* MessageId: ERROR_USER_MAPPED_FILE                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested operation cannot be performed                      */
 /*  on a file with a user mapped section open.                       */
 /*                                                                   */
 dcl ERROR_USER_MAPPED_FILE                   fixed bin(31) value(1224);

 /*                                                                   */
 /* MessageId: ERROR_CONNECTION_REFUSED                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The remote system refused the network connection.                */
 /*                                                                   */
 dcl ERROR_CONNECTION_REFUSED                 fixed bin(31) value(1225);

 /*                                                                   */
 /* MessageId: ERROR_GRACEFUL_DISCONNECT                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The network connection was gracefully closed.                    */
 /*                                                                   */
 dcl ERROR_GRACEFUL_DISCONNECT                fixed bin(31) value(1226);

 /*                                                                   */
 /* MessageId: ERROR_ADDRESS_ALREADY_ASSOCIATED                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The network transport endpoint already has                       */
 /*  an address associated with it.                                   */
 /*                                                                   */
 dcl ERROR_ADDRESS_ALREADY_ASSOCIATED         fixed bin(31) value(1227);

 /*                                                                   */
 /* MessageId: ERROR_ADDRESS_NOT_ASSOCIATED                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An address has not yet been associated with the network endpoint.*/
 /*                                                                   */
 dcl ERROR_ADDRESS_NOT_ASSOCIATED             fixed bin(31) value(1228);

 /*                                                                   */
 /* MessageId: ERROR_CONNECTION_INVALID                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An operation was attempted on a non-existent network connection. */
 /*                                                                   */
 dcl ERROR_CONNECTION_INVALID                 fixed bin(31) value(1229);

 /*                                                                   */
 /* MessageId: ERROR_CONNECTION_ACTIVE                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An invalid operation was attempted                               */
 /*  on an active network connection.                                 */
 /*                                                                   */
 dcl ERROR_CONNECTION_ACTIVE                  fixed bin(31) value(1230);

 /*                                                                   */
 /* MessageId: ERROR_NETWORK_UNREACHABLE                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The remote network is not reachable by the transport.            */
 /*                                                                   */
 dcl ERROR_NETWORK_UNREACHABLE                fixed bin(31) value(1231);

 /*                                                                   */
 /* MessageId: ERROR_HOST_UNREACHABLE                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The remote system is not reachable by the transport.             */
 /*                                                                   */
 dcl ERROR_HOST_UNREACHABLE                   fixed bin(31) value(1232);

 /*                                                                   */
 /* MessageId: ERROR_PROTOCOL_UNREACHABLE                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The remote system does not support the transport protocol.       */
 /*                                                                   */
 dcl ERROR_PROTOCOL_UNREACHABLE               fixed bin(31) value(1233);

 /*                                                                   */
 /* MessageId: ERROR_PORT_UNREACHABLE                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No service is operating at the destination network endpoint      */
 /*  on the remote system.                                            */
 /*                                                                   */
 dcl ERROR_PORT_UNREACHABLE                   fixed bin(31) value(1234);

 /*                                                                   */
 /* MessageId: ERROR_REQUEST_ABORTED                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The request was aborted.                                         */
 /*                                                                   */
 dcl ERROR_REQUEST_ABORTED                    fixed bin(31) value(1235);

 /*                                                                   */
 /* MessageId: ERROR_CONNECTION_ABORTED                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The network connection was aborted by the local system.          */
 /*                                                                   */
 dcl ERROR_CONNECTION_ABORTED                 fixed bin(31) value(1236);

 /*                                                                   */
 /* MessageId: ERROR_RETRY                                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operation could not be completed.                            */
 /*  A retry should be performed.                                     */
 /*                                                                   */
 dcl ERROR_RETRY                              fixed bin(31) value(1237);

 /*                                                                   */
 /* MessageId: ERROR_CONNECTION_COUNT_LIMIT                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A connection to the server could not be made because the limit   */
 /*  on the number of concurrent connections for this account has     */
 /*  been reached.                                                    */
 /*                                                                   */
 dcl ERROR_CONNECTION_COUNT_LIMIT             fixed bin(31) value(1238);

 /*                                                                   */
 /* MessageId: ERROR_LOGIN_TIME_RESTRICTION                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Attempting to login during an unauthorized                       */
 /*  time of day for this account.                                    */
 /*                                                                   */
 dcl ERROR_LOGIN_TIME_RESTRICTION             fixed bin(31) value(1239);

 /*                                                                   */
 /* MessageId: ERROR_LOGIN_WKSTA_RESTRICTION                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The account is not authorized to login from this station.        */
 /*                                                                   */
 dcl ERROR_LOGIN_WKSTA_RESTRICTION            fixed bin(31) value(1240);

 /*                                                                   */
 /* MessageId: ERROR_INCORRECT_ADDRESS                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The network address could not be used                            */
 /* for the operation requested.                                      */
 /*                                                                   */
 dcl ERROR_INCORRECT_ADDRESS                  fixed bin(31) value(1241);

 /*                                                                   */
 /* MessageId: ERROR_ALREADY_REGISTERED                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The service is already registered.                               */
 /*                                                                   */
 dcl ERROR_ALREADY_REGISTERED                 fixed bin(31) value(1242);

 /*                                                                   */
 /* MessageId: ERROR_SERVICE_NOT_FOUND                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified service does not exist.                            */
 /*                                                                   */
 dcl ERROR_SERVICE_NOT_FOUND                  fixed bin(31) value(1243);

 /*                                                                   */
 /* MessageId: ERROR_NOT_AUTHENTICATED                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operation being requested was not performed because the user */
 /*  has not been authenticated.                                      */
 /*                                                                   */
 dcl ERROR_NOT_AUTHENTICATED                  fixed bin(31) value(1244);

 /*                                                                   */
 /* MessageId: ERROR_NOT_LOGGED_ON                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operation being requested was not performed because the user */
 /*  has not logged on to the network.                                */
 /*  The specified service does not exist.                            */
 /*                                                                   */
 dcl ERROR_NOT_LOGGED_ON                      fixed bin(31) value(1245);

 /*                                                                   */
 /* MessageId: ERROR_CONTINUE                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Return that wants caller to continue with work in progress.      */
 /*                                                                   */
 dcl ERROR_CONTINUE                           fixed bin(31) value(1246);

 /*                                                                   */
 /* MessageId: ERROR_ALREADY_INITIALIZED                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An attempt was made to perform an initialization operation when  */
 /*  initialization has already been completed.                       */
 /*                                                                   */
 dcl ERROR_ALREADY_INITIALIZED                fixed bin(31) value(1247);

 /*                                                                   */
 /* MessageId: ERROR_NO_MORE_DEVICES                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No more local devices.                                           */
 /*                                                                   */
 dcl ERROR_NO_MORE_DEVICES                    fixed bin(31) value(1248);

 /*                                                                   */
 /* MessageId: ERROR_NO_SUCH_SITE                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified site does not exist.                               */
 /*                                                                   */
 dcl ERROR_NO_SUCH_SITE                       fixed bin(31) value(1249);

 /*                                                                   */
 /* MessageId: ERROR_DOMAIN_CONTROLLER_EXISTS                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A domain controller with the specified name already exists.      */
 /*                                                                   */
 dcl ERROR_DOMAIN_CONTROLLER_EXISTS           fixed bin(31) value(1250);

 /*                                                                   */
 /* MessageId: ERROR_ONLY_IF_CONNECTED                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This operation is supported only when you are connected to the   */
 /*  server.                                                          */
 /*                                                                   */
 dcl ERROR_ONLY_IF_CONNECTED                  fixed bin(31) value(1251);

 /*                                                                   */
 /* MessageId: ERROR_OVERRIDE_NOCHANGES                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The group policy framework should call the extension even        */
 /* if there are no changes.                                          */
 /*                                                                   */
 dcl ERROR_OVERRIDE_NOCHANGES                 fixed bin(31) value(1252);


 /*********************************************************************/
 /*                                                                   */
 /* Security Status Codes                                             */
 /*                                                                   */
 /*********************************************************************/

 /*                                                                   */
 /* MessageId: ERROR_NOT_ALL_ASSIGNED                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Not all privileges referenced are assigned to the caller.        */
 /*                                                                   */
 dcl ERROR_NOT_ALL_ASSIGNED                   fixed bin(31) value(1300);

 /*                                                                   */
 /* MessageId: ERROR_SOME_NOT_MAPPED                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Some mapping between account names and security IDs was          */
 /* not done.                                                         */
 /*                                                                   */
 dcl ERROR_SOME_NOT_MAPPED                    fixed bin(31) value(1301);

 /*                                                                   */
 /* MessageId: ERROR_NO_QUOTAS_FOR_ACCOUNT                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No system quota limits are specifically set for this account.    */
 /*                                                                   */
 dcl ERROR_NO_QUOTAS_FOR_ACCOUNT              fixed bin(31) value(1302);

 /*                                                                   */
 /* MessageId: ERROR_LOCAL_USER_SESSION_KEY                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No encryption key is available.  A well-known encryption         */
 /*  key was returned.                                                */
 /*                                                                   */
 dcl ERROR_LOCAL_USER_SESSION_KEY             fixed bin(31) value(1303);

 /*                                                                   */
 /* MessageId: ERROR_NULL_LM_PASSWORD                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The NT password is too complex to be converted to a LAN Manager  */
 /*  password.  The LAN Manager password returned is a NULL string.   */
 /*                                                                   */
 dcl ERROR_NULL_LM_PASSWORD                   fixed bin(31) value(1304);

 /*                                                                   */
 /* MessageId: ERROR_UNKNOWN_REVISION                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The revision level is unknown.                                   */
 /*                                                                   */
 dcl ERROR_UNKNOWN_REVISION                   fixed bin(31) value(1305);

 /*                                                                   */
 /* MessageId: ERROR_REVISION_MISMATCH                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Indicates two revision levels are incompatible.                  */
 /*                                                                   */
 dcl ERROR_REVISION_MISMATCH                  fixed bin(31) value(1306);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_OWNER                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This security ID may not be assigned as the owner of this        */
 /*  object.                                                          */
 /*                                                                   */
 dcl ERROR_INVALID_OWNER                      fixed bin(31) value(1307);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_PRIMARY_GROUP                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This security ID may not be assigned as                          */
 /*  the primary group of an object.                                  */
 /*                                                                   */
 dcl ERROR_INVALID_PRIMARY_GROUP              fixed bin(31) value(1308);

 /*                                                                   */
 /* MessageId: ERROR_NO_IMPERSONATION_TOKEN                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An attempt has been made to operate on an impersonation token    */
 /*  by a thread that is not currently impersonating a client.        */
 /*                                                                   */
 dcl ERROR_NO_IMPERSONATION_TOKEN             fixed bin(31) value(1309);

 /*                                                                   */
 /* MessageId: ERROR_CANT_DISABLE_MANDATORY                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The group may not be disabled.                                   */
 /*                                                                   */
 dcl ERROR_CANT_DISABLE_MANDATORY             fixed bin(31) value(1310);

 /*                                                                   */
 /* MessageId: ERROR_NO_LOGON_SERVERS                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There are currently no logon servers available to service the    */
 /*  logon request.                                                   */
 /*                                                                   */
 dcl ERROR_NO_LOGON_SERVERS                   fixed bin(31) value(1311);

 /*                                                                   */
 /* MessageId: ERROR_NO_SUCH_LOGON_SESSION                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*   A specified logon session does not exist.                       */
 /*   It may already have been terminated.                            */
 /*                                                                   */
 dcl ERROR_NO_SUCH_LOGON_SESSION              fixed bin(31) value(1312);

 /*                                                                   */
 /* MessageId: ERROR_NO_SUCH_PRIVILEGE                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*   A specified privilege does not exist.                           */
 /*                                                                   */
 dcl ERROR_NO_SUCH_PRIVILEGE                  fixed bin(31) value(1313);

 /*                                                                   */
 /* MessageId: ERROR_PRIVILEGE_NOT_HELD                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*   A required privilege is not held by the client.                 */
 /*                                                                   */
 dcl ERROR_PRIVILEGE_NOT_HELD                 fixed bin(31) value(1314);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_ACCOUNT_NAME                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The name provided is not a properly formed account name.         */
 /*                                                                   */
 dcl ERROR_INVALID_ACCOUNT_NAME               fixed bin(31) value(1315);

 /*                                                                   */
 /* MessageId: ERROR_USER_EXISTS                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified user already exists.                               */
 /*                                                                   */
 dcl ERROR_USER_EXISTS                        fixed bin(31) value(1316);

 /*                                                                   */
 /* MessageId: ERROR_NO_SUCH_USER                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified user does not exist.                               */
 /*                                                                   */
 dcl ERROR_NO_SUCH_USER                       fixed bin(31) value(1317);

 /*                                                                   */
 /* MessageId: ERROR_GROUP_EXISTS                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified group already exists.                              */
 /*                                                                   */
 dcl ERROR_GROUP_EXISTS                       fixed bin(31) value(1318);

 /*                                                                   */
 /* MessageId: ERROR_NO_SUCH_GROUP                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified group does not exist.                              */
 /*                                                                   */
 dcl ERROR_NO_SUCH_GROUP                      fixed bin(31) value(1319);

 /*                                                                   */
 /* MessageId: ERROR_MEMBER_IN_GROUP                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Either the specified user account is already a member of the     */
 /*  specified group, or the specified group cannot be deleted        */
 /*  because it contains a member.                                    */
 /*                                                                   */
 dcl ERROR_MEMBER_IN_GROUP                    fixed bin(31) value(1320);

 /*                                                                   */
 /* MessageId: ERROR_MEMBER_NOT_IN_GROUP                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified user account is not a member                       */
 /*  of the specified group account.                                  */
 /*                                                                   */
 dcl ERROR_MEMBER_NOT_IN_GROUP                fixed bin(31) value(1321);

 /*                                                                   */
 /* MessageId: ERROR_LAST_ADMIN                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The last remaining administration account cannot be disabled     */
 /*  or deleted.                                                      */
 /*                                                                   */
 dcl ERROR_LAST_ADMIN                         fixed bin(31) value(1322);

 /*                                                                   */
 /* MessageId: ERROR_WRONG_PASSWORD                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to update the password.  The value                        */
 /*  provided as the current                                          */
 /*  password is incorrect.                                           */
 /*                                                                   */
 dcl ERROR_WRONG_PASSWORD                     fixed bin(31) value(1323);

 /*                                                                   */
 /* MessageId: ERROR_ILL_FORMED_PASSWORD                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to update the password.  The value                        */
 /* provided for the new pass                                         */
 /* word                                                              */
 /*  contains values that are not allowed in passwords.               */
 /*                                                                   */
 dcl ERROR_ILL_FORMED_PASSWORD                fixed bin(31) value(1324);

 /*                                                                   */
 /* MessageId: ERROR_PASSWORD_RESTRICTION                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to update the password because a password update          */
 /*  rule has been violated.                                          */
 /*                                                                   */
 dcl ERROR_PASSWORD_RESTRICTION               fixed bin(31) value(1325);

 /*                                                                   */
 /* MessageId: ERROR_LOGON_FAILURE                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Logon failure: unknown user name or bad password.                */
 /*                                                                   */
 dcl ERROR_LOGON_FAILURE                      fixed bin(31) value(1326);

 /*                                                                   */
 /* MessageId: ERROR_ACCOUNT_RESTRICTION                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Logon failure: user account restriction.                         */
 /*                                                                   */
 dcl ERROR_ACCOUNT_RESTRICTION                fixed bin(31) value(1327);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_LOGON_HOURS                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Logon failure: account logon time restriction violation.         */
 /*                                                                   */
 dcl ERROR_INVALID_LOGON_HOURS                fixed bin(31) value(1328);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_WORKSTATION                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Logon failure: user not allowed to log on to this computer.      */
 /*                                                                   */
 dcl ERROR_INVALID_WORKSTATION                fixed bin(31) value(1329);

 /*                                                                   */
 /* MessageId: ERROR_PASSWORD_EXPIRED                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Logon failure: the specified account password has expired.       */
 /*                                                                   */
 dcl ERROR_PASSWORD_EXPIRED                   fixed bin(31) value(1330);

 /*                                                                   */
 /* MessageId: ERROR_ACCOUNT_DISABLED                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Logon failure: account currently disabled.                       */
 /*                                                                   */
 dcl ERROR_ACCOUNT_DISABLED                   fixed bin(31) value(1331);

 /*                                                                   */
 /* MessageId: ERROR_NONE_MAPPED                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No mapping between account names and security IDs was done.      */
 /*                                                                   */
 dcl ERROR_NONE_MAPPED                        fixed bin(31) value(1332);

 /*                                                                   */
 /* MessageId: ERROR_TOO_MANY_LUIDS_REQUESTED                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Too many local user identifiers (LUIDs) were requested           */
 /*  at one time.                                                     */
 /*                                                                   */
 dcl ERROR_TOO_MANY_LUIDS_REQUESTED           fixed bin(31) value(1333);

 /*                                                                   */
 /* MessageId: ERROR_LUIDS_EXHAUSTED                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No more local user identifiers (LUIDs) are available.            */
 /*                                                                   */
 dcl ERROR_LUIDS_EXHAUSTED                    fixed bin(31) value(1334);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_SUB_AUTHORITY                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The subauthority part of a security ID is invalid for            */
 /*  this particular use.                                             */
 /*                                                                   */
 dcl ERROR_INVALID_SUB_AUTHORITY              fixed bin(31) value(1335);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_ACL                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The access control list (ACL) structure is invalid.              */
 /*                                                                   */
 dcl ERROR_INVALID_ACL                        fixed bin(31) value(1336);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_SID                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The security ID structure is invalid.                            */
 /*                                                                   */
 dcl ERROR_INVALID_SID                        fixed bin(31) value(1337);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_SECURITY_DESCR                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The security descriptor structure is invalid.                    */
 /*                                                                   */
 dcl ERROR_INVALID_SECURITY_DESCR             fixed bin(31) value(1338);

 /*                                                                   */
 /* MessageId: ERROR_BAD_INHERITANCE_ACL                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The inherited access control list (ACL) or                       */
 /*  access control entry (ACE) could not be built.                   */
 /*                                                                   */
 dcl ERROR_BAD_INHERITANCE_ACL                fixed bin(31) value(1340);

 /*                                                                   */
 /* MessageId: ERROR_SERVER_DISABLED                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The server is currently disabled.                                */
 /*                                                                   */
 dcl ERROR_SERVER_DISABLED                    fixed bin(31) value(1341);

 /*                                                                   */
 /* MessageId: ERROR_SERVER_NOT_DISABLED                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The server is currently enabled.                                 */
 /*                                                                   */
 dcl ERROR_SERVER_NOT_DISABLED                fixed bin(31) value(1342);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_ID_AUTHORITY                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The value provided was an invalid value                          */
 /*  for an identifier authority.                                     */
 /*                                                                   */
 dcl ERROR_INVALID_ID_AUTHORITY               fixed bin(31) value(1343);

 /*                                                                   */
 /* MessageId: ERROR_ALLOTTED_SPACE_EXCEEDED                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No more memory is available for security information updates.    */
 /*                                                                   */
 dcl ERROR_ALLOTTED_SPACE_EXCEEDED            fixed bin(31) value(1344);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_GROUP_ATTRIBUTES                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified attributes are invalid, or incompatible with the   */
 /*  attributes for the group as a whole.                             */
 /*                                                                   */
 dcl ERROR_INVALID_GROUP_ATTRIBUTES           fixed bin(31) value(1345);

 /*                                                                   */
 /* MessageId: ERROR_BAD_IMPERSONATION_LEVEL                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Either a required impersonation level was not provided, or the   */
 /*  provided impersonation level is invalid.                         */
 /*                                                                   */
 dcl ERROR_BAD_IMPERSONATION_LEVEL            fixed bin(31) value(1346);

 /*                                                                   */
 /* MessageId: ERROR_CANT_OPEN_ANONYMOUS                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Cannot open an anonymous level security token.                   */
 /*                                                                   */
 dcl ERROR_CANT_OPEN_ANONYMOUS                fixed bin(31) value(1347);

 /*                                                                   */
 /* MessageId: ERROR_BAD_VALIDATION_CLASS                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The validation information class requested was invalid.          */
 /*                                                                   */
 dcl ERROR_BAD_VALIDATION_CLASS               fixed bin(31) value(1348);

 /*                                                                   */
 /* MessageId: ERROR_BAD_TOKEN_TYPE                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The type of the token is inappropriate for its attempted use.    */
 /*                                                                   */
 dcl ERROR_BAD_TOKEN_TYPE                     fixed bin(31) value(1349);

 /*                                                                   */
 /* MessageId: ERROR_NO_SECURITY_ON_OBJECT                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to perform a security operation on an object              */
 /*  which has no associated security.                                */
 /*                                                                   */
 dcl ERROR_NO_SECURITY_ON_OBJECT              fixed bin(31) value(1350);

 /*                                                                   */
 /* MessageId: ERROR_CANT_ACCESS_DOMAIN_INFO                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Indicates a Windows NT Server could not be contacted or that     */
 /*  objects within the domain are protected such that necessary      */
 /*  information could not be retrieved.                              */
 /*                                                                   */
 dcl ERROR_CANT_ACCESS_DOMAIN_INFO            fixed bin(31) value(1351);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_SERVER_STATE                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The security account manager (SAM) or local security             */
 /*  authority (LSA) server was in the wrong state to perform         */
 /*  the security operation.                                          */
 /*                                                                   */
 dcl ERROR_INVALID_SERVER_STATE               fixed bin(31) value(1352);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_DOMAIN_STATE                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The domain was in the wrong state to perform                     */
 /*  the security operation.                                          */
 /*                                                                   */
 dcl ERROR_INVALID_DOMAIN_STATE               fixed bin(31) value(1353);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_DOMAIN_ROLE                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This operation is only allowed for the                           */
 /*  Primary Domain Controller of the domain.                         */
 /*                                                                   */
 dcl ERROR_INVALID_DOMAIN_ROLE                fixed bin(31) value(1354);

 /*                                                                   */
 /* MessageId: ERROR_NO_SUCH_DOMAIN                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified domain did not exist.                              */
 /*                                                                   */
 dcl ERROR_NO_SUCH_DOMAIN                     fixed bin(31) value(1355);

 /*                                                                   */
 /* MessageId: ERROR_DOMAIN_EXISTS                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified domain already exists.                             */
 /*                                                                   */
 dcl ERROR_DOMAIN_EXISTS                      fixed bin(31) value(1356);

 /*                                                                   */
 /* MessageId: ERROR_DOMAIN_LIMIT_EXCEEDED                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An attempt was made to exceed the limit                          */
 /*  on the number of domains per server.                             */
 /*                                                                   */
 dcl ERROR_DOMAIN_LIMIT_EXCEEDED              fixed bin(31) value(1357);

 /*                                                                   */
 /* MessageId: ERROR_INTERNAL_DB_CORRUPTION                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to complete the requested operation because of either a   */
 /*  catastrophic media failure or a data structure corruption        */
 /*  on the disk.                                                     */
 /*                                                                   */
 dcl ERROR_INTERNAL_DB_CORRUPTION             fixed bin(31) value(1358);

 /*                                                                   */
 /* MessageId: ERROR_INTERNAL_ERROR                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The security account database contains an internal inconsistency.*/
 /*                                                                   */
 dcl ERROR_INTERNAL_ERROR                     fixed bin(31) value(1359);

 /*                                                                   */
 /* MessageId: ERROR_GENERIC_NOT_MAPPED                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Generic access types were contained in an access mask which      */
 /*  should already be mapped to non-generic types.                   */
 /*                                                                   */
 dcl ERROR_GENERIC_NOT_MAPPED                 fixed bin(31) value(1360);

 /*                                                                   */
 /* MessageId: ERROR_BAD_DESCRIPTOR_FORMAT                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A security descriptor is not in the right format                 */
 /*  (absolute or self-relative).                                     */
 /*                                                                   */
 dcl ERROR_BAD_DESCRIPTOR_FORMAT              fixed bin(31) value(1361);

 /*                                                                   */
 /* MessageId: ERROR_NOT_LOGON_PROCESS                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested action is restricted for use by logon processes    */
 /*  only.  The calling process has not registered as a logon process.*/
 /*                                                                   */
 dcl ERROR_NOT_LOGON_PROCESS                  fixed bin(31) value(1362);

 /*                                                                   */
 /* MessageId: ERROR_LOGON_SESSION_EXISTS                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Cannot start a new logon session with an                         */
 /*  ID that is already in use.                                       */
 /*                                                                   */
 dcl ERROR_LOGON_SESSION_EXISTS               fixed bin(31) value(1363);

 /*                                                                   */
 /* MessageId: ERROR_NO_SUCH_PACKAGE                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A specified authentication package is unknown.                   */
 /*                                                                   */
 dcl ERROR_NO_SUCH_PACKAGE                    fixed bin(31) value(1364);

 /*                                                                   */
 /* MessageId: ERROR_BAD_LOGON_SESSION_STATE                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The logon session is not in a state that is consistent           */
 /*  with the requested operation.                                    */
 /*                                                                   */
 dcl ERROR_BAD_LOGON_SESSION_STATE            fixed bin(31) value(1365);

 /*                                                                   */
 /* MessageId: ERROR_LOGON_SESSION_COLLISION                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The logon session ID is already in use.                          */
 /*                                                                   */
 dcl ERROR_LOGON_SESSION_COLLISION            fixed bin(31) value(1366);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_LOGON_TYPE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A logon request contained an invalid logon type value.           */
 /*                                                                   */
 dcl ERROR_INVALID_LOGON_TYPE                 fixed bin(31) value(1367);

 /*                                                                   */
 /* MessageId: ERROR_CANNOT_IMPERSONATE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to impersonate via a named pipe until data has been read  */
 /*  from that pipe.                                                  */
 /*                                                                   */
 dcl ERROR_CANNOT_IMPERSONATE                 fixed bin(31) value(1368);

 /*                                                                   */
 /* MessageId: ERROR_RXACT_INVALID_STATE                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The transaction state of a Registry subtree                      */
 /* is incompatible with the                                          */
 /*  requested operation.                                             */
 /*                                                                   */
 dcl ERROR_RXACT_INVALID_STATE                fixed bin(31) value(1369);

 /*                                                                   */
 /* MessageId: ERROR_RXACT_COMMIT_FAILURE                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An internal security database corruption                         */
 /* has been encountered.                                             */
 /*                                                                   */
 dcl ERROR_RXACT_COMMIT_FAILURE               fixed bin(31) value(1370);

 /*                                                                   */
 /* MessageId: ERROR_SPECIAL_ACCOUNT                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Cannot perform this operation on built-in accounts.              */
 /*                                                                   */
 dcl ERROR_SPECIAL_ACCOUNT                    fixed bin(31) value(1371);

 /*                                                                   */
 /* MessageId: ERROR_SPECIAL_GROUP                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Cannot perform this operation on this built-in special group.    */
 /*                                                                   */
 dcl ERROR_SPECIAL_GROUP                      fixed bin(31) value(1372);

 /*                                                                   */
 /* MessageId: ERROR_SPECIAL_USER                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Cannot perform this operation on this built-in special user.     */
 /*                                                                   */
 dcl ERROR_SPECIAL_USER                       fixed bin(31) value(1373);

 /*                                                                   */
 /* MessageId: ERROR_MEMBERS_PRIMARY_GROUP                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The user cannot be removed from a group because the group        */
 /*  is currently the user's primary group.                           */
 /*                                                                   */
 dcl ERROR_MEMBERS_PRIMARY_GROUP              fixed bin(31) value(1374);

 /*                                                                   */
 /* MessageId: ERROR_TOKEN_ALREADY_IN_USE                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The token is already in use as a primary token.                  */
 /*                                                                   */
 dcl ERROR_TOKEN_ALREADY_IN_USE               fixed bin(31) value(1375);

 /*                                                                   */
 /* MessageId: ERROR_NO_SUCH_ALIAS                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified local group does not exist.                        */
 /*                                                                   */
 dcl ERROR_NO_SUCH_ALIAS                      fixed bin(31) value(1376);

 /*                                                                   */
 /* MessageId: ERROR_MEMBER_NOT_IN_ALIAS                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified account name is not a member of the local group.   */
 /*                                                                   */
 dcl ERROR_MEMBER_NOT_IN_ALIAS                fixed bin(31) value(1377);

 /*                                                                   */
 /* MessageId: ERROR_MEMBER_IN_ALIAS                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified account name is already a member                   */
 /*  of the local group.                                              */
 /*                                                                   */
 dcl ERROR_MEMBER_IN_ALIAS                    fixed bin(31) value(1378);

 /*                                                                   */
 /* MessageId: ERROR_ALIAS_EXISTS                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified local group already exists.                        */
 /*                                                                   */
 dcl ERROR_ALIAS_EXISTS                       fixed bin(31) value(1379);

 /*                                                                   */
 /* MessageId: ERROR_LOGON_NOT_GRANTED                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Logon failure: the user has not been granted the requested       */
 /*  logon type at this computer.                                     */
 /*                                                                   */
 dcl ERROR_LOGON_NOT_GRANTED                  fixed bin(31) value(1380);

 /*                                                                   */
 /* MessageId: ERROR_TOO_MANY_SECRETS                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The maximum number of secrets that may be stored                 */
 /*  in a single system has been exceeded.                            */
 /*                                                                   */
 dcl ERROR_TOO_MANY_SECRETS                   fixed bin(31) value(1381);

 /*                                                                   */
 /* MessageId: ERROR_SECRET_TOO_LONG                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The length of a secret exceeds the maximum length allowed.       */
 /*                                                                   */
 dcl ERROR_SECRET_TOO_LONG                    fixed bin(31) value(1382);

 /*                                                                   */
 /* MessageId: ERROR_INTERNAL_DB_ERROR                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The local security authority database contains                   */
 /* an internal inconsistency.                                        */
 /*                                                                   */
 dcl ERROR_INTERNAL_DB_ERROR                  fixed bin(31) value(1383);

 /*                                                                   */
 /* MessageId: ERROR_TOO_MANY_CONTEXT_IDS                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  During a logon attempt, the user's security                      */
 /*  context accumulated too many security IDs.                       */
 /*                                                                   */
 dcl ERROR_TOO_MANY_CONTEXT_IDS               fixed bin(31) value(1384);

 /*                                                                   */
 /* MessageId: ERROR_LOGON_TYPE_NOT_GRANTED                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Logon failure: the user has not been granted                     */
 /*  the requested logon type at this computer.                       */
 /*                                                                   */
 dcl ERROR_LOGON_TYPE_NOT_GRANTED             fixed bin(31) value(1385);

 /*                                                                   */
 /* MessageId: ERROR_NT_CROSS_ENCRYPTION_REQUIRED                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A cross-encrypted password is necessary to change                */
 /*  a user password.                                                 */
 /*                                                                   */
 dcl ERROR_NT_CROSS_ENCRYPTION_REQUIRED       fixed bin(31) value(1386);

 /*                                                                   */
 /* MessageId: ERROR_NO_SUCH_MEMBER                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A new member could not be added to a local                       */
 /*  group because the member does not exist.                         */
 /*                                                                   */
 dcl ERROR_NO_SUCH_MEMBER                     fixed bin(31) value(1387);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_MEMBER                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A new member could not be added to a local group                 */
 /*  because the member has the wrong account type.                   */
 /*                                                                   */
 dcl ERROR_INVALID_MEMBER                     fixed bin(31) value(1388);

 /*                                                                   */
 /* MessageId: ERROR_TOO_MANY_SIDS                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Too many security IDs have been specified.                       */
 /*                                                                   */
 dcl ERROR_TOO_MANY_SIDS                      fixed bin(31) value(1389);

 /*                                                                   */
 /* MessageId: ERROR_LM_CROSS_ENCRYPTION_REQUIRED                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A cross-encrypted password is necessary to                       */
 /*  change this user password.                                       */
 /*                                                                   */
 dcl ERROR_LM_CROSS_ENCRYPTION_REQUIRED       fixed bin(31) value(1390);

 /*                                                                   */
 /* MessageId: ERROR_NO_INHERITANCE                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Indicates an ACL contains no inheritable components              */
 /*                                                                   */
 dcl ERROR_NO_INHERITANCE                     fixed bin(31) value(1391);

 /*                                                                   */
 /* MessageId: ERROR_FILE_CORRUPT                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file or directory is corrupt and non-readable.               */
 /*                                                                   */
 dcl ERROR_FILE_CORRUPT                       fixed bin(31) value(1392);

 /*                                                                   */
 /* MessageId: ERROR_DISK_CORRUPT                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The disk structure is corrupt and non-readable.                  */
 /*                                                                   */
 dcl ERROR_DISK_CORRUPT                       fixed bin(31) value(1393);

 /*                                                                   */
 /* MessageId: ERROR_NO_USER_SESSION_KEY                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There is no user session key for the specified logon session.    */
 /*                                                                   */
 dcl ERROR_NO_USER_SESSION_KEY                fixed bin(31) value(1394);

 /*                                                                   */
 /* MessageId: ERROR_LICENSE_QUOTA_EXCEEDED                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The service being accessed is licensed for a particular number   */
 /*  of connections. No more connections can be made to the service   */
 /*  at this time because there are already as many connections as    */
 /*  the service can accept.                                          */
 /*                                                                   */
 dcl ERROR_LICENSE_QUOTA_EXCEEDED             fixed bin(31) value(1395);

 /*                                                                   */
 /* MessageId: ERROR_WRONG_TARGET_NAME                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Logon Failure: The target account name is incorrect.             */
 /*                                                                   */
 dcl ERROR_WRONG_TARGET_NAME                  fixed bin(31) value(1396);

 /*                                                                   */
 /* MessageId: ERROR_MUTUAL_AUTH_FAILED                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Mutual Authentication failed. The server's password is out of    */
 /*  date at the domain controller.                                   */
 /*                                                                   */
 dcl ERROR_MUTUAL_AUTH_FAILED                 fixed bin(31) value(1397);

 /*                                                                   */
 /* MessageId: ERROR_TIME_SKEW                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There is a time difference between the client and server.        */
 /*                                                                   */
 dcl ERROR_TIME_SKEW                          fixed bin(31) value(1398);

 /* End of security error codes                                       */



 /*********************************************************************/
 /*                                                                   */
 /* WinUser Error Codes                                               */
 /*                                                                   */
 /*********************************************************************/


 /*                                                                   */
 /* MessageId: ERROR_INVALID_WINDOW_HANDLE                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid window handle.                                           */
 /*                                                                   */
 dcl ERROR_INVALID_WINDOW_HANDLE              fixed bin(31) value(1400);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_MENU_HANDLE                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid menu handle.                                             */
 /*                                                                   */
 dcl ERROR_INVALID_MENU_HANDLE                fixed bin(31) value(1401);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_CURSOR_HANDLE                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid cursor handle.                                           */
 /*                                                                   */
 dcl ERROR_INVALID_CURSOR_HANDLE              fixed bin(31) value(1402);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_ACCEL_HANDLE                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid accelerator table handle.                                */
 /*                                                                   */
 dcl ERROR_INVALID_ACCEL_HANDLE               fixed bin(31) value(1403);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_HOOK_HANDLE                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid hook handle.                                             */
 /*                                                                   */
 dcl ERROR_INVALID_HOOK_HANDLE                fixed bin(31) value(1404);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_DWP_HANDLE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid handle to a multiple-window position structure.          */
 /*                                                                   */
 dcl ERROR_INVALID_DWP_HANDLE                 fixed bin(31) value(1405);

 /*                                                                   */
 /* MessageId: ERROR_TLW_WITH_WSCHILD                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Cannot create a top-level child window.                          */
 /*                                                                   */
 dcl ERROR_TLW_WITH_WSCHILD                   fixed bin(31) value(1406);

 /*                                                                   */
 /* MessageId: ERROR_CANNOT_FIND_WND_CLASS                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Cannot find window class.                                        */
 /*                                                                   */
 dcl ERROR_CANNOT_FIND_WND_CLASS              fixed bin(31) value(1407);

 /*                                                                   */
 /* MessageId: ERROR_WINDOW_OF_OTHER_THREAD                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid window, belongs to other thread.                         */
 /*                                                                   */
 dcl ERROR_WINDOW_OF_OTHER_THREAD             fixed bin(31) value(1408);

 /*                                                                   */
 /* MessageId: ERROR_HOTKEY_ALREADY_REGISTERED                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Hot key is already registered.                                   */
 /*                                                                   */
 dcl ERROR_HOTKEY_ALREADY_REGISTERED          fixed bin(31) value(1409);

 /*                                                                   */
 /* MessageId: ERROR_CLASS_ALREADY_EXISTS                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Class already exists.                                            */
 /*                                                                   */
 dcl ERROR_CLASS_ALREADY_EXISTS               fixed bin(31) value(1410);

 /*                                                                   */
 /* MessageId: ERROR_CLASS_DOES_NOT_EXIST                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Class does not exist.                                            */
 /*                                                                   */
 dcl ERROR_CLASS_DOES_NOT_EXIST               fixed bin(31) value(1411);

 /*                                                                   */
 /* MessageId: ERROR_CLASS_HAS_WINDOWS                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Class still has open windows.                                    */
 /*                                                                   */
 dcl ERROR_CLASS_HAS_WINDOWS                  fixed bin(31) value(1412);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_INDEX                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid index.                                                   */
 /*                                                                   */
 dcl ERROR_INVALID_INDEX                      fixed bin(31) value(1413);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_ICON_HANDLE                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid icon handle.                                             */
 /*                                                                   */
 dcl ERROR_INVALID_ICON_HANDLE                fixed bin(31) value(1414);

 /*                                                                   */
 /* MessageId: ERROR_PRIVATE_DIALOG_INDEX                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Using private DIALOG window words.                               */
 /*                                                                   */
 dcl ERROR_PRIVATE_DIALOG_INDEX               fixed bin(31) value(1415);

 /*                                                                   */
 /* MessageId: ERROR_LISTBOX_ID_NOT_FOUND                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The listbox identifier was not found.                            */
 /*                                                                   */
 dcl ERROR_LISTBOX_ID_NOT_FOUND               fixed bin(31) value(1416);

 /*                                                                   */
 /* MessageId: ERROR_NO_WILDCARD_CHARACTERS                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No wildcards were found.                                         */
 /*                                                                   */
 dcl ERROR_NO_WILDCARD_CHARACTERS             fixed bin(31) value(1417);

 /*                                                                   */
 /* MessageId: ERROR_CLIPBOARD_NOT_OPEN                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Thread does not have a clipboard open.                           */
 /*                                                                   */
 dcl ERROR_CLIPBOARD_NOT_OPEN                 fixed bin(31) value(1418);

 /*                                                                   */
 /* MessageId: ERROR_HOTKEY_NOT_REGISTERED                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Hot key is not registered.                                       */
 /*                                                                   */
 dcl ERROR_HOTKEY_NOT_REGISTERED              fixed bin(31) value(1419);

 /*                                                                   */
 /* MessageId: ERROR_WINDOW_NOT_DIALOG                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The window is not a valid dialog window.                         */
 /*                                                                   */
 dcl ERROR_WINDOW_NOT_DIALOG                  fixed bin(31) value(1420);

 /*                                                                   */
 /* MessageId: ERROR_CONTROL_ID_NOT_FOUND                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Control ID not found.                                            */
 /*                                                                   */
 dcl ERROR_CONTROL_ID_NOT_FOUND               fixed bin(31) value(1421);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_COMBOBOX_MESSAGE                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid message for a combo box because it does not              */
 /*  have an edit control.                                            */
 /*                                                                   */
 dcl ERROR_INVALID_COMBOBOX_MESSAGE           fixed bin(31) value(1422);

 /*                                                                   */
 /* MessageId: ERROR_WINDOW_NOT_COMBOBOX                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The window is not a combo box.                                   */
 /*                                                                   */
 dcl ERROR_WINDOW_NOT_COMBOBOX                fixed bin(31) value(1423);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_EDIT_HEIGHT                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Height must be less than 256.                                    */
 /*                                                                   */
 dcl ERROR_INVALID_EDIT_HEIGHT                fixed bin(31) value(1424);

 /*                                                                   */
 /* MessageId: ERROR_DC_NOT_FOUND                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid device context (DC) handle.                              */
 /*                                                                   */
 dcl ERROR_DC_NOT_FOUND                       fixed bin(31) value(1425);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_HOOK_FILTER                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid hook procedure type.                                     */
 /*                                                                   */
 dcl ERROR_INVALID_HOOK_FILTER                fixed bin(31) value(1426);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_FILTER_PROC                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid hook procedure.                                          */
 /*                                                                   */
 dcl ERROR_INVALID_FILTER_PROC                fixed bin(31) value(1427);

 /*                                                                   */
 /* MessageId: ERROR_HOOK_NEEDS_HMOD                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Cannot set non-local hook without a module handle.               */
 /*                                                                   */
 dcl ERROR_HOOK_NEEDS_HMOD                    fixed bin(31) value(1428);

 /*                                                                   */
 /* MessageId: ERROR_GLOBAL_ONLY_HOOK                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This hook procedure can only be set globally.                    */
 /*                                                                   */
 dcl ERROR_GLOBAL_ONLY_HOOK                   fixed bin(31) value(1429);

 /*                                                                   */
 /* MessageId: ERROR_JOURNAL_HOOK_SET                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The journal hook procedure is already installed.                 */
 /*                                                                   */
 dcl ERROR_JOURNAL_HOOK_SET                   fixed bin(31) value(1430);

 /*                                                                   */
 /* MessageId: ERROR_HOOK_NOT_INSTALLED                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The hook procedure is not installed.                             */
 /*                                                                   */
 dcl ERROR_HOOK_NOT_INSTALLED                 fixed bin(31) value(1431);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_LB_MESSAGE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid message for single-selection listbox.                    */
 /*                                                                   */
 dcl ERROR_INVALID_LB_MESSAGE                 fixed bin(31) value(1432);

 /*                                                                   */
 /* MessageId: ERROR_SETCOUNT_ON_BAD_LB                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  LB_SETCOUNT sent to non-lazy listbox.                            */
 /*                                                                   */
 dcl ERROR_SETCOUNT_ON_BAD_LB                 fixed bin(31) value(1433);

 /*                                                                   */
 /* MessageId: ERROR_LB_WITHOUT_TABSTOPS                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This list box does not support tab stops.                        */
 /*                                                                   */
 dcl ERROR_LB_WITHOUT_TABSTOPS                fixed bin(31) value(1434);

 /*                                                                   */
 /* MessageId: ERROR_DESTROY_OBJECT_OF_OTHER_THREAD                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Cannot destroy object created by another thread.                 */
 /*                                                                   */
 dcl ERROR_DESTROY_OBJECT_OF_OTHER_THREAD     fixed bin(31) value(1435);

 /*                                                                   */
 /* MessageId: ERROR_CHILD_WINDOW_MENU                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Child windows cannot have menus.                                 */
 /*                                                                   */
 dcl ERROR_CHILD_WINDOW_MENU                  fixed bin(31) value(1436);

 /*                                                                   */
 /* MessageId: ERROR_NO_SYSTEM_MENU                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The window does not have a system menu.                          */
 /*                                                                   */
 dcl ERROR_NO_SYSTEM_MENU                     fixed bin(31) value(1437);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_MSGBOX_STYLE                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid message box style.                                       */
 /*                                                                   */
 dcl ERROR_INVALID_MSGBOX_STYLE               fixed bin(31) value(1438);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_SPI_VALUE                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid system-wide (SPI_*) parameter.                           */
 /*                                                                   */
 dcl ERROR_INVALID_SPI_VALUE                  fixed bin(31) value(1439);

 /*                                                                   */
 /* MessageId: ERROR_SCREEN_ALREADY_LOCKED                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Screen already locked.                                           */
 /*                                                                   */
 dcl ERROR_SCREEN_ALREADY_LOCKED              fixed bin(31) value(1440);

 /*                                                                   */
 /* MessageId: ERROR_HWNDS_HAVE_DIFF_PARENT                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  All handles to windows in a multiple-window                      */
 /*  position structure must have the same parent.                    */
 /*                                                                   */
 dcl ERROR_HWNDS_HAVE_DIFF_PARENT             fixed bin(31) value(1441);

 /*                                                                   */
 /* MessageId: ERROR_NOT_CHILD_WINDOW                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The window is not a child window.                                */
 /*                                                                   */
 dcl ERROR_NOT_CHILD_WINDOW                   fixed bin(31) value(1442);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_GW_COMMAND                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid GW_* command.                                            */
 /*                                                                   */
 dcl ERROR_INVALID_GW_COMMAND                 fixed bin(31) value(1443);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_THREAD_ID                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid thread identifier.                                       */
 /*                                                                   */
 dcl ERROR_INVALID_THREAD_ID                  fixed bin(31) value(1444);

 /*                                                                   */
 /* MessageId: ERROR_NON_MDICHILD_WINDOW                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Cannot process a message from a window that is                   */
 /*  not a multiple document interface (MDI) window.                  */
 /*                                                                   */
 dcl ERROR_NON_MDICHILD_WINDOW                fixed bin(31) value(1445);

 /*                                                                   */
 /* MessageId: ERROR_POPUP_ALREADY_ACTIVE                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Popup menu already active.                                       */
 /*                                                                   */
 dcl ERROR_POPUP_ALREADY_ACTIVE               fixed bin(31) value(1446);

 /*                                                                   */
 /* MessageId: ERROR_NO_SCROLLBARS                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The window does not have scroll bars.                            */
 /*                                                                   */
 dcl ERROR_NO_SCROLLBARS                      fixed bin(31) value(1447);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_SCROLLBAR_RANGE                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Scroll bar range cannot be greater than 0x7FFF.                  */
 /*                                                                   */
 dcl ERROR_INVALID_SCROLLBAR_RANGE            fixed bin(31) value(1448);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_SHOWWIN_COMMAND                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Cannot show or remove the window in the way specified.           */
 /*                                                                   */
 dcl ERROR_INVALID_SHOWWIN_COMMAND            fixed bin(31) value(1449);

 /*                                                                   */
 /* MessageId: ERROR_NO_SYSTEM_RESOURCES                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Insufficient system resources exist to                           */
 /*  complete the requested service.                                  */
 /*                                                                   */
 dcl ERROR_NO_SYSTEM_RESOURCES                fixed bin(31) value(1450);

 /*                                                                   */
 /* MessageId: ERROR_NONPAGED_SYSTEM_RESOURCES                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Insufficient system resources exist to                           */
 /*  complete the requested service.                                  */
 /*                                                                   */
 dcl ERROR_NONPAGED_SYSTEM_RESOURCES          fixed bin(31) value(1451);

 /*                                                                   */
 /* MessageId: ERROR_PAGED_SYSTEM_RESOURCES                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Insufficient system resources exist to complete                  */
 /*  the requested service.                                           */
 /*                                                                   */
 dcl ERROR_PAGED_SYSTEM_RESOURCES             fixed bin(31) value(1452);

 /*                                                                   */
 /* MessageId: ERROR_WORKING_SET_QUOTA                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Insufficient quota to complete the requested service.            */
 /*                                                                   */
 dcl ERROR_WORKING_SET_QUOTA                  fixed bin(31) value(1453);

 /*                                                                   */
 /* MessageId: ERROR_PAGEFILE_QUOTA                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Insufficient quota to complete the requested service.            */
 /*                                                                   */
 dcl ERROR_PAGEFILE_QUOTA                     fixed bin(31) value(1454);

 /*                                                                   */
 /* MessageId: ERROR_COMMITMENT_LIMIT                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The paging file is too small for this operation to complete.     */
 /*                                                                   */
 dcl ERROR_COMMITMENT_LIMIT                   fixed bin(31) value(1455);

 /*                                                                   */
 /* MessageId: ERROR_MENU_ITEM_NOT_FOUND                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A menu item was not found.                                       */
 /*                                                                   */
 dcl ERROR_MENU_ITEM_NOT_FOUND                fixed bin(31) value(1456);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_KEYBOARD_HANDLE                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid keyboard layout handle.                                  */
 /*                                                                   */
 dcl ERROR_INVALID_KEYBOARD_HANDLE            fixed bin(31) value(1457);

 /*                                                                   */
 /* MessageId: ERROR_HOOK_TYPE_NOT_ALLOWED                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Hook type not allowed.                                           */
 /*                                                                   */
 dcl ERROR_HOOK_TYPE_NOT_ALLOWED              fixed bin(31) value(1458);

 /*                                                                   */
 /* MessageId: ERROR_REQUIRES_INTERACTIVE_WINDOWSTATION               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This operation requires an interactive windowstation.            */
 /*                                                                   */
 dcl ERROR_REQUIRES_INTERACTIVE_WINDOWSTATION fixed bin(31) value(1459);

 /*                                                                   */
 /* MessageId: ERROR_TIMEOUT                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This operation returned because the timeout period expired.      */
 /*                                                                   */
 dcl ERROR_TIMEOUT                            fixed bin(31) value(1460);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_MONITOR_HANDLE                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid monitor handle.                                          */
 /*                                                                   */
 dcl ERROR_INVALID_MONITOR_HANDLE             fixed bin(31) value(1461);

 /* End of WinUser error codes                                        */



 /*********************************************************************/
 /*                                                                   */
 /* Eventlog Status Codes                                             */
 /*                                                                   */
 /*********************************************************************/


 /*                                                                   */
 /* MessageId: ERROR_EVENTLOG_FILE_CORRUPT                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The event log file is corrupt.                                   */
 /*                                                                   */
 dcl ERROR_EVENTLOG_FILE_CORRUPT              fixed bin(31) value(1500);

 /*                                                                   */
 /* MessageId: ERROR_EVENTLOG_CANT_START                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No event log file could be opened, so                            */
 /*  the event logging service did not start.                         */
 /*                                                                   */
 dcl ERROR_EVENTLOG_CANT_START                fixed bin(31) value(1501);

 /*                                                                   */
 /* MessageId: ERROR_LOG_FILE_FULL                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The event log file is full.                                      */
 /*                                                                   */
 dcl ERROR_LOG_FILE_FULL                      fixed bin(31) value(1502);

 /*                                                                   */
 /* MessageId: ERROR_EVENTLOG_FILE_CHANGED                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The event log file has changed between reads.                    */
 /*                                                                   */
 dcl ERROR_EVENTLOG_FILE_CHANGED              fixed bin(31) value(1503);

 /* End of eventlog error codes                                       */


 /*********************************************************************/
 /*                                                                   */
 /* MSI Error Codes                                                   */
 /*                                                                   */
 /*********************************************************************/


 /*                                                                   */
 /* MessageId: ERROR_INSTALL_SERVICE                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Failure accessing install service.                               */
 /*                                                                   */
 dcl ERROR_INSTALL_SERVICE                    fixed bin(31) value(1601);

 /*                                                                   */
 /* MessageId: ERROR_INSTALL_USEREXIT                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  User cancel installation.                                        */
 /*                                                                   */
 dcl ERROR_INSTALL_USEREXIT                   fixed bin(31) value(1602);

 /*                                                                   */
 /* MessageId: ERROR_INSTALL_FAILURE                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Fatal error during installation.                                 */
 /*                                                                   */
 dcl ERROR_INSTALL_FAILURE                    fixed bin(31) value(1603);

 /*                                                                   */
 /* MessageId: ERROR_INSTALL_SUSPEND                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Installation suspended, incomplete.                              */
 /*                                                                   */
 dcl ERROR_INSTALL_SUSPEND                    fixed bin(31) value(1604);

 /*                                                                   */
 /* MessageId: ERROR_UNKNOWN_PRODUCT                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Product code not registered.                                     */
 /*                                                                   */
 dcl ERROR_UNKNOWN_PRODUCT                    fixed bin(31) value(1605);

 /*                                                                   */
 /* MessageId: ERROR_UNKNOWN_FEATURE                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Feature ID not registered.                                       */
 /*                                                                   */
 dcl ERROR_UNKNOWN_FEATURE                    fixed bin(31) value(1606);

 /*                                                                   */
 /* MessageId: ERROR_UNKNOWN_COMPONENT                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Component ID not registered.                                     */
 /*                                                                   */
 dcl ERROR_UNKNOWN_COMPONENT                  fixed bin(31) value(1607);

 /*                                                                   */
 /* MessageId: ERROR_UNKNOWN_PROPERTY                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unknown property.                                                */
 /*                                                                   */
 dcl ERROR_UNKNOWN_PROPERTY                  fixed bin(31) value( 1608);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_HANDLE_STATE                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Handle is in an invalid state.                                   */
 /*                                                                   */
 dcl ERROR_INVALID_HANDLE_STATE               fixed bin(31) value(1609);

 /*                                                                   */
 /* MessageId: ERROR_BAD_CONFIGURATION                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Configuration data corrupt.                                      */
 /*                                                                   */
 dcl ERROR_BAD_CONFIGURATION                  fixed bin(31) value(1610);

 /*                                                                   */
 /* MessageId: ERROR_INDEX_ABSENT                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Language not available.                                          */
 /*                                                                   */
 dcl ERROR_INDEX_ABSENT                       fixed bin(31) value(1611);

 /*                                                                   */
 /* MessageId: ERROR_INSTALL_SOURCE_ABSENT                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Install source unavailable.                                      */
 /*                                                                   */
 dcl ERROR_INSTALL_SOURCE_ABSENT              fixed bin(31) value(1612);

 /*                                                                   */
 /* MessageId: ERROR_BAD_DATABASE_VERSION                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Database version unsupported.                                    */
 /*                                                                   */
 dcl ERROR_BAD_DATABASE_VERSION               fixed bin(31) value(1613);

 /*                                                                   */
 /* MessageId: ERROR_PRODUCT_UNINSTALLED                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Product is uninstalled.                                          */
 /*                                                                   */
 dcl ERROR_PRODUCT_UNINSTALLED                fixed bin(31) value(1614);

 /*                                                                   */
 /* MessageId: ERROR_BAD_QUERY_SYNTAX                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  SQL query syntax invalid or unsupported.                         */
 /*                                                                   */
 dcl ERROR_BAD_QUERY_SYNTAX                   fixed bin(31) value(1615);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_FIELD                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Record field does not exist.                                     */
 /*                                                                   */
 dcl ERROR_INVALID_FIELD                      fixed bin(31) value(1616);

 /*                                                                   */
 /* MessageId: ERROR_DEVICE_REMOVED                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The device has been removed.                                     */
 /*                                                                   */
 dcl ERROR_DEVICE_REMOVED                     fixed bin(31) value(1617);

 /*                                                                   */
 /* MessageId: ERROR_INSTALL_ALREADY_RUNNING                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Another installation is already in progress.  Complete that      */
 /*  installation before proceeding with this install.                */
 /*                                                                   */
 dcl ERROR_INSTALL_ALREADY_RUNNING            fixed bin(31) value(1618);

 /*                                                                   */
 /* MessageId: ERROR_INSTALL_PACKAGE_OPEN_FAILED                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This installation package could not be opened.  Verify that      */
 /*  the package exists and that you can access it, or contact the    */
 /*  application vendor to verify that this is a valid Windows        */
 /*  installer package.                                               */
 /*                                                                   */
 dcl ERROR_INSTALL_PACKAGE_OPEN_FAILED        fixed bin(31) value(1619);

 /*                                                                   */
 /* MessageId: ERROR_INSTALL_PACKAGE_INVALID                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This installation package could not be opened.  Contact the      */
 /*  application vendor to verify that this is a valid Windows        */
 /*  installer package.                                               */
 /*                                                                   */
 dcl ERROR_INSTALL_PACKAGE_INVALID            fixed bin(31) value(1620);

 /*                                                                   */
 /* MessageId: ERROR_INSTALL_UI_FAILURE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There was an error starting the Windows installer service user   */
 /*  interface.  Contact your support personnel.                      */
 /*                                                                   */
 dcl ERROR_INSTALL_UI_FAILURE                 fixed bin(31) value(1621);

 /*                                                                   */
 /* MessageId: ERROR_INSTALL_LOG_FAILURE                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Error opening installation log file. Verify that the specified   */
 /*  log file location exists and that you can write to it.           */
 /*                                                                   */
 dcl ERROR_INSTALL_LOG_FAILURE                fixed bin(31) value(1622);

 /*                                                                   */
 /* MessageId: ERROR_INSTALL_LANGUAGE_UNSUPPORTED                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The language of this installation package is not supported by    */
 /*  your system.                                                     */
 /*                                                                   */
 dcl ERROR_INSTALL_LANGUAGE_UNSUPPORTED       fixed bin(31) value(1623);

 /*                                                                   */
 /* MessageId: ERROR_INSTALL_TRANSFORM_FAILURE                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Error applying transforms.  Verify that the specified transform  */
 /*  paths are valid.                                                 */
 /*                                                                   */
 dcl ERROR_INSTALL_TRANSFORM_FAILURE          fixed bin(31) value(1624);

 /*                                                                   */
 /* MessageId: ERROR_INSTALL_PACKAGE_REJECTED                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This installation is forbidden by system policy.                 */
 /*  Contact your system administrator.                               */
 /*                                                                   */
 dcl ERROR_INSTALL_PACKAGE_REJECTED           fixed bin(31) value(1625);

 /*                                                                   */
 /* MessageId: ERROR_FUNCTION_NOT_CALLED                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Function could not be executed.                                  */
 /*                                                                   */
 dcl ERROR_FUNCTION_NOT_CALLED                fixed bin(31) value(1626);

 /*                                                                   */
 /* MessageId: ERROR_FUNCTION_FAILED                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Function failed during execution.                                */
 /*                                                                   */
 dcl ERROR_FUNCTION_FAILED                    fixed bin(31) value(1627);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_TABLE                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid or unknown table specified.                              */
 /*                                                                   */
 dcl ERROR_INVALID_TABLE                      fixed bin(31) value(1628);

 /*                                                                   */
 /* MessageId: ERROR_DATATYPE_MISMATCH                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Data supplied is of wrong type.                                  */
 /*                                                                   */
 dcl ERROR_DATATYPE_MISMATCH                  fixed bin(31) value(1629);

 /*                                                                   */
 /* MessageId: ERROR_UNSUPPORTED_TYPE                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Data of this type is not supported.                              */
 /*                                                                   */
 dcl ERROR_UNSUPPORTED_TYPE                   fixed bin(31) value(1630);

 /*                                                                   */
 /* MessageId: ERROR_CREATE_FAILED                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The Windows installer service failed to start.                   */
 /*  Contact your support personnel.                                  */
 /*                                                                   */
 dcl ERROR_CREATE_FAILED                      fixed bin(31) value(1631);

 /*                                                                   */
 /* MessageId: ERROR_INSTALL_TEMP_UNWRITABLE                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The temp folder is either full or inaccessible.                  */
 /*  Verify that the temp folder exists and that you can write to it. */
 /*                                                                   */
 dcl ERROR_INSTALL_TEMP_UNWRITABLE            fixed bin(31) value(1632);

 /*                                                                   */
 /* MessageId: ERROR_INSTALL_PLATFORM_UNSUPPORTED                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This installation package is not supported on this platform.     */
 /*  Contact your application vendor.                                 */
 /*                                                                   */
 dcl ERROR_INSTALL_PLATFORM_UNSUPPORTED       fixed bin(31) value(1633);

 /*                                                                   */
 /* MessageId: ERROR_INSTALL_NOTUSED                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Component not used on this computer.                             */
 /*                                                                   */
 dcl ERROR_INSTALL_NOTUSED                    fixed bin(31) value(1634);

 /*                                                                   */
 /* MessageId: ERROR_PATCH_PACKAGE_OPEN_FAILED                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This patch package could not be opened.  Verify that the patch   */
 /*  package exists and that you can access it, or contact the        */
 /*  application vendor to verify that this is a valid Windows        */
 /*  installer patch package.                                         */
 /*                                                                   */
 dcl ERROR_PATCH_PACKAGE_OPEN_FAILED          fixed bin(31) value(1635);

 /*                                                                   */
 /* MessageId: ERROR_PATCH_PACKAGE_INVALID                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This patch package could not be opened.                          */
 /*  Contact the application vendor to verify that this is a valid    */
 /*  Windows installer patch package.                                 */
 /*                                                                   */
 dcl ERROR_PATCH_PACKAGE_INVALID              fixed bin(31) value(1636);

 /*                                                                   */
 /* MessageId: ERROR_PATCH_PACKAGE_UNSUPPORTED                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This patch package cannot be processed by the Windows installer  */
 /*  service.  You must install a Windows service pack that contains  */
 /* a newer version of the Windows installer service.                 */
 /*                                                                   */
 dcl ERROR_PATCH_PACKAGE_UNSUPPORTED          fixed bin(31) value(1637);

 /*                                                                   */
 /* MessageId: ERROR_PRODUCT_VERSION                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Another version of this product is already installed.            */
 /*  Installation of this version cannot continue.                    */
 /*  To configure or remove the existing version of this product,     */
 /*  use Add/Remove Programs on the Control Panel.                    */
 /*                                                                   */
 dcl ERROR_PRODUCT_VERSION                    fixed bin(31) value(1638);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_COMMAND_LINE                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid command line argument.  Consult the Windows installer    */
 /*  SDK for detailed command line help.                              */
 /*                                                                   */
 dcl ERROR_INVALID_COMMAND_LINE               fixed bin(31) value(1639);

 /*                                                                   */
 /* MessageId: ERROR_INSTALL_REMOTE_DISALLOWED                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Only administrators have permission to add, remove, or configure */
 /*  server software during a Terminal services remote session.       */
 /*  If you want to install or configure software on the server,      */
 /*  contact your network administrator.                              */
 /*                                                                   */
 dcl ERROR_INSTALL_REMOTE_DISALLOWED          fixed bin(31) value(1640);

 /*                                                                   */
 /* MessageId: ERROR_SUCCESS_REBOOT_INITIATED                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested operation completed successfully.                  */
 /*  The system will be restarted so the changes can take effect.     */
 /*                                                                   */
 dcl ERROR_SUCCESS_REBOOT_INITIATED           fixed bin(31) value(1641);

 /* End of MSI error codes                                            */

 /*********************************************************************/
 /*                                                                   */
 /* RPC Status Codes                                                  */
 /*                                                                   */
 /*********************************************************************/


 /*                                                                   */
 /* MessageId: RPC_S_INVALID_STRING_BINDING                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The string binding is invalid.                                   */
 /*                                                                   */
 dcl RPC_S_INVALID_STRING_BINDING             fixed bin(31) value(1700);

 /*                                                                   */
 /* MessageId: RPC_S_WRONG_KIND_OF_BINDING                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The binding handle is not the correct type.                      */
 /*                                                                   */
 dcl RPC_S_WRONG_KIND_OF_BINDING              fixed bin(31) value(1701);

 /*                                                                   */
 /* MessageId: RPC_S_INVALID_BINDING                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The binding handle is invalid.                                   */
 /*                                                                   */
 dcl RPC_S_INVALID_BINDING                    fixed bin(31) value(1702);

 /*                                                                   */
 /* MessageId: RPC_S_PROTSEQ_NOT_SUPPORTED                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The RPC protocol sequence is not supported.                      */
 /*                                                                   */
 dcl RPC_S_PROTSEQ_NOT_SUPPORTED              fixed bin(31) value(1703);

 /*                                                                   */
 /* MessageId: RPC_S_INVALID_RPC_PROTSEQ                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The RPC protocol sequence is invalid.                            */
 /*                                                                   */
 dcl RPC_S_INVALID_RPC_PROTSEQ                fixed bin(31) value(1704);

 /*                                                                   */
 /* MessageId: RPC_S_INVALID_STRING_UUID                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The string universal unique identifier (UUID) is invalid.        */
 /*                                                                   */
 dcl RPC_S_INVALID_STRING_UUID                fixed bin(31) value(1705);

 /*                                                                   */
 /* MessageId: RPC_S_INVALID_ENDPOINT_FORMAT                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The endpoint format is invalid.                                  */
 /*                                                                   */
 dcl RPC_S_INVALID_ENDPOINT_FORMAT            fixed bin(31) value(1706);

 /*                                                                   */
 /* MessageId: RPC_S_INVALID_NET_ADDR                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The network address is invalid.                                  */
 /*                                                                   */
 dcl RPC_S_INVALID_NET_ADDR                   fixed bin(31) value(1707);

 /*                                                                   */
 /* MessageId: RPC_S_NO_ENDPOINT_FOUND                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No endpoint was found.                                           */
 /*                                                                   */
 dcl RPC_S_NO_ENDPOINT_FOUND                  fixed bin(31) value(1708);

 /*                                                                   */
 /* MessageId: RPC_S_INVALID_TIMEOUT                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The timeout value is invalid.                                    */
 /*                                                                   */
 dcl RPC_S_INVALID_TIMEOUT                    fixed bin(31) value(1709);

 /*                                                                   */
 /* MessageId: RPC_S_OBJECT_NOT_FOUND                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The object universal unique identifier (UUID) was not found.     */
 /*                                                                   */
 dcl RPC_S_OBJECT_NOT_FOUND                   fixed bin(31) value(1710);

 /*                                                                   */
 /* MessageId: RPC_S_ALREADY_REGISTERED                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The object universal unique identifier (UUID) has already        */
 /* been registered.                                                  */
 /*                                                                   */
 dcl RPC_S_ALREADY_REGISTERED                 fixed bin(31) value(1711);

 /*                                                                   */
 /* MessageId: RPC_S_TYPE_ALREADY_REGISTERED                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The type universal unique identifier (UUID) has                  */
 /* already been registered.                                          */
 /*                                                                   */
 dcl RPC_S_TYPE_ALREADY_REGISTERED            fixed bin(31) value(1712);

 /*                                                                   */
 /* MessageId: RPC_S_ALREADY_LISTENING                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The RPC server is already listening.                             */
 /*                                                                   */
 dcl RPC_S_ALREADY_LISTENING                  fixed bin(31) value(1713);

 /*                                                                   */
 /* MessageId: RPC_S_NO_PROTSEQS_REGISTERED                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No protocol sequences have been registered.                      */
 /*                                                                   */
 dcl RPC_S_NO_PROTSEQS_REGISTERED             fixed bin(31) value(1714);

 /*                                                                   */
 /* MessageId: RPC_S_NOT_LISTENING                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The RPC server is not listening.                                 */
 /*                                                                   */
 dcl RPC_S_NOT_LISTENING                      fixed bin(31) value(1715);

 /*                                                                   */
 /* MessageId: RPC_S_UNKNOWN_MGR_TYPE                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The manager type is unknown.                                     */
 /*                                                                   */
 dcl RPC_S_UNKNOWN_MGR_TYPE                   fixed bin(31) value(1716);

 /*                                                                   */
 /* MessageId: RPC_S_UNKNOWN_IF                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The interface is unknown.                                        */
 /*                                                                   */
 dcl RPC_S_UNKNOWN_IF                         fixed bin(31) value(1717);

 /*                                                                   */
 /* MessageId: RPC_S_NO_BINDINGS                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There are no bindings.                                           */
 /*                                                                   */
 dcl RPC_S_NO_BINDINGS                        fixed bin(31) value(1718);

 /*                                                                   */
 /* MessageId: RPC_S_NO_PROTSEQS                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There are no protocol sequences.                                 */
 /*                                                                   */
 dcl RPC_S_NO_PROTSEQS                        fixed bin(31) value(1719);

 /*                                                                   */
 /* MessageId: RPC_S_CANT_CREATE_ENDPOINT                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The endpoint cannot be created.                                  */
 /*                                                                   */
 dcl RPC_S_CANT_CREATE_ENDPOINT               fixed bin(31) value(1720);

 /*                                                                   */
 /* MessageId: RPC_S_OUT_OF_RESOURCES                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Not enough resources are available to complete this operation.   */
 /*                                                                   */
 dcl RPC_S_OUT_OF_RESOURCES                   fixed bin(31) value(1721);

 /*                                                                   */
 /* MessageId: RPC_S_SERVER_UNAVAILABLE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The RPC server is unavailable.                                   */
 /*                                                                   */
 dcl RPC_S_SERVER_UNAVAILABLE                 fixed bin(31) value(1722);

 /*                                                                   */
 /* MessageId: RPC_S_SERVER_TOO_BUSY                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The RPC server is too busy to complete this operation.           */
 /*                                                                   */
 dcl RPC_S_SERVER_TOO_BUSY                    fixed bin(31) value(1723);

 /*                                                                   */
 /* MessageId: RPC_S_INVALID_NETWORK_OPTIONS                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The network options are invalid.                                 */
 /*                                                                   */
 dcl RPC_S_INVALID_NETWORK_OPTIONS            fixed bin(31) value(1724);

 /*                                                                   */
 /* MessageId: RPC_S_NO_CALL_ACTIVE                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There is not a remote procedure call active in this thread.      */
 /*                                                                   */
 dcl RPC_S_NO_CALL_ACTIVE                     fixed bin(31) value(1725);

 /*                                                                   */
 /* MessageId: RPC_S_CALL_FAILED                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The remote procedure call failed.                                */
 /*                                                                   */
 dcl RPC_S_CALL_FAILED                        fixed bin(31) value(1726);

 /*                                                                   */
 /* MessageId: RPC_S_CALL_FAILED_DNE                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The remote procedure call failed and did not execute.            */
 /*                                                                   */
 dcl RPC_S_CALL_FAILED_DNE                    fixed bin(31) value(1727);

 /*                                                                   */
 /* MessageId: RPC_S_PROTOCOL_ERROR                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A remote procedure call (RPC) protocol error occurred.           */
 /*                                                                   */
 dcl RPC_S_PROTOCOL_ERROR                     fixed bin(31) value(1728);

 /*                                                                   */
 /* MessageId: RPC_S_UNSUPPORTED_TRANS_SYN                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The transfer syntax is not supported by the RPC server.          */
 /*                                                                   */
 dcl RPC_S_UNSUPPORTED_TRANS_SYN              fixed bin(31) value(1730);

 /*                                                                   */
 /* MessageId: RPC_S_UNSUPPORTED_TYPE                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The universal unique identifier (UUID) type is not supported.    */
 /*                                                                   */
 dcl RPC_S_UNSUPPORTED_TYPE                   fixed bin(31) value(1732);

 /*                                                                   */
 /* MessageId: RPC_S_INVALID_TAG                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The tag is invalid.                                              */
 /*                                                                   */
 dcl RPC_S_INVALID_TAG                        fixed bin(31) value(1733);

 /*                                                                   */
 /* MessageId: RPC_S_INVALID_BOUND                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The array bounds are invalid.                                    */
 /*                                                                   */
 dcl RPC_S_INVALID_BOUND                      fixed bin(31) value(1734);

 /*                                                                   */
 /* MessageId: RPC_S_NO_ENTRY_NAME                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The binding does not contain an entry name.                      */
 /*                                                                   */
 dcl RPC_S_NO_ENTRY_NAME                      fixed bin(31) value(1735);

 /*                                                                   */
 /* MessageId: RPC_S_INVALID_NAME_SYNTAX                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The name syntax is invalid.                                      */
 /*                                                                   */
 dcl RPC_S_INVALID_NAME_SYNTAX                fixed bin(31) value(1736);

 /*                                                                   */
 /* MessageId: RPC_S_UNSUPPORTED_NAME_SYNTAX                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The name syntax is not supported.                                */
 /*                                                                   */
 dcl RPC_S_UNSUPPORTED_NAME_SYNTAX            fixed bin(31) value(1737);

 /*                                                                   */
 /* MessageId: RPC_S_UUID_NO_ADDRESS                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No network address is available to use to construct a universal  */
 /*  unique identifier (UUID).                                        */
 /*                                                                   */
 dcl RPC_S_UUID_NO_ADDRESS                    fixed bin(31) value(1739);

 /*                                                                   */
 /* MessageId: RPC_S_DUPLICATE_ENDPOINT                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The endpoint is a duplicate.                                     */
 /*                                                                   */
 dcl RPC_S_DUPLICATE_ENDPOINT                 fixed bin(31) value(1740);

 /*                                                                   */
 /* MessageId: RPC_S_UNKNOWN_AUTHN_TYPE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The authentication type is unknown.                              */
 /*                                                                   */
 dcl RPC_S_UNKNOWN_AUTHN_TYPE                 fixed bin(31) value(1741);

 /*                                                                   */
 /* MessageId: RPC_S_MAX_CALLS_TOO_SMALL                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The maximum number of calls is too small.                        */
 /*                                                                   */
 dcl RPC_S_MAX_CALLS_TOO_SMALL                fixed bin(31) value(1742);

 /*                                                                   */
 /* MessageId: RPC_S_STRING_TOO_LONG                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The string is too long.                                          */
 /*                                                                   */
 dcl RPC_S_STRING_TOO_LONG                    fixed bin(31) value(1743);

 /*                                                                   */
 /* MessageId: RPC_S_PROTSEQ_NOT_FOUND                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The RPC protocol sequence was not found.                         */
 /*                                                                   */
 dcl RPC_S_PROTSEQ_NOT_FOUND                  fixed bin(31) value(1744);

 /*                                                                   */
 /* MessageId: RPC_S_PROCNUM_OUT_OF_RANGE                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The procedure number is out of range.                            */
 /*                                                                   */
 dcl RPC_S_PROCNUM_OUT_OF_RANGE               fixed bin(31) value(1745);

 /*                                                                   */
 /* MessageId: RPC_S_BINDING_HAS_NO_AUTH                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The binding does not contain any authentication information.     */
 /*                                                                   */
 dcl RPC_S_BINDING_HAS_NO_AUTH                fixed bin(31) value(1746);

 /*                                                                   */
 /* MessageId: RPC_S_UNKNOWN_AUTHN_SERVICE                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The authentication service is unknown.                           */
 /*                                                                   */
 dcl RPC_S_UNKNOWN_AUTHN_SERVICE              fixed bin(31) value(1747);

 /*                                                                   */
 /* MessageId: RPC_S_UNKNOWN_AUTHN_LEVEL                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The authentication level is unknown.                             */
 /*                                                                   */
 dcl RPC_S_UNKNOWN_AUTHN_LEVEL                fixed bin(31) value(1748);

 /*                                                                   */
 /* MessageId: RPC_S_INVALID_AUTH_IDENTITY                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The security context is invalid.                                 */
 /*                                                                   */
 dcl RPC_S_INVALID_AUTH_IDENTITY              fixed bin(31) value(1749);

 /*                                                                   */
 /* MessageId: RPC_S_UNKNOWN_AUTHZ_SERVICE                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The authorization service is unknown.                            */
 /*                                                                   */
 dcl RPC_S_UNKNOWN_AUTHZ_SERVICE              fixed bin(31) value(1750);

 /*                                                                   */
 /* MessageId: EPT_S_INVALID_ENTRY                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The entry is invalid.                                            */
 /*                                                                   */
 dcl EPT_S_INVALID_ENTRY                      fixed bin(31) value(1751);

 /*                                                                   */
 /* MessageId: EPT_S_CANT_PERFORM_OP                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The server endpoint cannot perform the operation.                */
 /*                                                                   */
 dcl EPT_S_CANT_PERFORM_OP                    fixed bin(31) value(1752);

 /*                                                                   */
 /* MessageId: EPT_S_NOT_REGISTERED                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There are no more endpoints available from the endpoint mapper.  */
 /*                                                                   */
 dcl EPT_S_NOT_REGISTERED                     fixed bin(31) value(1753);

 /*                                                                   */
 /* MessageId: RPC_S_NOTHING_TO_EXPORT                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No interfaces have been exported.                                */
 /*                                                                   */
 dcl RPC_S_NOTHING_TO_EXPORT                  fixed bin(31) value(1754);

 /*                                                                   */
 /* MessageId: RPC_S_INCOMPLETE_NAME                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The entry name is incomplete.                                    */
 /*                                                                   */
 dcl RPC_S_INCOMPLETE_NAME                    fixed bin(31) value(1755);

 /*                                                                   */
 /* MessageId: RPC_S_INVALID_VERS_OPTION                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The version option is invalid.                                   */
 /*                                                                   */
 dcl RPC_S_INVALID_VERS_OPTION                fixed bin(31) value(1756);

 /*                                                                   */
 /* MessageId: RPC_S_NO_MORE_MEMBERS                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There are no more members.                                       */
 /*                                                                   */
 dcl RPC_S_NO_MORE_MEMBERS                    fixed bin(31) value(1757);

 /*                                                                   */
 /* MessageId: RPC_S_NOT_ALL_OBJS_UNEXPORTED                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There is nothing to unexport.                                    */
 /*                                                                   */
 dcl RPC_S_NOT_ALL_OBJS_UNEXPORTED            fixed bin(31) value(1758);

 /*                                                                   */
 /* MessageId: RPC_S_INTERFACE_NOT_FOUND                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The interface was not found.                                     */
 /*                                                                   */
 dcl RPC_S_INTERFACE_NOT_FOUND                fixed bin(31) value(1759);

 /*                                                                   */
 /* MessageId: RPC_S_ENTRY_ALREADY_EXISTS                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The entry already exists.                                        */
 /*                                                                   */
 dcl RPC_S_ENTRY_ALREADY_EXISTS               fixed bin(31) value(1760);

 /*                                                                   */
 /* MessageId: RPC_S_ENTRY_NOT_FOUND                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The entry is not found.                                          */
 /*                                                                   */
 dcl RPC_S_ENTRY_NOT_FOUND                    fixed bin(31) value(1761);

 /*                                                                   */
 /* MessageId: RPC_S_NAME_SERVICE_UNAVAILABLE                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The name service is unavailable.                                 */
 /*                                                                   */
 dcl RPC_S_NAME_SERVICE_UNAVAILABLE           fixed bin(31) value(1762);

 /*                                                                   */
 /* MessageId: RPC_S_INVALID_NAF_ID                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The network address family is invalid.                           */
 /*                                                                   */
 dcl RPC_S_INVALID_NAF_ID                     fixed bin(31) value(1763);

 /*                                                                   */
 /* MessageId: RPC_S_CANNOT_SUPPORT                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested operation is not supported.                        */
 /*                                                                   */
 dcl RPC_S_CANNOT_SUPPORT                     fixed bin(31) value(1764);

 /*                                                                   */
 /* MessageId: RPC_S_NO_CONTEXT_AVAILABLE                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No security context is available to allow impersonation.         */
 /*                                                                   */
 dcl RPC_S_NO_CONTEXT_AVAILABLE               fixed bin(31) value(1765);

 /*                                                                   */
 /* MessageId: RPC_S_INTERNAL_ERROR                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An internal error occurred in a remote procedure call (RPC).     */
 /*                                                                   */
 dcl RPC_S_INTERNAL_ERROR                     fixed bin(31) value(1766);

 /*                                                                   */
 /* MessageId: RPC_S_ZERO_DIVIDE                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The RPC server attempted an integer division by zero.            */
 /*                                                                   */
 dcl RPC_S_ZERO_DIVIDE                        fixed bin(31) value(1767);

 /*                                                                   */
 /* MessageId: RPC_S_ADDRESS_ERROR                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An addressing error occurred in the RPC server.                  */
 /*                                                                   */
 dcl RPC_S_ADDRESS_ERROR                      fixed bin(31) value(1768);

 /*                                                                   */
 /* MessageId: RPC_S_FP_DIV_ZERO                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A floating-point operation at the RPC server                     */
 /*  caused a division by zero.                                       */
 /*                                                                   */
 dcl RPC_S_FP_DIV_ZERO                        fixed bin(31) value(1769);

 /*                                                                   */
 /* MessageId: RPC_S_FP_UNDERFLOW                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A floating-point underflow occurred at the RPC server.           */
 /*                                                                   */
 dcl RPC_S_FP_UNDERFLOW                       fixed bin(31) value(1770);

 /*                                                                   */
 /* MessageId: RPC_S_FP_OVERFLOW                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A floating-point overflow occurred at the RPC server.            */
 /*                                                                   */
 dcl RPC_S_FP_OVERFLOW                        fixed bin(31) value(1771);

 /*                                                                   */
 /* MessageId: RPC_X_NO_MORE_ENTRIES                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The list of RPC servers available for the binding of             */
 /*  auto handles has been exhausted.                                 */
 /*                                                                   */
 dcl RPC_X_NO_MORE_ENTRIES                    fixed bin(31) value(1772);

 /*                                                                   */
 /* MessageId: RPC_X_SS_CHAR_TRANS_OPEN_FAIL                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to open the character translation table file.             */
 /*                                                                   */
 dcl RPC_X_SS_CHAR_TRANS_OPEN_FAIL            fixed bin(31) value(1773);

 /*                                                                   */
 /* MessageId: RPC_X_SS_CHAR_TRANS_SHORT_FILE                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file containing the character translation                    */
 /*  table has fewer than 512 bytes.                                  */
 /*                                                                   */
 dcl RPC_X_SS_CHAR_TRANS_SHORT_FILE           fixed bin(31) value(1774);

 /*                                                                   */
 /* MessageId: RPC_X_SS_IN_NULL_CONTEXT                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A null context handle was passed from the                        */
 /*  client to the host during a remote procedure call.               */
 /*                                                                   */
 dcl RPC_X_SS_IN_NULL_CONTEXT                 fixed bin(31) value(1775);

 /*                                                                   */
 /* MessageId: RPC_X_SS_CONTEXT_DAMAGED                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The context handle changed during a remote procedure call.       */
 /*                                                                   */
 dcl RPC_X_SS_CONTEXT_DAMAGED                 fixed bin(31) value(1777);

 /*                                                                   */
 /* MessageId: RPC_X_SS_HANDLES_MISMATCH                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The binding handles passed to a remote                           */
 /*procedure call do not match.                                       */
 /*                                                                   */
 dcl RPC_X_SS_HANDLES_MISMATCH                fixed bin(31) value(1778);

 /*                                                                   */
 /* MessageId: RPC_X_SS_CANNOT_GET_CALL_HANDLE                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The stub is unable to get the remote procedure call handle.      */
 /*                                                                   */
 dcl RPC_X_SS_CANNOT_GET_CALL_HANDLE          fixed bin(31) value(1779);

 /*                                                                   */
 /* MessageId: RPC_X_NULL_REF_POINTER                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A null reference pointer was passed to the stub.                 */
 /*                                                                   */
 dcl RPC_X_NULL_REF_POINTER                   fixed bin(31) value(1780);

 /*                                                                   */
 /* MessageId: RPC_X_ENUM_VALUE_OUT_OF_RANGE                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The enumeration value is out of range.                           */
 /*                                                                   */
 dcl RPC_X_ENUM_VALUE_OUT_OF_RANGE            fixed bin(31) value(1781);

 /*                                                                   */
 /* MessageId: RPC_X_BYTE_COUNT_TOO_SMALL                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The byte count is too small.                                     */
 /*                                                                   */
 dcl RPC_X_BYTE_COUNT_TOO_SMALL               fixed bin(31) value(1782);

 /*                                                                   */
 /* MessageId: RPC_X_BAD_STUB_DATA                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The stub received bad data.                                      */
 /*                                                                   */
 dcl RPC_X_BAD_STUB_DATA                      fixed bin(31) value(1783);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_USER_BUFFER                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The supplied user buffer is not valid                            */
 /* for the requested operation.                                      */
 /*                                                                   */
 dcl ERROR_INVALID_USER_BUFFER                fixed bin(31) value(1784);

 /*                                                                   */
 /* MessageId: ERROR_UNRECOGNIZED_MEDIA                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The disk media is not recognized.  It may not be formatted.      */
 /*                                                                   */
 dcl ERROR_UNRECOGNIZED_MEDIA                 fixed bin(31) value(1785);

 /*                                                                   */
 /* MessageId: ERROR_NO_TRUST_LSA_SECRET                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The workstation does not have a trust secret.                    */
 /*                                                                   */
 dcl ERROR_NO_TRUST_LSA_SECRET                fixed bin(31) value(1786);

 /*                                                                   */
 /* MessageId: ERROR_NO_TRUST_SAM_ACCOUNT                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The SAM database on the Windows NT Server does not have a        */
 /*  computer account for this workstation trust relationship.        */
 /*                                                                   */
 dcl ERROR_NO_TRUST_SAM_ACCOUNT               fixed bin(31) value(1787);

 /*                                                                   */
 /* MessageId: ERROR_TRUSTED_DOMAIN_FAILURE                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The trust relationship between the primary domain and            */
 /*  the trusted domain failed.                                       */
 /*                                                                   */
 dcl ERROR_TRUSTED_DOMAIN_FAILURE             fixed bin(31) value(1788);

 /*                                                                   */
 /* MessageId: ERROR_TRUSTED_RELATIONSHIP_FAILURE                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The trust relationship between this workstation and the primary  */
 /*  domain failed.                                                   */
 /*                                                                   */
 dcl ERROR_TRUSTED_RELATIONSHIP_FAILURE       fixed bin(31) value(1789);

 /*                                                                   */
 /* MessageId: ERROR_TRUST_FAILURE                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The network logon failed.                                        */
 /*                                                                   */
 dcl ERROR_TRUST_FAILURE                      fixed bin(31) value(1790);

 /*                                                                   */
 /* MessageId: RPC_S_CALL_IN_PROGRESS                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A remote procedure call is already in progress for this thread.  */
 /*                                                                   */
 dcl RPC_S_CALL_IN_PROGRESS                   fixed bin(31) value(1791);

 /*                                                                   */
 /* MessageId: ERROR_NETLOGON_NOT_STARTED                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An attempt was made to logon, but the                            */
 /*  network logon service was not started.                           */
 /*                                                                   */
 dcl ERROR_NETLOGON_NOT_STARTED               fixed bin(31) value(1792);

 /*                                                                   */
 /* MessageId: ERROR_ACCOUNT_EXPIRED                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The user's account has expired.                                  */
 /*                                                                   */
 dcl ERROR_ACCOUNT_EXPIRED                    fixed bin(31) value(1793);

 /*                                                                   */
 /* MessageId: ERROR_REDIRECTOR_HAS_OPEN_HANDLES                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The redirector is in use and cannot be unloaded.                 */
 /*                                                                   */
 dcl ERROR_REDIRECTOR_HAS_OPEN_HANDLES        fixed bin(31) value(1794);

 /*                                                                   */
 /* MessageId: ERROR_PRINTER_DRIVER_ALREADY_INSTALLED                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified printer driver is already installed.               */
 /*                                                                   */
 dcl ERROR_PRINTER_DRIVER_ALREADY_INSTALLED   fixed bin(31) value(1795);

 /*                                                                   */
 /* MessageId: ERROR_UNKNOWN_PORT                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified port is unknown.                                   */
 /*                                                                   */
 dcl ERROR_UNKNOWN_PORT                       fixed bin(31) value(1796);

 /*                                                                   */
 /* MessageId: ERROR_UNKNOWN_PRINTER_DRIVER                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The printer driver is unknown.                                   */
 /*                                                                   */
 dcl ERROR_UNKNOWN_PRINTER_DRIVER             fixed bin(31) value(1797);

 /*                                                                   */
 /* MessageId: ERROR_UNKNOWN_PRINTPROCESSOR                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The print processor is unknown.                                  */
 /*                                                                   */
 dcl ERROR_UNKNOWN_PRINTPROCESSOR             fixed bin(31) value(1798);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_SEPARATOR_FILE                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified separator file is invalid.                         */
 /*                                                                   */
 dcl ERROR_INVALID_SEPARATOR_FILE             fixed bin(31) value(1799);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_PRIORITY                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified priority is invalid.                               */
 /*                                                                   */
 dcl ERROR_INVALID_PRIORITY                   fixed bin(31) value(1800);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_PRINTER_NAME                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The printer name is invalid.                                     */
 /*                                                                   */
 dcl ERROR_INVALID_PRINTER_NAME               fixed bin(31) value(1801);

 /*                                                                   */
 /* MessageId: ERROR_PRINTER_ALREADY_EXISTS                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The printer already exists.                                      */
 /*                                                                   */
 dcl ERROR_PRINTER_ALREADY_EXISTS             fixed bin(31) value(1802);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_PRINTER_COMMAND                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The printer command is invalid.                                  */
 /*                                                                   */
 dcl ERROR_INVALID_PRINTER_COMMAND            fixed bin(31) value(1803);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_DATATYPE                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified datatype is invalid.                               */
 /*                                                                   */
 dcl ERROR_INVALID_DATATYPE                   fixed bin(31) value(1804);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_ENVIRONMENT                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The Environment specified is invalid.                            */
 /*                                                                   */
 dcl ERROR_INVALID_ENVIRONMENT                fixed bin(31) value(1805);

 /*                                                                   */
 /* MessageId: RPC_S_NO_MORE_BINDINGS                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There are no more bindings.                                      */
 /*                                                                   */
 dcl RPC_S_NO_MORE_BINDINGS                   fixed bin(31) value(1806);

 /*                                                                   */
 /* MessageId: ERROR_NOLOGON_INTERDOMAIN_TRUST_ACCOUNT                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The account used is an interdomain trust account.  Use your      */
 /*  global user account or local user account to access this server. */
 /*                                                                   */
 dcl ERROR_NOLOGON_INTERDOMAIN_TRUST_ACCOUNT  fixed bin(31) value(1807);

 /*                                                                   */
 /* MessageId: ERROR_NOLOGON_WORKSTATION_TRUST_ACCOUNT                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The account used is a Computer Account.  Use your global         */
 /*  user account or local user account to access this server.        */
 /*                                                                   */
 dcl ERROR_NOLOGON_WORKSTATION_TRUST_ACCOUNT  fixed bin(31) value(1808);


 /*                                                                   */
 /* MessageId: ERROR_NOLOGON_SERVER_TRUST_ACCOUNT                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The account used is an server trust account.  Use your global    */
 /*  user account or local user account to access this server.        */
 /*                                                                   */
 dcl ERROR_NOLOGON_SERVER_TRUST_ACCOUNT       fixed bin(31) value(1809);

 /*                                                                   */
 /* MessageId: ERROR_DOMAIN_TRUST_INCONSISTENT                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The name or security ID (SID) of the domain specified is         */
 /*  inconsistent with the trust information for that domain.         */
 /*                                                                   */
 dcl ERROR_DOMAIN_TRUST_INCONSISTENT          fixed bin(31) value(1810);

 /*                                                                   */
 /* MessageId: ERROR_SERVER_HAS_OPEN_HANDLES                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The server is in use and cannot be unloaded.                     */
 /*                                                                   */
 dcl ERROR_SERVER_HAS_OPEN_HANDLES            fixed bin(31) value(1811);

 /*                                                                   */
 /* MessageId: ERROR_RESOURCE_DATA_NOT_FOUND                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified image file did not contain a resource section.     */
 /*                                                                   */
 dcl ERROR_RESOURCE_DATA_NOT_FOUND            fixed bin(31) value(1812);

 /*                                                                   */
 /* MessageId: ERROR_RESOURCE_TYPE_NOT_FOUND                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified resource type can not be found in the image file.  */
 /*                                                                   */
 dcl ERROR_RESOURCE_TYPE_NOT_FOUND            fixed bin(31) value(1813);

 /*                                                                   */
 /* MessageId: ERROR_RESOURCE_NAME_NOT_FOUND                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified resource name can not be found in the image file.  */
 /*                                                                   */
 dcl ERROR_RESOURCE_NAME_NOT_FOUND            fixed bin(31) value(1814);

 /*                                                                   */
 /* MessageId: ERROR_RESOURCE_LANG_NOT_FOUND                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified resource language ID cannot be found               */
 /*  in the image file.                                               */
 /*                                                                   */
 dcl ERROR_RESOURCE_LANG_NOT_FOUND            fixed bin(31) value(1815);

 /*                                                                   */
 /* MessageId: ERROR_NOT_ENOUGH_QUOTA                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Not enough quota is available to process this command.           */
 /*                                                                   */
 dcl ERROR_NOT_ENOUGH_QUOTA                   fixed bin(31) value(1816);

 /*                                                                   */
 /* MessageId: RPC_S_NO_INTERFACES                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No interfaces have been registered.                              */
 /*                                                                   */
 dcl RPC_S_NO_INTERFACES                      fixed bin(31) value(1817);

 /*                                                                   */
 /* MessageId: RPC_S_CALL_CANCELLED                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The server was altered while processing this call.               */
 /*                                                                   */
 dcl RPC_S_CALL_CANCELLED                     fixed bin(31) value(1818);

 /*                                                                   */
 /* MessageId: RPC_S_BINDING_INCOMPLETE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The binding handle does not contain all required information.    */
 /*                                                                   */
 dcl RPC_S_BINDING_INCOMPLETE                 fixed bin(31) value(1819);

 /*                                                                   */
 /* MessageId: RPC_S_COMM_FAILURE                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Communications failure.                                          */
 /*                                                                   */
 dcl RPC_S_COMM_FAILURE                       fixed bin(31) value(1820);

 /*                                                                   */
 /* MessageId: RPC_S_UNSUPPORTED_AUTHN_LEVEL                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested authentication level is not supported.             */
 /*                                                                   */
 dcl RPC_S_UNSUPPORTED_AUTHN_LEVEL            fixed bin(31) value(1821);

 /*                                                                   */
 /* MessageId: RPC_S_NO_PRINC_NAME                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No principal name registered.                                    */
 /*                                                                   */
 dcl RPC_S_NO_PRINC_NAME                      fixed bin(31) value(1822);

 /*                                                                   */
 /* MessageId: RPC_S_NOT_RPC_ERROR                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The error specified is not a valid Windows RPC error code.       */
 /*                                                                   */
 dcl RPC_S_NOT_RPC_ERROR                      fixed bin(31) value(1823);

 /*                                                                   */
 /* MessageId: RPC_S_UUID_LOCAL_ONLY                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A UUID that is valid only on this computer has been allocated.   */
 /*                                                                   */
 dcl RPC_S_UUID_LOCAL_ONLY                    fixed bin(31) value(1824);

 /*                                                                   */
 /* MessageId: RPC_S_SEC_PKG_ERROR                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A security package specific error occurred.                      */
 /*                                                                   */
 dcl RPC_S_SEC_PKG_ERROR                      fixed bin(31) value(1825);

 /*                                                                   */
 /* MessageId: RPC_S_NOT_CANCELLED                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Thread is not cancelled.                                         */
 /*                                                                   */
 dcl RPC_S_NOT_CANCELLED                      fixed bin(31) value(1826);

 /*                                                                   */
 /* MessageId: RPC_X_INVALID_ES_ACTION                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid operation on the encoding/decoding handle.               */
 /*                                                                   */
 dcl RPC_X_INVALID_ES_ACTION                  fixed bin(31) value(1827);

 /*                                                                   */
 /* MessageId: RPC_X_WRONG_ES_VERSION                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Incompatible version of the serializing package.                 */
 /*                                                                   */
 dcl RPC_X_WRONG_ES_VERSION                   fixed bin(31) value(1828);

 /*                                                                   */
 /* MessageId: RPC_X_WRONG_STUB_VERSION                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Incompatible version of the RPC stub.                            */
 /*                                                                   */
 dcl RPC_X_WRONG_STUB_VERSION                 fixed bin(31) value(1829);

 /*                                                                   */
 /* MessageId: RPC_X_INVALID_PIPE_OBJECT                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The idl pipe object is invalid or corrupted.                     */
 /*                                                                   */
 dcl RPC_X_INVALID_PIPE_OBJECT                fixed bin(31) value(1830);

 /*                                                                   */
 /* MessageId: RPC_X_WRONG_PIPE_ORDER                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An invalid operation was attempted on an RPC pipe object.        */
 /*                                                                   */
 dcl RPC_X_WRONG_PIPE_ORDER                   fixed bin(31) value(1831);

 /*                                                                   */
 /* MessageId: RPC_X_WRONG_PIPE_VERSION                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The idl pipe version is not supported.                           */
 /*                                                                   */
 dcl RPC_X_WRONG_PIPE_VERSION                 fixed bin(31) value(1832);

 /*                                                                   */
 /* MessageId: RPC_S_GROUP_MEMBER_NOT_FOUND                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The group member was not found.                                  */
 /*                                                                   */
 dcl RPC_S_GROUP_MEMBER_NOT_FOUND             fixed bin(31) value(1898);

 /*                                                                   */
 /* MessageId: EPT_S_CANT_CREATE                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The endpoint mapper database entry could not be created.         */
 /*                                                                   */
 dcl EPT_S_CANT_CREATE                        fixed bin(31) value(1899);

 /*                                                                   */
 /* MessageId: RPC_S_INVALID_OBJECT                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The object universal unique identifier (UUID) is the nil UUID.   */
 /*                                                                   */
 dcl RPC_S_INVALID_OBJECT                     fixed bin(31) value(1900);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_TIME                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified time is invalid.                                   */
 /*                                                                   */
 dcl ERROR_INVALID_TIME                       fixed bin(31) value(1901);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_FORM_NAME                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified Form name is invalid.                              */
 /*                                                                   */
 dcl ERROR_INVALID_FORM_NAME                  fixed bin(31) value(1902);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_FORM_SIZE                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified Form size is invalid                               */
 /*                                                                   */
 dcl ERROR_INVALID_FORM_SIZE                  fixed bin(31) value(1903);

 /*                                                                   */
 /* MessageId: ERROR_ALREADY_WAITING                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified Printer handle is already being waited on          */
 /*                                                                   */
 dcl ERROR_ALREADY_WAITING                    fixed bin(31) value(1904);

 /*                                                                   */
 /* MessageId: ERROR_PRINTER_DELETED                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified Printer has been deleted                           */
 /*                                                                   */
 dcl ERROR_PRINTER_DELETED                    fixed bin(31) value(1905);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_PRINTER_STATE                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The state of the Printer is invalid                              */
 /*                                                                   */
 dcl ERROR_INVALID_PRINTER_STATE              fixed bin(31) value(1906);

 /*                                                                   */
 /* MessageId: ERROR_PASSWORD_MUST_CHANGE                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The user must change his password before he logs on              */
 /*  the first time.                                                  */
 /*                                                                   */
 dcl ERROR_PASSWORD_MUST_CHANGE               fixed bin(31) value(1907);

 /*                                                                   */
 /* MessageId: ERROR_DOMAIN_CONTROLLER_NOT_FOUND                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Could not find the domain controller for this domain.            */
 /*                                                                   */
 dcl ERROR_DOMAIN_CONTROLLER_NOT_FOUND        fixed bin(31) value(1908);

 /*                                                                   */
 /* MessageId: ERROR_ACCOUNT_LOCKED_OUT                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The referenced account is currently locked out                   */
 /* and may not be logged on to.                                      */
 /*                                                                   */
 dcl ERROR_ACCOUNT_LOCKED_OUT                 fixed bin(31) value(1909);

 /*                                                                   */
 /* MessageId: OR_INVALID_OXID                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The object exporter specified was not found.                     */
 /*                                                                   */
 dcl OR_INVALID_OXID                          fixed bin(31) value(1910);

 /*                                                                   */
 /* MessageId: OR_INVALID_OID                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The object specified was not found.                              */
 /*                                                                   */
 dcl OR_INVALID_OID                           fixed bin(31) value(1911);

 /*                                                                   */
 /* MessageId: OR_INVALID_SET                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The object resolver set specified was not found.                 */
 /*                                                                   */
 dcl OR_INVALID_SET                           fixed bin(31) value(1912);

 /*                                                                   */
 /* MessageId: RPC_S_SEND_INCOMPLETE                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Some data remains to be sent in the request buffer.              */
 /*                                                                   */
 dcl RPC_S_SEND_INCOMPLETE                    fixed bin(31) value(1913);

 /*                                                                   */
 /* MessageId: RPC_S_INVALID_ASYNC_HANDLE                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid asynchronous remote procedure call handle.               */
 /*                                                                   */
 dcl RPC_S_INVALID_ASYNC_HANDLE               fixed bin(31) value(1914);

 /*                                                                   */
 /* MessageId: RPC_S_INVALID_ASYNC_CALL                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid asynchronous RPC call handle for this operation.         */
 /*                                                                   */
 dcl RPC_S_INVALID_ASYNC_CALL                 fixed bin(31) value(1915);

 /*                                                                   */
 /* MessageId: RPC_X_PIPE_CLOSED                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The RPC pipe object has already been closed.                     */
 /*                                                                   */
 dcl RPC_X_PIPE_CLOSED                        fixed bin(31) value(1916);

 /*                                                                   */
 /* MessageId: RPC_X_PIPE_DISCIPLINE_ERROR                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The RPC call completed before all pipes were processed.          */
 /*                                                                   */
 dcl RPC_X_PIPE_DISCIPLINE_ERROR              fixed bin(31) value(1917);

 /*                                                                   */
 /* MessageId: RPC_X_PIPE_EMPTY                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No more data is available from the RPC pipe.                     */
 /*                                                                   */
 dcl RPC_X_PIPE_EMPTY                         fixed bin(31) value(1918);

 /*                                                                   */
 /* MessageId: ERROR_NO_SITENAME                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No site name is available for this machine.                      */
 /*                                                                   */
 dcl ERROR_NO_SITENAME                        fixed bin(31) value(1919);

 /*                                                                   */
 /* MessageId: ERROR_CANT_ACCESS_FILE                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file can not be accessed by the system.                      */
 /*                                                                   */
 dcl ERROR_CANT_ACCESS_FILE                   fixed bin(31) value(1920);

 /*                                                                   */
 /* MessageId: ERROR_CANT_RESOLVE_FILENAME                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The name of the file cannot be resolved by the system.           */
 /*                                                                   */
 dcl ERROR_CANT_RESOLVE_FILENAME              fixed bin(31) value(1921);

 /*                                                                   */
 /* MessageId: RPC_S_ENTRY_TYPE_MISMATCH                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The entry is not of the expected type.                           */
 /*                                                                   */
 dcl RPC_S_ENTRY_TYPE_MISMATCH                fixed bin(31) value(1922);

 /*                                                                   */
 /* MessageId: RPC_S_NOT_ALL_OBJS_EXPORTED                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Not all object UUIDs could be exported to the specified entry.   */
 /*                                                                   */
 dcl RPC_S_NOT_ALL_OBJS_EXPORTED              fixed bin(31) value(1923);

 /*                                                                   */
 /* MessageId: RPC_S_INTERFACE_NOT_EXPORTED                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Interface could not be exported to the specified entry.          */
 /*                                                                   */
 dcl RPC_S_INTERFACE_NOT_EXPORTED             fixed bin(31) value(1924);

 /*                                                                   */
 /* MessageId: RPC_S_PROFILE_NOT_ADDED                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified profile entry could not be added.                  */
 /*                                                                   */
 dcl RPC_S_PROFILE_NOT_ADDED                  fixed bin(31) value(1925);

 /*                                                                   */
 /* MessageId: RPC_S_PRF_ELT_NOT_ADDED                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified profile element could not be added.                */
 /*                                                                   */
 dcl RPC_S_PRF_ELT_NOT_ADDED                  fixed bin(31) value(1926);

 /*                                                                   */
 /* MessageId: RPC_S_PRF_ELT_NOT_REMOVED                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified profile element could not be removed.              */
 /*                                                                   */
 dcl RPC_S_PRF_ELT_NOT_REMOVED                fixed bin(31) value(1927);

 /*                                                                   */
 /* MessageId: RPC_S_GRP_ELT_NOT_ADDED                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The group element could not be added.                            */
 /*                                                                   */
 dcl RPC_S_GRP_ELT_NOT_ADDED                  fixed bin(31) value(1928);

 /*                                                                   */
 /* MessageId: RPC_S_GRP_ELT_NOT_REMOVED                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The group element could not be removed.                          */
 /*                                                                   */
 dcl RPC_S_GRP_ELT_NOT_REMOVED                fixed bin(31) value(1929);

 /*                                                                   */
 /* MessageId: ERROR_NO_BROWSER_SERVERS_FOUND                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The list of servers for this workgroup is not currently          */
 /*  available                                                        */
 /*                                                                   */
 dcl ERROR_NO_BROWSER_SERVERS_FOUND           fixed bin(31) value(6118);



 /*********************************************************************/
 /*                                                                   */
 /* OpenGL Error Code                                                 */
 /*                                                                   */
 /*********************************************************************/


 /*                                                                   */
 /* MessageId: ERROR_INVALID_PIXEL_FORMAT                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The pixel format is invalid.                                     */
 /*                                                                   */
 dcl ERROR_INVALID_PIXEL_FORMAT               fixed bin(31) value(2000);

 /*                                                                   */
 /* MessageId: ERROR_BAD_DRIVER                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified driver is invalid.                                 */
 /*                                                                   */
 dcl ERROR_BAD_DRIVER                         fixed bin(31) value(2001);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_WINDOW_STYLE                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The window style or class attribute is invalid for               */
 /*  this operation.                                                  */
 /*                                                                   */
 dcl ERROR_INVALID_WINDOW_STYLE               fixed bin(31) value(2002);

 /*                                                                   */
 /* MessageId: ERROR_METAFILE_NOT_SUPPORTED                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested metafile operation is not supported.               */
 /*                                                                   */
 dcl ERROR_METAFILE_NOT_SUPPORTED             fixed bin(31) value(2003);

 /*                                                                   */
 /* MessageId: ERROR_TRANSFORM_NOT_SUPPORTED                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested transformation operation is not supported.         */
 /*                                                                   */
 dcl ERROR_TRANSFORM_NOT_SUPPORTED            fixed bin(31) value(2004);

 /*                                                                   */
 /* MessageId: ERROR_CLIPPING_NOT_SUPPORTED                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested clipping operation is not supported.               */
 /*                                                                   */
 dcl ERROR_CLIPPING_NOT_SUPPORTED             fixed bin(31) value(2005);

 /* End of OpenGL error codes                                         */


 /*********************************************************************/
 /*                                                                   */
 /*   Image Color Management Error Codes                              */
 /*                                                                   */
 /*********************************************************************/


 /*                                                                   */
 /* MessageId: ERROR_INVALID_CMM                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified color management module is invalid.                */
 /*                                                                   */
 dcl ERROR_INVALID_CMM                        fixed bin(31) value(2010);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_PROFILE                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified color profile is invalid.                          */
 /*                                                                   */
 dcl ERROR_INVALID_PROFILE                    fixed bin(31) value(2011);

 /*                                                                   */
 /* MessageId: ERROR_TAG_NOT_FOUND                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified tag was not found.                                 */
 /*                                                                   */
 dcl ERROR_TAG_NOT_FOUND                      fixed bin(31) value(2012);

 /*                                                                   */
 /* MessageId: ERROR_TAG_NOT_PRESENT                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A required tag is not present.                                   */
 /*                                                                   */
 dcl ERROR_TAG_NOT_PRESENT                    fixed bin(31) value(2013);

 /*                                                                   */
 /* MessageId: ERROR_DUPLICATE_TAG                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified tag is already present.                            */
 /*                                                                   */
 dcl ERROR_DUPLICATE_TAG                      fixed bin(31) value(2014);

 /*                                                                   */
 /* MessageId: ERROR_PROFILE_NOT_ASSOCIATED_WITH_DEVICE               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified color profile is not associated with any device.   */
 /*                                                                   */
 dcl ERROR_PROFILE_NOT_ASSOCIATED_WITH_DEVICE fixed bin(31) value(2015);

 /*                                                                   */
 /* MessageId: ERROR_PROFILE_NOT_FOUND                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified color profile was not found.                       */
 /*                                                                   */
 dcl ERROR_PROFILE_NOT_FOUND                  fixed bin(31) value(2016);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_COLORSPACE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified color space is invalid.                            */
 /*                                                                   */
 dcl ERROR_INVALID_COLORSPACE                 fixed bin(31) value(2017);

 /*                                                                   */
 /* MessageId: ERROR_ICM_NOT_ENABLED                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Image Color Management is not enabled.                           */
 /*                                                                   */
 dcl ERROR_ICM_NOT_ENABLED                    fixed bin(31) value(2018);

 /*                                                                   */
 /* MessageId: ERROR_DELETING_ICM_XFORM                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There was an error while deleting the color transform.           */
 /*                                                                   */
 dcl ERROR_DELETING_ICM_XFORM                 fixed bin(31) value(2019);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_TRANSFORM                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified color transform is invalid.                        */
 /*                                                                   */
 dcl ERROR_INVALID_TRANSFORM                  fixed bin(31) value(2020);

 /*                                                                   */
 /* MessageId: ERROR_COLORSPACE_MISMATCH                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified transform does not match the bitmap's color space. */
 /*                                                                   */
 dcl ERROR_COLORSPACE_MISMATCH                fixed bin(31) value(2021);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_COLORINDEX                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified named color index is not present in the profile.   */
 /*                                                                   */
 dcl ERROR_INVALID_COLORINDEX                 fixed bin(31) value(2022);


 /*********************************************************************/
 /*                                                                   */
 /* Winnet32 Status Codes                                             */
 /*                                                                   */
 /*********************************************************************/

 /*                                                                   */
 /* MessageId: ERROR_CONNECTED_OTHER_PASSWORD                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The network connection was made successfully, but the user had   */
 /*  to be prompted for a password other than the one originally      */
 /*  specified.                                                       */
 /*                                                                   */
 dcl ERROR_CONNECTED_OTHER_PASSWORD           fixed bin(31) value(2108);

 /*                                                                   */
 /* MessageId: ERROR_BAD_USERNAME                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified username is invalid.                               */
 /*                                                                   */
 dcl ERROR_BAD_USERNAME                       fixed bin(31) value(2202);

 /*                                                                   */
 /* MessageId: ERROR_NOT_CONNECTED                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This network connection does not exist.                          */
 /*                                                                   */
 dcl ERROR_NOT_CONNECTED                      fixed bin(31) value(2250);

 /*                                                                   */
 /* MessageId: ERROR_OPEN_FILES                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This network connection has files open or requests pending.      */
 /*                                                                   */
 dcl ERROR_OPEN_FILES                         fixed bin(31) value(2401);

 /*                                                                   */
 /* MessageId: ERROR_ACTIVE_CONNECTIONS                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Active connections still exist.                                  */
 /*                                                                   */
 dcl ERROR_ACTIVE_CONNECTIONS                 fixed bin(31) value(2402);

 /*                                                                   */
 /* MessageId: ERROR_DEVICE_IN_USE                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The device is in use by an active process and cannot be          */
 /*  disconnected.                                                    */
 /*                                                                   */
 dcl ERROR_DEVICE_IN_USE                      fixed bin(31) value(2404);


 /*********************************************************************/
 /*                                                                   */
 /* Win32 Spooler Error Codes                                         */
 /*                                                                   */
 /*********************************************************************/

 /*                                                                   */
 /* MessageId: ERROR_UNKNOWN_PRINT_MONITOR                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified print monitor is unknown.                          */
 /*                                                                   */
 dcl ERROR_UNKNOWN_PRINT_MONITOR              fixed bin(31) value(3000);

 /*                                                                   */
 /* MessageId: ERROR_PRINTER_DRIVER_IN_USE                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified printer driver is currently in use.                */
 /*                                                                   */
 dcl ERROR_PRINTER_DRIVER_IN_USE              fixed bin(31) value(3001);

 /*                                                                   */
 /* MessageId: ERROR_SPOOL_FILE_NOT_FOUND                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The spool file was not found.                                    */
 /*                                                                   */
 dcl ERROR_SPOOL_FILE_NOT_FOUND               fixed bin(31) value(3002);

 /*                                                                   */
 /* MessageId: ERROR_SPL_NO_STARTDOC                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A StartDocPrinter call was not issued.                           */
 /*                                                                   */
 dcl ERROR_SPL_NO_STARTDOC                    fixed bin(31) value(3003);

 /*                                                                   */
 /* MessageId: ERROR_SPL_NO_ADDJOB                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An AddJob call was not issued.                                   */
 /*                                                                   */
 dcl ERROR_SPL_NO_ADDJOB                      fixed bin(31) value(3004);

 /*                                                                   */
 /* MessageId: ERROR_PRINT_PROCESSOR_ALREADY_INSTALLED                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified print processor has already been installed.        */
 /*                                                                   */
 dcl ERROR_PRINT_PROCESSOR_ALREADY_INSTALLED  fixed bin(31) value(3005);

 /*                                                                   */
 /* MessageId: ERROR_PRINT_MONITOR_ALREADY_INSTALLED                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified print monitor has already been installed.          */
 /*                                                                   */
 dcl ERROR_PRINT_MONITOR_ALREADY_INSTALLED    fixed bin(31) value(3006);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_PRINT_MONITOR                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified print monitor does not have the required functions.*/
 /*                                                                   */
 dcl ERROR_INVALID_PRINT_MONITOR              fixed bin(31) value(3007);

 /*                                                                   */
 /* MessageId: ERROR_PRINT_MONITOR_IN_USE                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified print monitor is currently in use.                 */
 /*                                                                   */
 dcl ERROR_PRINT_MONITOR_IN_USE               fixed bin(31) value(3008);

 /*                                                                   */
 /* MessageId: ERROR_PRINTER_HAS_JOBS_QUEUED                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested operation is not allowed when there are jobs       */
 /*  queued to the printer.                                           */
 /*                                                                   */
 dcl ERROR_PRINTER_HAS_JOBS_QUEUED            fixed bin(31) value(3009);

 /*                                                                   */
 /* MessageId: ERROR_SUCCESS_REBOOT_REQUIRED                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested operation is successful.  Changes will not be      */
 /*  effective until the system is rebooted.                          */
 /*                                                                   */
 dcl ERROR_SUCCESS_REBOOT_REQUIRED            fixed bin(31) value(3010);

 /*                                                                   */
 /* MessageId: ERROR_SUCCESS_RESTART_REQUIRED                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested operation is successful.  Changes will not be      */
 /*  effective until the service is restarted.                        */
 /*                                                                   */
 dcl ERROR_SUCCESS_RESTART_REQUIRED           fixed bin(31) value(3011);

 /*                                                                   */
 /* MessageId: ERROR_PRINTER_NOT_FOUND                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No printers were found.                                          */
 /*                                                                   */
 dcl ERROR_PRINTER_NOT_FOUND                  fixed bin(31) value(3012);

 /*********************************************************************/
 /*                                                                   */
 /* Wins Error Codes                                                  */
 /*                                                                   */
 /*********************************************************************/

 /*                                                                   */
 /* MessageId: ERROR_WINS_INTERNAL                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  WINS encountered an error while processing the command.          */
 /*                                                                   */
 dcl ERROR_WINS_INTERNAL                      fixed bin(31) value(4000);

 /*                                                                   */
 /* MessageId: ERROR_CAN_NOT_DEL_LOCAL_WINS                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The local WINS can not be deleted.                               */
 /*                                                                   */
 dcl ERROR_CAN_NOT_DEL_LOCAL_WINS             fixed bin(31) value(4001);

 /*                                                                   */
 /* MessageId: ERROR_STATIC_INIT                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The importation from the file failed.                            */
 /*                                                                   */
 dcl ERROR_STATIC_INIT                        fixed bin(31) value(4002);

 /*                                                                   */
 /* MessageId: ERROR_INC_BACKUP                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The backup Failed.  Was a full backup done before ?              */
 /*                                                                   */
 dcl ERROR_INC_BACKUP                         fixed bin(31) value(4003);

 /*                                                                   */
 /* MessageId: ERROR_FULL_BACKUP                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The backup Failed.  Check the directory that you                 */
 /* are backing the database to.                                      */
 /*                                                                   */
 dcl ERROR_FULL_BACKUP                        fixed bin(31) value(4004);

 /*                                                                   */
 /* MessageId: ERROR_REC_NON_EXISTENT                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The name does not exist in the WINS database.                    */
 /*                                                                   */
 dcl ERROR_REC_NON_EXISTENT                   fixed bin(31) value(4005);

 /*                                                                   */
 /* MessageId: ERROR_RPL_NOT_ALLOWED                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Replication with a non-configured partner is not allowed.        */
 /*                                                                   */
 dcl ERROR_RPL_NOT_ALLOWED                    fixed bin(31) value(4006);


 /*********************************************************************/
 /*                                                                   */
 /*     DHCP Error Codes                                              */
 /*                                                                   */
 /*********************************************************************/

 /*                                                                   */
 /* MessageId: ERROR_DHCP_ADDRESS_CONFLICT                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The DHCP client has obtained an IP address that is already in    */
 /*  use on the network.  The local interface will be disabled until  */
 /*  the DHCP client can obtain a new address.                        */
 /*                                                                   */
 dcl ERROR_DHCP_ADDRESS_CONFLICT            fixed bin (31) value (4100);


 /*********************************************************************/
 /*                                                                   */
 /*     WMI Error Codes                                               */
 /*                                                                   */
 /*********************************************************************/

 /*                                                                   */
 /* MessageId: ERROR_WMI_GUID_NOT_FOUND                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The guid passed was not recognized as valid by a WMI data        */
 /*  provider.                                                        */
 /*                                                                   */
 dcl ERROR_WMI_GUID_NOT_FOUND               fixed bin (31) value (4200);

 /*                                                                   */
 /* MessageId: ERROR_WMI_INSTANCE_NOT_FOUND                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The instance name passed was not recognized as valid by a WMI    */
 /*  data provider.                                                   */
 /*                                                                   */
 dcl ERROR_WMI_INSTANCE_NOT_FOUND           fixed bin (31) value (4201);

 /*                                                                   */
 /* MessageId: ERROR_WMI_ITEMID_NOT_FOUND                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The data item id passed was not recognized as valid by a WMI     */
 /*  data provider.                                                   */
 /*                                                                   */
 dcl ERROR_WMI_ITEMID_NOT_FOUND             fixed bin (31) value (4202);

 /*                                                                   */
 /* MessageId: ERROR_WMI_TRY_AGAIN                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The WMI request could not be completed and should be retried.    */
 /*                                                                   */
 dcl ERROR_WMI_TRY_AGAIN                    fixed bin (31) value (4203);

 /*                                                                   */
 /* MessageId: ERROR_WMI_DP_NOT_FOUND                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The WMI data provider could not be located.                      */
 /*                                                                   */
 dcl ERROR_WMI_DP_NOT_FOUND                 fixed bin (31) value (4204);

 /*                                                                   */
 /* MessageId: ERROR_WMI_UNRESOLVED_INSTANCE_REF                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The WMI data provider references an instance set that has not    */
 /*   been registered.                                                */
 /*                                                                   */
 dcl ERROR_WMI_UNRESOLVED_INSTANCE_REF      fixed bin (31) value (4205);

 /*                                                                   */
 /* MessageId: ERROR_WMI_ALREADY_ENABLED                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The WMI data block or event notification has already been        */
 /*  enabled.                                                         */
 /*                                                                   */
 dcl ERROR_WMI_ALREADY_ENABLED              fixed bin (31) value (4206);

 /*                                                                   */
 /* MessageId: ERROR_WMI_GUID_DISCONNECTED                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The WMI data block is no longer available.                       */
 /*                                                                   */
 dcl ERROR_WMI_GUID_DISCONNECTED            fixed bin (31) value (4207);

 /*                                                                   */
 /* MessageId: ERROR_WMI_SERVER_UNAVAILABLE                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The WMI data service is not available.                           */
 /*                                                                   */
 dcl ERROR_WMI_SERVER_UNAVAILABLE           fixed bin (31) value (4208);

 /*                                                                   */
 /* MessageId: ERROR_WMI_DP_FAILED                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The WMI data provider failed to carry out the request.           */
 /*                                                                   */
 dcl ERROR_WMI_DP_FAILED                    fixed bin (31) value (4209);

 /*                                                                   */
 /* MessageId: ERROR_WMI_INVALID_MOF                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The WMI MOF information is not valid.                            */
 /*                                                                   */
 dcl ERROR_WMI_INVALID_MOF                  fixed bin (31) value (4210);

 /*                                                                   */
 /* MessageId: ERROR_WMI_INVALID_REGINFO                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The WMI registration information is not valid.                   */
 /*                                                                   */
 dcl ERROR_WMI_INVALID_REGINFO              fixed bin (31) value (4211);

 /*                                                                   */
 /* MessageId: ERROR_WMI_ALREADY_DISABLED                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The WMI data block or event notification has already been        */
 /*  disabled.                                                        */
 /*                                                                   */
 dcl ERROR_WMI_ALREADY_DISABLED             fixed bin (31) value (4212);

 /*                                                                   */
 /* MessageId: ERROR_WMI_READ_ONLY                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The WMI data item or data block is read only.                    */
 /*                                                                   */
 dcl ERROR_WMI_READ_ONLY                    fixed bin (31) value (4213);

 /*                                                                   */
 /* MessageId: ERROR_WMI_SET_FAILURE                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The WMI data item or data block could not be changed.            */
 /*                                                                   */
 dcl ERROR_WMI_SET_FAILURE                  fixed bin (31) value (4214);

 /*********************************************************************/
 /*                                                                   */
 /* NT Media Services Error Codes                                     */
 /*                                                                   */
 /*********************************************************************/

 /*                                                                   */
 /* MessageId: ERROR_INVALID_MEDIA                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The media identifier does not represent a valid medium.          */
 /*                                                                   */
 dcl ERROR_INVALID_MEDIA                    fixed bin (31) value (4300);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_LIBRARY                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The library identifier does not represent a valid library.       */
 /*                                                                   */
 dcl ERROR_INVALID_LIBRARY                  fixed bin (31) value (4301);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_MEDIA_POOL                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The media pool identifier does not represent a valid media pool. */
 /*                                                                   */
 dcl ERROR_INVALID_MEDIA_POOL               fixed bin (31) value (4302);

 /*                                                                   */
 /* MessageId: ERROR_DRIVE_MEDIA_MISMATCH                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The drive and medium are not compatible or exist in different    */
 /*  libraries.                                                       */
 /*                                                                   */
 dcl ERROR_DRIVE_MEDIA_MISMATCH             fixed bin (31) value (4303);

 /*                                                                   */
 /* MessageId: ERROR_MEDIA_OFFLINE                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The medium currently exists in an offline library and must be    */
 /*  online to perform this operation.                                */
 /*                                                                   */
 dcl ERROR_MEDIA_OFFLINE                    fixed bin (31) value (4304);

 /*                                                                   */
 /* MessageId: ERROR_LIBRARY_OFFLINE                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operation cannot be performed on an offline library.         */
 /*                                                                   */
 dcl ERROR_LIBRARY_OFFLINE                  fixed bin (31) value (4305);

 /*                                                                   */
 /* MessageId: ERROR_EMPTY                                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The library, drive or media pool is empty.                       */
 /*                                                                   */
 dcl ERROR_EMPTY                            fixed bin (31) value (4306);

 /*                                                                   */
 /* MessageId: ERROR_NOT_EMPTY                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The library,drive or media pool must be empty to perform this    */
 /*  operation.                                                       */
 /*                                                                   */
 dcl ERROR_NOT_EMPTY                        fixed bin (31) value (4307);

 /*                                                                   */
 /* MessageId: ERROR_MEDIA_UNAVAILABLE                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No media is current available in this media pool or library.     */
 /*                                                                   */
 dcl ERROR_MEDIA_UNAVAILABLE                fixed bin (31) value (4308);

 /*                                                                   */
 /* MessageId: ERROR_RESOURCE_DISABLED                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A resource required for this operation is disabled.              */
 /*                                                                   */
 dcl ERROR_RESOURCE_DISABLED                fixed bin (31) value (4309);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_CLEANER                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The media identifier does not represent a valid cleaner.         */
 /*                                                                   */
 dcl ERROR_INVALID_CLEANER                  fixed bin (31) value (4310);

 /*                                                                   */
 /* MessageId: ERROR_UNABLE_TO_CLEAN                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The drive cannot be cleaned or does not support cleaning.        */
 /*                                                                   */
 dcl ERROR_UNABLE_TO_CLEAN                  fixed bin (31) value (4311);

 /*                                                                   */
 /* MessageId: ERROR_OBJECT_NOT_FOUND                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The object identifier does not represent a valid object.         */
 /*                                                                   */
 dcl ERROR_OBJECT_NOT_FOUND                 fixed bin (31) value (4312);

 /*                                                                   */
 /* MessageId: ERROR_DATABASE_FAILURE                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to read or write to the database.                         */
 /*                                                                   */
 dcl ERROR_DATABASE_FAILURE                 fixed bin (31) value (4313);

 /*                                                                   */
 /* MessageId: ERROR_DATABASE_FULL                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The database is full.                                            */
 /*                                                                   */
 dcl ERROR_DATABASE_FULL                    fixed bin (31) value (4314);

 /*                                                                   */
 /* MessageId: ERROR_MEDIA_INCOMPATIBLE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The medium is not compatible with the device or media pool.      */
 /*                                                                   */
 dcl ERROR_MEDIA_INCOMPATIBLE               fixed bin (31) value (4315);

 /*                                                                   */
 /* MessageId: ERROR_RESOURCE_NOT_PRESENT                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The resource required for this operation does not exist.         */
 /*                                                                   */
 dcl ERROR_RESOURCE_NOT_PRESENT             fixed bin (31) value (4316);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_OPERATION                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operation identifier is not valid.                           */
 /*                                                                   */
 dcl ERROR_INVALID_OPERATION                fixed bin (31) value (4317);

 /*                                                                   */
 /* MessageId: ERROR_MEDIA_NOT_AVAILABLE                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The media is not mounted or ready for use.                       */
 /*                                                                   */
 dcl ERROR_MEDIA_NOT_AVAILABLE              fixed bin (31) value (4318);

 /*                                                                   */
 /* MessageId: ERROR_DEVICE_NOT_AVAILABLE                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The device is not ready for use.                                 */
 /*                                                                   */
 dcl ERROR_DEVICE_NOT_AVAILABLE             fixed bin (31) value (4319);

 /*                                                                   */
 /* MessageId: ERROR_REQUEST_REFUSED                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operator or administrator has refused the request            */
 /*                                                                   */
 dcl ERROR_REQUEST_REFUSED                  fixed bin (31) value (4320);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_DRIVE_OBJECT                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The drive identifier does not represent a valid drive.           */
 /*                                                                   */
 dcl ERROR_INVALID_DRIVE_OBJECT             fixed bin (31) value (4321);

 /*                                                                   */
 /* MessageId: ERROR_LIBRARY_FULL                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Library is full.  No slot is available for use.                  */
 /*                                                                   */
 dcl ERROR_LIBRARY_FULL                     fixed bin (31) value (4322);

 /*                                                                   */
 /* MessageId: ERROR_MEDIUM_NOT_ACCESSIBLE                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The transport cannot access the medium.                          */
 /*                                                                   */
 dcl ERROR_MEDIUM_NOT_ACCESSIBLE            fixed bin (31) value (4323);

 /*                                                                   */
 /* MessageId: ERROR_UNABLE_TO_LOAD_MEDIUM                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to load the medium into the drive.                        */
 /*                                                                   */
 dcl ERROR_UNABLE_TO_LOAD_MEDIUM            fixed bin (31) value (4324);

 /*                                                                   */
 /* MessageId: ERROR_UNABLE_TO_INVENTORY_DRIVE                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to retrieve the drive status.                             */
 /*                                                                   */
 dcl ERROR_UNABLE_TO_INVENTORY_DRIVE        fixed bin (31) value (4325);

 /*                                                                   */
 /* MessageId: ERROR_UNABLE_TO_INVENTORY_SLOT                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to retrieve the slot status.                              */
 /*                                                                   */
 dcl ERROR_UNABLE_TO_INVENTORY_SLOT         fixed bin (31) value (4326);

 /*                                                                   */
 /* MessageId: ERROR_UNABLE_TO_INVENTORY_TRANSPORT                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to retrieve status about the transport.                   */
 /*                                                                   */
 dcl ERROR_UNABLE_TO_INVENTORY_TRANSPORT    fixed bin (31) value (4327);

 /*                                                                   */
 /* MessageId: ERROR_TRANSPORT_FULL                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Cannot use the transport because it is already in use.           */
 /*                                                                   */
 dcl ERROR_TRANSPORT_FULL                   fixed bin (31) value (4328);

 /*                                                                   */
 /* MessageId: ERROR_CONTROLLING_IEPORT                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to open or close the inject/eject port.                   */
 /*                                                                   */
 dcl ERROR_CONTROLLING_IEPORT               fixed bin (31) value (4329);

 /*                                                                   */
 /* MessageId: ERROR_UNABLE_TO_EJECT_MOUNTED_MEDIA                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to eject the medium because it is in a drive.             */
 /*                                                                   */
 dcl ERROR_UNABLE_TO_EJECT_MOUNTED_MEDIA    fixed bin (31) value (4330);

 /*                                                                   */
 /* MessageId: ERROR_CLEANER_SLOT_SET                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A cleaner slot is already reserved.                              */
 /*                                                                   */
 dcl ERROR_CLEANER_SLOT_SET                 fixed bin (31) value (4331);

 /*                                                                   */
 /* MessageId: ERROR_CLEANER_SLOT_NOT_SET                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A cleaner slot is not reserved.                                  */
 /*                                                                   */
 dcl ERROR_CLEANER_SLOT_NOT_SET             fixed bin (31) value (4332);

 /*                                                                   */
 /* MessageId: ERROR_CLEANER_CARTRIDGE_SPENT                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cleaner cartridge has performed the maximum number of        */
 /*  drive cleanings.                                                 */
 /*                                                                   */
 dcl ERROR_CLEANER_CARTRIDGE_SPENT          fixed bin (31) value (4333);

 /*                                                                   */
 /* MessageId: ERROR_UNEXPECTED_OMID                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unexpected on-medium identifier.                                 */
 /*                                                                   */
 dcl ERROR_UNEXPECTED_OMID                  fixed bin (31) value (4334);

 /*                                                                   */
 /* MessageId: ERROR_CANT_DELETE_LAST_ITEM                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The last remaining item in this group or resource cannot be      */
 /*  deleted.                                                         */
 /*                                                                   */
 dcl ERROR_CANT_DELETE_LAST_ITEM            fixed bin (31) value (4335);

 /*                                                                   */
 /* MessageId: ERROR_MESSAGE_EXCEEDS_MAX_SIZE                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The message provided exceeds the maximum size allowed            */
 /*  for this parameter.                                              */
 /*                                                                   */
 dcl ERROR_MESSAGE_EXCEEDS_MAX_SIZE         fixed bin (31) value (4336);

 /*                                                                   */
 /* MessageId: ERROR_VOLUME_CONTAINS_SYS_FILES                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The volume contains system or paging files.                      */
 /*                                                                   */
 dcl ERROR_VOLUME_CONTAINS_SYS_FILES        fixed bin (31) value (4337);

 /*                                                                   */
 /* MessageId: ERROR_INDIGENOUS_TYPE                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The media type cannot be removed from this library since at least*/
 /*  one drive in the library reports it can support this media type. */
 /*                                                                   */
 dcl ERROR_INDIGENOUS_TYPE                  fixed bin (31) value (4338);

 /*                                                                   */
 /* MessageId: ERROR_NO_SUPPORTING_DRIVES                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This offline media cannot be mounted on this system since no     */
 /*  enabled drives are present which can be used.                    */
 /*                                                                   */
 dcl ERROR_NO_SUPPORTING_DRIVES             fixed bin (31) value (4339);


 /*********************************************************************/
 /*                                                                   */
 /* NT Remote Storage Service Error Codes                             */
 /*                                                                   */
 /*********************************************************************/

 /*                                                                   */
 /* MessageId: ERROR_FILE_OFFLINE                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The remote storage service was not able to recall the file.      */
 /*                                                                   */
 dcl ERROR_FILE_OFFLINE                       fixed bin(31) value(4350);

 /*                                                                   */
 /* MessageId: ERROR_REMOTE_STORAGE_NOT_ACTIVE                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The remote storage service is not operational at this time.      */
 /*                                                                   */
 dcl ERROR_REMOTE_STORAGE_NOT_ACTIVE          fixed bin(31) value(4351);

 /*                                                                   */
 /* MessageId: ERROR_REMOTE_STORAGE_MEDIA_ERROR                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The remote storage service encountered a media error.            */
 /*                                                                   */
 dcl ERROR_REMOTE_STORAGE_MEDIA_ERROR         fixed bin(31) value(4352);

 /*********************************************************************/
 /*                                                                   */
 /* NT Reparse Points Error Codes                                     */
 /*                                                                   */
 /*********************************************************************/

 /*                                                                   */
 /* MessageId: ERROR_NOT_A_REPARSE_POINT                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file or directory is not a reparse point.                    */
 /*                                                                   */
 dcl ERROR_NOT_A_REPARSE_POINT                fixed bin(31) value(4390);

 /*                                                                   */
 /* MessageId: ERROR_REPARSE_ATTRIBUTE_CONFLICT                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The reparse point attribute cannot be set because it conflicts   */
 /*  with an existing attribute.                                      */
 /*                                                                   */
 dcl ERROR_REPARSE_ATTRIBUTE_CONFLICT         fixed bin(31) value(4391);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_REPARSE_DATA                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The data present in the reparse point buffer is invalid.         */
 /*                                                                   */
 dcl ERROR_INVALID_REPARSE_DATA               fixed bin(31) value(4392);

 /*                                                                   */
 /* MessageId: ERROR_REPARSE_TAG_INVALID                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The tag present in the reparse point buffer is invalid.          */
 /*                                                                   */
 dcl ERROR_REPARSE_TAG_INVALID                fixed bin(31) value(4393);

 /*                                                                   */
 /* MessageId: ERROR_REPARSE_TAG_MISMATCH                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There is a mismatch between the tag specified in the request     */
 /*  and the tag present in the reparse point.                        */
 /*                                                                   */
 dcl ERROR_REPARSE_TAG_MISMATCH               fixed bin(31) value(4394);


 /*********************************************************************/
 /*                                                                   */
 /* NT Single Instance Store Error Codes                              */
 /*                                                                   */
 /*********************************************************************/

 /*                                                                   */
 /* MessageId: ERROR_VOLUME_NOT_SIS_ENABLED                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Single Instance Storage is not available on this volume.         */
 /*                                                                   */
 dcl ERROR_VOLUME_NOT_SIS_ENABLED             fixed bin(31) value(4500);

 /*********************************************************************/
 /*                                                                   */
 /*     Cluster Error Codes                                           */
 /*                                                                   */
 /*********************************************************************/

 /*                                                                   */
 /* MessageId: ERROR_DEPENDENT_RESOURCE_EXISTS                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster resource cannot be moved to another group because    */
 /*  other resources are dependent on it.                             */
 /*                                                                   */
 dcl ERROR_DEPENDENT_RESOURCE_EXISTS          fixed bin(31) value(5001);

 /*                                                                   */
 /* MessageId: ERROR_DEPENDENCY_NOT_FOUND                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster resource dependency cannot be found.                 */
 /*                                                                   */
 dcl ERROR_DEPENDENCY_NOT_FOUND               fixed bin(31) value(5002);

 /*                                                                   */
 /* MessageId: ERROR_DEPENDENCY_ALREADY_EXISTS                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster resource cannot be made dependent on the specified   */
 /*  resource because it is already dependent.                        */
 /*                                                                   */
 dcl ERROR_DEPENDENCY_ALREADY_EXISTS          fixed bin(31) value(5003);

 /*                                                                   */
 /* MessageId: ERROR_RESOURCE_NOT_ONLINE                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster resource is not online.                              */
 /*                                                                   */
 dcl ERROR_RESOURCE_NOT_ONLINE                fixed bin(31) value(5004);

 /*                                                                   */
 /* MessageId: ERROR_HOST_NODE_NOT_AVAILABLE                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A cluster node is not available for this operation.              */
 /*                                                                   */
 dcl ERROR_HOST_NODE_NOT_AVAILABLE            fixed bin(31) value(5005);

 /*                                                                   */
 /* MessageId: ERROR_RESOURCE_NOT_AVAILABLE                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster resource is not available.                           */
 /*                                                                   */
 dcl ERROR_RESOURCE_NOT_AVAILABLE            fixed bin(31) value(5006);

 /*                                                                   */
 /* MessageId: ERROR_RESOURCE_NOT_FOUND                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster resource could not be found.                         */
 /*                                                                   */
 dcl ERROR_RESOURCE_NOT_FOUND                 fixed bin(31) value(5007);

 /*                                                                   */
 /* MessageId: ERROR_SHUTDOWN_CLUSTER                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster is being shut down.                                  */
 /*                                                                   */
 dcl ERROR_SHUTDOWN_CLUSTER                   fixed bin(31) value(5008);

 /*                                                                   */
 /* MessageId: ERROR_CANT_EVICT_ACTIVE_NODE                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A cluster node cannot be evicted from the cluster while it is    */
 /*  online.                                                          */
 /*                                                                   */
 dcl ERROR_CANT_EVICT_ACTIVE_NODE             fixed bin(31) value(5009);

 /*                                                                   */
 /* MessageId: ERROR_OBJECT_ALREADY_EXISTS                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The object already exists.                                       */
 /*                                                                   */
 dcl ERROR_OBJECT_ALREADY_EXISTS              fixed bin(31) value(5010);

 /*                                                                   */
 /* MessageId: ERROR_OBJECT_IN_LIST                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The object is already in the list.                               */
 /*                                                                   */
 dcl ERROR_OBJECT_IN_LIST                     fixed bin(31) value(5011);

 /*                                                                   */
 /* MessageId: ERROR_GROUP_NOT_AVAILABLE                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster group is not available for any new requests.         */
 /*                                                                   */
 dcl ERROR_GROUP_NOT_AVAILABLE                fixed bin(31) value(5012);

 /*                                                                   */
 /* MessageId: ERROR_GROUP_NOT_FOUND                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster group could not be found.                            */
 /*                                                                   */
 dcl ERROR_GROUP_NOT_FOUND                    fixed bin(31) value(5013);

 /*                                                                   */
 /* MessageId: ERROR_GROUP_NOT_ONLINE                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operation could not be completed because the cluster group   */
 /*  is not online.                                                   */
 /*                                                                   */
 dcl ERROR_GROUP_NOT_ONLINE                   fixed bin(31) value(5014);

 /*                                                                   */
 /* MessageId: ERROR_HOST_NODE_NOT_RESOURCE_OWNER                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster node is not the owner of the resource.               */
 /*                                                                   */
 dcl ERROR_HOST_NODE_NOT_RESOURCE_OWNER       fixed bin(31) value(5015);

 /*                                                                   */
 /* MessageId: ERROR_HOST_NODE_NOT_GROUP_OWNER                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster node is not the owner of the group.                  */
 /*                                                                   */
 dcl ERROR_HOST_NODE_NOT_GROUP_OWNER          fixed bin(31) value(5016);

 /*                                                                   */
 /* MessageId: ERROR_RESMON_CREATE_FAILED                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster resource could not be created in the specified       */
 /*  resource monitor.                                                */
 /*                                                                   */
 dcl ERROR_RESMON_CREATE_FAILED               fixed bin(31) value(5017);

 /*                                                                   */
 /* MessageId: ERROR_RESMON_ONLINE_FAILED                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster resource could not be brought online by the resource */
 /*  monitor.                                                         */
 /*                                                                   */
 dcl ERROR_RESMON_ONLINE_FAILED               fixed bin(31) value(5018);

 /*                                                                   */
 /* MessageId: ERROR_RESOURCE_ONLINE                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operation could not be completed because the cluster         */
 /*  resource is online.                                              */
 /*                                                                   */
 dcl ERROR_RESOURCE_ONLINE                    fixed bin(31) value(5019);

 /*                                                                   */
 /* MessageId: ERROR_QUORUM_RESOURCE                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster resource could not be deleted or brought offline     */
 /*  because it is the quorum resource.                               */
 /*                                                                   */
 dcl ERROR_QUORUM_RESOURCE                    fixed bin(31) value(5020);

 /*                                                                   */
 /* MessageId: ERROR_NOT_QUORUM_CAPABLE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster could not make the specified resource a quorum       */
 /* resource because it is not capable of being a quorum resource.    */
 /*                                                                   */
 dcl ERROR_NOT_QUORUM_CAPABLE                 fixed bin(31) value(5021);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_SHUTTING_DOWN                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster software is shutting down.                           */
 /*                                                                   */
 dcl ERROR_CLUSTER_SHUTTING_DOWN              fixed bin(31) value(5022);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_STATE                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The group or resource is not in the correct state to perform the */
 /*  requested operation.                                             */
 /*                                                                   */
 dcl ERROR_INVALID_STATE                      fixed bin(31) value(5023);

 /*                                                                   */
 /* MessageId: ERROR_RESOURCE_PROPERTIES_STORED                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The properties were stored but not all changes will take effect  */
 /*  until the next time the resource is brought online.              */
 /*                                                                   */
 dcl ERROR_RESOURCE_PROPERTIES_STORED         fixed bin(31) value(5024);

 /*                                                                   */
 /* MessageId: ERROR_NOT_QUORUM_CLASS                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster could not make the specified resource a quorum       */
 /*  resource because it does not belong to a shared storage class.   */
 /*                                                                   */
 dcl ERROR_NOT_QUORUM_CLASS                   fixed bin(31) value(5025);

 /*                                                                   */
 /* MessageId: ERROR_CORE_RESOURCE                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster resource could not be deleted since it is a core     */
 /*  resource.                                                        */
 /*                                                                   */
 dcl ERROR_CORE_RESOURCE                      fixed bin(31) value(5026);

 /*                                                                   */
 /* MessageId: ERROR_QUORUM_RESOURCE_ONLINE_FAILED                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The quorum resource failed to come online.                       */
 /*                                                                   */
 dcl ERROR_QUORUM_RESOURCE_ONLINE_FAILED      fixed bin(31) value(5027);

 /*                                                                   */
 /* MessageId: ERROR_QUORUMLOG_OPEN_FAILED                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The quorum log could not be created or mounted successfully.     */
 /*                                                                   */
 dcl ERROR_QUORUMLOG_OPEN_FAILED              fixed bin(31) value(5028);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTERLOG_CORRUPT                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster log is corrupt.                                      */
 /*                                                                   */
 dcl ERROR_CLUSTERLOG_CORRUPT                 fixed bin(31) value(5029);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTERLOG_RECORD_EXCEEDS_MAXSIZE                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The record could not be written to the cluster log since it      */
 /*  exceeds the maximum size.                                        */
 /*                                                                   */
 dcl ERROR_CLUSTERLOG_RECORD_EXCEEDS_MAXSIZE  fixed bin(31) value(5030);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTERLOG_EXCEEDS_MAXSIZE                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster log exceeds its maximum size.                        */
 /*                                                                   */
 dcl ERROR_CLUSTERLOG_EXCEEDS_MAXSIZE         fixed bin(31) value(5031);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTERLOG_CHKPOINT_NOT_FOUND                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No checkpoint record was found in the cluster log.               */
 /*                                                                   */
 dcl ERROR_CLUSTERLOG_CHKPOINT_NOT_FOUND      fixed bin(31) value(5032);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTERLOG_NOT_ENOUGH_SPACE                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The minimum required disk space needed for logging is not        */
 /*  available.                                                       */
 /*                                                                   */
 dcl ERROR_CLUSTERLOG_NOT_ENOUGH_SPACE        fixed bin(31) value(5033);

 /*                                                                   */
 /* MessageId: ERROR_QUORUM_OWNER_ALIVE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster node failed to take control of the quorum resource   */
 /*  because the resource is owned by another active node.            */
 /*                                                                   */
 dcl ERROR_QUORUM_OWNER_ALIVE                 fixed bin(31) value(5034);

 /*                                                                   */
 /* MessageId: ERROR_NETWORK_NOT_AVAILABLE                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A cluster network is not available for this operation.           */
 /*                                                                   */
 dcl ERROR_NETWORK_NOT_AVAILABLE              fixed bin(31) value(5035);

 /*                                                                   */
 /* MessageId: ERROR_NODE_NOT_AVAILABLE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A cluster node is not available for this operation.              */
 /*                                                                   */
 dcl ERROR_NODE_NOT_AVAILABLE                 fixed bin(31) value(5036);

 /*                                                                   */
 /* MessageId: ERROR_ALL_NODES_NOT_AVAILABLE                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  All cluster nodes must be running to perform this operation.     */
 /*                                                                   */
 dcl ERROR_ALL_NODES_NOT_AVAILABLE            fixed bin(31) value(5037);

 /*                                                                   */
 /* MessageId: ERROR_RESOURCE_FAILED                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A cluster resource failed.                                       */
 /*                                                                   */
 dcl ERROR_RESOURCE_FAILED                    fixed bin(31) value(5038);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_INVALID_NODE                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster node is not valid.                                   */
 /*                                                                   */
 dcl ERROR_CLUSTER_INVALID_NODE               fixed bin(31) value(5039);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_NODE_EXISTS                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster node already exists.                                 */
 /*                                                                   */
 dcl ERROR_CLUSTER_NODE_EXISTS                fixed bin(31) value(5040);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_JOIN_IN_PROGRESS                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A node is in the process of joining the cluster.                 */
 /*                                                                   */
 dcl ERROR_CLUSTER_JOIN_IN_PROGRESS           fixed bin(31) value(5041);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_NODE_NOT_FOUND                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster node was not found.                                  */
 /*                                                                   */
 dcl ERROR_CLUSTER_NODE_NOT_FOUND             fixed bin(31) value(5042);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_LOCAL_NODE_NOT_FOUND                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster local node information was not found.                */
 /*                                                                   */
 dcl ERROR_CLUSTER_LOCAL_NODE_NOT_FOUND       fixed bin(31) value(5043);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_NETWORK_EXISTS                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster network already exists.                              */
 /*                                                                   */
 dcl ERROR_CLUSTER_NETWORK_EXISTS             fixed bin(31) value(5044);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_NETWORK_NOT_FOUND                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster network was not found.                               */
 /*                                                                   */
 dcl ERROR_CLUSTER_NETWORK_NOT_FOUND          fixed bin(31) value(5045);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_NETINTERFACE_EXISTS                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster network interface already exists.                    */
 /*                                                                   */
 dcl ERROR_CLUSTER_NETINTERFACE_EXISTS        fixed bin(31) value(5046);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_NETINTERFACE_NOT_FOUND                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster network interface was not found.                     */
 /*                                                                   */
 dcl ERROR_CLUSTER_NETINTERFACE_NOT_FOUND     fixed bin(31) value(5047);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_INVALID_REQUEST                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster request is not valid for this object.                */
 /*                                                                   */
 dcl ERROR_CLUSTER_INVALID_REQUEST            fixed bin(31) value(5048);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_INVALID_NETWORK_PROVIDER                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster network provider is not valid.                       */
 /*                                                                   */
 dcl ERROR_CLUSTER_INVALID_NETWORK_PROVIDER   fixed bin(31) value(5049);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_NODE_DOWN                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster node is down.                                        */
 /*                                                                   */
 dcl ERROR_CLUSTER_NODE_DOWN                  fixed bin(31) value(5050);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_NODE_UNREACHABLE                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster node is not reachable.                               */
 /*                                                                   */
 dcl ERROR_CLUSTER_NODE_UNREACHABLE           fixed bin(31) value(5051);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_NODE_NOT_MEMBER                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster node is not a member of the cluster.                 */
 /*                                                                   */
 dcl ERROR_CLUSTER_NODE_NOT_MEMBER            fixed bin(31) value(5052);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_JOIN_NOT_IN_PROGRESS                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A cluster join operation is not in progress.                     */
 /*                                                                   */
 dcl ERROR_CLUSTER_JOIN_NOT_IN_PROGRESS       fixed bin(31) value(5053);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_INVALID_NETWORK                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster network is not valid.                                */
 /*                                                                   */
 dcl ERROR_CLUSTER_INVALID_NETWORK            fixed bin(31) value(5054);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_NODE_UP                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster node is up.                                          */
 /*                                                                   */
 dcl ERROR_CLUSTER_NODE_UP                    fixed bin(31) value(5056);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_IPADDR_IN_USE                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster IP address is already in use.                        */
 /*                                                                   */
 dcl ERROR_CLUSTER_IPADDR_IN_USE              fixed bin(31) value(5057);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_NODE_NOT_PAUSED                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster node is not paused.                                  */
 /*                                                                   */
 dcl ERROR_CLUSTER_NODE_NOT_PAUSED            fixed bin(31) value(5058);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_NO_SECURITY_CONTEXT                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No cluster security context is available.                        */
 /*                                                                   */
 dcl ERROR_CLUSTER_NO_SECURITY_CONTEXT        fixed bin(31) value(5059);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_NETWORK_NOT_INTERNAL                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster network is not configured for internal cluster       */
 /*  communication.                                                   */
 /*                                                                   */
 dcl ERROR_CLUSTER_NETWORK_NOT_INTERNAL       fixed bin(31) value(5060);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_NODE_ALREADY_UP                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster node is already up.                                  */
 /*                                                                   */
 dcl ERROR_CLUSTER_NODE_ALREADY_UP            fixed bin(31) value(5061);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_NODE_ALREADY_DOWN                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster node is already down.                                */
 /*                                                                   */
 dcl ERROR_CLUSTER_NODE_ALREADY_DOWN          fixed bin(31) value(5062);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_NETWORK_ALREADY_ONLINE                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster network is already online.                           */
 /*                                                                   */
 dcl ERROR_CLUSTER_NETWORK_ALREADY_ONLINE     fixed bin(31) value(5063);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_NETWORK_ALREADY_OFFLINE                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster network is already offline.                          */
 /*                                                                   */
 dcl ERROR_CLUSTER_NETWORK_ALREADY_OFFLINE    fixed bin(31) value(5064);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_NODE_ALREADY_MEMBER                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster node is already a member of the cluster.             */
 /*                                                                   */
 dcl ERROR_CLUSTER_NODE_ALREADY_MEMBER        fixed bin(31) value(5065);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_LAST_INTERNAL_NETWORK                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster network is the only one configured for internal      */
 /*  cluster communication between two or more active cluster nodes.  */
 /*  The internal communication capability cannot be removed from the */
 /*  network.                                                         */
 /*                                                                   */
 dcl ERROR_CLUSTER_LAST_INTERNAL_NETWORK      fixed bin(31) value(5066);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_NETWORK_HAS_DEPENDENTS                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  One or more cluster resources depend on the network to provide   */
 /*  service to clients. The client access capability cannot be       */
 /*  removed from the network.                                        */
 /*                                                                   */
 dcl ERROR_CLUSTER_NETWORK_HAS_DEPENDENTS     fixed bin(31) value(5067);

 /*                                                                   */
 /* MessageId: ERROR_INVALID_OPERATION_ON_QUORUM                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This operation cannot be performed on the cluster resource as    */
 /*  it is the quorum resource. You may not bring the quorum resource */
 /*  offline or modify its possible owners list.                      */
 /*                                                                   */
 dcl ERROR_INVALID_OPERATION_ON_QUORUM        fixed bin(31) value(5068);

 /*                                                                   */
 /* MessageId: ERROR_DEPENDENCY_NOT_ALLOWED                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster quorum resource is not allowed to have any           */
 /*  dependencies.                                                    */
 /*                                                                   */
 dcl ERROR_DEPENDENCY_NOT_ALLOWED             fixed bin(31) value(5069);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_NODE_PAUSED                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster node is paused.                                      */
 /*                                                                   */
 dcl ERROR_CLUSTER_NODE_PAUSED                fixed bin(31) value(5070);

 /*                                                                   */
 /* MessageId: ERROR_NODE_CANT_HOST_RESOURCE                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster resource cannot be brought online. The owner node    */
 /*  cannot run this resource.                                        */
 /*                                                                   */
 dcl ERROR_NODE_CANT_HOST_RESOURCE            fixed bin(31) value(5071);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_NODE_NOT_READY                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster node is not ready to perform the requested operation.*/
 /*                                                                   */
 dcl ERROR_CLUSTER_NODE_NOT_READY             fixed bin(31) value(5072);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_NODE_SHUTTING_DOWN                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster node is shutting down.                               */
 /*                                                                   */
 dcl ERROR_CLUSTER_NODE_SHUTTING_DOWN         fixed bin(31) value(5073);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_JOIN_ABORTED                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster join operation was aborted.                          */
 /*                                                                   */
 dcl ERROR_CLUSTER_JOIN_ABORTED               fixed bin(31) value(5074);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_INCOMPATIBLE_VERSIONS                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cluster join operation failed due to incompatible software   */
 /*  versions between the joining node and its sponsor.               */
 /*                                                                   */
 dcl ERROR_CLUSTER_INCOMPATIBLE_VERSIONS      fixed bin(31) value(5075);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_MAXNUM_OF_RESOURCES_EXCEEDED             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This resource cannot be created because the cluster has reached  */
 /*  the limit on the number of resources it can monitor.             */
 /*                                                                   */
 dcl ERROR_CLUSTER_MAXNUM_OF_RESOURCES_EXCEEDED
                                              fixed bin(31) value(5076);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_SYSTEM_CONFIG_CHANGED                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system configuration changed during the cluster join or form */
 /*  operation. The join or form operation was aborted.               */
 /*                                                                   */
 dcl ERROR_CLUSTER_SYSTEM_CONFIG_CHANGED      fixed bin(31) value(5077);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_RESOURCE_TYPE_NOT_FOUND                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified resource type was not found.                       */
 /*                                                                   */
 dcl ERROR_CLUSTER_RESOURCE_TYPE_NOT_FOUND    fixed bin(31) value(5078);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_RESTYPE_NOT_SUPPORTED                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified node does not support a resource of this type.     */
 /*  This may be due to version inconsistencies or due to the absence */
 /*  of the resource DLL on this node.                                */
 /*                                                                   */
 dcl ERROR_CLUSTER_RESTYPE_NOT_SUPPORTED      fixed bin(31) value(5079);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_RESNAME_NOT_FOUND                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified resource name is not supported by this resource    */
 /*  DLL. This may be due to a bad (or changed) name supplied to the  */
 /*  resource DLL.                                                    */
 /*                                                                   */
 dcl ERROR_CLUSTER_RESNAME_NOT_FOUND          fixed bin(31) value(5080);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_NO_RPC_PACKAGES_REGISTERED               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No authentication package could be registered with the           */
 /*  RPC server.                                                      */
 /*                                                                   */
 dcl ERROR_CLUSTER_NO_RPC_PACKAGES_REGISTERED fixed bin(31) value(5081);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_OWNER_NOT_IN_PREFLIST                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  You cannot bring the group online because the owner of the group */
 /*  is not in the preferred list for the group. To change the owner  */
 /*  node for the group, move the group.                              */
 /*                                                                   */
 dcl ERROR_CLUSTER_OWNER_NOT_IN_PREFLIST      fixed bin(31) value(5082);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_DATABASE_SEQMISMATCH                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The join operation failed because the cluster database sequence  */
 /*  number has changed or is incompatible with the locker node.      */
 /*  This may happen during a join operation if the cluster database  */
 /*  was changing during the join.                                    */
 /*                                                                   */
 dcl ERROR_CLUSTER_DATABASE_SEQMISMATCH       fixed bin(31) value(5083);

 /*                                                                   */
 /* MessageId: ERROR_RESMON_INVALID_STATE                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The resource monitor will not allow the fail operation to be     */
 /*  performed while the resource is in its current state.            */
 /*  This may happen if the resource is in a pending state.           */
 /*                                                                   */
 dcl ERROR_RESMON_INVALID_STATE               fixed bin(31) value(5084);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_GUM_NOT_LOCKER                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A non locker code got a request to reserve the lock for making   */
 /*  global updates.                                                  */
 /*                                                                   */
 dcl ERROR_CLUSTER_GUM_NOT_LOCKER             fixed bin(31) value(5085);

 /*                                                                   */
 /* MessageId: ERROR_QUORUM_DISK_NOT_FOUND                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The quorum disk could not be located by the cluster service.     */
 /*                                                                   */
 dcl ERROR_QUORUM_DISK_NOT_FOUND              fixed bin(31) value(5086);

 /*                                                                   */
 /* MessageId: ERROR_DATABASE_BACKUP_CORRUPT                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The backed up cluster database is possibly corrupt.              */
 /*                                                                   */
 dcl ERROR_DATABASE_BACKUP_CORRUPT            fixed bin(31) value(5087);

 /*                                                                   */
 /* MessageId: ERROR_CLUSTER_NODE_ALREADY_HAS_DFS_ROOT                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A DFS root already exists in this cluster node.                  */
 /*                                                                   */
 dcl ERROR_CLUSTER_NODE_ALREADY_HAS_DFS_ROOT  fixed bin(31) value(5088);

 /*                                                                   */
 /* MessageId: ERROR_RESOURCE_PROPERTY_UNCHANGEABLE                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An attempt to modify a resource property failed because it       */
 /*  conflicts with another existing property.                        */
 /*                                                                   */
 dcl ERROR_RESOURCE_PROPERTY_UNCHANGEABLE     fixed bin(31) value(5089);


 /*********************************************************************/
 /*                                                                   */
 /*     EFS Error Codes                                               */
 /*                                                                   */
 /*********************************************************************/

 /*                                                                   */
 /* MessageId: ERROR_ENCRYPTION_FAILED                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified file could not be encrypted.                       */
 /*                                                                   */
 dcl ERROR_ENCRYPTION_FAILED                  fixed bin(31) value(6000);

 /*                                                                   */
 /* MessageId: ERROR_DECRYPTION_FAILED                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified file could not be decrypted.                       */
 /*                                                                   */
 dcl ERROR_DECRYPTION_FAILED                  fixed bin(31) value(6001);

 /*                                                                   */
 /* MessageId: ERROR_FILE_ENCRYPTED                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified file is encrypted and the user does not have the   */
 /*  ability to decrypt it.                                           */
 /*                                                                   */
 dcl ERROR_FILE_ENCRYPTED                     fixed bin(31) value(6002);

 /*                                                                   */
 /* MessageId: ERROR_NO_RECOVERY_POLICY                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There is no encryption recovery policy configured for this       */
 /*  system.                                                          */
 /*                                                                   */
 dcl ERROR_NO_RECOVERY_POLICY                 fixed bin(31) value(6003);

 /*                                                                   */
 /* MessageId: ERROR_NO_EFS                                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The required encryption driver is not loaded for this system.    */
 /*                                                                   */
 dcl ERROR_NO_EFS                             fixed bin(31) value(6004);

 /*                                                                   */
 /* MessageId: ERROR_WRONG_EFS                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file was encrypted with a different encryption driver than   */
 /*  is currently loaded.                                             */
 /*                                                                   */
 dcl ERROR_WRONG_EFS                          fixed bin(31) value(6005);

 /*                                                                   */
 /* MessageId: ERROR_NO_USER_KEYS                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There are no EFS keys defined for the user.                      */
 /*                                                                   */
 dcl ERROR_NO_USER_KEYS                       fixed bin(31) value(6006);

 /*                                                                   */
 /* MessageId: ERROR_FILE_NOT_ENCRYPTED                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified file is not encrypted.                             */
 /*                                                                   */
 dcl ERROR_FILE_NOT_ENCRYPTED                 fixed bin(31) value(6007);

 /*                                                                   */
 /* MessageId: ERROR_NOT_EXPORT_FORMAT                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified file is not in the defined EFS export format.      */
 /*                                                                   */
 dcl ERROR_NOT_EXPORT_FORMAT                  fixed bin(31) value(6008);

 /*                                                                   */
 /* MessageId: ERROR_FILE_READ_ONLY                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified file is read only.                                 */
 /*                                                                   */
 dcl ERROR_FILE_READ_ONLY                     fixed bin(31) value(6009);


 /*********************************************************************/
 /*                                                                   */
 /* Terminal Server Error Codes                                       */
 /*                                                                   */
 /*********************************************************************/

 /*                                                                   */
 /* MessageId: ERROR_CTX_WINSTATION_NAME_INVALID                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified session name is invalid.                           */
 /*                                                                   */
 dcl ERROR_CTX_WINSTATION_NAME_INVALID        fixed bin(31) value(7001);

 /*                                                                   */
 /* MessageId: ERROR_CTX_INVALID_PD                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified protocol driver is invalid.                        */
 /*                                                                   */
 dcl ERROR_CTX_INVALID_PD                     fixed bin(31) value(7002);

 /*                                                                   */
 /* MessageId: ERROR_CTX_PD_NOT_FOUND                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified protocol driver was not found in the system path.  */
 /*                                                                   */
 dcl ERROR_CTX_PD_NOT_FOUND                   fixed bin(31) value(7003);

 /*                                                                   */
 /* MessageId: ERROR_CTX_WD_NOT_FOUND                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified terminal connection driver was not found           */
 /*  in the system path.                                              */
 /*                                                                   */
 dcl ERROR_CTX_WD_NOT_FOUND                   fixed bin(31) value(7004);

 /*                                                                   */
 /* MessageId: ERROR_CTX_CANNOT_MAKE_EVENTLOG_ENTRY                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A registry key for event logging could not be created for        */
 /*  this session.                                                    */
 /*                                                                   */
 dcl ERROR_CTX_CANNOT_MAKE_EVENTLOG_ENTRY     fixed bin(31) value(7005);

 /*                                                                   */
 /* MessageId: ERROR_CTX_SERVICE_NAME_COLLISION                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A service with the same name already exists on the system.       */
 /*                                                                   */
 dcl ERROR_CTX_SERVICE_NAME_COLLISION         fixed bin(31) value(7006);

 /*                                                                   */
 /* MessageId: ERROR_CTX_CLOSE_PENDING                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A close operation is pending on the session.                     */
 /*                                                                   */
 dcl ERROR_CTX_CLOSE_PENDING                  fixed bin(31) value(7007);

 /*                                                                   */
 /* MessageId: ERROR_CTX_NO_OUTBUF                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There are no free output buffers available.                      */
 /*                                                                   */
 dcl ERROR_CTX_NO_OUTBUF                      fixed bin(31) value(7008);

 /*                                                                   */
 /* MessageId: ERROR_CTX_MODEM_INF_NOT_FOUND                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The MODEM.INF file was not found.                                */
 /*                                                                   */
 dcl ERROR_CTX_MODEM_INF_NOT_FOUND            fixed bin(31) value(7009);

 /*                                                                   */
 /* MessageId: ERROR_CTX_INVALID_MODEMNAME                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The modem name was not found in MODEM.INF.                       */
 /*                                                                   */
 dcl ERROR_CTX_INVALID_MODEMNAME              fixed bin(31) value(7010);

 /*                                                                   */
 /* MessageId: ERROR_CTX_MODEM_RESPONSE_ERROR                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The modem did not accept the command sent to it.                 */
 /*  Verify that the configured modem name matches the attached modem.*/
 /*                                                                   */
 dcl ERROR_CTX_MODEM_RESPONSE_ERROR           fixed bin(31) value(7011);

 /*                                                                   */
 /* MessageId: ERROR_CTX_MODEM_RESPONSE_TIMEOUT                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The modem did not respond to the command sent to it.             */
 /*  Verify that the modem is properly cabled and powered on.         */
 /*                                                                   */
 dcl ERROR_CTX_MODEM_RESPONSE_TIMEOUT         fixed bin(31) value(7012);

 /*                                                                   */
 /* MessageId: ERROR_CTX_MODEM_RESPONSE_NO_CARRIER                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Carrier detect has failed or carrier has been dropped due to     */
 /*  disconnect.                                                      */
 /*                                                                   */
 dcl ERROR_CTX_MODEM_RESPONSE_NO_CARRIER      fixed bin(31) value(7013);

 /*                                                                   */
 /* MessageId: ERROR_CTX_MODEM_RESPONSE_NO_DIALTONE                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Dial tone not detected within the required time. Verify that the */
 /*  phone cable is properly attached and functional.                 */
 /*                                                                   */
 dcl ERROR_CTX_MODEM_RESPONSE_NO_DIALTONE     fixed bin(31) value(7014);

 /*                                                                   */
 /* MessageId: ERROR_CTX_MODEM_RESPONSE_BUSY                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Busy signal detected at remote site on callback.                 */
 /*                                                                   */
 dcl ERROR_CTX_MODEM_RESPONSE_BUSY            fixed bin(31) value(7015);

 /*                                                                   */
 /* MessageId: ERROR_CTX_MODEM_RESPONSE_VOICE                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Voice detected at remote site on callback.                       */
 /*                                                                   */
 dcl ERROR_CTX_MODEM_RESPONSE_VOICE           fixed bin(31) value(7016);

 /*                                                                   */
 /* MessageId: ERROR_CTX_TD_ERROR                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Transport driver error                                           */
 /*                                                                   */
 dcl ERROR_CTX_TD_ERROR                       fixed bin(31) value(7017);

 /*                                                                   */
 /* MessageId: ERROR_CTX_WINSTATION_NOT_FOUND                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified session cannot be found.                           */
 /*                                                                   */
 dcl ERROR_CTX_WINSTATION_NOT_FOUND           fixed bin(31) value(7022);

 /*                                                                   */
 /* MessageId: ERROR_CTX_WINSTATION_ALREADY_EXISTS                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified session name is already in use.                    */
 /*                                                                   */
 dcl ERROR_CTX_WINSTATION_ALREADY_EXISTS      fixed bin(31) value(7023);

 /*                                                                   */
 /* MessageId: ERROR_CTX_WINSTATION_BUSY                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested operation cannot be completed because the terminal */
 /*  connection is currently busy processing a connect, disconnect,   */
 /*  reset, or delete operation.                                      */
 /*                                                                   */
 dcl ERROR_CTX_WINSTATION_BUSY                fixed bin(31) value(7024);

 /*                                                                   */
 /* MessageId: ERROR_CTX_BAD_VIDEO_MODE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An attempt has been made to connect to a session whose           */
 /*  video mode is not supported by the current client.               */
 /*                                                                   */
 dcl ERROR_CTX_BAD_VIDEO_MODE                 fixed bin(31) value(7025);

 /*                                                                   */
 /* MessageId: ERROR_CTX_GRAPHICS_INVALID                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The application attempted to enable DOS graphics mode.           */
 /*  DOS graphics mode is not supported.                              */
 /*                                                                   */
 dcl ERROR_CTX_GRAPHICS_INVALID               fixed bin(31) value(7035);

 /*                                                                   */
 /* MessageId: ERROR_CTX_LOGON_DISABLED                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Your interactive logon privilege has been disabled.              */
 /*  Please contact your administrator.                               */
 /*                                                                   */
 dcl ERROR_CTX_LOGON_DISABLED                 fixed bin(31) value(7037);

 /*                                                                   */
 /* MessageId: ERROR_CTX_NOT_CONSOLE                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested operation can be performed only on the system      */
 /*  console. This is most often the result of a driver or system     */
 /*  DLL requiring direct console access.                             */
 /*                                                                   */
 dcl ERROR_CTX_NOT_CONSOLE                    fixed bin(31) value(7038);

 /*                                                                   */
 /* MessageId: ERROR_CTX_CLIENT_QUERY_TIMEOUT                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The client failed to respond to the server connect message.      */
 /*                                                                   */
 dcl ERROR_CTX_CLIENT_QUERY_TIMEOUT           fixed bin(31) value(7040);

 /*                                                                   */
 /* MessageId: ERROR_CTX_CONSOLE_DISCONNECT                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Disconnecting the console session is not supported.              */
 /*                                                                   */
 dcl ERROR_CTX_CONSOLE_DISCONNECT             fixed bin(31) value(7041);

 /*                                                                   */
 /* MessageId: ERROR_CTX_CONSOLE_CONNECT                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Reconnecting a disconnected session to the console               */
 /*  is not supported.                                                */
 /*                                                                   */
 dcl ERROR_CTX_CONSOLE_CONNECT                fixed bin(31) value(7042);

 /*                                                                   */
 /* MessageId: ERROR_CTX_SHADOW_DENIED                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The request to control another session remotely was denied.      */
 /*                                                                   */
 dcl ERROR_CTX_SHADOW_DENIED                  fixed bin(31) value(7044);

 /*                                                                   */
 /* MessageId: ERROR_CTX_WINSTATION_ACCESS_DENIED                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested session access is denied.                          */
 /*                                                                   */
 dcl ERROR_CTX_WINSTATION_ACCESS_DENIED       fixed bin(31) value(7045);

 /*                                                                   */
 /* MessageId: ERROR_CTX_INVALID_WD                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified terminal connection driver is invalid.             */
 /*                                                                   */
 dcl ERROR_CTX_INVALID_WD                     fixed bin(31) value(7049);

 /*                                                                   */
 /* MessageId: ERROR_CTX_SHADOW_INVALID                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested session cannot be controlled remotely.             */
 /*  This may be because the session is disconnected or does not      */
 /*  currently have a user logged on. Also, you cannot control a      */
 /*  session remotely from the system console or control the system   */
 /*  console remotely. And you cannot remote control your own         */
 /*  current session.                                                 */
 /*                                                                   */
 dcl ERROR_CTX_SHADOW_INVALID                 fixed bin(31) value(7050);

 /*                                                                   */
 /* MessageId: ERROR_CTX_SHADOW_DISABLED                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested session is not configured to allow remote control. */
 /*                                                                   */
 dcl ERROR_CTX_SHADOW_DISABLED                fixed bin(31) value(7051);

 /*                                                                   */
 /* MessageId: ERROR_CTX_CLIENT_LICENSE_IN_USE                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Your request to connect to this Terminal Server has been         */
 /*  rejected. Your Terminal Server client license number is          */
 /*  currently being used by another user. Please call your system    */
 /*  administrator to obtain a new copy of the Terminal Server client */
 /*  with a valid, unique license number.                             */
 /*                                                                   */
 dcl ERROR_CTX_CLIENT_LICENSE_IN_USE          fixed bin(31) value(7052);

 /*                                                                   */
 /* MessageId: ERROR_CTX_CLIENT_LICENSE_NOT_SET                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Your request to connect to this Terminal Server has been         */
 /*  rejected. Your Terminal Server client license number has not     */
 /*  been entered for this copy of the Terminal Server client.        */
 /*  Please call your system administrator for help in entering a     */
 /*  valid, unique license number for this Terminal Server client.    */
 /*                                                                   */
 dcl ERROR_CTX_CLIENT_LICENSE_NOT_SET         fixed bin(31) value(7053);

 /*                                                                   */
 /* MessageId: ERROR_CTX_LICENSE_NOT_AVAILABLE                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system has reached its licensed logon limit.                 */
 /*  Please try again later.                                          */
 /*                                                                   */
 dcl ERROR_CTX_LICENSE_NOT_AVAILABLE          fixed bin(31) value(7054);

 /*                                                                   */
 /* MessageId: ERROR_CTX_LICENSE_CLIENT_INVALID                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The client you are using is not licensed to use this system.     */
 /*  Your logon request is denied.                                    */
 /*                                                                   */
 dcl ERROR_CTX_LICENSE_CLIENT_INVALID         fixed bin(31) value(7055);

 /*                                                                   */
 /* MessageId: ERROR_CTX_LICENSE_EXPIRED                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system license has expired.  Your logon request is denied.   */
 /*                                                                   */
 dcl ERROR_CTX_LICENSE_EXPIRED                fixed bin(31) value(7056);

 /*********************************************************************/
 /*                                                                   */
 /*             Traffic Control Error Codes                           */
 /*                                                                   */
 /*                  7500 to  7999                                    */
 /*                                                                   */
 /*         defined in: tcerror.h                                     */
 /*********************************************************************/

 /*********************************************************************/
 /*                                                                   */
 /*             Active Directory Error Codes                          */
 /*                                                                   */
 /*                  8000 to  8999                                    */
 /*********************************************************************/

 /* ***********************************/
 /* FACILITY_FILE_REPLICATION_SERVICE */
 /* ***********************************/
 /*                                                                   */
 /* MessageId: FRS_ERR_INVALID_API_SEQUENCE                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file replication service API was called incorrectly.         */
 /*                                                                   */
 dcl FRS_ERR_INVALID_API_SEQUENCE             fixed bin(31) value(8001);

 /*                                                                   */
 /* MessageId: FRS_ERR_STARTING_SERVICE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file replication service cannot be started.                  */
 /*                                                                   */
 dcl FRS_ERR_STARTING_SERVICE                 fixed bin(31) value(8002);

 /*                                                                   */
 /* MessageId: FRS_ERR_STOPPING_SERVICE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file replication service cannot be stopped.                  */
 /*                                                                   */
 dcl FRS_ERR_STOPPING_SERVICE                 fixed bin(31) value(8003);

 /*                                                                   */
 /* MessageId: FRS_ERR_INTERNAL_API                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file replication service API terminated the request.         */
 /*  The event log may have more information.                         */
 /*                                                                   */
 dcl FRS_ERR_INTERNAL_API                     fixed bin(31) value(8004);

 /*                                                                   */
 /* MessageId: FRS_ERR_INTERNAL                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file replication service terminated the request.             */
 /*  The event log may have more information.                         */
 /*                                                                   */
 dcl FRS_ERR_INTERNAL                         fixed bin(31) value(8005);

 /*                                                                   */
 /* MessageId: FRS_ERR_SERVICE_COMM                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file replication service cannot be contacted.                */
 /*  The event log may have more information.                         */
 /*                                                                   */
 dcl FRS_ERR_SERVICE_COMM                     fixed bin(31) value(8006);

 /*                                                                   */
 /* MessageId: FRS_ERR_INSUFFICIENT_PRIV                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file replication service cannot satisfy the request because  */
 /*  the user has insufficient privileges.                            */
 /*  The event log may have more information.                         */
 /*                                                                   */
 dcl FRS_ERR_INSUFFICIENT_PRIV                fixed bin(31) value(8007);

 /*                                                                   */
 /* MessageId: FRS_ERR_AUTHENTICATION                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file replication service cannot satisfy the request because  */
 /*  authenticated RPC is not available.                              */
 /*  The event log may have more information.                         */
 /*                                                                   */
 dcl FRS_ERR_AUTHENTICATION                   fixed bin(31) value(8008);

 /*                                                                   */
 /* MessageId: FRS_ERR_PARENT_INSUFFICIENT_PRIV                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file replication service cannot satisfy the request because  */
 /*  the user has insufficient privileges on the domain controller.   */
 /*  The event log may have more information.                         */
 /*                                                                   */
 dcl FRS_ERR_PARENT_INSUFFICIENT_PRIV         fixed bin(31) value(8009);

 /*                                                                   */
 /* MessageId: FRS_ERR_PARENT_AUTHENTICATION                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file replication service cannot satisfy the request because  */
 /*  authenticated RPC is not available on the domain controller.     */
 /*  The event log may have more information.                         */
 /*                                                                   */
 dcl FRS_ERR_PARENT_AUTHENTICATION            fixed bin(31) value(8010);

 /*                                                                   */
 /* MessageId: FRS_ERR_CHILD_TO_PARENT_COMM                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file replication service cannot communicate with the file    */
 /*  replication service on the domain controller.                    */
 /*  The event log may have more information.                         */
 /*                                                                   */
 dcl FRS_ERR_CHILD_TO_PARENT_COMM             fixed bin(31) value(8011);

 /*                                                                   */
 /* MessageId: FRS_ERR_PARENT_TO_CHILD_COMM                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file replication service on the domain controller cannot     */
 /*  communicate with the file replication service on this computer.  */
 /*  The event log may have more information.                         */
 /*                                                                   */
 dcl FRS_ERR_PARENT_TO_CHILD_COMM             fixed bin(31) value(8012);

 /*                                                                   */
 /* MessageId: FRS_ERR_SYSVOL_POPULATE                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file replication service cannot populate the system volume   */
 /*  because of an internal error.                                    */
 /*  The event log may have more information.                         */
 /*                                                                   */
 dcl FRS_ERR_SYSVOL_POPULATE                  fixed bin(31) value(8013);

 /*                                                                   */
 /* MessageId: FRS_ERR_SYSVOL_POPULATE_TIMEOUT                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file replication service cannot populate the system volume   */
 /*  because of an internal timeout.                                  */
 /*  The event log may have more information.                         */
 /*                                                                   */
 dcl FRS_ERR_SYSVOL_POPULATE_TIMEOUT          fixed bin(31) value(8014);

 /*                                                                   */
 /* MessageId: FRS_ERR_SYSVOL_IS_BUSY                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file replication service cannot process the request.         */
 /*  The system volume is busy with a previous request.               */
 /*                                                                   */
 dcl FRS_ERR_SYSVOL_IS_BUSY                   fixed bin(31) value(8015);

 /*                                                                   */
 /* MessageId: FRS_ERR_SYSVOL_DEMOTE                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file replication service cannot stop replicating the system  */
 /*  volume because of an internal error.                             */
 /*  The event log may have more information.                         */
 /*                                                                   */
 dcl FRS_ERR_SYSVOL_DEMOTE                    fixed bin(31) value(8016);

 /*                                                                   */
 /* MessageId: FRS_ERR_INVALID_SERVICE_PARAMETER                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file replication service detected an invalid parameter.      */
 /*                                                                   */
 dcl FRS_ERR_INVALID_SERVICE_PARAMETER        fixed bin(31) value(8017);

 /* ****************************/
 /* FACILITY DIRECTORY SERVICE */
 /* ****************************/
 dcl DS_S_SUCCESS                         fixed bin(31) value(NO_ERROR);
 /*                                                                   */
 /* MessageId: ERROR_DS_NOT_INSTALLED                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An error occurred while installing the directory service.        */
 /*  For more information, see the event log.                         */
 /*                                                                   */
 dcl ERROR_DS_NOT_INSTALLED                   fixed bin(31) value(8200);

 /*                                                                   */
 /* MessageId: ERROR_DS_MEMBERSHIP_EVALUATED_LOCALLY                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The directory service evaluated group memberships locally.       */
 /*                                                                   */
 dcl ERROR_DS_MEMBERSHIP_EVALUATED_LOCALLY    fixed bin(31) value(8201);

 /*                                                                   */
 /* MessageId: ERROR_DS_NO_ATTRIBUTE_OR_VALUE                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified directory service attribute or value does          */
 /*  not exist.                                                       */
 /*                                                                   */
 dcl ERROR_DS_NO_ATTRIBUTE_OR_VALUE           fixed bin(31) value(8202);

 /*                                                                   */
 /* MessageId: ERROR_DS_INVALID_ATTRIBUTE_SYNTAX                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The attribute syntax specified to the directory service          */
 /*  is invalid.                                                      */
 /*                                                                   */
 dcl ERROR_DS_INVALID_ATTRIBUTE_SYNTAX        fixed bin(31) value(8203);

 /*                                                                   */
 /* MessageId: ERROR_DS_ATTRIBUTE_TYPE_UNDEFINED                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The attribute type specified to the directory service is         */
 /*  not defined.                                                     */
 /*                                                                   */
 dcl ERROR_DS_ATTRIBUTE_TYPE_UNDEFINED        fixed bin(31) value(8204);

 /*                                                                   */
 /* MessageId: ERROR_DS_ATTRIBUTE_OR_VALUE_EXISTS                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified directory service attribute or value already       */
 /*  exists.                                                          */
 /*                                                                   */
 dcl ERROR_DS_ATTRIBUTE_OR_VALUE_EXISTS       fixed bin(31) value(8205);

 /*                                                                   */
 /* MessageId: ERROR_DS_BUSY                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The directory service is busy.                                   */
 /*                                                                   */
 dcl ERROR_DS_BUSY                            fixed bin(31) value(8206);

 /*                                                                   */
 /* MessageId: ERROR_DS_UNAVAILABLE                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The directory service is unavailable.                            */
 /*                                                                   */
 dcl ERROR_DS_UNAVAILABLE                     fixed bin(31) value(8207);

 /*                                                                   */
 /* MessageId: ERROR_DS_NO_RIDS_ALLOCATED                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The directory service was unable to allocate a relative          */
 /*  identifier.                                                      */
 /*                                                                   */
 dcl ERROR_DS_NO_RIDS_ALLOCATED               fixed bin(31) value(8208);

 /*                                                                   */
 /* MessageId: ERROR_DS_NO_MORE_RIDS                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The directory service has exhausted the pool of relative         */
 /*  identifiers.                                                     */
 /*                                                                   */
 dcl ERROR_DS_NO_MORE_RIDS                    fixed bin(31) value(8209);

 /*                                                                   */
 /* MessageId: ERROR_DS_INCORRECT_ROLE_OWNER                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested operation could not be performed because the       */
 /*  directory service is not the master for that type of operation.  */
 /*                                                                   */
 dcl ERROR_DS_INCORRECT_ROLE_OWNER            fixed bin(31) value(8210);

 /*                                                                   */
 /* MessageId: ERROR_DS_RIDMGR_INIT_ERROR                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The directory service was unable to initialize the subsystem     */
 /*  that allocates relative identifiers.                             */
 /*                                                                   */
 dcl ERROR_DS_RIDMGR_INIT_ERROR               fixed bin(31) value(8211);

 /*                                                                   */
 /* MessageId: ERROR_DS_OBJ_CLASS_VIOLATION                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested operation did not satisfy one or more constraints  */
 /*  associated with the class of the object.                         */
 /*                                                                   */
 dcl ERROR_DS_OBJ_CLASS_VIOLATION             fixed bin(31) value(8212);

 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_ON_NON_LEAF                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The directory service can perform the requested operation only   */
 /*  on a leaf object.                                                */
 /*                                                                   */
 dcl ERROR_DS_CANT_ON_NON_LEAF                fixed bin(31) value(8213);

 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_ON_RDN                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The directory service cannot perform the requested operation     */
 /*  on the RDN attribute of an object.                               */
 /*                                                                   */
 dcl ERROR_DS_CANT_ON_RDN                     fixed bin(31) value(8214);

 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_MOD_OBJ_CLASS                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The directory service detected an attempt to modify the object   */
 /*  class of an object.                                              */
 /*                                                                   */
 dcl ERROR_DS_CANT_MOD_OBJ_CLASS              fixed bin(31) value(8215);

 /*                                                                   */
 /* MessageId: ERROR_DS_CROSS_DOM_MOVE_ERROR                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested cross-domain move operation could not be performed.*/
 /*                                                                   */
 dcl ERROR_DS_CROSS_DOM_MOVE_ERROR            fixed bin(31) value(8216);

 /*                                                                   */
 /* MessageId: ERROR_DS_GC_NOT_AVAILABLE                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to contact the global catalog server.                     */
 /*                                                                   */
 dcl ERROR_DS_GC_NOT_AVAILABLE                fixed bin(31) value(8217);

 /*                                                                   */
 /* MessageId: ERROR_SHARED_POLICY                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The policy object is shared and can only be modified at the root.*/
 /*                                                                   */
 dcl ERROR_SHARED_POLICY                      fixed bin(31) value(8218);

 /*                                                                   */
 /* MessageId: ERROR_POLICY_OBJECT_NOT_FOUND                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The policy object does not exist.                                */
 /*                                                                   */
 dcl ERROR_POLICY_OBJECT_NOT_FOUND            fixed bin(31) value(8219);

 /*                                                                   */
 /* MessageId: ERROR_POLICY_ONLY_IN_DS                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested policy information is only in the directory        */
 /*  service.                                                         */
 /*                                                                   */
 dcl ERROR_POLICY_ONLY_IN_DS                  fixed bin(31) value(8220);

 /*                                                                   */
 /* MessageId: ERROR_PROMOTION_ACTIVE                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A domain controller promotion is currently active.               */
 /*                                                                   */
 dcl ERROR_PROMOTION_ACTIVE                   fixed bin(31) value(8221);

 /*                                                                   */
 /* MessageId: ERROR_NO_PROMOTION_ACTIVE                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A domain controller promotion is not currently active            */
 /*                                                                   */
 dcl ERROR_NO_PROMOTION_ACTIVE                fixed bin(31) value(8222);

 /* 8223 unused                                                       */
 /*                                                                   */
 /* MessageId: ERROR_DS_OPERATIONS_ERROR                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An operations error occurred.                                    */
 /*                                                                   */
 dcl ERROR_DS_OPERATIONS_ERROR                fixed bin(31) value(8224);

 /*                                                                   */
 /* MessageId: ERROR_DS_PROTOCOL_ERROR                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A protocol error occurred.                                       */
 /*                                                                   */
 dcl ERROR_DS_PROTOCOL_ERROR                  fixed bin(31) value(8225);

 /*                                                                   */
 /* MessageId: ERROR_DS_TIMELIMIT_EXCEEDED                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The time limit for this request was exceeded.                    */
 /*                                                                   */
 dcl ERROR_DS_TIMELIMIT_EXCEEDED              fixed bin(31) value(8226);

 /*                                                                   */
 /* MessageId: ERROR_DS_SIZELIMIT_EXCEEDED                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The size limit for this request was exceeded.                    */
 /*                                                                   */
 dcl ERROR_DS_SIZELIMIT_EXCEEDED              fixed bin(31) value(8227);

 /*                                                                   */
 /* MessageId: ERROR_DS_ADMIN_LIMIT_EXCEEDED                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The administrative limit for this request was exceeded.          */
 /*                                                                   */
 dcl ERROR_DS_ADMIN_LIMIT_EXCEEDED            fixed bin(31) value(8228);

 /*                                                                   */
 /* MessageId: ERROR_DS_COMPARE_FALSE                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The compare response was false.                                  */
 /*                                                                   */
 dcl ERROR_DS_COMPARE_FALSE                   fixed bin(31) value(8229);

 /*                                                                   */
 /* MessageId: ERROR_DS_COMPARE_TRUE                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The compare response was true.                                   */
 /*                                                                   */
 dcl ERROR_DS_COMPARE_TRUE                    fixed bin(31) value(8230);

 /*                                                                   */
 /* MessageId: ERROR_DS_AUTH_METHOD_NOT_SUPPORTED                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested authentication method is not supported by the      */
 /*  server.                                                          */
 /*                                                                   */
 dcl ERROR_DS_AUTH_METHOD_NOT_SUPPORTED       fixed bin(31) value(8231);

 /*                                                                   */
 /* MessageId: ERROR_DS_STRONG_AUTH_REQUIRED                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A more secure authentication method is required for this server. */
 /*                                                                   */
 dcl ERROR_DS_STRONG_AUTH_REQUIRED            fixed bin(31) value(8232);

 /*                                                                   */
 /* MessageId: ERROR_DS_INAPPROPRIATE_AUTH                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Inappropriate authentication.                                    */
 /*                                                                   */
 dcl ERROR_DS_INAPPROPRIATE_AUTH              fixed bin(31) value(8233);

 /*                                                                   */
 /* MessageId: ERROR_DS_AUTH_UNKNOWN                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The authentication mechanism is unknown.                         */
 /*                                                                   */
 dcl ERROR_DS_AUTH_UNKNOWN                    fixed bin(31) value(8234);

 /*                                                                   */
 /* MessageId: ERROR_DS_REFERRAL                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A referral was returned from the server.                         */
 /*                                                                   */
 dcl ERROR_DS_REFERRAL                        fixed bin(31) value(8235);

 /*                                                                   */
 /* MessageId: ERROR_DS_UNAVAILABLE_CRIT_EXTENSION                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The server does not support the requested critical extension.    */
 /*                                                                   */
 dcl ERROR_DS_UNAVAILABLE_CRIT_EXTENSION      fixed bin(31) value(8236);

 /*                                                                   */
 /* MessageId: ERROR_DS_CONFIDENTIALITY_REQUIRED                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This request requires a secure connection.                       */
 /*                                                                   */
 dcl ERROR_DS_CONFIDENTIALITY_REQUIRED        fixed bin(31) value(8237);

 /*                                                                   */
 /* MessageId: ERROR_DS_INAPPROPRIATE_MATCHING                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Inappropriate matching.                                          */
 /*                                                                   */
 dcl ERROR_DS_INAPPROPRIATE_MATCHING          fixed bin(31) value(8238);

 /*                                                                   */
 /* MessageId: ERROR_DS_CONSTRAINT_VIOLATION                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A constraint violation occurred.                                 */
 /*                                                                   */
 dcl ERROR_DS_CONSTRAINT_VIOLATION            fixed bin(31) value(8239);

 /*                                                                   */
 /* MessageId: ERROR_DS_NO_SUCH_OBJECT                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There is no such object on the server.                           */
 /*                                                                   */
 dcl ERROR_DS_NO_SUCH_OBJECT                  fixed bin(31) value(8240);

 /*                                                                   */
 /* MessageId: ERROR_DS_ALIAS_PROBLEM                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There is an alias problem.                                       */
 /*                                                                   */
 dcl ERROR_DS_ALIAS_PROBLEM                   fixed bin(31) value(8241);

 /*                                                                   */
 /* MessageId: ERROR_DS_INVALID_DN_SYNTAX                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An invalid dn syntax has been specified.                         */
 /*                                                                   */
 dcl ERROR_DS_INVALID_DN_SYNTAX               fixed bin(31) value(8242);

 /*                                                                   */
 /* MessageId: ERROR_DS_IS_LEAF                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The object is a leaf object.                                     */
 /*                                                                   */
 dcl ERROR_DS_IS_LEAF                         fixed bin(31) value(8243);

 /*                                                                   */
 /* MessageId: ERROR_DS_ALIAS_DEREF_PROBLEM                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There is an alias dereferencing problem.                         */
 /*                                                                   */
 dcl ERROR_DS_ALIAS_DEREF_PROBLEM             fixed bin(31) value(8244);

 /*                                                                   */
 /* MessageId: ERROR_DS_UNWILLING_TO_PERFORM                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The server is unwilling to process the request.                  */
 /*                                                                   */
 dcl ERROR_DS_UNWILLING_TO_PERFORM            fixed bin(31) value(8245);

 /*                                                                   */
 /* MessageId: ERROR_DS_LOOP_DETECT                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A loop has been detected.                                        */
 /*                                                                   */
 dcl ERROR_DS_LOOP_DETECT                     fixed bin(31) value(8246);

 /*                                                                   */
 /* MessageId: ERROR_DS_NAMING_VIOLATION                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There is a naming violation.                                     */
 /*                                                                   */
 dcl ERROR_DS_NAMING_VIOLATION                fixed bin(31) value(8247);

 /*                                                                   */
 /* MessageId: ERROR_DS_OBJECT_RESULTS_TOO_LARGE                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The result set is too large.                                     */
 /*                                                                   */
 dcl ERROR_DS_OBJECT_RESULTS_TOO_LARGE        fixed bin(31) value(8248);

 /*                                                                   */
 /* MessageId: ERROR_DS_AFFECTS_MULTIPLE_DSAS                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operation affects multiple DSAs                              */
 /*                                                                   */
 dcl ERROR_DS_AFFECTS_MULTIPLE_DSAS           fixed bin(31) value(8249);

 /*                                                                   */
 /* MessageId: ERROR_DS_SERVER_DOWN                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The server is not operational.                                   */
 /*                                                                   */
 dcl ERROR_DS_SERVER_DOWN                     fixed bin(31) value(8250);

 /*                                                                   */
 /* MessageId: ERROR_DS_LOCAL_ERROR                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A local error has occurred.                                      */
 /*                                                                   */
 dcl ERROR_DS_LOCAL_ERROR                     fixed bin(31) value(8251);

 /*                                                                   */
 /* MessageId: ERROR_DS_ENCODING_ERROR                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An encoding error has occurred.                                  */
 /*                                                                   */
 dcl ERROR_DS_ENCODING_ERROR                  fixed bin(31) value(8252);

 /*                                                                   */
 /* MessageId: ERROR_DS_DECODING_ERROR                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A decoding error has occurred.                                   */
 /*                                                                   */
 dcl ERROR_DS_DECODING_ERROR                  fixed bin(31) value(8253);

 /*                                                                   */
 /* MessageId: ERROR_DS_FILTER_UNKNOWN                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The search filter cannot be recognized.                          */
 /*                                                                   */
 dcl ERROR_DS_FILTER_UNKNOWN                  fixed bin(31) value(8254);

 /*                                                                   */
 /* MessageId: ERROR_DS_PARAM_ERROR                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  One or more parameters are illegal.                              */
 /*                                                                   */
 dcl ERROR_DS_PARAM_ERROR                     fixed bin(31) value(8255);

 /*                                                                   */
 /* MessageId: ERROR_DS_NOT_SUPPORTED                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified method is not supported.                           */
 /*                                                                   */
 dcl ERROR_DS_NOT_SUPPORTED                   fixed bin(31) value(8256);

 /*                                                                   */
 /* MessageId: ERROR_DS_NO_RESULTS_RETURNED                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No results were returned.                                        */
 /*                                                                   */
 dcl ERROR_DS_NO_RESULTS_RETURNED             fixed bin(31) value(8257);

 /*                                                                   */
 /* MessageId: ERROR_DS_CONTROL_NOT_FOUND                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified control is not supported by the server.            */
 /*                                                                   */
 dcl ERROR_DS_CONTROL_NOT_FOUND               fixed bin(31) value(8258);

 /*                                                                   */
 /* MessageId: ERROR_DS_CLIENT_LOOP                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A referral loop was detected by the client.                      */
 /*                                                                   */
 dcl ERROR_DS_CLIENT_LOOP                     fixed bin(31) value(8259);

 /*                                                                   */
 /* MessageId: ERROR_DS_REFERRAL_LIMIT_EXCEEDED                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The preset referral limit was exceeded.                          */
 /*                                                                   */
 dcl ERROR_DS_REFERRAL_LIMIT_EXCEEDED         fixed bin(31) value(8260);

 /*                                                                   */
 /* MessageId: ERROR_DS_ROOT_MUST_BE_NC                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The root object must be the head of a naming context.            */
 /*  The root object cannot have an instantiated parent.              */
 /*                                                                   */
 dcl ERROR_DS_ROOT_MUST_BE_NC                 fixed bin(31) value(8301);

 /*                                                                   */
 /* MessageId: ERROR_DS_ADD_REPLICA_INHIBITED                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The add replica operation cannot be performed. The naming        */
 /*  context must be writable in order to create the replica.         */
 /*                                                                   */
 dcl ERROR_DS_ADD_REPLICA_INHIBITED           fixed bin(31) value(8302);

 /*                                                                   */
 /* MessageId: ERROR_DS_ATT_NOT_DEF_IN_SCHEMA                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A reference to an attribute that is not defined in the schema    */
 /*  occurred.                                                        */
 /*                                                                   */
 dcl ERROR_DS_ATT_NOT_DEF_IN_SCHEMA           fixed bin(31) value(8303);

 /*                                                                   */
 /* MessageId: ERROR_DS_MAX_OBJ_SIZE_EXCEEDED                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The maximum size of an object has been exceeded.                 */
 /*                                                                   */
 dcl ERROR_DS_MAX_OBJ_SIZE_EXCEEDED           fixed bin(31) value(8304);

 /*                                                                   */
 /* MessageId: ERROR_DS_OBJ_STRING_NAME_EXISTS                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An attempt was made to add an object to the directory with       */
 /*  a name that is already in use.                                   */
 /*                                                                   */
 dcl ERROR_DS_OBJ_STRING_NAME_EXISTS          fixed bin(31) value(8305);

 /*                                                                   */
 /* MessageId: ERROR_DS_NO_RDN_DEFINED_IN_SCHEMA                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An attempt was made to add an object of a class that does not    */
 /*  have an RDN defined in the schema.                               */
 /*                                                                   */
 dcl ERROR_DS_NO_RDN_DEFINED_IN_SCHEMA        fixed bin(31) value(8306);

 /*                                                                   */
 /* MessageId: ERROR_DS_RDN_DOESNT_MATCH_SCHEMA                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An attempt was made to add an object using an RDN that is not    */
 /*  the RDN defined in the schema.                                   */
 /*                                                                   */
 dcl ERROR_DS_RDN_DOESNT_MATCH_SCHEMA         fixed bin(31) value(8307);

 /*                                                                   */
 /* MessageId: ERROR_DS_NO_REQUESTED_ATTS_FOUND                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  None of the requested attributes were found on the objects.      */
 /*                                                                   */
 dcl ERROR_DS_NO_REQUESTED_ATTS_FOUND         fixed bin(31) value(8308);

 /*                                                                   */
 /* MessageId: ERROR_DS_USER_BUFFER_TO_SMALL                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The user buffer is too small.                                    */
 /*                                                                   */
 dcl ERROR_DS_USER_BUFFER_TO_SMALL            fixed bin(31) value(8309);

 /*                                                                   */
 /* MessageId: ERROR_DS_ATT_IS_NOT_ON_OBJ                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The attribute specified in the operation is not present          */
 /*  on the object.                                                   */
 /*                                                                   */
 dcl ERROR_DS_ATT_IS_NOT_ON_OBJ               fixed bin(31) value(8310);

 /*                                                                   */
 /* MessageId: ERROR_DS_ILLEGAL_MOD_OPERATION                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Illegal modify operation. Some aspect of the modification        */
 /*  is not permitted.                                                */
 /*                                                                   */
 dcl ERROR_DS_ILLEGAL_MOD_OPERATION           fixed bin(31) value(8311);

 /*                                                                   */
 /* MessageId: ERROR_DS_OBJ_TOO_LARGE                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified object is too large.                               */
 /*                                                                   */
 dcl ERROR_DS_OBJ_TOO_LARGE                   fixed bin(31) value(8312);

 /*                                                                   */
 /* MessageId: ERROR_DS_BAD_INSTANCE_TYPE                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified instance type is not valid.                        */
 /*                                                                   */
 dcl ERROR_DS_BAD_INSTANCE_TYPE               fixed bin(31) value(8313);

 /*                                                                   */
 /* MessageId: ERROR_DS_MASTERDSA_REQUIRED                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operation must be performed at a master DSA.                 */
 /*                                                                   */
 dcl ERROR_DS_MASTERDSA_REQUIRED              fixed bin(31) value(8314);

 /*                                                                   */
 /* MessageId: ERROR_DS_OBJECT_CLASS_REQUIRED                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The object class attribute must be specified.                    */
 /*                                                                   */
 dcl ERROR_DS_OBJECT_CLASS_REQUIRED           fixed bin(31) value(8315);

 /*                                                                   */
 /* MessageId: ERROR_DS_MISSING_REQUIRED_ATT                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A required attribute is missing.                                 */
 /*                                                                   */
 dcl ERROR_DS_MISSING_REQUIRED_ATT            fixed bin(31) value(8316);

 /*                                                                   */
 /* MessageId: ERROR_DS_ATT_NOT_DEF_FOR_CLASS                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An attempt was made to modify an object to include an attribute  */
 /*  that is not legal for its class.                                 */
 /*                                                                   */
 dcl ERROR_DS_ATT_NOT_DEF_FOR_CLASS           fixed bin(31) value(8317);

 /*                                                                   */
 /* MessageId: ERROR_DS_ATT_ALREADY_EXISTS                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified attribute is already present on the object.        */
 /*                                                                   */
 dcl ERROR_DS_ATT_ALREADY_EXISTS              fixed bin(31) value(8318);

 /* 8319 unused                                                       */
 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_ADD_ATT_VALUES                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified attribute is not present, or has no values.        */
 /*                                                                   */
 dcl ERROR_DS_CANT_ADD_ATT_VALUES             fixed bin(31) value(8320);

 /*                                                                   */
 /* MessageId: ERROR_DS_SINGLE_VALUE_CONSTRAINT                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An attribute's single value constraint has been violated.        */
 /*                                                                   */
 dcl ERROR_DS_SINGLE_VALUE_CONSTRAINT         fixed bin(31) value(8321);

 /*                                                                   */
 /* MessageId: ERROR_DS_RANGE_CONSTRAINT                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An attribute's range constaint has been violated.                */
 /*                                                                   */
 dcl ERROR_DS_RANGE_CONSTRAINT                fixed bin(31) value(8322);

 /*                                                                   */
 /* MessageId: ERROR_DS_ATT_VAL_ALREADY_EXISTS                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified value already exists.                              */
 /*                                                                   */
 dcl ERROR_DS_ATT_VAL_ALREADY_EXISTS          fixed bin(31) value(8323);

 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_REM_MISSING_ATT                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The attribute cannot be removed because it is not                */
 /*  present on the object.                                           */
 /*                                                                   */
 dcl ERROR_DS_CANT_REM_MISSING_ATT            fixed bin(31) value(8324);

 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_REM_MISSING_ATT_VAL                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The attribute value cannot be removed because it is not          */
 /*  present on the object.                                           */
 /*                                                                   */
 dcl ERROR_DS_CANT_REM_MISSING_ATT_VAL        fixed bin(31) value(8325);

 /*                                                                   */
 /* MessageId: ERROR_DS_ROOT_CANT_BE_SUBREF                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified root object cannot be a subref.                    */
 /*                                                                   */
 dcl ERROR_DS_ROOT_CANT_BE_SUBREF             fixed bin(31) value(8326);

 /*                                                                   */
 /* MessageId: ERROR_DS_NO_CHAINING                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Chaining is not permitted.                                       */
 /*                                                                   */
 dcl ERROR_DS_NO_CHAINING                     fixed bin(31) value(8327);

 /*                                                                   */
 /* MessageId: ERROR_DS_NO_CHAINED_EVAL                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Chained evaluation is not permitted.                             */
 /*                                                                   */
 dcl ERROR_DS_NO_CHAINED_EVAL                 fixed bin(31) value(8328);

 /*                                                                   */
 /* MessageId: ERROR_DS_NO_PARENT_OBJECT                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operation could not be performed because the object's parent */
 /*  is either uninstantiated or deleted.                             */
 /*                                                                   */
 dcl ERROR_DS_NO_PARENT_OBJECT                fixed bin(31) value(8329);

 /*                                                                   */
 /* MessageId: ERROR_DS_PARENT_IS_AN_ALIAS                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Having a parent that is an alias is not permitted.               */
 /*  Aliases are leaf objects.                                        */
 /*                                                                   */
 dcl ERROR_DS_PARENT_IS_AN_ALIAS              fixed bin(31) value(8330);

 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_MIX_MASTER_AND_REPS                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The object and parent must be of the same type,                  */
 /*  either both masters or both replicas.                            */
 /*                                                                   */
 dcl ERROR_DS_CANT_MIX_MASTER_AND_REPS        fixed bin(31) value(8331);

 /*                                                                   */
 /* MessageId: ERROR_DS_CHILDREN_EXIST                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operation cannot be performed because child objects exist.   */
 /*  This operation can only be performed on a leaf object.           */
 /*                                                                   */
 dcl ERROR_DS_CHILDREN_EXIST                  fixed bin(31) value(8332);

 /*                                                                   */
 /* MessageId: ERROR_DS_OBJ_NOT_FOUND                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Directory object not found.                                      */
 /*                                                                   */
 dcl ERROR_DS_OBJ_NOT_FOUND                   fixed bin(31) value(8333);

 /*                                                                   */
 /* MessageId: ERROR_DS_ALIASED_OBJ_MISSING                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The aliased object is missing.                                   */
 /*                                                                   */
 dcl ERROR_DS_ALIASED_OBJ_MISSING             fixed bin(31) value(8334);

 /*                                                                   */
 /* MessageId: ERROR_DS_BAD_NAME_SYNTAX                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The object name has bad syntax.                                  */
 /*                                                                   */
 dcl ERROR_DS_BAD_NAME_SYNTAX                 fixed bin(31) value(8335);

 /*                                                                   */
 /* MessageId: ERROR_DS_ALIAS_POINTS_TO_ALIAS                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  It is not permitted for an alias to refer to another alias.      */
 /*                                                                   */
 dcl ERROR_DS_ALIAS_POINTS_TO_ALIAS           fixed bin(31) value(8336);

 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_DEREF_ALIAS                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The alias cannot be dereferenced.                                */
 /*                                                                   */
 dcl ERROR_DS_CANT_DEREF_ALIAS                fixed bin(31) value(8337);

 /*                                                                   */
 /* MessageId: ERROR_DS_OUT_OF_SCOPE                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operation is out of scope.                                   */
 /*                                                                   */
 dcl ERROR_DS_OUT_OF_SCOPE                    fixed bin(31) value(8338);

 /* 8339 unused                                                       */
 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_DELETE_DSA_OBJ                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The DSA object cannot be deleted.                                */
 /*                                                                   */
 dcl ERROR_DS_CANT_DELETE_DSA_OBJ             fixed bin(31) value(8340);

 /*                                                                   */
 /* MessageId: ERROR_DS_GENERIC_ERROR                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A directory service error has occurred.                          */
 /*                                                                   */
 dcl ERROR_DS_GENERIC_ERROR                   fixed bin(31) value(8341);

 /*                                                                   */
 /* MessageId: ERROR_DS_DSA_MUST_BE_INT_MASTER                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operation can only be performed on an internal master        */
 /*  DSA object.                                                      */
 /*                                                                   */
 dcl ERROR_DS_DSA_MUST_BE_INT_MASTER          fixed bin(31) value(8342);

 /*                                                                   */
 /* MessageId: ERROR_DS_CLASS_NOT_DSA                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The object must be of class DSA.                                 */
 /*                                                                   */
 dcl ERROR_DS_CLASS_NOT_DSA                   fixed bin(31) value(8343);

 /*                                                                   */
 /* MessageId: ERROR_DS_INSUFF_ACCESS_RIGHTS                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Insufficient access rights to perform the operation.             */
 /*                                                                   */
 dcl ERROR_DS_INSUFF_ACCESS_RIGHTS            fixed bin(31) value(8344);

 /*                                                                   */
 /* MessageId: ERROR_DS_ILLEGAL_SUPERIOR                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The object cannot be added because the parent is not on the list */
 /*  of possible superiors.                                           */
 /*                                                                   */
 dcl ERROR_DS_ILLEGAL_SUPERIOR                fixed bin(31) value(8345);

 /*                                                                   */
 /* MessageId: ERROR_DS_ATTRIBUTE_OWNED_BY_SAM                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Access to the attribute is not permitted because the attribute   */
 /*  is owned by the Security Accounts Manager (SAM).                 */
 /*                                                                   */
 dcl ERROR_DS_ATTRIBUTE_OWNED_BY_SAM          fixed bin(31) value(8346);

 /*                                                                   */
 /* MessageId: ERROR_DS_NAME_TOO_MANY_PARTS                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The name has too many parts.                                     */
 /*                                                                   */
 dcl ERROR_DS_NAME_TOO_MANY_PARTS             fixed bin(31) value(8347);

 /*                                                                   */
 /* MessageId: ERROR_DS_NAME_TOO_LONG                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The name is too long.                                            */
 /*                                                                   */
 dcl ERROR_DS_NAME_TOO_LONG                   fixed bin(31) value(8348);

 /*                                                                   */
 /* MessageId: ERROR_DS_NAME_VALUE_TOO_LONG                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The name value is too long.                                      */
 /*                                                                   */
 dcl ERROR_DS_NAME_VALUE_TOO_LONG             fixed bin(31) value(8349);

 /*                                                                   */
 /* MessageId: ERROR_DS_NAME_UNPARSEABLE                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The directory service encountered an error parsing a name.       */
 /*                                                                   */
 dcl ERROR_DS_NAME_UNPARSEABLE                fixed bin(31) value(8350);

 /*                                                                   */
 /* MessageId: ERROR_DS_NAME_TYPE_UNKNOWN                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The directory service cannot get the attribute type for a name.  */
 /*                                                                   */
 dcl ERROR_DS_NAME_TYPE_UNKNOWN               fixed bin(31) value(8351);

 /*                                                                   */
 /* MessageId: ERROR_DS_NOT_AN_OBJECT                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The name does not identify an object; the name identifies        */
 /*  a phantom.                                                       */
 /*                                                                   */
 dcl ERROR_DS_NOT_AN_OBJECT                   fixed bin(31) value(8352);

 /*                                                                   */
 /* MessageId: ERROR_DS_SEC_DESC_TOO_SHORT                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The security descriptor is too short.                            */
 /*                                                                   */
 dcl ERROR_DS_SEC_DESC_TOO_SHORT              fixed bin(31) value(8353);

 /*                                                                   */
 /* MessageId: ERROR_DS_SEC_DESC_INVALID                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The security descriptor is invalid.                              */
 /*                                                                   */
 dcl ERROR_DS_SEC_DESC_INVALID                fixed bin(31) value(8354);

 /*                                                                   */
 /* MessageId: ERROR_DS_NO_DELETED_NAME                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Failed to create name for deleted object.                        */
 /*                                                                   */
 dcl ERROR_DS_NO_DELETED_NAME                 fixed bin(31) value(8355);

 /*                                                                   */
 /* MessageId: ERROR_DS_SUBREF_MUST_HAVE_PARENT                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The parent of a new subref must exist.                           */
 /*                                                                   */
 dcl ERROR_DS_SUBREF_MUST_HAVE_PARENT         fixed bin(31) value(8356);

 /*                                                                   */
 /* MessageId: ERROR_DS_NCNAME_MUST_BE_NC                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The object must be a naming context.                             */
 /*                                                                   */
 dcl ERROR_DS_NCNAME_MUST_BE_NC               fixed bin(31) value(8357);

 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_ADD_SYSTEM_ONLY                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  It is not permitted to add an attribute which is owned           */
 /*  by the system.                                                   */
 /*                                                                   */
 dcl ERROR_DS_CANT_ADD_SYSTEM_ONLY            fixed bin(31) value(8358);

 /*                                                                   */
 /* MessageId: ERROR_DS_CLASS_MUST_BE_CONCRETE                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The class of the object must be structural, you cannot           */
 /*  instantiate an abstract class.                                   */
 /*                                                                   */
 dcl ERROR_DS_CLASS_MUST_BE_CONCRETE          fixed bin(31) value(8359);

 /*                                                                   */
 /* MessageId: ERROR_DS_INVALID_DMD                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The schema object could not be found.                            */
 /*                                                                   */
 dcl ERROR_DS_INVALID_DMD                     fixed bin(31) value(8360);

 /*                                                                   */
 /* MessageId: ERROR_DS_OBJ_GUID_EXISTS                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A local object with this GUID (dead or alive) already exists.    */
 /*                                                                   */
 dcl ERROR_DS_OBJ_GUID_EXISTS                 fixed bin(31) value(8361);

 /*                                                                   */
 /* MessageId: ERROR_DS_NOT_ON_BACKLINK                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operation cannot be performed on a back link.                */
 /*                                                                   */
 dcl ERROR_DS_NOT_ON_BACKLINK                 fixed bin(31) value(8362);

 /*                                                                   */
 /* MessageId: ERROR_DS_NO_CROSSREF_FOR_NC                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cross reference for the specified naming context could       */
 /*  not be found.                                                    */
 /*                                                                   */
 dcl ERROR_DS_NO_CROSSREF_FOR_NC              fixed bin(31) value(8363);

 /*                                                                   */
 /* MessageId: ERROR_DS_SHUTTING_DOWN                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operation could not be performed because the directory       */
 /*  service is shutting down.                                        */
 /*                                                                   */
 dcl ERROR_DS_SHUTTING_DOWN                   fixed bin(31) value(8364);

 /*                                                                   */
 /* MessageId: ERROR_DS_UNKNOWN_OPERATION                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The directory service request is invalid.                        */
 /*                                                                   */
 dcl ERROR_DS_UNKNOWN_OPERATION               fixed bin(31) value(8365);

 /*                                                                   */
 /* MessageId: ERROR_DS_INVALID_ROLE_OWNER                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The role owner attribute could not be read.                      */
 /*                                                                   */
 dcl ERROR_DS_INVALID_ROLE_OWNER              fixed bin(31) value(8366);

 /*                                                                   */
 /* MessageId: ERROR_DS_COULDNT_CONTACT_FSMO                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested FSMO operation failed. The current FSMO holder     */
 /*  could not be contacted.                                          */
 /*                                                                   */
 dcl ERROR_DS_COULDNT_CONTACT_FSMO            fixed bin(31) value(8367);

 /*                                                                   */
 /* MessageId: ERROR_DS_CROSS_NC_DN_RENAME                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Modification of a DN across a naming context is not permitted.   */
 /*                                                                   */
 dcl ERROR_DS_CROSS_NC_DN_RENAME              fixed bin(31) value(8368);

 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_MOD_SYSTEM_ONLY                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The attribute cannot be modified because it is owned by the      */
 /*  system.                                                          */
 /*                                                                   */
 dcl ERROR_DS_CANT_MOD_SYSTEM_ONLY            fixed bin(31) value(8369);

 /*                                                                   */
 /* MessageId: ERROR_DS_REPLICATOR_ONLY                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Only the replicator can perform this function.                   */
 /*                                                                   */
 dcl ERROR_DS_REPLICATOR_ONLY                 fixed bin(31) value(8370);

 /*                                                                   */
 /* MessageId: ERROR_DS_OBJ_CLASS_NOT_DEFINED                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified class is not defined.                              */
 /*                                                                   */
 dcl ERROR_DS_OBJ_CLASS_NOT_DEFINED           fixed bin(31) value(8371);

 /*                                                                   */
 /* MessageId: ERROR_DS_OBJ_CLASS_NOT_SUBCLASS                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified class is not a subclass.                           */
 /*                                                                   */
 dcl ERROR_DS_OBJ_CLASS_NOT_SUBCLASS          fixed bin(31) value(8372);

 /*                                                                   */
 /* MessageId: ERROR_DS_NAME_REFERENCE_INVALID                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The name reference is invalid.                                   */
 /*                                                                   */
 dcl ERROR_DS_NAME_REFERENCE_INVALID          fixed bin(31) value(8373);

 /*                                                                   */
 /* MessageId: ERROR_DS_CROSS_REF_EXISTS                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A cross reference already exists.                                */
 /*                                                                   */
 dcl ERROR_DS_CROSS_REF_EXISTS                fixed bin(31) value(8374);

 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_DEL_MASTER_CROSSREF                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  It is not permitted to delete a master cross reference.          */
 /*                                                                   */
 dcl ERROR_DS_CANT_DEL_MASTER_CROSSREF        fixed bin(31) value(8375);

 /*                                                                   */
 /* MessageId: ERROR_DS_SUBTREE_NOTIFY_NOT_NC_HEAD                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Subtree notifications are only supported on NC heads.            */
 /*                                                                   */
 dcl ERROR_DS_SUBTREE_NOTIFY_NOT_NC_HEAD      fixed bin(31) value(8376);

 /*                                                                   */
 /* MessageId: ERROR_DS_NOTIFY_FILTER_TOO_COMPLEX                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Notification filter is too complex.                              */
 /*                                                                   */
 dcl ERROR_DS_NOTIFY_FILTER_TOO_COMPLEX       fixed bin(31) value(8377);

 /*                                                                   */
 /* MessageId: ERROR_DS_DUP_RDN                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Schema update failed: duplicate RDN.                             */
 /*                                                                   */
 dcl ERROR_DS_DUP_RDN                         fixed bin(31) value(8378);

 /*                                                                   */
 /* MessageId: ERROR_DS_DUP_OID                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Schema update failed: duplicate OID.                             */
 /*                                                                   */
 dcl ERROR_DS_DUP_OID                         fixed bin(31) value(8379);

 /*                                                                   */
 /* MessageId: ERROR_DS_DUP_MAPI_ID                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Schema update failed: duplicate MAPI identifier.                 */
 /*                                                                   */
 dcl ERROR_DS_DUP_MAPI_ID                     fixed bin(31) value(8380);

 /*                                                                   */
 /* MessageId: ERROR_DS_DUP_SCHEMA_ID_GUID                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Schema update failed: duplicate schema-id GUID.                  */
 /*                                                                   */
 dcl ERROR_DS_DUP_SCHEMA_ID_GUID              fixed bin(31) value(8381);

 /*                                                                   */
 /* MessageId: ERROR_DS_DUP_LDAP_DISPLAY_NAME                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Schema update failed: duplicate LDAP display name.               */
 /*                                                                   */
 dcl ERROR_DS_DUP_LDAP_DISPLAY_NAME           fixed bin(31) value(8382);

 /*                                                                   */
 /* MessageId: ERROR_DS_SEMANTIC_ATT_TEST                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Schema update failed: range-lower less than range upper.         */
 /*                                                                   */
 dcl ERROR_DS_SEMANTIC_ATT_TEST               fixed bin(31) value(8383);

 /*                                                                   */
 /* MessageId: ERROR_DS_SYNTAX_MISMATCH                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Schema update failed: syntax mismatch.                           */
 /*                                                                   */
 dcl ERROR_DS_SYNTAX_MISMATCH                 fixed bin(31) value(8384);

 /*                                                                   */
 /* MessageId: ERROR_DS_EXISTS_IN_MUST_HAVE                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Schema deletion failed: attribute is used in must-contain.       */
 /*                                                                   */
 dcl ERROR_DS_EXISTS_IN_MUST_HAVE             fixed bin(31) value(8385);

 /*                                                                   */
 /* MessageId: ERROR_DS_EXISTS_IN_MAY_HAVE                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Schema deletion failed: attribute is used in may-contain.        */
 /*                                                                   */
 dcl ERROR_DS_EXISTS_IN_MAY_HAVE              fixed bin(31) value(8386);

 /*                                                                   */
 /* MessageId: ERROR_DS_NONEXISTENT_MAY_HAVE                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Schema update failed: attribute in may-contain does not exist.   */
 /*                                                                   */
 dcl ERROR_DS_NONEXISTENT_MAY_HAVE            fixed bin(31) value(8387);

 /*                                                                   */
 /* MessageId: ERROR_DS_NONEXISTENT_MUST_HAVE                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Schema update failed: attribute in must-contain does not exist.  */
 /*                                                                   */
 dcl ERROR_DS_NONEXISTENT_MUST_HAVE           fixed bin(31) value(8388);

 /*                                                                   */
 /* MessageId: ERROR_DS_AUX_CLS_TEST_FAIL                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Schema update failed: class in aux-class list does not exist     */
 /*  or is not an auxiliary class.                                    */
 /*                                                                   */
 dcl ERROR_DS_AUX_CLS_TEST_FAIL               fixed bin(31) value(8389);

 /*                                                                   */
 /* MessageId: ERROR_DS_NONEXISTENT_POSS_SUP                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Schema update failed: class in poss-superiors does not exist.    */
 /*                                                                   */
 dcl ERROR_DS_NONEXISTENT_POSS_SUP            fixed bin(31) value(8390);

 /*                                                                   */
 /* MessageId: ERROR_DS_SUB_CLS_TEST_FAIL                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Schema update failed: class in subclassof list does not exist    */
 /*  or does not satisfy hierarchy rules.                             */
 /*                                                                   */
 dcl ERROR_DS_SUB_CLS_TEST_FAIL               fixed bin(31) value(8391);

 /*                                                                   */
 /* MessageId: ERROR_DS_BAD_RDN_ATT_ID_SYNTAX                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Schema update failed: Rdn-Att-Id has wrong syntax.               */
 /*                                                                   */
 dcl ERROR_DS_BAD_RDN_ATT_ID_SYNTAX           fixed bin(31) value(8392);

 /*                                                                   */
 /* MessageId: ERROR_DS_EXISTS_IN_AUX_CLS                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Schema deletion failed: class is used as auxiliary class.        */
 /*                                                                   */
 dcl ERROR_DS_EXISTS_IN_AUX_CLS               fixed bin(31) value(8393);

 /*                                                                   */
 /* MessageId: ERROR_DS_EXISTS_IN_SUB_CLS                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Schema deletion failed: class is used as sub class.              */
 /*                                                                   */
 dcl ERROR_DS_EXISTS_IN_SUB_CLS               fixed bin(31) value(8394);

 /*                                                                   */
 /* MessageId: ERROR_DS_EXISTS_IN_POSS_SUP                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Schema deletion failed: class is used as poss superior.          */
 /*                                                                   */
 dcl ERROR_DS_EXISTS_IN_POSS_SUP              fixed bin(31) value(8395);

 /*                                                                   */
 /* MessageId: ERROR_DS_RECALCSCHEMA_FAILED                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Schema update failed in recalculating validation cache.          */
 /*                                                                   */
 dcl ERROR_DS_RECALCSCHEMA_FAILED             fixed bin(31) value(8396);

 /*                                                                   */
 /* MessageId: ERROR_DS_TREE_DELETE_NOT_FINISHED                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The tree deletion is not finished.  The request must be made     */
 /*  again to continue deleting the tree.                             */
 /*                                                                   */
 dcl ERROR_DS_TREE_DELETE_NOT_FINISHED        fixed bin(31) value(8397);

 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_DELETE                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested delete operation could not be performed.           */
 /*                                                                   */
 dcl ERROR_DS_CANT_DELETE                     fixed bin(31) value(8398);

 /*                                                                   */
 /* MessageId: ERROR_DS_ATT_SCHEMA_REQ_ID                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Cannot read the governs class identifier for the schema record.  */
 /*                                                                   */
 dcl ERROR_DS_ATT_SCHEMA_REQ_ID               fixed bin(31) value(8399);

 /*                                                                   */
 /* MessageId: ERROR_DS_BAD_ATT_SCHEMA_SYNTAX                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The attribute schema has bad syntax.                             */
 /*                                                                   */
 dcl ERROR_DS_BAD_ATT_SCHEMA_SYNTAX           fixed bin(31) value(8400);

 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_CACHE_ATT                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The attribute could not be cached.                               */
 /*                                                                   */
 dcl ERROR_DS_CANT_CACHE_ATT                  fixed bin(31) value(8401);

 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_CACHE_CLASS                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The class could not be cached.                                   */
 /*                                                                   */
 dcl ERROR_DS_CANT_CACHE_CLASS                fixed bin(31) value(8402);

 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_REMOVE_ATT_CACHE                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The attribute could not be removed from the cache.               */
 /*                                                                   */
 dcl ERROR_DS_CANT_REMOVE_ATT_CACHE           fixed bin(31) value(8403);

 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_REMOVE_CLASS_CACHE                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The class could not be removed from the cache.                   */
 /*                                                                   */
 dcl ERROR_DS_CANT_REMOVE_CLASS_CACHE         fixed bin(31) value(8404);

 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_RETRIEVE_DN                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The distinguished name attribute could not be read.              */
 /*                                                                   */
 dcl ERROR_DS_CANT_RETRIEVE_DN                fixed bin(31) value(8405);

 /*                                                                   */
 /* MessageId: ERROR_DS_MISSING_SUPREF                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A required subref is missing.                                    */
 /*                                                                   */
 dcl ERROR_DS_MISSING_SUPREF                  fixed bin(31) value(8406);

 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_RETRIEVE_INSTANCE                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The instance type attribute could not be retrieved.              */
 /*                                                                   */
 dcl ERROR_DS_CANT_RETRIEVE_INSTANCE          fixed bin(31) value(8407);

 /*                                                                   */
 /* MessageId: ERROR_DS_CODE_INCONSISTENCY                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An internal error has occurred.                                  */
 /*                                                                   */
 dcl ERROR_DS_CODE_INCONSISTENCY              fixed bin(31) value(8408);

 /*                                                                   */
 /* MessageId: ERROR_DS_DATABASE_ERROR                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A database error has occurred.                                   */
 /*                                                                   */
 dcl ERROR_DS_DATABASE_ERROR                  fixed bin(31) value(8409);

 /*                                                                   */
 /* MessageId: ERROR_DS_GOVERNSID_MISSING                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The attribute GOVERNSID is missing.                              */
 /*                                                                   */
 dcl ERROR_DS_GOVERNSID_MISSING               fixed bin(31) value(8410);

 /*                                                                   */
 /* MessageId: ERROR_DS_MISSING_EXPECTED_ATT                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An expected attribute is missing.                                */
 /*                                                                   */
 dcl ERROR_DS_MISSING_EXPECTED_ATT            fixed bin(31) value(8411);

 /*                                                                   */
 /* MessageId: ERROR_DS_NCNAME_MISSING_CR_REF                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified naming context is missing a cross reference.       */
 /*                                                                   */
 dcl ERROR_DS_NCNAME_MISSING_CR_REF           fixed bin(31) value(8412);

 /*                                                                   */
 /* MessageId: ERROR_DS_SECURITY_CHECKING_ERROR                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A security checking error has occurred.                          */
 /*                                                                   */
 dcl ERROR_DS_SECURITY_CHECKING_ERROR         fixed bin(31) value(8413);

 /*                                                                   */
 /* MessageId: ERROR_DS_SCHEMA_NOT_LOADED                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The schema is not loaded.                                        */
 /*                                                                   */
 dcl ERROR_DS_SCHEMA_NOT_LOADED               fixed bin(31) value(8414);

 /*                                                                   */
 /* MessageId: ERROR_DS_SCHEMA_ALLOC_FAILED                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Schema allocation failed. Please check if the machine is         */
 /*  running low on memory.                                           */
 /*                                                                   */
 dcl ERROR_DS_SCHEMA_ALLOC_FAILED             fixed bin(31) value(8415);

 /*                                                                   */
 /* MessageId: ERROR_DS_ATT_SCHEMA_REQ_SYNTAX                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Failed to obtain the required syntax for the attribute schema.   */
 /*                                                                   */
 dcl ERROR_DS_ATT_SCHEMA_REQ_SYNTAX           fixed bin(31) value(8416);

 /*                                                                   */
 /* MessageId: ERROR_DS_GCVERIFY_ERROR                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The global catalog verification failed. The global catalog is    */
 /*  not available or does not support the operation.                 */
 /*  Some part of the directory is currently not available.           */
 /*                                                                   */
 dcl ERROR_DS_GCVERIFY_ERROR                  fixed bin(31) value(8417);

 /*                                                                   */
 /* MessageId: ERROR_DS_DRA_SCHEMA_MISMATCH                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The replication operation failed because of a schema mismatch    */
 /*  between the servers involved.                                    */
 /*                                                                   */
 dcl ERROR_DS_DRA_SCHEMA_MISMATCH             fixed bin(31) value(8418);

 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_FIND_DSA_OBJ                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The DSA object could not be found.                               */
 /*                                                                   */
 dcl ERROR_DS_CANT_FIND_DSA_OBJ               fixed bin(31) value(8419);

 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_FIND_EXPECTED_NC                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The naming context could not be found.                           */
 /*                                                                   */
 dcl ERROR_DS_CANT_FIND_EXPECTED_NC           fixed bin(31) value(8420);

 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_FIND_NC_IN_CACHE                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The naming context could not be found in the cache.              */
 /*                                                                   */
 dcl ERROR_DS_CANT_FIND_NC_IN_CACHE           fixed bin(31) value(8421);

 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_RETRIEVE_CHILD                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The child object could not be retrieved.                         */
 /*                                                                   */
 dcl ERROR_DS_CANT_RETRIEVE_CHILD             fixed bin(31) value(8422);

 /*                                                                   */
 /* MessageId: ERROR_DS_SECURITY_ILLEGAL_MODIFY                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The modification was not permitted for security reasons.         */
 /*                                                                   */
 dcl ERROR_DS_SECURITY_ILLEGAL_MODIFY         fixed bin(31) value(8423);

 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_REPLACE_HIDDEN_REC                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operation cannot replace the hidden record.                  */
 /*                                                                   */
 dcl ERROR_DS_CANT_REPLACE_HIDDEN_REC         fixed bin(31) value(8424);

 /*                                                                   */
 /* MessageId: ERROR_DS_BAD_HIERARCHY_FILE                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The hierarchy file is invalid.                                   */
 /*                                                                   */
 dcl ERROR_DS_BAD_HIERARCHY_FILE              fixed bin(31) value(8425);

 /*                                                                   */
 /* MessageId: ERROR_DS_BUILD_HIERARCHY_TABLE_FAILED                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The attempt to build the hierarchy table failed.                 */
 /*                                                                   */
 dcl ERROR_DS_BUILD_HIERARCHY_TABLE_FAILED    fixed bin(31) value(8426);

 /*                                                                   */
 /* MessageId: ERROR_DS_CONFIG_PARAM_MISSING                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The directory configuration parameter is missing                 */
 /*  from the registry.                                               */
 /*                                                                   */
 dcl ERROR_DS_CONFIG_PARAM_MISSING            fixed bin(31) value(8427);

 /*                                                                   */
 /* MessageId: ERROR_DS_COUNTING_AB_INDICES_FAILED                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The attempt to count the address book indices failed.            */
 /*                                                                   */
 dcl ERROR_DS_COUNTING_AB_INDICES_FAILED      fixed bin(31) value(8428);

 /*                                                                   */
 /* MessageId: ERROR_DS_HIERARCHY_TABLE_MALLOC_FAILED                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The allocation of the hierarchy table failed.                    */
 /*                                                                   */
 dcl ERROR_DS_HIERARCHY_TABLE_MALLOC_FAILED   fixed bin(31) value(8429);

 /*                                                                   */
 /* MessageId: ERROR_DS_INTERNAL_FAILURE                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The directory service encountered an internal failure.           */
 /*                                                                   */
 dcl ERROR_DS_INTERNAL_FAILURE                fixed bin(31) value(8430);

 /*                                                                   */
 /* MessageId: ERROR_DS_UNKNOWN_ERROR                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The directory service encountered an unknown failure.            */
 /*                                                                   */
 dcl ERROR_DS_UNKNOWN_ERROR                   fixed bin(31) value(8431);

 /*                                                                   */
 /* MessageId: ERROR_DS_ROOT_REQUIRES_CLASS_TOP                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A root object requires a class of 'top'.                         */
 /*                                                                   */
 dcl ERROR_DS_ROOT_REQUIRES_CLASS_TOP         fixed bin(31) value(8432);

 /*                                                                   */
 /* MessageId: ERROR_DS_REFUSING_FSMO_ROLES                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This directory server is shutting down, and cannot take          */
 /*  ownership of new floating single-master operation roles.         */
 /*                                                                   */
 dcl ERROR_DS_REFUSING_FSMO_ROLES             fixed bin(31) value(8433);

 /*                                                                   */
 /* MessageId: ERROR_DS_MISSING_FSMO_SETTINGS                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The directory service is missing mandatory configuration         */
 /*  information, and is unable to determine the ownership of         */
 /*  floating single-master operation roles.                          */
 /*                                                                   */
 dcl ERROR_DS_MISSING_FSMO_SETTINGS           fixed bin(31) value(8434);

 /*                                                                   */
 /* MessageId: ERROR_DS_UNABLE_TO_SURRENDER_ROLES                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The directory service was unable to transfer ownership of one or */
 /*  more floating single-master operation roles to other servers.    */
 /*                                                                   */
 dcl ERROR_DS_UNABLE_TO_SURRENDER_ROLES       fixed bin(31) value(8435);

 /*                                                                   */
 /* MessageId: ERROR_DS_DRA_GENERIC                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The replication operation failed.                                */
 /*                                                                   */
 dcl ERROR_DS_DRA_GENERIC                     fixed bin(31) value(8436);

 /*                                                                   */
 /* MessageId: ERROR_DS_DRA_INVALID_PARAMETER                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An invalid parameter was specified for this replication          */
 /*  operation.                                                       */
 /*                                                                   */
 dcl ERROR_DS_DRA_INVALID_PARAMETER           fixed bin(31) value(8437);

 /*                                                                   */
 /* MessageId: ERROR_DS_DRA_BUSY                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The directory service is too busy to complete the replication    */
 /*  operation at this time.                                          */
 /*                                                                   */
 dcl ERROR_DS_DRA_BUSY                        fixed bin(31) value(8438);

 /*                                                                   */
 /* MessageId: ERROR_DS_DRA_BAD_DN                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The distinguished name specified for this replication operation  */
 /*  is invalid.                                                      */
 /*                                                                   */
 dcl ERROR_DS_DRA_BAD_DN                      fixed bin(31) value(8439);

 /*                                                                   */
 /* MessageId: ERROR_DS_DRA_BAD_NC                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The naming context specified for this replication operation      */
 /*  is invalid.                                                      */
 /*                                                                   */
 dcl ERROR_DS_DRA_BAD_NC                      fixed bin(31) value(8440);

 /*                                                                   */
 /* MessageId: ERROR_DS_DRA_DN_EXISTS                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The distinguished name specified for this replication operation  */
 /*  already exists.                                                  */
 /*                                                                   */
 dcl ERROR_DS_DRA_DN_EXISTS                   fixed bin(31) value(8441);

 /*                                                                   */
 /* MessageId: ERROR_DS_DRA_INTERNAL_ERROR                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The replication system encountered an internal error.            */
 /*                                                                   */
 dcl ERROR_DS_DRA_INTERNAL_ERROR              fixed bin(31) value(8442);

 /*                                                                   */
 /* MessageId: ERROR_DS_DRA_INCONSISTENT_DIT                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The replication operation encountered a database inconsistency.  */
 /*                                                                   */
 dcl ERROR_DS_DRA_INCONSISTENT_DIT            fixed bin(31) value(8443);

 /*                                                                   */
 /* MessageId: ERROR_DS_DRA_CONNECTION_FAILED                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The server specified for this replication operation              */
 /*  could not be contacted.                                          */
 /*                                                                   */
 dcl ERROR_DS_DRA_CONNECTION_FAILED           fixed bin(31) value(8444);

 /*                                                                   */
 /* MessageId: ERROR_DS_DRA_BAD_INSTANCE_TYPE                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The replication operation encountered an object with             */
 /*  an invalid instance type.                                        */
 /*                                                                   */
 dcl ERROR_DS_DRA_BAD_INSTANCE_TYPE           fixed bin(31) value(8445);

 /*                                                                   */
 /* MessageId: ERROR_DS_DRA_OUT_OF_MEM                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The replication operation failed to allocate memory.             */
 /*                                                                   */
 dcl ERROR_DS_DRA_OUT_OF_MEM                  fixed bin(31) value(8446);

 /*                                                                   */
 /* MessageId: ERROR_DS_DRA_MAIL_PROBLEM                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The replication operation encountered an error with the          */
 /*  mail system.                                                     */
 /*                                                                   */
 dcl ERROR_DS_DRA_MAIL_PROBLEM                fixed bin(31) value(8447);

 /*                                                                   */
 /* MessageId: ERROR_DS_DRA_REF_ALREADY_EXISTS                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The replication reference information for the target server      */
 /*  already exists.                                                  */
 /*                                                                   */
 dcl ERROR_DS_DRA_REF_ALREADY_EXISTS          fixed bin(31) value(8448);

 /*                                                                   */
 /* MessageId: ERROR_DS_DRA_REF_NOT_FOUND                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The replication reference information for the target server      */
 /*  does not exist.                                                  */
 /*                                                                   */
 dcl ERROR_DS_DRA_REF_NOT_FOUND               fixed bin(31) value(8449);

 /*                                                                   */
 /* MessageId: ERROR_DS_DRA_OBJ_IS_REP_SOURCE                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The naming context cannot be removed because it is replicated    */
 /*  to another server.                                               */
 /*                                                                   */
 dcl ERROR_DS_DRA_OBJ_IS_REP_SOURCE           fixed bin(31) value(8450);

 /*                                                                   */
 /* MessageId: ERROR_DS_DRA_DB_ERROR                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The replication operation encountered a database error.          */
 /*                                                                   */
 dcl ERROR_DS_DRA_DB_ERROR                    fixed bin(31) value(8451);

 /*                                                                   */
 /* MessageId: ERROR_DS_DRA_NO_REPLICA                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The naming context is in the process of being removed or         */
 /*  is not replicated from the specified server.                     */
 /*                                                                   */
 dcl ERROR_DS_DRA_NO_REPLICA                  fixed bin(31) value(8452);

 /*                                                                   */
 /* MessageId: ERROR_DS_DRA_ACCESS_DENIED                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Replication access was denied.                                   */
 /*                                                                   */
 dcl ERROR_DS_DRA_ACCESS_DENIED               fixed bin(31) value(8453);

 /*                                                                   */
 /* MessageId: ERROR_DS_DRA_NOT_SUPPORTED                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested operation is not supported by this version         */
 /*  of the directory service.                                        */
 /*                                                                   */
 dcl ERROR_DS_DRA_NOT_SUPPORTED               fixed bin(31) value(8454);

 /*                                                                   */
 /* MessageId: ERROR_DS_DRA_RPC_CANCELLED                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The replication remote procedure call was cancelled.             */
 /*                                                                   */
 dcl ERROR_DS_DRA_RPC_CANCELLED               fixed bin(31) value(8455);

 /*                                                                   */
 /* MessageId: ERROR_DS_DRA_SOURCE_DISABLED                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The source server is currently rejecting replication requests.   */
 /*                                                                   */
 dcl ERROR_DS_DRA_SOURCE_DISABLED             fixed bin(31) value(8456);

 /*                                                                   */
 /* MessageId: ERROR_DS_DRA_SINK_DISABLED                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The destination server is currently rejecting replication        */
 /*  requests.                                                        */
 /*                                                                   */
 dcl ERROR_DS_DRA_SINK_DISABLED               fixed bin(31) value(8457);

 /*                                                                   */
 /* MessageId: ERROR_DS_DRA_NAME_COLLISION                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The replication operation failed due to a collision              */
 /*  of object names.                                                 */
 /*                                                                   */
 dcl ERROR_DS_DRA_NAME_COLLISION              fixed bin(31) value(8458);

 /*                                                                   */
 /* MessageId: ERROR_DS_DRA_SOURCE_REINSTALLED                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The replication source has been reinstalled.                     */
 /*                                                                   */
 dcl ERROR_DS_DRA_SOURCE_REINSTALLED          fixed bin(31) value(8459);

 /*                                                                   */
 /* MessageId: ERROR_DS_DRA_MISSING_PARENT                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The replication operation failed because a required parent       */
 /*  object is missing.                                               */
 /*                                                                   */
 dcl ERROR_DS_DRA_MISSING_PARENT              fixed bin(31) value(8460);

 /*                                                                   */
 /* MessageId: ERROR_DS_DRA_PREEMPTED                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The replication operation was preempted.                         */
 /*                                                                   */
 dcl ERROR_DS_DRA_PREEMPTED                   fixed bin(31) value(8461);

 /*                                                                   */
 /* MessageId: ERROR_DS_DRA_ABANDON_SYNC                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The replication synchronization attempt was abandoned            */
 /*  because of a lack of updates.                                    */
 /*                                                                   */
 dcl ERROR_DS_DRA_ABANDON_SYNC                fixed bin(31) value(8462);

 /*                                                                   */
 /* MessageId: ERROR_DS_DRA_SHUTDOWN                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The replication operation was terminated because the system      */
 /*  is shutting down.                                                */
 /*                                                                   */
 dcl ERROR_DS_DRA_SHUTDOWN                    fixed bin(31) value(8463);

 /*                                                                   */
 /* MessageId: ERROR_DS_DRA_INCOMPATIBLE_PARTIAL_SET                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The replication synchronization attempt failed as the            */
 /*  destination partial attribute set is not a subset of source      */
 /*  partial attribute set.                                           */
 /*                                                                   */
 dcl ERROR_DS_DRA_INCOMPATIBLE_PARTIAL_SET    fixed bin(31) value(8464);

 /*                                                                   */
 /* MessageId: ERROR_DS_DRA_SOURCE_IS_PARTIAL_REPLICA                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The replication synchronization attempt failed because a master  */
 /*  replica attempted to sync from a partial replica.                */
 /*                                                                   */
 dcl ERROR_DS_DRA_SOURCE_IS_PARTIAL_REPLICA   fixed bin(31) value(8465);

 /*                                                                   */
 /* MessageId: ERROR_DS_DRA_EXTN_CONNECTION_FAILED                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The server specified for this replication operation was          */
 /*  contacted, but that server was unable to contact an additional   */
 /*  server needed to complete the operation.                         */
 /*                                                                   */
 dcl ERROR_DS_DRA_EXTN_CONNECTION_FAILED      fixed bin(31) value(8466);

 /*                                                                   */
 /* MessageId: ERROR_DS_INSTALL_SCHEMA_MISMATCH                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A schema mismatch is detected between the source and the build   */
 /*  used during a replica install. The replica cannot be installed.  */
 /*                                                                   */
 dcl ERROR_DS_INSTALL_SCHEMA_MISMATCH        fixed bin(31) value(8467);

 /*                                                                   */
 /* MessageId: ERROR_DS_DUP_LINK_ID                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Schema update failed: An attribute with the same link            */
 /*  identifier already exists.                                       */
 /*                                                                   */
 dcl ERROR_DS_DUP_LINK_ID                     fixed bin(31) value(8468);

 /*                                                                   */
 /* MessageId: ERROR_DS_NAME_ERROR_RESOLVING                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Name translation: Generic processing error.                      */
 /*                                                                   */
 dcl ERROR_DS_NAME_ERROR_RESOLVING            fixed bin(31) value(8469);

 /*                                                                   */
 /* MessageId: ERROR_DS_NAME_ERROR_NOT_FOUND                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Name translation: Could not find the name or insufficient        */
 /*  right to see name.                                               */
 /*                                                                   */
 dcl ERROR_DS_NAME_ERROR_NOT_FOUND            fixed bin(31) value(8470);

 /*                                                                   */
 /* MessageId: ERROR_DS_NAME_ERROR_NOT_UNIQUE                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Name translation: Input name mapped to more than one output name.*/
 /*                                                                   */
 dcl ERROR_DS_NAME_ERROR_NOT_UNIQUE           fixed bin(31) value(8471);

 /*                                                                   */
 /* MessageId: ERROR_DS_NAME_ERROR_NO_MAPPING                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Name translation: Input name found, but not the associated       */
 /*  output format.                                                   */
 /*                                                                   */
 dcl ERROR_DS_NAME_ERROR_NO_MAPPING           fixed bin(31) value(8472);

 /*                                                                   */
 /* MessageId: ERROR_DS_NAME_ERROR_DOMAIN_ONLY                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Name translation: Unable to resolve completely,                  */
 /*  only the domain was found.                                       */
 /*                                                                   */
 dcl ERROR_DS_NAME_ERROR_DOMAIN_ONLY          fixed bin(31) value(8473);

 /*                                                                   */
 /* MessageId: ERROR_DS_NAME_ERROR_NO_SYNTACTICAL_MAPPING             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Name translation: Unable to perform purely syntactical           */
 /*  mapping at the client without going out to the wire.             */
 /*                                                                   */
 dcl ERROR_DS_NAME_ERROR_NO_SYNTACTICAL_MAPPING
                                              fixed bin(31) value(8474);

 /*                                                                   */
 /* MessageId: ERROR_DS_CONSTRUCTED_ATT_MOD                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Modification of a constructed att is not allowed.                */
 /*                                                                   */
 dcl ERROR_DS_CONSTRUCTED_ATT_MOD             fixed bin(31) value(8475);

 /*                                                                   */
 /* MessageId: ERROR_DS_WRONG_OM_OBJ_CLASS                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The OM-Object-Class specified is incorrect for an                */
 /*  attribute with the specified syntax.                             */
 /*                                                                   */
 dcl ERROR_DS_WRONG_OM_OBJ_CLASS              fixed bin(31) value(8476);

 /*                                                                   */
 /* MessageId: ERROR_DS_DRA_REPL_PENDING                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The replication request has been posted, waiting for reply.      */
 /*                                                                   */
 dcl ERROR_DS_DRA_REPL_PENDING                fixed bin(31) value(8477);

 /*                                                                   */
 /* MessageId: ERROR_DS_DS_REQUIRED                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested operation requires a directory service,            */
 /*  and none was available.                                          */
 /*                                                                   */
 dcl ERROR_DS_DS_REQUIRED                     fixed bin(31) value(8478);

 /*                                                                   */
 /* MessageId: ERROR_DS_INVALID_LDAP_DISPLAY_NAME                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The LDAP display name of the class or attribute contains         */
 /*  non-ASCII characters.                                            */
 /*                                                                   */
 dcl ERROR_DS_INVALID_LDAP_DISPLAY_NAME       fixed bin(31) value(8479);

 /*                                                                   */
 /* MessageId: ERROR_DS_NON_BASE_SEARCH                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested search operation is only supported for             */
 /*  base searches.                                                   */
 /*                                                                   */
 dcl ERROR_DS_NON_BASE_SEARCH                 fixed bin(31) value(8480);

 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_RETRIEVE_ATTS                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The search failed to retrieve attributes from the database.      */
 /*                                                                   */
 dcl ERROR_DS_CANT_RETRIEVE_ATTS              fixed bin(31) value(8481);

 /*                                                                   */
 /* MessageId: ERROR_DS_BACKLINK_WITHOUT_LINK                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The schema update operation tried to add a backward link         */
 /*  attribute that has no corresponding forward link.                */
 /*                                                                   */
 dcl ERROR_DS_BACKLINK_WITHOUT_LINK           fixed bin(31) value(8482);

 /*                                                                   */
 /* MessageId: ERROR_DS_EPOCH_MISMATCH                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Source and destination of a cross-domain move do not agree on    */
 /*  the object's epoch number.  Either source or destination does    */
 /*  not have the latest version of the object.                       */
 /*                                                                   */
 dcl ERROR_DS_EPOCH_MISMATCH                  fixed bin(31) value(8483);

 /*                                                                   */
 /* MessageId: ERROR_DS_SRC_NAME_MISMATCH                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Source and destination of a cross-domain move do not agree on    */
 /*  the object's current name.  Either source or destination does    */
 /*  not have the latest version of the object.                       */
 /*                                                                   */
 dcl ERROR_DS_SRC_NAME_MISMATCH               fixed bin(31) value(8484);

 /*                                                                   */
 /* MessageId: ERROR_DS_SRC_AND_DST_NC_IDENTICAL                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Source and destination for the cross-domain move operation       */
 /*  are identical.  Caller should use local move operation instead   */
 /*  of cross-domain move operation.                                  */
 /*                                                                   */
 dcl ERROR_DS_SRC_AND_DST_NC_IDENTICAL        fixed bin(31) value(8485);

 /*                                                                   */
 /* MessageId: ERROR_DS_DST_NC_MISMATCH                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Source and destination for a cross-domain move are not in        */
 /*  agreement on the naming contexts in the forest.                  */
 /*  Either source or destination does not have the latest version    */
 /*  of the Partitions container.                                     */
 /*                                                                   */
 dcl ERROR_DS_DST_NC_MISMATCH                 fixed bin(31) value(8486);

 /*                                                                   */
 /* MessageId: ERROR_DS_NOT_AUTHORITIVE_FOR_DST_NC                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Destination of a cross-domain move is not authoritative for      */
 /*  the destination naming context.                                  */
 /*                                                                   */
 dcl ERROR_DS_NOT_AUTHORITIVE_FOR_DST_NC      fixed bin(31) value(8487);

 /*                                                                   */
 /* MessageId: ERROR_DS_SRC_GUID_MISMATCH                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Source and destination of a cross-domain move do not agree on    */
 /*  the identity of the source object.  Either source or destination */
 /*  does not have the latest version of the source object.           */
 /*                                                                   */
 dcl ERROR_DS_SRC_GUID_MISMATCH               fixed bin(31) value(8488);

 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_MOVE_DELETED_OBJECT                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Object being moved across-domains is already known to be deleted */
 /*  by the destination server.  The source server does not have the  */
 /*  latest version of the source object.                             */
 /*                                                                   */
 dcl ERROR_DS_CANT_MOVE_DELETED_OBJECT        fixed bin(31) value(8489);

 /*                                                                   */
 /* MessageId: ERROR_DS_PDC_OPERATION_IN_PROGRESS                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Another operation which requires exclusive access to the PDC     */
 /*  FSMO is already in progress.                                     */
 /*                                                                   */
 dcl ERROR_DS_PDC_OPERATION_IN_PROGRESS       fixed bin(31) value(8490);

 /*                                                                   */
 /* MessageId: ERROR_DS_CROSS_DOMAIN_CLEANUP_REQD                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A cross-domain move operation failed such that two versions of   */
 /*  the moved object exist - one each in the source and destination  */
 /*  domains.  The destination object needs to be removed to restore  */
 /*  the system to a consistent state.                                */
 /*                                                                   */
 dcl ERROR_DS_CROSS_DOMAIN_CLEANUP_REQD       fixed bin(31) value(8491);

 /*                                                                   */
 /* MessageId: ERROR_DS_ILLEGAL_XDOM_MOVE_OPERATION                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This object may not be moved across domain boundaries either     */
 /*  because cross-domain moves for this class are disallowed, or     */
 /*  the object has some special characteristics, eg: trust account   */
 /*  or restricted RID, which prevent its move.                       */
 /*                                                                   */
 dcl ERROR_DS_ILLEGAL_XDOM_MOVE_OPERATION     fixed bin(31) value(8492);

 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_WITH_ACCT_GROUP_MEMBERSHPS               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Can't move objects with memberships across domain boundaries     */
 /*  as once moved, this would violate the membership conditions of   */
 /*  the account group.  Remove the object from any account group     */
 /*  memberships and retry.                                           */
 /*                                                                   */
 dcl ERROR_DS_CANT_WITH_ACCT_GROUP_MEMBERSHPS fixed bin(31) value(8493);

 /*                                                                   */
 /* MessageId: ERROR_DS_NC_MUST_HAVE_NC_PARENT                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A naming context head must be the immediate child of another     */
 /*  naming context head, not of an interior node.                    */
 /*                                                                   */
 dcl ERROR_DS_NC_MUST_HAVE_NC_PARENT          fixed bin(31) value(8494);

 /*                                                                   */
 /* MessageId: ERROR_DS_CR_IMPOSSIBLE_TO_VALIDATE                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The directory cannot validate the proposed naming context name   */
 /*  because it does not hold a replica of the naming context above   */
 /*  the proposed naming context.                                     */
 /*                                                                   */
 dcl ERROR_DS_CR_IMPOSSIBLE_TO_VALIDATE       fixed bin(31) value(8495);

 /*                                                                   */
 /* MessageId: ERROR_DS_DST_DOMAIN_NOT_NATIVE                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Destination domain must be in native mode.                       */
 /*                                                                   */
 dcl ERROR_DS_DST_DOMAIN_NOT_NATIVE           fixed bin(31) value(8496);

 /*                                                                   */
 /* MessageId: ERROR_DS_MISSING_INFRASTRUCTURE_CONTAINER              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operation can not be performed because the server does not   */
 /*  have an infrastructure container in the domain of interest.      */
 /*                                                                   */
 dcl ERROR_DS_MISSING_INFRASTRUCTURE_CONTAINER
                                              fixed bin(31) value(8497);

 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_MOVE_ACCOUNT_GROUP                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Cross-domain move of account groups is not allowed.              */
 /*                                                                   */
 dcl ERROR_DS_CANT_MOVE_ACCOUNT_GROUP         fixed bin(31) value(8498);

 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_MOVE_RESOURCE_GROUP                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Cross-domain move of resource groups is not allowed.             */
 /*                                                                   */
 dcl ERROR_DS_CANT_MOVE_RESOURCE_GROUP        fixed bin(31) value(8499);

 /*                                                                   */
 /* MessageId: ERROR_DS_INVALID_SEARCH_FLAG                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The search flags for the attribute are invalid. The ANR bit is   */
 /*  valid only on attributes of Unicode or Teletex strings.          */
 /*                                                                   */
 dcl ERROR_DS_INVALID_SEARCH_FLAG             fixed bin(31) value(8500);

 /*                                                                   */
 /* MessageId: ERROR_DS_NO_TREE_DELETE_ABOVE_NC                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Tree deletions starting at an object which has an NC head        */
 /*  as a descendant are not allowed.                                 */
 /*                                                                   */
 dcl ERROR_DS_NO_TREE_DELETE_ABOVE_NC         fixed bin(31) value(8501);

 /*                                                                   */
 /* MessageId: ERROR_DS_COULDNT_LOCK_TREE_FOR_DELETE                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The directory service failed to lock a tree in preparation       */
 /*  for a tree deletion because the tree was in use.                 */
 /*                                                                   */
 dcl ERROR_DS_COULDNT_LOCK_TREE_FOR_DELETE    fixed bin(31) value(8502);

 /*                                                                   */
 /* MessageId: ERROR_DS_COULDNT_IDENTIFY_OBJECTS_FOR_TREE_DELETE      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The directory service failed to identify the list of objects     */
 /*  to delete while attempting a tree deletion.                      */
 /*                                                                   */
 dcl ERROR_DS_COULDNT_IDENTIFY_OBJECTS_FOR_TREE_DELETE
                                              fixed bin(31) value(8503);

 /*                                                                   */
 /* MessageId: ERROR_DS_SAM_INIT_FAILURE                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Security Accounts Manager initialization failed because of the   */
 /*  following error :%1.                                             */
 /*  Error Status: 0x%2. Click OK to shut down the system and reboot  */
 /*  into Directory Services Restore Mode. Check the event log for    */
 /*  detailed information.                                            */
 /*                                                                   */
 dcl ERROR_DS_SAM_INIT_FAILURE                fixed bin(31) value(8504);

 /*                                                                   */
 /* MessageId: ERROR_DS_SENSITIVE_GROUP_VIOLATION                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Only an administrator can modify the membership list of an       */
 /*  administrative group.                                            */
 /*                                                                   */
 dcl ERROR_DS_SENSITIVE_GROUP_VIOLATION       fixed bin(31) value(8505);

 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_MOD_PRIMARYGROUPID                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Cannot change the primary group ID of a domain controller        */
 /*  account.                                                         */
 /*                                                                   */
 dcl ERROR_DS_CANT_MOD_PRIMARYGROUPID         fixed bin(31) value(8506);

 /*                                                                   */
 /* MessageId: ERROR_DS_ILLEGAL_BASE_SCHEMA_MOD                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An attempt is made to modify the base schema.                    */
 /*                                                                   */
 dcl ERROR_DS_ILLEGAL_BASE_SCHEMA_MOD         fixed bin(31) value(8507);

 /*                                                                   */
 /* MessageId: ERROR_DS_NONSAFE_SCHEMA_CHANGE                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An attempt was made to add a new Must-Contain attribute or       */
 /*  delete an existing Must-Contain/May-Contain/Poss-Superiors       */
 /* attribute from an existing class (directly or through inheritance,*/
 /*  for example, by adding or deleting an auxiliary class).          */
 /*                                                                   */
 dcl ERROR_DS_NONSAFE_SCHEMA_CHANGE           fixed bin(31) value(8508);

 /*                                                                   */
 /* MessageId: ERROR_DS_SCHEMA_UPDATE_DISALLOWED                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Schema update is not allowed on this DC. Either the registry key */
 /*  is not set or the DC is not the schema FSMO Role Owner.          */
 /*                                                                   */
 dcl ERROR_DS_SCHEMA_UPDATE_DISALLOWED        fixed bin(31) value(8509);

 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_CREATE_UNDER_SCHEMA                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An object of this class cannot be created under the schema       */
 /*  container. You can only create attribute-schema and              */
 /*  class-schema objects under the schema container.                 */
 /*                                                                   */
 dcl ERROR_DS_CANT_CREATE_UNDER_SCHEMA        fixed bin(31) value(8510);

 /*                                                                   */
 /* MessageId: ERROR_DS_INSTALL_NO_SRC_SCH_VERSION                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The replica/child install failed to get the objectVersion        */
 /*  attribute on the schema container on the source DC.              */
 /*  Either the attribute is missing on the schema container or       */
 /*  the credentials supplied do not have permission to read it.      */
 /*                                                                   */
 dcl ERROR_DS_INSTALL_NO_SRC_SCH_VERSION      fixed bin(31) value(8511);

 /*                                                                   */
 /* MessageId: ERROR_DS_INSTALL_NO_SCH_VERSION_IN_INIFILE             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The replica/child install failed to read the objectVersion       */
 /*  attribute in the SCHEMA section of the file schema.ini           */
 /*  in the system32 directory.                                       */
 /*                                                                   */
 dcl ERROR_DS_INSTALL_NO_SCH_VERSION_IN_INIFILE
                                              fixed bin(31) value(8512);

 /*                                                                   */
 /* MessageId: ERROR_DS_INVALID_GROUP_TYPE                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified group type is invalid.                             */
 /*                                                                   */
 dcl ERROR_DS_INVALID_GROUP_TYPE              fixed bin(31) value(8513);

 /*                                                                   */
 /* MessageId: ERROR_DS_NO_NEST_GLOBALGROUP_IN_MIXEDDOMAIN            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  You cannot nest global groups in a mixed domain if the group     */
 /*  is security-enabled.                                             */
 /*                                                                   */
 dcl ERROR_DS_NO_NEST_GLOBALGROUP_IN_MIXEDDOMAIN
                                             fixed bin(31) value(8514);

 /*                                                                   */
 /* MessageId: ERROR_DS_NO_NEST_LOCALGROUP_IN_MIXEDDOMAIN             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  You cannot nest local groups in a mixed domain if the            */
 /*  group is security-enabled.                                       */
 /*                                                                   */
 dcl ERROR_DS_NO_NEST_LOCALGROUP_IN_MIXEDDOMAIN
                                              fixed bin(31) value(8515);

 /*                                                                   */
 /* MessageId: ERROR_DS_GLOBAL_CANT_HAVE_LOCAL_MEMBER                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A global group cannot have a local group as a member.            */
 /*                                                                   */
 dcl ERROR_DS_GLOBAL_CANT_HAVE_LOCAL_MEMBER   fixed bin(31) value(8516);

 /*                                                                   */
 /* MessageId: ERROR_DS_GLOBAL_CANT_HAVE_UNIVERSAL_MEMBER             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A global group cannot have a universal group as a member.        */
 /*                                                                   */
 dcl ERROR_DS_GLOBAL_CANT_HAVE_UNIVERSAL_MEMBER
                                              fixed bin(31) value(8517);

 /*                                                                   */
 /* MessageId: ERROR_DS_UNIVERSAL_CANT_HAVE_LOCAL_MEMBER              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A universal group cannot have a local group as a member.         */
 /*                                                                   */
 dcl ERROR_DS_UNIVERSAL_CANT_HAVE_LOCAL_MEMBER
                                              fixed bin(31) value(8518);

 /*                                                                   */
 /* MessageId: ERROR_DS_GLOBAL_CANT_HAVE_CROSSDOMAIN_MEMBER           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A global group cannot have a cross-domain member.                */
 /*                                                                   */
 dcl ERROR_DS_GLOBAL_CANT_HAVE_CROSSDOMAIN_MEMBER
                                              fixed bin(31) value(8519);

 /*                                                                   */
 /* MessageId: ERROR_DS_LOCAL_CANT_HAVE_CROSSDOMAIN_LOCAL_MEMBER      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A local group cannot have another cross domain local group       */
 /*  as a member.                                                     */
 /*                                                                   */
 dcl ERROR_DS_LOCAL_CANT_HAVE_CROSSDOMAIN_LOCAL_MEMBER
                                             fixed bin(31) value(8520);

 /*                                                                   */
 /* MessageId: ERROR_DS_HAVE_PRIMARY_MEMBERS                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A group with primary members cannot change to a                  */
 /*  security-disabled group.                                         */
 /*                                                                   */
 dcl ERROR_DS_HAVE_PRIMARY_MEMBERS            fixed bin(31) value(8521);

 /*                                                                   */
 /* MessageId: ERROR_DS_STRING_SD_CONVERSION_FAILED                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The schema cache load failed to convert the string default       */
 /*  SD on a class-schema object.                                     */
 /*                                                                   */
 dcl ERROR_DS_STRING_SD_CONVERSION_FAILED     fixed bin(31) value(8522);

 /*                                                                   */
 /* MessageId: ERROR_DS_NAMING_MASTER_GC                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Only DSAs configured to be Global Catalog servers should be      */
 /*  allowed to hold the Domain Naming Master FSMO role.              */
 /*                                                                   */
 dcl ERROR_DS_NAMING_MASTER_GC                fixed bin(31) value(8523);

 /*                                                                   */
 /* MessageId: ERROR_DS_DNS_LOOKUP_FAILURE                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The DSA operation is unable to proceed because of a DNS          */
 /*  lookup failure.                                                  */
 /*                                                                   */
 dcl ERROR_DS_DNS_LOOKUP_FAILURE              fixed bin(31) value(8524);

 /*                                                                   */
 /* MessageId: ERROR_DS_COULDNT_UPDATE_SPNS                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  While processing a change to the DNS Host Name for an object,    */
 /*  the Service Principal Name values could not be kept in sync.     */
 /*                                                                   */
 dcl ERROR_DS_COULDNT_UPDATE_SPNS             fixed bin(31) value(8525);

 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_RETRIEVE_SD                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The Security Descriptor attribute could not be read.             */
 /*                                                                   */
 dcl ERROR_DS_CANT_RETRIEVE_SD                fixed bin(31) value(8526);

 /*                                                                   */
 /* MessageId: ERROR_DS_KEY_NOT_UNIQUE                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The object requested was not found, but an object with           */
 /*  that key was found.                                              */
 /*                                                                   */
 dcl ERROR_DS_KEY_NOT_UNIQUE                  fixed bin(31) value(8527);

 /*                                                                   */
 /* MessageId: ERROR_DS_WRONG_LINKED_ATT_SYNTAX                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The syntax of the linked attribute being added is incorrect.     */
 /*  Forward links can only have syntax 2.5.5.1, 2.5.5.7, and         */
 /*  2.5.5.14, and backlinks can only have syntax 2.5.5.1             */
 /*                                                                   */
 dcl ERROR_DS_WRONG_LINKED_ATT_SYNTAX         fixed bin(31) value(8528);

 /*                                                                   */
 /* MessageId: ERROR_DS_SAM_NEED_BOOTKEY_PASSWORD                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Security Account Manager needs to get the boot password.         */
 /*                                                                   */
 dcl ERROR_DS_SAM_NEED_BOOTKEY_PASSWORD       fixed bin(31) value(8529);

 /*                                                                   */
 /* MessageId: ERROR_DS_SAM_NEED_BOOTKEY_FLOPPY                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Security Account Manager needs to get the boot key from floppy   */
 /*  disk.                                                            */
 /*                                                                   */
 dcl ERROR_DS_SAM_NEED_BOOTKEY_FLOPPY         fixed bin(31) value(8530);

 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_START                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Directory Service can not start.                                 */
 /*                                                                   */
 dcl ERROR_DS_CANT_START                      fixed bin(31) value(8531);

 /*                                                                   */
 /* MessageId: ERROR_DS_INIT_FAILURE                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Directory Services could not start.                              */
 /*                                                                   */
 dcl ERROR_DS_INIT_FAILURE                    fixed bin(31) value(8532);

 /*                                                                   */
 /* MessageId: ERROR_DS_NO_PKT_PRIVACY_ON_CONNECTION                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The connection between client and server requires                */
 /*  packet privacy or better.                                        */
 /*                                                                   */
 dcl ERROR_DS_NO_PKT_PRIVACY_ON_CONNECTION    fixed bin(31) value(8533);

 /*                                                                   */
 /* MessageId: ERROR_DS_SOURCE_DOMAIN_IN_FOREST                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The source domain may not be in the same forest as destination.  */
 /*                                                                   */
 dcl ERROR_DS_SOURCE_DOMAIN_IN_FOREST         fixed bin(31) value(8534);

 /*                                                                   */
 /* MessageId: ERROR_DS_DESTINATION_DOMAIN_NOT_IN_FOREST              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The destination domain must be in the forest.                    */
 /*                                                                   */
 dcl ERROR_DS_DESTINATION_DOMAIN_NOT_IN_FOREST
                                              fixed bin(31) value(8535);

 /*                                                                   */
 /* MessageId: ERROR_DS_DESTINATION_AUDITING_NOT_ENABLED              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operation requires that destination domain auditing be       */
 /*  enabled.                                                         */
 /*                                                                   */
 dcl ERROR_DS_DESTINATION_AUDITING_NOT_ENABLED
                                              fixed bin(31) value(8536);

 /*                                                                   */
 /* MessageId: ERROR_DS_CANT_FIND_DC_FOR_SRC_DOMAIN                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operation couldn't locate a DC for the source domain.        */
 /*                                                                   */
 dcl ERROR_DS_CANT_FIND_DC_FOR_SRC_DOMAIN     fixed bin(31) value(8537);

 /*                                                                   */
 /* MessageId: ERROR_DS_SRC_OBJ_NOT_GROUP_OR_USER                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The source object must be a group or user.                       */
 /*                                                                   */
 dcl ERROR_DS_SRC_OBJ_NOT_GROUP_OR_USER       fixed bin(31) value(8538);

 /*                                                                   */
 /* MessageId: ERROR_DS_SRC_SID_EXISTS_IN_FOREST                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The source object's SID already exists in destination forest.    */
 /*                                                                   */
 dcl ERROR_DS_SRC_SID_EXISTS_IN_FOREST        fixed bin(31) value(8539);

 /*                                                                   */
 /* MessageId: ERROR_DS_SRC_AND_DST_OBJECT_CLASS_MISMATCH             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The source and destination object must be of the same type.      */
 /*                                                                   */
 dcl ERROR_DS_SRC_AND_DST_OBJECT_CLASS_MISMATCH
                                              fixed bin(31) value(8540);

 /*                                                                   */
 /* MessageId: ERROR_SAM_INIT_FAILURE                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Security Accounts Manager initialization failed because of       */
 /*  the following error :%1.                                         */
 /*  Error Status: 0x%2. Click OK to shut down the system and reboot  */
 /*  into Safe Mode. Check the event log for detailed information.    */
 /*                                                                   */
 dcl ERROR_SAM_INIT_FAILURE                   fixed bin(31) value(8541);

 /*********************************************************************/
 /*                                                                   */
 /*     End of Active Directory Error Codes                           */
 /*                                                                   */
 /*                  8000 to  8999                                    */
 /*********************************************************************/


 /*********************************************************************/
 /*                                                                   */
 /*                  DNS Error Codes                                  */
 /*                                                                   */
 /*                   9000 to 9999                                    */
 /*********************************************************************/

 /* ============================= */
 /* Facility DNS Error Messages   */
 /* ============================= */

 /*                      */
 /*  DNS response codes. */
 /*                      */

 dcl DNS_ERROR_RESPONSE_CODES_BASE            fixed bin(31) value(9000);

 dcl DNS_ERROR_RCODE_NO_ERROR         fixed bin(31) value(NO_ERROR);

 dcl DNS_ERROR_MASK                   fixed bin(31) value('00002328'xn);
 /* 9000 or DNS_ERROR_RESPONSE_CODES_BASE                             */

 /* DNS_ERROR_RCODE_FORMAT_ERROR          0x00002329                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_RCODE_FORMAT_ERROR                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS server unable to interpret format.                           */
 /*                                                                   */
 dcl DNS_ERROR_RCODE_FORMAT_ERROR             fixed bin(31) value(9001);

 /* DNS_ERROR_RCODE_SERVER_FAILURE        0x0000232a                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_RCODE_SERVER_FAILURE                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS server failure.                                              */
 /*                                                                   */
 dcl DNS_ERROR_RCODE_SERVER_FAILURE           fixed bin(31) value(9002);

 /* DNS_ERROR_RCODE_NAME_ERROR            0x0000232b                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_RCODE_NAME_ERROR                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS name does not exist.                                         */
 /*                                                                   */
 dcl DNS_ERROR_RCODE_NAME_ERROR               fixed bin(31) value(9003);

 /* DNS_ERROR_RCODE_NOT_IMPLEMENTED       0x0000232c                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_RCODE_NOT_IMPLEMENTED                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS request not supported by name server.                        */
 /*                                                                   */
 dcl DNS_ERROR_RCODE_NOT_IMPLEMENTED          fixed bin(31) value(9004);

 /* DNS_ERROR_RCODE_REFUSED               0x0000232d                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_RCODE_REFUSED                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS operation refused.                                           */
 /*                                                                   */
 dcl DNS_ERROR_RCODE_REFUSED                  fixed bin(31) value(9005);

 /* DNS_ERROR_RCODE_YXDOMAIN              0x0000232e                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_RCODE_YXDOMAIN                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS name that ought not exist, does exist.                       */
 /*                                                                   */
 dcl DNS_ERROR_RCODE_YXDOMAIN                 fixed bin(31) value(9006);

 /* DNS_ERROR_RCODE_YXRRSET               0x0000232f                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_RCODE_YXRRSET                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS RR set that ought not exist, does exist.                     */
 /*                                                                   */
 dcl DNS_ERROR_RCODE_YXRRSET                  fixed bin(31) value(9007);

 /* DNS_ERROR_RCODE_NXRRSET               0x00002330                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_RCODE_NXRRSET                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS RR set that ought to exist, does not exist.                  */
 /*                                                                   */
 dcl DNS_ERROR_RCODE_NXRRSET                  fixed bin(31) value(9008);

 /* DNS_ERROR_RCODE_NOTAUTH               0x00002331                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_RCODE_NOTAUTH                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS server not authoritative for zone.                           */
 /*                                                                   */
 dcl DNS_ERROR_RCODE_NOTAUTH                  fixed bin(31) value(9009);

 /* DNS_ERROR_RCODE_NOTZONE               0x00002332                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_RCODE_NOTZONE                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS name in update or prereq is not in zone.                     */
 /*                                                                   */
 dcl DNS_ERROR_RCODE_NOTZONE                  fixed bin(31) value(9010);

 /* DNS_ERROR_RCODE_BADSIG                0x00002338                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_RCODE_BADSIG                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS signature failed to verify.                                  */
 /*                                                                   */
 dcl DNS_ERROR_RCODE_BADSIG                   fixed bin(31) value(9016);

 /* DNS_ERROR_RCODE_BADKEY                0x00002339                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_RCODE_BADKEY                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS bad key.                                                     */
 /*                                                                   */
 dcl DNS_ERROR_RCODE_BADKEY                   fixed bin(31) value(9017);

 /* DNS_ERROR_RCODE_BADTIME               0x0000233a                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_RCODE_BADTIME                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS signature validity expired.                                  */
 /*                                                                   */
 dcl DNS_ERROR_RCODE_BADTIME                  fixed bin(31) value(9018);

 dcl DNS_ERROR_RCODE_LAST  fixed bin(31) value(DNS_ERROR_RCODE_BADTIME);


 /*                                                                   */
 /*  Packet format                                                    */
 /*                                                                   */

 dcl DNS_ERROR_PACKET_FMT_BASE                fixed bin(31) value(9500);

 /* DNS_INFO_NO_RECORDS                   0x0000251d                  */
 /*                                                                   */
 /* MessageId: DNS_INFO_NO_RECORDS                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No records found for given DNS query.                            */
 /*                                                                   */
 dcl DNS_INFO_NO_RECORDS                      fixed bin(31) value(9501);

 /* DNS_ERROR_BAD_PACKET                  0x0000251e                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_BAD_PACKET                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Bad DNS packet.                                                  */
 /*                                                                   */
 dcl DNS_ERROR_BAD_PACKET                     fixed bin(31) value(9502);

 /* DNS_ERROR_NO_PACKET                   0x0000251f                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_NO_PACKET                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No DNS packet.                                                   */
 /*                                                                   */
 dcl DNS_ERROR_NO_PACKET                      fixed bin(31) value(9503);

 /* DNS_ERROR_RCODE                       0x00002520                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_RCODE                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS error, check rcode.                                          */
 /*                                                                   */
 dcl DNS_ERROR_RCODE                          fixed bin(31) value(9504);

 /* DNS_ERROR_UNSECURE_PACKET             0x00002521                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_UNSECURE_PACKET                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unsecured DNS packet.                                            */
 /*                                                                   */
 dcl DNS_ERROR_UNSECURE_PACKET                fixed bin(31) value(9505);

 dcl DNS_STATUS_PACKET_UNSECURE               fixed bin(31)
                                       value(DNS_ERROR_UNSECURE_PACKET);


 /*                                                                   */
 /*  General API errors                                               */
 /*                                                                   */

 dcl DNS_ERROR_NO_MEMORY        fixed bin(31) value(ERROR_OUTOFMEMORY);
 dcl DNS_ERROR_INVALID_NAME     fixed bin(31) value(ERROR_INVALID_NAME);
 dcl DNS_ERROR_INVALID_DATA     fixed bin(31) value(ERROR_INVALID_DATA);

 dcl DNS_ERROR_GENERAL_API_BASE               fixed bin(31) value(9550);

 /* DNS_ERROR_INVALID_TYPE                0x0000254f                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_INVALID_TYPE                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid DNS type.                                                */
 /*                                                                   */
 dcl DNS_ERROR_INVALID_TYPE                   fixed bin(31) value(9551);

 /* DNS_ERROR_INVALID_IP_ADDRESS          0x00002550                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_INVALID_IP_ADDRESS                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid IP address.                                              */
 /*                                                                   */
 dcl DNS_ERROR_INVALID_IP_ADDRESS             fixed bin(31) value(9552);

 /* DNS_ERROR_INVALID_PROPERTY            0x00002551                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_INVALID_PROPERTY                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid property.                                                */
 /*                                                                   */
 dcl DNS_ERROR_INVALID_PROPERTY               fixed bin(31) value(9553);

 /* DNS_ERROR_TRY_AGAIN_LATER             0x00002552                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_TRY_AGAIN_LATER                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Try DNS operation again later.                                   */
 /*                                                                   */
 dcl DNS_ERROR_TRY_AGAIN_LATER                fixed bin(31) value(9554);

 /* DNS_ERROR_NOT_UNIQUE                  0x00002553                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_NOT_UNIQUE                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Record for given name and type is not unique.                    */
 /*                                                                   */
 dcl DNS_ERROR_NOT_UNIQUE                     fixed bin(31) value(9555);

 /* DNS_ERROR_NON_RFC_NAME                0x00002554                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_NON_RFC_NAME                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS name does not comply with RFC specifications.                */
 /*                                                                   */
 dcl DNS_ERROR_NON_RFC_NAME                   fixed bin(31) value(9556);

 /* DNS_STATUS_FQDN                       0x00002555                  */
 /*                                                                   */
 /* MessageId: DNS_STATUS_FQDN                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS name is a fully-qualified DNS name.                          */
 /*                                                                   */
 dcl DNS_STATUS_FQDN                          fixed bin(31) value(9557);

 /* DNS_STATUS_DOTTED_NAME                0x00002556                  */
 /*                                                                   */
 /* MessageId: DNS_STATUS_DOTTED_NAME                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS name is dotted (multi-label).                                */
 /*                                                                   */
 dcl DNS_STATUS_DOTTED_NAME                   fixed bin(31) value(9558);

 /* DNS_STATUS_SINGLE_PART_NAME           0x00002557                  */
 /*                                                                   */
 /* MessageId: DNS_STATUS_SINGLE_PART_NAME                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS name is a single-part name.                                  */
 /*                                                                   */
 dcl DNS_STATUS_SINGLE_PART_NAME              fixed bin(31) value(9559);


 /*               */
 /*  Zone errors  */
 /*               */

 dcl DNS_ERROR_ZONE_BASE                      fixed bin(31) value(9600);

 /* DNS_ERROR_ZONE_DOES_NOT_EXIST         0x00002581                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_ZONE_DOES_NOT_EXIST                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS zone does not exist.                                         */
 /*                                                                   */
 dcl DNS_ERROR_ZONE_DOES_NOT_EXIST            fixed bin(31) value(9601);

 /* DNS_ERROR_NO_ZONE_INFO                0x00002582                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_NO_ZONE_INFO                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS zone information not available.                              */
 /*                                                                   */
 dcl DNS_ERROR_NO_ZONE_INFO                   fixed bin(31) value(9602);

 /* DNS_ERROR_INVALID_ZONE_OPERATION      0x00002583                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_INVALID_ZONE_OPERATION                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid operation for DNS zone.                                  */
 /*                                                                   */
 dcl DNS_ERROR_INVALID_ZONE_OPERATION         fixed bin(31) value(9603);

 /* DNS_ERROR_ZONE_CONFIGURATION_ERROR    0x00002584                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_ZONE_CONFIGURATION_ERROR                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid DNS zone configuration.                                  */
 /*                                                                   */
 dcl DNS_ERROR_ZONE_CONFIGURATION_ERROR       fixed bin(31) value(9604);

 /* DNS_ERROR_ZONE_HAS_NO_SOA_RECORD      0x00002585                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_ZONE_HAS_NO_SOA_RECORD                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS zone has no start of authority (SOA) record.                 */
 /*                                                                   */
 dcl DNS_ERROR_ZONE_HAS_NO_SOA_RECORD         fixed bin(31) value(9605);

 /* DNS_ERROR_ZONE_HAS_NO_NS_RECORDS      0x00002586                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_ZONE_HAS_NO_NS_RECORDS                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS zone has no Name Server (NS) record.                         */
 /*                                                                   */
 dcl DNS_ERROR_ZONE_HAS_NO_NS_RECORDS         fixed bin(31) value(9606);

 /* DNS_ERROR_ZONE_LOCKED                 0x00002587                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_ZONE_LOCKED                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS zone is locked.                                              */
 /*                                                                   */
 dcl DNS_ERROR_ZONE_LOCKED                    fixed bin(31) value(9607);

 /* DNS_ERROR_ZONE_CREATION_FAILED        0x00002588                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_ZONE_CREATION_FAILED                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS zone creation failed.                                        */
 /*                                                                   */
 dcl DNS_ERROR_ZONE_CREATION_FAILED           fixed bin(31) value(9608);

 /* DNS_ERROR_ZONE_ALREADY_EXISTS         0x00002589                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_ZONE_ALREADY_EXISTS                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS zone already exists.                                         */
 /*                                                                   */
 dcl DNS_ERROR_ZONE_ALREADY_EXISTS            fixed bin(31) value(9609);

 /* DNS_ERROR_AUTOZONE_ALREADY_EXISTS     0x0000258a                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_AUTOZONE_ALREADY_EXISTS                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS automatic zone already exists.                               */
 /*                                                                   */
 dcl DNS_ERROR_AUTOZONE_ALREADY_EXISTS        fixed bin(31) value(9610);

 /* DNS_ERROR_INVALID_ZONE_TYPE           0x0000258b                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_INVALID_ZONE_TYPE                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid DNS zone type.                                           */
 /*                                                                   */
 dcl DNS_ERROR_INVALID_ZONE_TYPE              fixed bin(31) value(9611);

 /* DNS_ERROR_SECONDARY_REQUIRES_MASTER_IP 0x0000258c                 */
 /*                                                                   */
 /* MessageId: DNS_ERROR_SECONDARY_REQUIRES_MASTER_IP                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Secondary DNS zone requires master IP address.                   */
 /*                                                                   */
 dcl DNS_ERROR_SECONDARY_REQUIRES_MASTER_IP   fixed bin(31) value(9612);

 /* DNS_ERROR_ZONE_NOT_SECONDARY          0x0000258d                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_ZONE_NOT_SECONDARY                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS zone not secondary.                                          */
 /*                                                                   */
 dcl DNS_ERROR_ZONE_NOT_SECONDARY             fixed bin(31) value(9613);

 /* DNS_ERROR_NEED_SECONDARY_ADDRESSES    0x0000258e                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_NEED_SECONDARY_ADDRESSES                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Need secondary IP address.                                       */
 /*                                                                   */
 dcl DNS_ERROR_NEED_SECONDARY_ADDRESSES       fixed bin(31) value(9614);

 /* DNS_ERROR_WINS_INIT_FAILED            0x0000258f                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_WINS_INIT_FAILED                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  WINS initialization failed.                                      */
 /*                                                                   */
 dcl DNS_ERROR_WINS_INIT_FAILED               fixed bin(31) value(9615);

 /* DNS_ERROR_NEED_WINS_SERVERS           0x00002590                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_NEED_WINS_SERVERS                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Need WINS servers.                                               */
 /*                                                                   */
 dcl DNS_ERROR_NEED_WINS_SERVERS              fixed bin(31) value(9616);

 /* DNS_ERROR_NBSTAT_INIT_FAILED          0x00002591                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_NBSTAT_INIT_FAILED                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  NBTSTAT initialization call failed.                              */
 /*                                                                   */
 dcl DNS_ERROR_NBSTAT_INIT_FAILED             fixed bin(31) value(9617);

 /* DNS_ERROR_SOA_DELETE_INVALID          0x00002592                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_SOA_DELETE_INVALID                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid delete of start of authority (SOA)                       */
 /*                                                                   */
 dcl DNS_ERROR_SOA_DELETE_INVALID             fixed bin(31) value(9618);


 /*                   */
 /*  Datafile errors  */
 /*                   */

 dcl DNS_ERROR_DATAFILE_BASE                  fixed bin(31) value(9650);

 /* DNS                                   0x000025b3                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_PRIMARY_REQUIRES_DATAFILE                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Primary DNS zone requires datafile.                              */
 /*                                                                   */
 dcl DNS_ERROR_PRIMARY_REQUIRES_DATAFILE      fixed bin(31) value(9651);

 /* DNS                                   0x000025b4                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_INVALID_DATAFILE_NAME                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid datafile name for DNS zone.                              */
 /*                                                                   */
 dcl DNS_ERROR_INVALID_DATAFILE_NAME          fixed bin(31) value(9652);

 /* DNS                                   0x000025b5                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_DATAFILE_OPEN_FAILURE                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Failed to open datafile for DNS zone.                            */
 /*                                                                   */
 dcl DNS_ERROR_DATAFILE_OPEN_FAILURE          fixed bin(31) value(9653);

 /* DNS                                   0x000025b6                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_FILE_WRITEBACK_FAILED                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Failed to write datafile for DNS zone.                           */
 /*                                                                   */
 dcl DNS_ERROR_FILE_WRITEBACK_FAILED          fixed bin(31) value(9654);

 /* DNS                                   0x000025b7                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_DATAFILE_PARSING                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Failure while reading datafile for DNS zone.                     */
 /*                                                                   */
 dcl DNS_ERROR_DATAFILE_PARSING               fixed bin(31) value(9655);


 /*                                                                   */
 /*  Database errors                                                  */
 /*                                                                   */

 dcl DNS_ERROR_DATABASE_BASE                  fixed bin(31) value(9700);

 /* DNS_ERROR_RECORD_DOES_NOT_EXIST       0x000025e5                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_RECORD_DOES_NOT_EXIST                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS record does not exist.                                       */
 /*                                                                   */
 dcl DNS_ERROR_RECORD_DOES_NOT_EXIST          fixed bin(31) value(9701);

 /* DNS_ERROR_RECORD_FORMAT               0x000025e6                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_RECORD_FORMAT                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS record format error.                                         */
 /*                                                                   */
 dcl DNS_ERROR_RECORD_FORMAT                  fixed bin(31) value(9702);

 /* DNS_ERROR_NODE_CREATION_FAILED        0x000025e7                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_NODE_CREATION_FAILED                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Node creation failure in DNS.                                    */
 /*                                                                   */
 dcl DNS_ERROR_NODE_CREATION_FAILED           fixed bin(31) value(9703);

 /* DNS_ERROR_UNKNOWN_RECORD_TYPE         0x000025e8                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_UNKNOWN_RECORD_TYPE                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unknown DNS record type.                                         */
 /*                                                                   */
 dcl DNS_ERROR_UNKNOWN_RECORD_TYPE            fixed bin(31) value(9704);

 /* DNS_ERROR_RECORD_TIMED_OUT            0x000025e9                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_RECORD_TIMED_OUT                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS record timed out.                                            */
 /*                                                                   */
 dcl DNS_ERROR_RECORD_TIMED_OUT               fixed bin(31) value(9705);

 /* DNS_ERROR_NAME_NOT_IN_ZONE            0x000025ea                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_NAME_NOT_IN_ZONE                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Name not in DNS zone.                                            */
 /*                                                                   */
 dcl DNS_ERROR_NAME_NOT_IN_ZONE               fixed bin(31) value(9706);

 /* DNS_ERROR_CNAME_LOOP                  0x000025eb                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_CNAME_LOOP                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  CNAME loop detected.                                             */
 /*                                                                   */
 dcl DNS_ERROR_CNAME_LOOP                     fixed bin(31) value(9707);

 /* DNS_ERROR_NODE_IS_CNAME               0x000025ec                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_NODE_IS_CNAME                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Node is a CNAME DNS record.                                      */
 /*                                                                   */
 dcl DNS_ERROR_NODE_IS_CNAME                  fixed bin(31) value(9708);

 /* DNS_ERROR_CNAME_COLLISION             0x000025ed                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_CNAME_COLLISION                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A CNAME record already exists for given name.                    */
 /*                                                                   */
 dcl DNS_ERROR_CNAME_COLLISION                fixed bin(31) value(9709);

 /* DNS_ERROR_RECORD_ONLY_AT_ZONE_ROOT    0x000025ee                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_RECORD_ONLY_AT_ZONE_ROOT                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Record only at DNS zone root.                                    */
 /*                                                                   */
 dcl DNS_ERROR_RECORD_ONLY_AT_ZONE_ROOT       fixed bin(31) value(9710);

 /* DNS_ERROR_RECORD_ALREADY_EXISTS       0x000025ef                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_RECORD_ALREADY_EXISTS                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS record already exists.                                       */
 /*                                                                   */
 dcl DNS_ERROR_RECORD_ALREADY_EXISTS          fixed bin(31) value(9711);

 /* DNS_ERROR_SECONDARY_DATA              0x000025f0                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_SECONDARY_DATA                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Secondary DNS zone data error.                                   */
 /*                                                                   */
 dcl DNS_ERROR_SECONDARY_DATA                 fixed bin(31) value(9712);

 /* DNS_ERROR_NO_CREATE_CACHE_DATA        0x000025f1                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_NO_CREATE_CACHE_DATA                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Could not create DNS cache data.                                 */
 /*                                                                   */
 dcl DNS_ERROR_NO_CREATE_CACHE_DATA           fixed bin(31) value(9713);

 /* DNS_ERROR_NAME_DOES_NOT_EXIST         0x000025f2                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_NAME_DOES_NOT_EXIST                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS name does not exist.                                         */
 /*                                                                   */
 dcl DNS_ERROR_NAME_DOES_NOT_EXIST            fixed bin(31) value(9714);

 /* DNS_WARNING_PTR_CREATE_FAILED         0x000025f3                  */
 /*                                                                   */
 /* MessageId: DNS_WARNING_PTR_CREATE_FAILED                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Could not create pointer (PTR) record.                           */
 /*                                                                   */
 dcl DNS_WARNING_PTR_CREATE_FAILED            fixed bin(31) value(9715);

 /* DNS_WARNING_DOMAIN_UNDELETED          0x000025f4                  */
 /*                                                                   */
 /* MessageId: DNS_WARNING_DOMAIN_UNDELETED                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS domain was undeleted.                                        */
 /*                                                                   */
 dcl DNS_WARNING_DOMAIN_UNDELETED             fixed bin(31) value(9716);

 /* DNS_ERROR_DS_UNAVAILABLE              0x000025f5                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_DS_UNAVAILABLE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The directory service is unavailable.                            */
 /*                                                                   */
 dcl DNS_ERROR_DS_UNAVAILABLE                 fixed bin(31) value(9717);

 /* DNS_ERROR_DS_ZONE_ALREADY_EXISTS      0x000025f6                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_DS_ZONE_ALREADY_EXISTS                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS zone already exists in the directory service.                */
 /*                                                                   */
 dcl DNS_ERROR_DS_ZONE_ALREADY_EXISTS         fixed bin(31) value(9718);

 /* DNS_ERROR_NO_BOOTFILE_IF_DS_ZONE      0x000025f7                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_NO_BOOTFILE_IF_DS_ZONE                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS server not creating or reading the boot file for             */
 /*  the directory service integrated DNS zone.                       */
 /*                                                                   */
 dcl DNS_ERROR_NO_BOOTFILE_IF_DS_ZONE         fixed bin(31) value(9719);


 /*                    */
 /*  Operation errors  */
 /*                    */

 dcl DNS_ERROR_OPERATION_BASE                 fixed bin(31) value(9750);

 /* DNS_INFO_AXFR_COMPLETE                0x00002617                  */
 /*                                                                   */
 /* MessageId: DNS_INFO_AXFR_COMPLETE                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS AXFR (zone transfer) complete.                               */
 /*                                                                   */
 dcl DNS_INFO_AXFR_COMPLETE                   fixed bin(31) value(9751);

 /* DNS_ERROR_AXFR                        0x00002618                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_AXFR                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DNS zone transfer failed.                                        */
 /*                                                                   */
 dcl DNS_ERROR_AXFR                           fixed bin(31) value(9752);

 /* DNS_INFO_ADDED_LOCAL_WINS             0x00002619                  */
 /*                                                                   */
 /* MessageId: DNS_INFO_ADDED_LOCAL_WINS                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Added local WINS server.                                         */
 /*                                                                   */
 dcl DNS_INFO_ADDED_LOCAL_WINS                fixed bin(31) value(9753);


 /*                                                                   */
 /*  Secure update                                                    */
 /*                                                                   */

 dcl DNS_ERROR_SECURE_BASE                    fixed bin(31) value(9800);

 /* DNS_STATUS_CONTINUE_NEEDED            0x00002649                  */
 /*                                                                   */
 /* MessageId: DNS_STATUS_CONTINUE_NEEDED                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Secure update call needs to continue update request.             */
 /*                                                                   */
 dcl DNS_STATUS_CONTINUE_NEEDED               fixed bin(31) value(9801);


 /*                                                                   */
 /*  Setup errors                                                     */
 /*                                                                   */

 dcl DNS_ERROR_SETUP_BASE                     fixed bin(31) value(9850);

 /* DNS_ERROR_NO_TCPIP                    0x0000267b                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_NO_TCPIP                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  TCP/IP network protocol not installed.                           */
 /*                                                                   */
 dcl DNS_ERROR_NO_TCPIP                       fixed bin(31) value(9851);

 /* DNS_ERROR_NO_DNS_SERVERS              0x0000267c                  */
 /*                                                                   */
 /* MessageId: DNS_ERROR_NO_DNS_SERVERS                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No DNS servers configured for local system.                      */
 /*                                                                   */
 dcl DNS_ERROR_NO_DNS_SERVERS                 fixed bin(31) value(9852);

 /*********************************************************************/
 /*                                                                   */
 /*             End of DNS Error Codes                                */
 /*                                                                   */
 /*                  9000 to 9999                                     */
 /*********************************************************************/


 /*********************************************************************/
 /*                                                                   */
 /*               WinSock Error Codes                                 */
 /*                                                                   */
 /*                 10000 to 11999                                    */
 /*********************************************************************/

 /*                                                                   */
 /* WinSock error codes are also defined in WinSock.cpy               */
 /* and WinSock2.cpy, hence the IFDEF                                 */
 /*                                                                   */
 %dcl #WSABASEERR fixed ext;
 %if #WSABASEERR = 0 %then %do;
 %#WSABASEERR = 10000;
 dcl WSABASEERR                              fixed bin(31) value(10000);
 /*                                                                   */
 /* MessageId: WSAEINTR                                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A blocking operation was interrupted by a call to                */
 /*  WSACancelBlockingCall.                                           */
 /*                                                                   */
 dcl WSAEINTR                                fixed bin(31) value(10004);

 /*                                                                   */
 /* MessageId: WSAEBADF                                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file handle supplied is not valid.                           */
 /*                                                                   */
 dcl WSAEBADF                                fixed bin(31) value(10009);

 /*                                                                   */
 /* MessageId: WSAEACCES                                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An attempt was made to access a socket in a way forbidden        */
 /*  by its access permissions.                                       */
 /*                                                                   */
 dcl WSAEACCES                               fixed bin(31) value(10013);

 /*                                                                   */
 /* MessageId: WSAEFAULT                                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system detected an invalid pointer address in attempting     */
 /*  to use a pointer argument in a call.                             */
 /*                                                                   */
 dcl WSAEFAULT                               fixed bin(31) value(10014);

 /*                                                                   */
 /* MessageId: WSAEINVAL                                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An invalid argument was supplied.                                */
 /*                                                                   */
 dcl WSAEINVAL                               fixed bin(31) value(10022);

 /*                                                                   */
 /* MessageId: WSAEMFILE                                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Too many open sockets.                                           */
 /*                                                                   */
 dcl WSAEMFILE                               fixed bin(31) value(10024);

 /*                                                                   */
 /* MessageId: WSAEWOULDBLOCK                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A non-blocking socket operation could not be completed           */
 /*  immediately.                                                     */
 /*                                                                   */
 dcl WSAEWOULDBLOCK                          fixed bin(31) value(10035);

 /*                                                                   */
 /* MessageId: WSAEINPROGRESS                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A blocking operation is currently executing.                     */
 /*                                                                   */
 dcl WSAEINPROGRESS                          fixed bin(31) value(10036);

 /*                                                                   */
 /* MessageId: WSAEALREADY                                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An operation was attempted on a non-blocking socket that         */
 /*  already had an operation in progress.                            */
 /*                                                                   */
 dcl WSAEALREADY                             fixed bin(31) value(10037);

 /*                                                                   */
 /* MessageId: WSAENOTSOCK                                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An operation was attempted on something that is not a socket.    */
 /*                                                                   */
 dcl WSAENOTSOCK                             fixed bin(31) value(10038);

 /*                                                                   */
 /* MessageId: WSAEDESTADDRREQ                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A required address was omitted from an operation on a socket.    */
 /*                                                                   */
 dcl WSAEDESTADDRREQ                         fixed bin(31) value(10039);

 /*                                                                   */
 /* MessageId: WSAEMSGSIZE                                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A message sent on a datagram socket was larger than the internal */
 /*  message buffer or some other network limit, or the buffer used   */
 /* to receive a datagram into was smaller than the datagram itself.  */
 /*                                                                   */
 dcl WSAEMSGSIZE                             fixed bin(31) value(10040);

 /*                                                                   */
 /* MessageId: WSAEPROTOTYPE                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A protocol was specified in the socket function call that does   */
 /*  not support the semantics of the socket type requested.          */
 /*                                                                   */
 dcl WSAEPROTOTYPE                           fixed bin(31) value(10041);

 /*                                                                   */
 /* MessageId: WSAENOPROTOOPT                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An unknown, invalid, or unsupported option or level was specified*/
 /*  in a getsockopt or setsockopt call.                              */
 /*                                                                   */
 dcl WSAENOPROTOOPT                          fixed bin(31) value(10042);

 /*                                                                   */
 /* MessageId: WSAEPROTONOSUPPORT                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested protocol has not been configured into the system,  */
 /*  or no implementation for it exists.                              */
 /*                                                                   */
 dcl WSAEPROTONOSUPPORT                      fixed bin(31) value(10043);

 /*                                                                   */
 /* MessageId: WSAESOCKTNOSUPPORT                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The support for the specified socket type does not exist         */
 /*  in this address family.                                          */
 /*                                                                   */
 dcl WSAESOCKTNOSUPPORT                      fixed bin(31) value(10044);

 /*                                                                   */
 /* MessageId: WSAEOPNOTSUPP                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The attempted operation is not supported for the type of         */
 /*  object referenced.                                               */
 /*                                                                   */
 dcl WSAEOPNOTSUPP                           fixed bin(31) value(10045);

 /*                                                                   */
 /* MessageId: WSAEPFNOSUPPORT                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The protocol family has not been configured into the system      */
 /*  or no implementation for it exists.                              */
 /*                                                                   */
 dcl WSAEPFNOSUPPORT                         fixed bin(31) value(10046);

 /*                                                                   */
 /* MessageId: WSAEAFNOSUPPORT                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An address incompatible with the requested protocol was used.    */
 /*                                                                   */
 dcl WSAEAFNOSUPPORT                         fixed bin(31) value(10047);

 /*                                                                   */
 /* MessageId: WSAEADDRINUSE                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Only one usage of each socket address (protocol/network          */
 /*  address/port) is normally permitted.                             */
 /*                                                                   */
 dcl WSAEADDRINUSE                           fixed bin(31) value(10048);

 /*                                                                   */
 /* MessageId: WSAEADDRNOTAVAIL                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested address is not valid in its context.               */
 /*                                                                   */
 dcl WSAEADDRNOTAVAIL                        fixed bin(31) value(10049);

 /*                                                                   */
 /* MessageId: WSAENETDOWN                                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A socket operation encountered a dead network.                   */
 /*                                                                   */
 dcl WSAENETDOWN                             fixed bin(31) value(10050);

 /*                                                                   */
 /* MessageId: WSAENETUNREACH                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A socket operation was attempted to an unreachable network.      */
 /*                                                                   */
 dcl WSAENETUNREACH                          fixed bin(31) value(10051);

 /*                                                                   */
 /* MessageId: WSAENETRESET                                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The connection has been broken due to keep-alive activity        */
 /*  detecting a failure while the operation was in progress.         */
 /*                                                                   */
 dcl WSAENETRESET                            fixed bin(31) value(10052);

 /*                                                                   */
 /* MessageId: WSAECONNABORTED                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An established connection was aborted by the software in your    */
 /*  host machine.                                                    */
 /*                                                                   */
 dcl WSAECONNABORTED                         fixed bin(31) value(10053);

 /*                                                                   */
 /* MessageId: WSAECONNRESET                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An existing connection was forcibly closed by the remote host.   */
 /*                                                                   */
 dcl WSAECONNRESET                           fixed bin(31) value(10054);

 /*                                                                   */
 /* MessageId: WSAENOBUFS                                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An operation on a socket could not be performed because the      */
 /*  system lacked sufficient buffer space or because a queue was     */
 /*  full.                                                            */
 /*                                                                   */
 dcl WSAENOBUFS                              fixed bin(31) value(10055);

 /*                                                                   */
 /* MessageId: WSAEISCONN                                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A connect request was made on an already connected socket.       */
 /*                                                                   */
 dcl WSAEISCONN                              fixed bin(31) value(10056);

 /*                                                                   */
 /* MessageId: WSAENOTCONN                                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A request to send or receive data was disallowed because the     */
 /*  socket is not connected and (when sending on a datagram socket   */
 /*  using a sendto call) no address was supplied.                    */
 /*                                                                   */
 dcl WSAENOTCONN                             fixed bin(31) value(10057);

 /*                                                                   */
 /* MessageId: WSAESHUTDOWN                                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A request to send or receive data was disallowed because the     */
 /*  socket had already been shut down in that direction with a       */
 /*  previous shutdown call.                                          */
 /*                                                                   */
 dcl WSAESHUTDOWN                            fixed bin(31) value(10058);

 /*                                                                   */
 /* MessageId: WSAETOOMANYREFS                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Too many references to some kernel object.                       */
 /*                                                                   */
 dcl WSAETOOMANYREFS                         fixed bin(31) value(10059);

 /*                                                                   */
 /* MessageId: WSAETIMEDOUT                                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A connection attempt failed because the connected party did not  */
 /*  properly respond after a period of time, or established          */
 /*  connection failed because connected host has failed to respond.  */
 /*                                                                   */
 dcl WSAETIMEDOUT                            fixed bin(31) value(10060);

 /*                                                                   */
 /* MessageId: WSAECONNREFUSED                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No connection could be made because the target machine actively  */
 /*  refused it.                                                      */
 /*                                                                   */
 dcl WSAECONNREFUSED                         fixed bin(31) value(10061);

 /*                                                                   */
 /* MessageId: WSAELOOP                                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Cannot translate name.                                           */
 /*                                                                   */
 dcl WSAELOOP                                fixed bin(31) value(10062);

 /*                                                                   */
 /* MessageId: WSAENAMETOOLONG                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Name component or name was too long.                             */
 /*                                                                   */
 dcl WSAENAMETOOLONG                         fixed bin(31) value(10063);

 /*                                                                   */
 /* MessageId: WSAEHOSTDOWN                                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A socket operation failed because the destination host was down. */
 /*                                                                   */
 dcl WSAEHOSTDOWN                            fixed bin(31) value(10064);

 /*                                                                   */
 /* MessageId: WSAEHOSTUNREACH                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A socket operation was attempted to an unreachable host.         */
 /*                                                                   */
 dcl WSAEHOSTUNREACH                         fixed bin(31) value(10065);

 /*                                                                   */
 /* MessageId: WSAENOTEMPTY                                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Cannot remove a directory that is not empty.                     */
 /*                                                                   */
 dcl WSAENOTEMPTY                            fixed bin(31) value(10066);

 /*                                                                   */
 /* MessageId: WSAEPROCLIM                                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A Windows Sockets implementation may have a limit on the number  */
 /*  of applications that may use it simultaneously.                  */
 /*                                                                   */
 dcl WSAEPROCLIM                             fixed bin(31) value(10067);

 /*                                                                   */
 /* MessageId: WSAEUSERS                                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Ran out of quota.                                                */
 /*                                                                   */
 dcl WSAEUSERS                               fixed bin(31) value(10068);

 /*                                                                   */
 /* MessageId: WSAEDQUOT                                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Ran out of disk quota.                                           */
 /*                                                                   */
 dcl WSAEDQUOT                               fixed bin(31) value(10069);

 /*                                                                   */
 /* MessageId: WSAESTALE                                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  File handle reference is no longer available.                    */
 /*                                                                   */
 dcl WSAESTALE                               fixed bin(31) value(10070);

 /*                                                                   */
 /* MessageId: WSAEREMOTE                                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Item is not available locally.                                   */
 /*                                                                   */
 dcl WSAEREMOTE                              fixed bin(31) value(10071);

 /*                                                                   */
 /* MessageId: WSASYSNOTREADY                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  WSAStartup cannot function at this time because the underlying   */
 /*  system it uses to provide network services is currently          */
 /*  unavailable.                                                     */
 /*                                                                   */
 dcl WSASYSNOTREADY                          fixed bin(31) value(10091);

 /*                                                                   */
 /* MessageId: WSAVERNOTSUPPORTED                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The Windows Sockets version requested is not supported.          */
 /*                                                                   */
 dcl WSAVERNOTSUPPORTED                      fixed bin(31) value(10092);

 /*                                                                   */
 /* MessageId: WSANOTINITIALISED                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Either the application has not called WSAStartup,                */
 /*  or WSAStartup failed.                                            */
 /*                                                                   */
 dcl WSANOTINITIALISED                       fixed bin(31) value(10093);

 /*                                                                   */
 /* MessageId: WSAEDISCON                                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Returned by WSARecv or WSARecvFrom to indicate the remote party  */
 /*   has initiated a graceful shutdown sequence.                     */
 /*                                                                   */
 dcl WSAEDISCON                              fixed bin(31) value(10101);

 /*                                                                   */
 /* MessageId: WSAENOMORE                                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No more results can be returned by WSALookupServiceNext.         */
 /*                                                                   */
 dcl WSAENOMORE                              fixed bin(31) value(10102);

 /*                                                                   */
 /* MessageId: WSAECANCELLED                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A call to WSALookupServiceEnd was made while this call was       */
 /*  still processing. The call has been cancelled.                   */
 /*                                                                   */
 dcl WSAECANCELLED                           fixed bin(31) value(10103);

 /*                                                                   */
 /* MessageId: WSAEINVALIDPROCTABLE                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The procedure call table is invalid.                             */
 /*                                                                   */
 dcl WSAEINVALIDPROCTABLE                    fixed bin(31) value(10104);

 /*                                                                   */
 /* MessageId: WSAEINVALIDPROVIDER                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested service provider is invalid.                       */
 /*                                                                   */
 dcl WSAEINVALIDPROVIDER                     fixed bin(31) value(10105);

 /*                                                                   */
 /* MessageId: WSAEPROVIDERFAILEDINIT                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested service provider could not be loaded or            */
 /*  initialized.                                                     */
 /*                                                                   */
 dcl WSAEPROVIDERFAILEDINIT                  fixed bin(31) value(10106);

 /*                                                                   */
 /* MessageId: WSASYSCALLFAILURE                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A system call that should never fail has failed.                 */
 /*                                                                   */
 dcl WSASYSCALLFAILURE                       fixed bin(31) value(10107);

 /*                                                                   */
 /* MessageId: WSASERVICE_NOT_FOUND                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No such service is known. The service cannot be found in the     */
 /*  specified name space.                                            */
 /*                                                                   */
 dcl WSASERVICE_NOT_FOUND                    fixed bin(31) value(10108);

 /*                                                                   */
 /* MessageId: WSATYPE_NOT_FOUND                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified class was not found.                               */
 /*                                                                   */
 dcl WSATYPE_NOT_FOUND                       fixed bin(31) value(10109);

 /*                                                                   */
 /* MessageId: WSA_E_NO_MORE                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No more results can be returned by WSALookupServiceNext.         */
 /*                                                                   */
 dcl WSA_E_NO_MORE                           fixed bin(31) value(10110);

 /*                                                                   */
 /* MessageId: WSA_E_CANCELLED                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A call to WSALookupServiceEnd was made while this call was still */
 /*  processing. The call has been cancelled.                         */
 /*                                                                   */
 dcl WSA_E_CANCELLED                         fixed bin(31) value(10111);

 /*                                                                   */
 /* MessageId: WSAEREFUSED                                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A database query failed because it was actively refused.         */
 /*                                                                   */
 dcl WSAEREFUSED                             fixed bin(31) value(10112);

 /*                                                                   */
 /* MessageId: WSAHOST_NOT_FOUND                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No such host is known.                                           */
 /*                                                                   */
 dcl WSAHOST_NOT_FOUND                       fixed bin(31) value(11001);

 /*                                                                   */
 /* MessageId: WSATRY_AGAIN                                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This is usually a temporary error during hostname resolution     */
 /*  and means that the local server did not receive a response       */
 /*  from an authoritative server.                                    */
 /*                                                                   */
 dcl WSATRY_AGAIN                            fixed bin(31) value(11002);

 /*                                                                   */
 /* MessageId: WSANO_RECOVERY                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A non-recoverable error occurred during a database lookup.       */
 /*                                                                   */
 dcl WSANO_RECOVERY                          fixed bin(31) value(11003);

 /*                                                                   */
 /* MessageId: WSANO_DATA                                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested name is valid and was found in the database,       */
 /*  but it does not have the correct associated data being           */
 /*  resolved for.                                                    */
 /*                                                                   */
 dcl WSANO_DATA                              fixed bin(31) value(11004);

 /*                                                                   */
 /* MessageId: WSA_QOS_RECEIVERS                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  At least one reserve has arrived.                                */
 /*                                                                   */
 dcl WSA_QOS_RECEIVERS                       fixed bin(31) value(11005);

 /*                                                                   */
 /* MessageId: WSA_QOS_SENDERS                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  At least one path has arrived.                                   */
 /*                                                                   */
 dcl WSA_QOS_SENDERS                         fixed bin(31) value(11006);

 /*                                                                   */
 /* MessageId: WSA_QOS_NO_SENDERS                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There are no senders.                                            */
 /*                                                                   */
 dcl WSA_QOS_NO_SENDERS                      fixed bin(31) value(11007);

 /*                                                                   */
 /* MessageId: WSA_QOS_NO_RECEIVERS                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There are no receivers.                                          */
 /*                                                                   */
 dcl WSA_QOS_NO_RECEIVERS                    fixed bin(31) value(11008);

 /*                                                                   */
 /* MessageId: WSA_QOS_REQUEST_CONFIRMED                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Reserve has been confirmed.                                      */
 /*                                                                   */
 dcl WSA_QOS_REQUEST_CONFIRMED               fixed bin(31) value(11009);

 /*                                                                   */
 /* MessageId: WSA_QOS_ADMISSION_FAILURE                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Error due to lack of resources.                                  */
 /*                                                                   */
 dcl WSA_QOS_ADMISSION_FAILURE               fixed bin(31) value(11010);

 /*                                                                   */
 /* MessageId: WSA_QOS_POLICY_FAILURE                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Rejected for administrative reasons - bad credentials.           */
 /*                                                                   */
 dcl WSA_QOS_POLICY_FAILURE                  fixed bin(31) value(11011);

 /*                                                                   */
 /* MessageId: WSA_QOS_BAD_STYLE                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unknown or conflicting style.                                    */
 /*                                                                   */
 dcl WSA_QOS_BAD_STYLE                       fixed bin(31) value(11012);

 /*                                                                   */
 /* MessageId: WSA_QOS_BAD_OBJECT                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Problem with some part of the filterspec or                      */
 /*  providerspecific buffer in general.                              */
 /*                                                                   */
 dcl WSA_QOS_BAD_OBJECT                      fixed bin(31) value(11013);

 /*                                                                   */
 /* MessageId: WSA_QOS_TRAFFIC_CTRL_ERROR                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Problem with some part of the flowspec.                          */
 /*                                                                   */
 dcl WSA_QOS_TRAFFIC_CTRL_ERROR              fixed bin(31) value(11014);

 /*                                                                   */
 /* MessageId: WSA_QOS_GENERIC_ERROR                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  General QOS error.                                               */
 /*                                                                   */
 dcl WSA_QOS_GENERIC_ERROR                  fixed bin(31) value(11015);

 %end; /* defined(WSABASEERR) */

 /*********************************************************************/
 /*                                                                   */
 /*           End of WinSock Error Codes                              */
 /*                                                                   */
 /*                 10000 to 11999                                    */
 /*********************************************************************/


 /*********************************************************************/
 /*                                                                   */
 /* OLE Error Codes                                                   */
 /*                                                                   */
 /*********************************************************************/

 /*                                                                   */
 /* OLE error definitions and values                                  */
 /*                                                                   */
 /* The return value of OLE APIs and methods is an HRESULT.           */
 /* This is not a handle to anything, but is merely a 32-bit value    */
 /* with several fields encoded in the value.  The parts of an        */
 /* HRESULT are shown below.                                          */
 /*                                                                   */
 /* Many of the macros and functions below were orginally defined to  */
 /* operate on SCODEs.  SCODEs are no longer used.  The macros are    */
 /* still present for compatibility and easy porting of Win16 code.   */
 /* Newly written code should use the HRESULT macros and functions.   */
 /*                                                                   */

 /*                                                                   */
 /*  HRESULTs are 32 bit values layed out as follows:                 */
 /*                                                                   */
 /*  3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1                      */
 /*  1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0  */
 /* +-+-+-+-+-+---------------------+-------------------------------+ */
 /* |S|R|C|N|r|    Facility         |               Code            | */
 /* +-+-+-+-+-+---------------------+-------------------------------+ */
 /*                                                                   */
 /*  where                                                            */
 /*                                                                   */
 /*      S - Severity - indicates success/fail                        */
 /*                                                                   */
 /*          0 - Success                                              */
 /*          1 - Fail (COERROR)                                       */
 /*                                                                   */
 /*   R - reserved portion of the facility code, corresponds to NT's  */
 /*              second severity bit.                                 */
 /*                                                                   */
 /*   C - reserved portion of the facility code, corresponds to NT's  */
 /*              C field.                                             */
 /*                                                                   */
 /*   N - reserved portion of the facility code. Used to indicate a   */
 /*              mapped NT status value.                              */
 /*                                                                   */
 /*r - reserved portion of the facility code. Reserved for internal   */
 /*    use. Used to indicate HRESULT values that are not status       */
 /*       values, but are instead message ids for display strings.    */
 /*                                                                   */
 /*      Facility - is the facility code                              */
 /*                                                                   */
 /*      Code - is the facility's status code                         */
 /*                                                                   */

 /*                                                                   */
 /* Severity values                                                   */
 /*                                                                   */

 dcl SEVERITY_SUCCESS fixed bin(31) value(0);
 dcl SEVERITY_ERROR   fixed bin(31) value(1);


 /*                                                                   */
 /* Generic test for success on any                                   */
 /* status value (non-negative numbers                                */
 /* indicate success).                                                */
 /*                                                                   */

 SUCCEEDED: proc (Status) returns (bit (1) aligned byvalue)
            options (inline reorder) internal;
   dcl Status fixed bin (31) byvalue;
   return (Status >= 0);
 end SUCCEEDED;

 /*                                                                   */
 /* and the inverse                                                   */
 /*                                                                   */

 FAILED: proc (Status) returns (bit (1) aligned byvalue)
         options (inline reorder) internal;
   dcl Status fixed bin (31) byvalue;
   return (Status < 0);
 end FAILED;


 /*                                                                   */
 /* Generic test for error on any status value.                       */
 /*                                                                   */

 IS_ERROR: proc (Status) returns (bit (1) aligned byvalue)
          options (inline reorder) internal;
   dcl status fixed bin (31) byvalue;
   dcl isrl builtin;
   return (isrl (Status, 31) = SEVERITY_ERROR);
 end IS_ERROR;


 /*                                                                   */
 /* Return the code                                                   */
 /*                                                                   */

 HRESULT_CODE: proc (hr) returns (fixed bin (16) unsigned byvalue)
               options (inline reorder) internal;
   dcl hr fixed bin (31) byvalue;
   dcl iand builtin;
   return (iand (hr, 'ffff'xn));
 end HRESULT_CODE;

 SCODE_CODE: proc (sc) returns (fixed bin (16) unsigned byvalue)
             options (inline reorder) internal;
   dcl sc fixed bin (31) byvalue;
   dcl iand builtin;
   return (iand (sc, 'ffff'xn));
 end SCODE_CODE;


 /*                                                                   */
 /*  Return the facility                                              */
 /*                                                                   */


 HRESULT_FACILITY: proc (hr) returns (fixed bin (16) unsigned byvalue)
                   options (inline reorder) internal;
   dcl hr fixed bin (31) byvalue;
   dcl (iand, isrl) builtin;
   return (iand (isrl (hr, 16), '1fff'xn));
 end HRESULT_FACILITY;

 SCODE_FACILITY: proc (sc) returns (fixed bin (16) unsigned byvalue)
                 options (inline reorder) internal;
   dcl sc fixed bin (31) byvalue;
   dcl (iand, isrl) builtin;
   return (iand (isrl (sc, 16), '1fff'xn));
 end SCODE_FACILITY;


 /*                                                                   */
 /*  Return the severity                                              */
 /*                                                                   */


 HRESULT_SEVERITY: proc (hr) returns (fixed bin (31) byvalue)
                   options (inline reorder) internal;
   dcl hr fixed bin (31) byvalue;
   dcl (iand, isrl) builtin;
   return (iand (isrl (hr, 31), '1'xn));
 end HRESULT_SEVERITY;

 SCODE_SEVERITY: proc (sc) returns (fixed bin (31) byvalue)
                 options (inline reorder) internal;
   dcl sc fixed bin (31) byvalue;
   dcl (iand, isrl) builtin;
   return (iand (isrl (sc, 31), '1'xn));
 end SCODE_SEVERITY;

 /*                                                                   */
 /* Create an HRESULT value from component pieces                     */
 /*                                                                   */

 MAKE_HRESULT: proc (sev, fac, code) returns (fixed bin (31) byvalue)
               options (inline reorder) internal;
   dcl (sev, fac, code) fixed bin (31) byvalue;
   dcl (ior, raise2) builtin;
   return (ior (raise2 (sev, 31), raise2 (fac, 16), code));
 end MAKE_HRESULT;

 MAKE_SCODE: proc (sev, fac, code) returns (fixed bin (31) byvalue)
               options (inline reorder) internal;
   dcl (sev, fac, code) fixed bin (31) byvalue;
   dcl (ior, raise2) builtin;
   return (ior (raise2 (sev, 31), raise2 (fac, 16), code));
 end MAKE_SCODE;

 /*                                                                   */
 /* Map a WIN32 error value into a HRESULT                            */
 /* Note: This assumes that WIN32 errors fall in the                  */
 /* range -32k to 32k.                                                */


 /*                                                                   */
 /* Define bits here so macros are guaranteed to work                 */

 dcl FACILITY_NT_BIT fixed bin(31) value('10000000'xn);

 HRESULT_FROM_WIN32: proc (x) returns (fixed bin (31) byvalue)
                     options (inline reorder) internal;
   dcl x fixed bin (31) byvalue;
   dcl (iand, ior, raise2) builtin;
   if x = 0 then
     return (0);
   else
     return (ior (iand (x, '0000ffff'xn),
                  raise2 (FACILITY_WIN32, 16),
                  '80000000'xn));
 end HRESULT_FROM_WIN32;


 /*                                                                   */
 /* Map an NT status value into a HRESULT                             */
 /*                                                                   */

 HRESULT_FROM_NT: proc (x) returns (fixed bin (31) byvalue)
                  options (inline reorder) internal;
   dcl x fixed bin (31) byvalue;
   dcl ior builtin;
   if x = 0 then
     return (0);
   else
     return (ior (x, FACILITY_NT_BIT));
 end HRESULT_FROM_NT;


 /* ****** OBSOLETE functions                                         */

 /* HRESULT functions                                                 */
 /* As noted above, these functions are obsolete                      */
 /* and should not be used.                                           */


 /* Extract the SCODE from a HRESULT                                  */

 GetScode: proc (hr) returns (fixed bin (31) byvalue)
           options (inline reorder) internal;
   dcl hr fixed bin (31) byvalue;
   return (hr);
 end GetScode;

 /* Convert an SCODE into an HRESULT.                                 */

 ResultFromScode: proc (sc) returns (fixed bin (31) byvalue)
                  options (inline reorder) internal;
   dcl sc fixed bin (31) byvalue;
   return (sc);
 end ResultFromScode;

 /* PropagateResult is a noop                                         */

 PropagateResult: proc (hrPrevious, scBase)
                  returns (fixed bin (31) byvalue optional)
                  options (inline reorder) internal;
   dcl (hrPrevious, scBase) fixed bin (31) byvalue;
   return (scBase);
 end PropagateResult;


 /****** End of OBSOLETE functions.                                   */


 /* ---------------------- HRESULT value definitions ---------------  */
 /*                                                                   */
 /* HRESULT definitions                                               */
 /*                                                                   */


 dcl NOERROR                          fixed bin (31) value(0);

 /*                                                                   */
 /* Error definitions follow                                          */
 /*                                                                   */

 /*                                                                   */
 /* Codes 0x4000-0x40ff are reserved for OLE                          */
 /*                                                                   */

 /* Error codes                                                       */

 /*                                                                   */
 /* MessageId: E_UNEXPECTED                                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unexpected failure                                               */
 /*                                                                   */
 dcl E_UNEXPECTED                     fixed bin(31) value('8000FFFF'xn);

 %if #WIN32 ^= '' %then %do;
 /*                                                                   */
 /* MessageId: E_NOTIMPL                                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Not implemented                                                  */
 /*                                                                   */
 dcl E_NOTIMPL                        fixed bin(31) value('80004001'xn);

 /*                                                                   */
 /* MessageId: E_OUTOFMEMORY                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Ran out of memory                                                */
 /*                                                                   */
 dcl E_OUTOFMEMORY                    fixed bin(31) value('8007000E'xn);

 /*                                                                   */
 /* MessageId: E_INVALIDARG                                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  One or more arguments are invalid                                */
 /*                                                                   */
 dcl E_INVALIDARG                     fixed bin(31) value('80070057'xn);

 /*                                                                   */
 /* MessageId: E_NOINTERFACE                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No such interface supported                                      */
 /*                                                                   */
 dcl E_NOINTERFACE                    fixed bin(31) value('80004002'xn);

 /*                                                                   */
 /* MessageId: E_POINTER                                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid pointer                                                  */
 /*                                                                   */
 dcl E_POINTER                        fixed bin(31) value('80004003'xn);

 /*                                                                   */
 /* MessageId: E_HANDLE                                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid handle                                                   */
 /*                                                                   */
 dcl E_HANDLE                         fixed bin(31) value('80070006'xn);

 /*                                                                   */
 /* MessageId: E_ABORT                                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Operation aborted                                                */
 /*                                                                   */
 dcl E_ABORT                          fixed bin(31) value('80004004'xn);

 /*                                                                   */
 /* MessageId: E_FAIL                                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unspecified error                                                */
 /*                                                                   */
 dcl E_FAIL                           fixed bin(31) value('80004005'xn);

 /*                                                                   */
 /* MessageId: E_ACCESSDENIED                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  General access denied error                                      */
 /*                                                                   */
 dcl E_ACCESSDENIED                   fixed bin(31) value('80070005'xn);

 %end; %else %do;
 /*                                                                   */
 /* MessageId: E_NOTIMPL                                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Not implemented                                                  */
 /*                                                                   */
 dcl E_NOTIMPL                        fixed bin(31) value('80000001'xn);

 /*                                                                   */
 /* MessageId: E_OUTOFMEMORY                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Ran out of memory                                                */
 /*                                                                   */
 dcl E_OUTOFMEMORY                    fixed bin(31) value('80000002'xn);

 /*                                                                   */
 /* MessageId: E_INVALIDARG                                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  One or more arguments are invalid                                */
 /*                                                                   */
 dcl E_INVALIDARG                     fixed bin(31) value('80000003'xn);

 /*                                                                   */
 /* MessageId: E_NOINTERFACE                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No such interface supported                                      */
 /*                                                                   */
 dcl E_NOINTERFACE                    fixed bin(31) value('80000004'xn);

 /*                                                                   */
 /* MessageId: E_POINTER                                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid pointer                                                  */
 /*                                                                   */
 dcl E_POINTER                        fixed bin(31) value('80000005'xn);

 /*                                                                   */
 /* MessageId: E_HANDLE                                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid handle                                                   */
 /*                                                                   */
 dcl E_HANDLE                         fixed bin(31) value('80000006'xn);

 /*                                                                   */
 /* MessageId: E_ABORT                                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Operation aborted                                                */
 /*                                                                   */
 dcl E_ABORT                          fixed bin(31) value('80000007'xn);

 /*                                                                   */
 /* MessageId: E_FAIL                                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unspecified error                                                */
 /*                                                                   */
 dcl E_FAIL                           fixed bin(31) value('80000008'xn);

 /*                                                                   */
 /* MessageId: E_ACCESSDENIED                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  General access denied error                                      */
 /*                                                                   */
 dcl E_ACCESSDENIED                   fixed bin(31) value('80000009'xn);

 %end; /*_WIN32 */

 /*                                                                   */
 /* MessageId: CO_E_INIT_TLS                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Thread local storage failure                                     */
 /*                                                                   */
 dcl CO_E_INIT_TLS                    fixed bin(31) value('80004006'xn);

 /*                                                                   */
 /* MessageId: CO_E_INIT_SHARED_ALLOCATOR                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Get shared memory allocator failure                              */
 /*                                                                   */
 dcl CO_E_INIT_SHARED_ALLOCATOR       fixed bin(31) value('80004007'xn);

 /*                                                                   */
 /* MessageId: CO_E_INIT_MEMORY_ALLOCATOR                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Get memory allocator failure                                     */
 /*                                                                   */
 dcl CO_E_INIT_MEMORY_ALLOCATOR       fixed bin(31) value('80004008'xn);

 /*                                                                   */
 /* MessageId: CO_E_INIT_CLASS_CACHE                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to initialize class cache                                 */
 /*                                                                   */
 dcl CO_E_INIT_CLASS_CACHE            fixed bin(31) value('80004009'xn);

 /*                                                                   */
 /* MessageId: CO_E_INIT_RPC_CHANNEL                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to initialize RPC services                                */
 /*                                                                   */
 dcl CO_E_INIT_RPC_CHANNEL            fixed bin(31) value('8000400A'xn);

 /*                                                                   */
 /* MessageId: CO_E_INIT_TLS_SET_CHANNEL_CONTROL                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Cannot set thread local storage channel control                  */
 /*                                                                   */
 dcl CO_E_INIT_TLS_SECHANNEL_CONTROL  fixed bin(31) value('8000400B'xn);

 /*                                                                   */
 /* MessageId: CO_E_INIT_TLS_CHANNEL_CONTROL                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Could not allocate thread local storage channel control          */
 /*                                                                   */
 dcl CO_E_INIT_TLS_CHANNEL_CONTROL    fixed bin(31) value('8000400C'xn);

 /*                                                                   */
 /* MessageId: CO_E_INIT_UNACCEPTED_USER_ALLOCATOR                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The user supplied memory allocator is unacceptable               */
 /*                                                                   */
 dcl CO_E_INIT_UNACCE_USER_ALLOCATOR  fixed bin(31) value('8000400D'xn);

 /*                                                                   */
 /* MessageId: CO_E_INIT_SCM_MUTEX_EXISTS                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The OLE service mutex already exists                             */
 /*                                                                   */
 dcl CO_E_INIT_SCM_MUTEX_EXISTS       fixed bin(31) value('8000400E'xn);

 /*                                                                   */
 /* MessageId: CO_E_INIT_SCM_FILE_MAPPING_EXISTS                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The OLE service file mapping already exists                      */
 /*                                                                   */
 dcl CO_E_INIT_SCM_FI_MAPPING_EXISTS  fixed bin(31) value('8000400F'xn);

 /*                                                                   */
 /* MessageId: CO_E_INIT_SCM_MAP_VIEW_OF_FILE                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to map view of file for OLE service                       */
 /*                                                                   */
 dcl CO_E_INIT_SCM_MAP_VIEW_OF_FILE   fixed bin(31) value('80004010'xn);

 /*                                                                   */
 /* MessageId: CO_E_INIT_SCM_EXEC_FAILURE                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Failure attempting to launch OLE service                         */
 /*                                                                   */
 dcl CO_E_INIT_SCM_EXEC_FAILURE       fixed bin(31) value('80004011'xn);

 /*                                                                   */
 /* MessageId: CO_E_INIT_ONLY_SINGLE_THREADED                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There was an attempt to call CoInitialize a second               */
 /*  time while single threaded                                       */
 /*                                                                   */
 dcl CO_E_INIT_ONLY_SINGLE_THREADED   fixed bin(31) value('80004012'xn);


 /*                                                                   */
 /* MessageId: CO_E_CANT_REMOTE                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A Remote activation was necessary but was not allowed            */
 /*                                                                   */
 dcl CO_E_CANT_REMOTE                 fixed bin(31) value('80004013'xn);

 /*                                                                   */
 /* MessageId: CO_E_BAD_SERVER_NAME                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A Remote activation was necessary but the server name provided   */
 /*  was invalid                                                      */
 /*                                                                   */
 dcl CO_E_BAD_SERVER_NAME             fixed bin(31) value('80004014'xn);

 /*                                                                   */
 /* MessageId: CO_E_WRONG_SERVER_IDENTITY                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The class is configured to run as a security id different from   */
 /*  the caller                                                       */
 /*                                                                   */
 dcl CO_E_WRONG_SERVER_IDENTITY       fixed bin(31) value('80004015'xn);

 /*                                                                   */
 /* MessageId: CO_E_OLE1DDE_DISABLED                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Use of Ole1 services requiring DDE windows is disabled           */
 /*                                                                   */
 dcl CO_E_OLE1DDE_DISABLED            fixed bin(31) value('80004016'xn);

 /*                                                                   */
 /* MessageId: CO_E_RUNAS_SYNTAX                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A RunAs specification must be <domain name>\<user name> or       */
 /*  simply <user name>                                               */
 /*                                                                   */
 dcl CO_E_RUNAS_SYNTAX                fixed bin(31) value('80004017'xn);

 /*                                                                   */
 /* MessageId: CO_E_CREATEPROCESS_FAILURE                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The server process could not be started.  The pathname may be    */
 /*  incorrect.                                                       */
 /*                                                                   */
 dcl CO_E_CREATEPROCESS_FAILURE       fixed bin(31) value('80004018'xn);

 /*                                                                   */
 /* MessageId: CO_E_RUNAS_CREATEPROCESS_FAILURE                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The server process could not be started as the configured        */
 /*  identity.  The pathname may be incorrect or unavailable.         */
 /*                                                                   */
 dcl CO_E_RUNAS_CREATEPROCESS_FAILURE fixed bin(31) value('80004019'xn);

 /*                                                                   */
 /* MessageId: CO_E_RUNAS_LOGON_FAILURE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The server process could not be started because the configured   */
 /*  identity is incorrect.  Check the username and password.         */
 /*                                                                   */
 dcl CO_E_RUNAS_LOGON_FAILURE         fixed bin(31) value('8000401A'xn);

 /*                                                                   */
 /* MessageId: CO_E_LAUNCH_PERMSSION_DENIED                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The client is not allowed to launch this server.                 */
 /*                                                                   */
 dcl CO_E_LAUNCH_PERMSSION_DENIED     fixed bin(31) value('8000401B'xn);

 /*                                                                   */
 /* MessageId: CO_E_START_SERVICE_FAILURE                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The service providing this server could not be started.          */
 /*                                                                   */
 dcl CO_E_START_SERVICE_FAILURE       fixed bin(31) value('8000401C'xn);

 /*                                                                   */
 /* MessageId: CO_E_REMOTE_COMMUNICATION_FAILURE                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This computer was unable to communicate with the computer        */
 /*  providing the server.                                            */
 /*                                                                   */
 dcl CO_E_REMOTE_COMMUNICATION_FAILURE fixed bin(31)
                                                    value('8000401D'xn);

 /*                                                                   */
 /* MessageId: CO_E_SERVER_START_TIMEOUT                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The server did not respond after being launched.                 */
 /*                                                                   */
 dcl CO_E_SERVER_START_TIMEOUT        fixed bin(31) value('8000401E'xn);

 /*                                                                   */
 /* MessageId: CO_E_CLSREG_INCONSISTENT                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The registration information for this server is inconsistent     */
 /*  or incomplete.                                                   */
 /*                                                                   */
 dcl CO_E_CLSREG_INCONSISTENT         fixed bin(31) value('8000401F'xn);

 /*                                                                   */
 /* MessageId: CO_E_IIDREG_INCONSISTENT                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The registration information for this interface is inconsistent  */
 /*  or incomplete.                                                   */
 /*                                                                   */
 dcl CO_E_IIDREG_INCONSISTENT         fixed bin(31) value('80004020'xn);

 /*                                                                   */
 /* MessageId: CO_E_NOT_SUPPORTED                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operation attempted is not supported.                        */
 /*                                                                   */
 dcl CO_E_NOT_SUPPORTED               fixed bin(31) value('80004021'xn);

 /*                                                                   */
 /* MessageId: CO_E_RELOAD_DLL                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A dll must be loaded.                                            */
 /*                                                                   */
 dcl CO_E_RELOAD_DLL                  fixed bin(31) value('80004022'xn);

 /*                                                                   */
 /* MessageId: CO_E_MSI_ERROR                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A Microsoft Software Installer error was encountered.            */
 /*                                                                   */
 dcl CO_E_MSI_ERROR                   fixed bin(31) value('80004023'xn);


 /*                                                                   */
 /* Success codes                                                     */
 /*                                                                   */
 dcl S_OK                             fixed bin(31) value('00000000'xn);
 dcl S_FALSE                          fixed bin(31) value('00000001'xn);

 /*********************************************************************/
 /*                                                                   */
 /* FACILITY_ITF                                                      */
 /*                                                                   */
 /*********************************************************************/

 /*                                                                   */
 /* Codes 0x0-0x01ff are reserved for the OLE group of interfaces.    */
 /*                                                                   */


 /*                                                                   */
 /* Generic OLE errors that may be returned by many inerfaces         */
 /*                                                                   */

 dcl OLE_E_FIRST                      fixed bin(31) value('80040000'xn);
 dcl OLE_E_LAST                       fixed bin(31) value('800400FF'xn);
 dcl OLE_S_FIRST                      fixed bin(31) value('00040000'xn);
 dcl OLE_S_LAST                       fixed bin(31) value('000400FF'xn);

 /*                                                                   */
 /* Old OLE errors                                                    */
 /*                                                                   */

 /*                                                                   */
 /* MessageId: OLE_E_OLEVERB                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid OLEVERB structure                                        */
 /*                                                                   */
 dcl OLE_E_OLEVERB                    fixed bin(31) value('80040000'xn);

 /*                                                                   */
 /* MessageId: OLE_E_ADVF                                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid advise flags                                             */
 /*                                                                   */
 dcl OLE_E_ADVF                       fixed bin(31) value('80040001'xn);

 /*                                                                   */
 /* MessageId: OLE_E_ENUM_NOMORE                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Can't enumerate any more, because the associated data is missing */
 /*                                                                   */
 dcl OLE_E_ENUM_NOMORE                fixed bin(31) value('80040002'xn);

 /*                                                                   */
 /* MessageId: OLE_E_ADVISENOTSUPPORTED                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This implementation doesn't take advises                         */
 /*                                                                   */
 dcl OLE_E_ADVISENOTSUPPORTED         fixed bin(31) value('80040003'xn);

 /*                                                                   */
 /* MessageId: OLE_E_NOCONNECTION                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There is no connection for this connection ID                    */
 /*                                                                   */
 dcl OLE_E_NOCONNECTION               fixed bin(31) value('80040004'xn);

 /*                                                                   */
 /* MessageId: OLE_E_NOTRUNNING                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Need to run the object to perform this operation                 */
 /*                                                                   */
 dcl OLE_E_NOTRUNNING                 fixed bin(31) value('80040005'xn);

 /*                                                                   */
 /* MessageId: OLE_E_NOCACHE                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There is no cache to operate on                                  */
 /*                                                                   */
 dcl OLE_E_NOCACHE                    fixed bin(31) value('80040006'xn);

 /*                                                                   */
 /* MessageId: OLE_E_BLANK                                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Uninitialized object                                             */
 /*                                                                   */
 dcl OLE_E_BLANK                      fixed bin(31) value('80040007'xn);

 /*                                                                   */
 /* MessageId: OLE_E_CLASSDIFF                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Linked object's source class has changed                         */
 /*                                                                   */
 dcl OLE_E_CLASSDIFF                  fixed bin(31) value('80040008'xn);

 /*                                                                   */
 /* MessageId: OLE_E_CANT_GETMONIKER                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Not able to get the moniker of the object                        */
 /*                                                                   */
 dcl OLE_E_CANT_GETMONIKER            fixed bin(31) value('80040009'xn);

 /*                                                                   */
 /* MessageId: OLE_E_CANT_BINDTOSOURCE                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Not able to bind to the source                                   */
 /*                                                                   */
 dcl OLE_E_CANT_BINDTOSOURCE          fixed bin(31) value('8004000A'xn);

 /*                                                                   */
 /* MessageId: OLE_E_STATIC                                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Object is static; operation not allowed                          */
 /*                                                                   */
 dcl OLE_E_STATIC                     fixed bin(31) value('8004000B'xn);

 /*                                                                   */
 /* MessageId: OLE_E_PROMPTSAVECANCELLED                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  User cancelled out of save dialog                                */
 /*                                                                   */
 dcl OLE_E_PROMPTSAVECANCELLED        fixed bin(31) value('8004000C'xn);

 /*                                                                   */
 /* MessageId: OLE_E_INVALIDRECT                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid rectangle                                                */
 /*                                                                   */
 dcl OLE_E_INVALIDRECT                fixed bin(31) value('8004000D'xn);

 /*                                                                   */
 /* MessageId: OLE_E_WRONGCOMPOBJ                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  compobj.dll is too old for the ole2.dll initialized              */
 /*                                                                   */
 dcl OLE_E_WRONGCOMPOBJ               fixed bin(31) value('8004000E'xn);

 /*                                                                   */
 /* MessageId: OLE_E_INVALIDHWND                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid window handle                                            */
 /*                                                                   */
 dcl OLE_E_INVALIDHWND                fixed bin(31) value('8004000F'xn);

 /*                                                                   */
 /* MessageId: OLE_E_NOT_INPLACEACTIVE                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Object is not in any of the inplace active states                */
 /*                                                                   */
 dcl OLE_E_NOT_INPLACEACTIVE          fixed bin(31) value('80040010'xn);

 /*                                                                   */
 /* MessageId: OLE_E_CANTCONVERT                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Not able to convert object                                       */
 /*                                                                   */
 dcl OLE_E_CANTCONVERT                fixed bin(31) value('80040011'xn);

 /*                                                                   */
 /* MessageId: OLE_E_NOSTORAGE                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Not able to perform the operation because object is              */
 /*  not given storage yet                                            */
 /*                                                                   */
 /*                                                                   */
 dcl OLE_E_NOSTORAGE                  fixed bin(31) value('80040012'xn);

 /*                                                                   */
 /* MessageId: DV_E_FORMATETC                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid FORMATETC structure                                      */
 /*                                                                   */
 dcl DV_E_FORMATETC                   fixed bin(31) value('80040064'xn);

 /*                                                                   */
 /* MessageId: DV_E_DVTARGETDEVICE                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid DVTARGETDEVICE structure                                 */
 /*                                                                   */
 dcl DV_E_DVTARGETDEVICE              fixed bin(31) value('80040065'xn);

 /*                                                                   */
 /* MessageId: DV_E_STGMEDIUM                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid STDGMEDIUM structure                                     */
 /*                                                                   */
 dcl DV_E_STGMEDIUM                   fixed bin(31) value('80040066'xn);

 /*                                                                   */
 /* MessageId: DV_E_STATDATA                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid STATDATA structure                                       */
 /*                                                                   */
 dcl DV_E_STATDATA                    fixed bin(31) value('80040067'xn);

 /*                                                                   */
 /* MessageId: DV_E_LINDEX                                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid lindex                                                   */
 /*                                                                   */
 dcl DV_E_LINDEX                      fixed bin(31) value('80040068'xn);

 /*                                                                   */
 /* MessageId: DV_E_TYMED                                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid tymed                                                    */
 /*                                                                   */
 dcl DV_E_TYMED                       fixed bin(31) value('80040069'xn);

 /*                                                                   */
 /* MessageId: DV_E_CLIPFORMAT                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid clipboard format                                         */
 /*                                                                   */
 dcl DV_E_CLIPFORMAT                  fixed bin(31) value('8004006A'xn);

 /*                                                                   */
 /* MessageId: DV_E_DVASPECT                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid aspect(s)                                                */
 /*                                                                   */
 dcl DV_E_DVASPECT                    fixed bin(31) value('8004006B'xn);

 /*                                                                   */
 /* MessageId: DV_E_DVTARGETDEVICE_SIZE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  tdSize parameter of the DVTARGETDEVICE structure is invalid      */
 /*                                                                   */
 dcl DV_E_DVTARGETDEVICE_SIZE         fixed bin(31) value('8004006C'xn);

 /*                                                                   */
 /* MessageId: DV_E_NOIVIEWOBJECT                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Object doesn't support IViewObject interface                     */
 /*                                                                   */
 dcl DV_E_NOIVIEWOBJECT               fixed bin(31) value('8004006D'xn);

 dcl DRAGDROP_E_FIRST                 fixed bin(31) value('80040100'xn);
 dcl DRAGDROP_E_LAST                  fixed bin(31) value('8004010F'xn);
 dcl DRAGDROP_S_FIRST                 fixed bin(31) value('00040100'xn);
 dcl DRAGDROP_S_LAST                  fixed bin(31) value('0004010F'xn);
 /*                                                                   */
 /* MessageId: DRAGDROP_E_NOTREGISTERED                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Trying to revoke a drop target that has not been registered      */
 /*                                                                   */
 dcl DRAGDROP_E_NOTREGISTERED         fixed bin(31) value('80040100'xn);

 /*                                                                   */
 /* MessageId: DRAGDROP_E_ALREADYREGISTERED                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This window has already been registered as a drop target         */
 /*                                                                   */
 dcl DRAGDROP_E_ALREADYREGISTERED     fixed bin(31) value('80040101'xn);

 /*                                                                   */
 /* MessageId: DRAGDROP_E_INVALIDHWND                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid window handle                                            */
 /*                                                                   */
 dcl DRAGDROP_E_INVALIDHWND           fixed bin(31) value('80040102'xn);

 dcl CLASSFACTORY_E_FIRST             fixed bin(31) value('80040110'xn);
 dcl CLASSFACTORY_E_LAST              fixed bin(31) value('8004011F'xn);
 dcl CLASSFACTORY_S_FIRST             fixed bin(31) value('00040110'xn);
 dcl CLASSFACTORY_S_LAST              fixed bin(31) value('0004011F'xn);
 /*                                                                   */
 /* MessageId: CLASS_E_NOAGGREGATION                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Class does not support aggregation (or class object is remote)   */
 /*                                                                   */
 dcl CLASS_E_NOAGGREGATION            fixed bin(31) value('80040110'xn);

 /*                                                                   */
 /* MessageId: CLASS_E_CLASSNOTAVAILABLE                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  ClassFactory cannot supply requested class                       */
 /*                                                                   */
 dcl CLASS_E_CLASSNOTAVAILABLE        fixed bin(31) value('80040111'xn);

 /*                                                                   */
 /* MessageId: CLASS_E_NOTLICENSED                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Class is not licensed for use                                    */
 /*                                                                   */
 dcl CLASS_E_NOTLICENSED              fixed bin(31) value('80040112'xn);

 dcl MARSHAL_E_FIRST                  fixed bin(31) value('80040120'xn);
 dcl MARSHAL_E_LAST                   fixed bin(31) value('8004012F'xn);
 dcl MARSHAL_S_FIRST                  fixed bin(31) value('00040120'xn);
 dcl MARSHAL_S_LAST                   fixed bin(31) value('0004012F'xn);
 dcl DATA_E_FIRST                     fixed bin(31) value('80040130'xn);
 dcl DATA_E_LAST                      fixed bin(31) value('8004013F'xn);
 dcl DATA_S_FIRST                     fixed bin(31) value('00040130'xn);
 dcl DATA_S_LAST                      fixed bin(31) value('0004013F'xn);
 dcl VIEW_E_FIRST                     fixed bin(31) value('80040140'xn);
 dcl VIEW_E_LAST                      fixed bin(31) value('8004014F'xn);
 dcl VIEW_S_FIRST                     fixed bin(31) value('00040140'xn);
 dcl VIEW_S_LAST                      fixed bin(31) value('0004014F'xn);
 /*                                                                   */
 /* MessageId: VIEW_E_DRAW                                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Error drawing view                                               */
 /*                                                                   */
 dcl VIEW_E_DRAW                      fixed bin(31) value('80040140'xn);

 dcl REGDB_E_FIRST                    fixed bin(31) value('80040150'xn);
 dcl REGDB_E_LAST                     fixed bin(31) value('8004015F'xn);
 dcl REGDB_S_FIRST                    fixed bin(31) value('00040150'xn);
 dcl REGDB_S_LAST                     fixed bin(31) value('0004015F'xn);
 /*                                                                   */
 /* MessageId: REGDB_E_READREGDB                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Could not read key from registry                                 */
 /*                                                                   */
 dcl REGDB_E_READREGDB                fixed bin(31) value('80040150'xn);

 /*                                                                   */
 /* MessageId: REGDB_E_WRITEREGDB                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Could not write key to registry                                  */
 /*                                                                   */
 dcl REGDB_E_WRITEREGDB               fixed bin(31) value('80040151'xn);

 /*                                                                   */
 /* MessageId: REGDB_E_KEYMISSING                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Could not find the key in the registry                           */
 /*                                                                   */
 dcl REGDB_E_KEYMISSING               fixed bin(31) value('80040152'xn);

 /*                                                                   */
 /* MessageId: REGDB_E_INVALIDVALUE                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid value for registry                                       */
 /*                                                                   */
 dcl REGDB_E_INVALIDVALUE             fixed bin(31) value('80040153'xn);

 /*                                                                   */
 /* MessageId: REGDB_E_CLASSNOTREG                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Class not registered                                             */
 /*                                                                   */
 dcl REGDB_E_CLASSNOTREG              fixed bin(31) value('80040154'xn);

 /*                                                                   */
 /* MessageId: REGDB_E_IIDNOTREG                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Interface not registered                                         */
 /*                                                                   */
 dcl REGDB_E_IIDNOTREG                fixed bin(31) value('80040155'xn);

 dcl CAT_E_FIRST                      fixed bin(31) value('80040160'xn);
 dcl CAT_E_LAST                       fixed bin(31) value('80040161'xn);
 /*                                                                   */
 /* MessageId: CAT_E_CATIDNOEXIST                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  CATID does not exist                                             */
 /*                                                                   */
 dcl CAT_E_CATIDNOEXIST               fixed bin(31) value('80040160'xn);

 /*                                                                   */
 /* MessageId: CAT_E_NODESCRIPTION                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Description not found                                            */
 /*                                                                   */
 dcl CAT_E_NODESCRIPTION              fixed bin(31) value('80040161'xn);

 /*********************************************************************/
 /*                                                                   */
 /*     Class Store Error Codes                                       */
 /*                                                                   */
 /*********************************************************************/

 dcl CS_E_FIRST                       fixed bin(31) value('80040164'xn);
 dcl CS_E_LAST                        fixed bin(31) value('80040168'xn);
 /*                                                                   */
 /* MessageId: CS_E_PACKAGE_NOTFOUND                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No package in Class Store meets this criteria                    */
 /*                                                                   */
 dcl CS_E_PACKAGE_NOTFOUND            fixed bin(31) value('80040164'xn);

 /*                                                                   */
 /* MessageId: CS_E_NOT_DELETABLE                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Deleting this will break referential integrity                   */
 /*                                                                   */
 dcl CS_E_NOT_DELETABLE               fixed bin(31) value('80040165'xn);

 /*                                                                   */
 /* MessageId: CS_E_CLASS_NOTFOUND                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No such CLSID in Class Store                                     */
 /*                                                                   */
 dcl CS_E_CLASS_NOTFOUND              fixed bin(31) value('80040166'xn);

 /*                                                                   */
 /* MessageId: CS_E_INVALID_VERSION                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The Class Store is corrupted or has a version that is no more    */
 /*  supported                                                        */
 /*                                                                   */
 dcl CS_E_INVALID_VERSION             fixed bin(31) value('80040167'xn);

 /*                                                                   */
 /* MessageId: CS_E_NO_CLASSSTORE                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No such Class Store                                              */
 /*                                                                   */
 dcl CS_E_NO_CLASSSTORE               fixed bin(31) value('80040168'xn);

 dcl CACHE_E_FIRST                    fixed bin(31) value('80040170'xn);
 dcl CACHE_E_LAST                     fixed bin(31) value('8004017F'xn);
 dcl CACHE_S_FIRST                    fixed bin(31) value('00040170'xn);
 dcl CACHE_S_LAST                     fixed bin(31) value('0004017F'xn);
 /*                                                                   */
 /* MessageId: CACHE_E_NOCACHE_UPDATED                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Cache not updated                                                */
 /*                                                                   */
 dcl CACHE_E_NOCACHE_UPDATED          fixed bin(31) value('80040170'xn);

 dcl OLEOBJ_E_FIRST                   fixed bin(31) value('80040180'xn);
 dcl OLEOBJ_E_LAST                    fixed bin(31) value('8004018F'xn);
 dcl OLEOBJ_S_FIRST                   fixed bin(31) value('00040180'xn);
 dcl OLEOBJ_S_LAST                    fixed bin(31) value('0004018F'xn);
 /*                                                                   */
 /* MessageId: OLEOBJ_E_NOVERBS                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No verbs for OLE object                                          */
 /*                                                                   */
 dcl OLEOBJ_E_NOVERBS                 fixed bin(31) value('80040180'xn);

 /*                                                                   */
 /* MessageId: OLEOBJ_E_INVALIDVERB                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid verb for OLE object                                      */
 /*                                                                   */
 dcl OLEOBJ_E_INVALIDVERB             fixed bin(31) value('80040181'xn);

 dcl CLIENTSITE_E_FIRST               fixed bin(31) value('80040190'xn);
 dcl CLIENTSITE_E_LAST                fixed bin(31) value('8004019F'xn);
 dcl CLIENTSITE_S_FIRST               fixed bin(31) value('00040190'xn);
 dcl CLIENTSITE_S_LAST                fixed bin(31) value('0004019F'xn);
 /*                                                                   */
 /* MessageId: INPLACE_E_NOTUNDOABLE                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Undo is not available                                            */
 /*                                                                   */
 dcl INPLACE_E_NOTUNDOABLE            fixed bin(31) value('800401A0'xn);

 /*                                                                   */
 /* MessageId: INPLACE_E_NOTOOLSPACE                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Space for tools is not available                                 */
 /*                                                                   */
 dcl INPLACE_E_NOTOOLSPACE            fixed bin(31) value('800401A1'xn);

 dcl INPLACE_E_FIRST                  fixed bin(31) value('800401A0'xn);
 dcl INPLACE_E_LAST                   fixed bin(31) value('800401AF'xn);
 dcl INPLACE_S_FIRST                  fixed bin(31) value('000401A0'xn);
 dcl INPLACE_S_LAST                   fixed bin(31) value('000401AF'xn);
 dcl ENUM_E_FIRST                     fixed bin(31) value('800401B0'xn);
 dcl ENUM_E_LAST                      fixed bin(31) value('800401BF'xn);
 dcl ENUM_S_FIRST                     fixed bin(31) value('000401B0'xn);
 dcl ENUM_S_LAST                      fixed bin(31) value('000401BF'xn);
 dcl CONVERT10_E_FIRST                fixed bin(31) value('800401C0'xn);
 dcl CONVERT10_E_LAST                 fixed bin(31) value('800401CF'xn);
 dcl CONVERT10_S_FIRST                fixed bin(31) value('000401C0'xn);
 dcl CONVERT10_S_LAST                 fixed bin(31) value('000401CF'xn);
 /*                                                                   */
 /* MessageId: CONVERT10_E_OLESTREAM_GET                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OLESTREAM Get method failed                                      */
 /*                                                                   */
 dcl CONVERT10_E_OLESTREAM_GET        fixed bin(31) value('800401C0'xn);

 /*                                                                   */
 /* MessageId: CONVERT10_E_OLESTREAM_PUT                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OLESTREAM Put method failed                                      */
 /*                                                                   */
 dcl CONVERT10_E_OLESTREAM_PUT        fixed bin(31) value('800401C1'xn);

 /*                                                                   */
 /* MessageId: CONVERT10_E_OLESTREAM_FMT                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Contents of the OLESTREAM not in correct format                  */
 /*                                                                   */
 dcl CONVERT10_E_OLESTREAM_FMT        fixed bin(31) value('800401C2'xn);

 /*                                                                   */
 /* MessageId: CONVERT10_E_OLESTREAM_BITMAP_TO_DIB                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There was an error in a Windows GDI call while                   */
 /*  converting the bitmap to a DIB                                   */
 /*                                                                   */
 dcl CONVERT10_E_OLESM_BITMAP_TO_DIB  fixed bin(31) value('800401C3'xn);

 /*                                                                   */
 /* MessageId: CONVERT10_E_STG_FMT                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Contents of the IStorage not in correct format                   */
 /*                                                                   */
 dcl CONVERT10_E_STG_FMT              fixed bin(31) value('800401C4'xn);

 /*                                                                   */
 /* MessageId: CONVERT10_E_STG_NO_STD_STREAM                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Contents of IStorage is missing one of the standard streams      */
 /*                                                                   */
 dcl CONVERT10_E_STG_NO_STD_STREAM    fixed bin(31) value('800401C5'xn);

 /*                                                                   */
 /* MessageId: CONVERT10_E_STG_DIB_TO_BITMAP                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There was an error in a Windows GDI call while                   */
 /*  converting the DIB to a bitmap.                                  */
 /*                                                                   */
 dcl CONVERT10_E_STG_DIB_TO_BITMAP    fixed bin(31) value('800401C6'xn);

 dcl CLIPBRD_E_FIRST                  fixed bin(31) value('800401D0'xn);
 dcl CLIPBRD_E_LAST                   fixed bin(31) value('800401DF'xn);
 dcl CLIPBRD_S_FIRST                  fixed bin(31) value('000401D0'xn);
 dcl CLIPBRD_S_LAST                   fixed bin(31) value('000401DF'xn);

 /*                                                                   */
 /* MessageId: CLIPBRD_E_CANT_OPEN                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OpenClipboard Failed                                             */
 /*                                                                   */
 dcl CLIPBRD_E_CANT_OPEN              fixed bin(31) value('800401D0'xn);

 /*                                                                   */
 /* MessageId: CLIPBRD_E_CANT_EMPTY                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  EmptyClipboard Failed                                            */
 /*                                                                   */
 dcl CLIPBRD_E_CANT_EMPTY             fixed bin(31) value('800401D1'xn);

 /*                                                                   */
 /* MessageId: CLIPBRD_E_CANT_SET                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  SetClipboard Failed                                              */
 /*                                                                   */
 dcl CLIPBRD_E_CANT_SET               fixed bin(31) value('800401D2'xn);

 /*                                                                   */
 /* MessageId: CLIPBRD_E_BAD_DATA                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Data on clipboard is invalid                                     */
 /*                                                                   */
 dcl CLIPBRD_E_BAD_DATA               fixed bin(31) value('800401D3'xn);

 /*                                                                   */
 /* MessageId: CLIPBRD_E_CANT_CLOSE                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  CloseClipboard Failed                                            */
 /*                                                                   */
 dcl CLIPBRD_E_CANT_CLOSE             fixed bin(31) value('800401D4'xn);

 dcl MK_E_FIRST                       fixed bin(31) value('800401E0'xn);
 dcl MK_E_LAST                        fixed bin(31) value('800401EF'xn);
 dcl MK_S_FIRST                       fixed bin(31) value('000401E0'xn);
 dcl MK_S_LAST                        fixed bin(31) value('000401EF'xn);
 /*                                                                   */
 /* MessageId: MK_E_CONNECTMANUALLY                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Moniker needs to be connected manually                           */
 /*                                                                   */
 dcl MK_E_CONNECTMANUALLY             fixed bin(31) value('800401E0'xn);

 /*                                                                   */
 /* MessageId: MK_E_EXCEEDEDDEADLINE                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Operation exceeded deadline                                      */
 /*                                                                   */
 dcl MK_E_EXCEEDEDDEADLINE            fixed bin(31) value('800401E1'xn);

 /*                                                                   */
 /* MessageId: MK_E_NEEDGENERIC                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Moniker needs to be generic                                      */
 /*                                                                   */
 dcl MK_E_NEEDGENERIC                 fixed bin(31) value('800401E2'xn);

 /*                                                                   */
 /* MessageId: MK_E_UNAVAILABLE                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Operation unavailable                                            */
 /*                                                                   */
 dcl MK_E_UNAVAILABLE                 fixed bin(31) value('800401E3'xn);

 /*                                                                   */
 /* MessageId: MK_E_SYNTAX                                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid syntax                                                   */
 /*                                                                   */
 dcl MK_E_SYNTAX                      fixed bin(31) value('800401E4'xn);

 /*                                                                   */
 /* MessageId: MK_E_NOOBJECT                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No object for moniker                                            */
 /*                                                                   */
 dcl MK_E_NOOBJECT                    fixed bin(31) value('800401E5'xn);

 /*                                                                   */
 /* MessageId: MK_E_INVALIDEXTENSION                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Bad extension for file                                           */
 /*                                                                   */
 dcl MK_E_INVALIDEXTENSION            fixed bin(31) value('800401E6'xn);

 /*                                                                   */
 /* MessageId: MK_E_INTERMEDIATEINTERFACENOTSUPPORTED                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Intermediate operation failed                                    */
 /*                                                                   */
 dcl MK_E_INTERMEDIATACENOTSUPPORTED  fixed bin(31) value('800401E7'xn);

 /*                                                                   */
 /* MessageId: MK_E_NOTBINDABLE                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Moniker is not bindable                                          */
 /*                                                                   */
 dcl MK_E_NOTBINDABLE                 fixed bin(31) value('800401E8'xn);

 /*                                                                   */
 /* MessageId: MK_E_NOTBOUND                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Moniker is not bound                                             */
 /*                                                                   */
 dcl MK_E_NOTBOUND                    fixed bin(31) value('800401E9'xn);

 /*                                                                   */
 /* MessageId: MK_E_CANTOPENFILE                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Moniker cannot open file                                         */
 /*                                                                   */
 dcl MK_E_CANTOPENFILE                fixed bin(31) value('800401EA'xn);

 /*                                                                   */
 /* MessageId: MK_E_MUSTBOTHERUSER                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  User input required for operation to succeed                     */
 /*                                                                   */
 dcl MK_E_MUSTBOTHERUSER              fixed bin(31) value('800401EB'xn);

 /*                                                                   */
 /* MessageId: MK_E_NOINVERSE                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Moniker class has no inverse                                     */
 /*                                                                   */
 dcl MK_E_NOINVERSE                   fixed bin(31) value('800401EC'xn);

 /*                                                                   */
 /* MessageId: MK_E_NOSTORAGE                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Moniker does not refer to storage                                */
 /*                                                                   */
 dcl MK_E_NOSTORAGE                   fixed bin(31) value('800401ED'xn);

 /*                                                                   */
 /* MessageId: MK_E_NOPREFIX                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No common prefix                                                 */
 /*                                                                   */
 dcl MK_E_NOPREFIX                    fixed bin(31) value('800401EE'xn);

 /*                                                                   */
 /* MessageId: MK_E_ENUMERATION_FAILED                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Moniker could not be enumerated                                  */
 /*                                                                   */
 dcl MK_E_ENUMERATION_FAILED          fixed bin(31) value('800401EF'xn);

 dcl CO_E_FIRST                       fixed bin(31) value('800401F0'xn);
 dcl CO_E_LAST                        fixed bin(31) value('800401FF'xn);
 dcl CO_S_FIRST                       fixed bin(31) value('000401F0'xn);
 dcl CO_S_LAST                        fixed bin(31) value('000401FF'xn);
 /*                                                                   */
 /* MessageId: CO_E_NOTINITIALIZED                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  CoInitialize has not been called.                                */
 /*                                                                   */
 dcl CO_E_NOTINITIALIZED              fixed bin(31) value('800401F0'xn);

 /*                                                                   */
 /* MessageId: CO_E_ALREADYINITIALIZED                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  CoInitialize has already been called.                            */
 /*                                                                   */
 dcl CO_E_ALREADYINITIALIZED          fixed bin(31) value('800401F1'xn);

 /*                                                                   */
 /* MessageId: CO_E_CANTDETERMINECLASS                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Class of object cannot be determined                             */
 /*                                                                   */
 dcl CO_E_CANTDETERMINECLASS          fixed bin(31) value('800401F2'xn);

 /*                                                                   */
 /* MessageId: CO_E_CLASSSTRING                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid class string                                             */
 /*                                                                   */
 dcl CO_E_CLASSSTRING                 fixed bin(31) value('800401F3'xn);

 /*                                                                   */
 /* MessageId: CO_E_IIDSTRING                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid interface string                                         */
 /*                                                                   */
 dcl CO_E_IIDSTRING                   fixed bin(31) value('800401F4'xn);

 /*                                                                   */
 /* MessageId: CO_E_APPNOTFOUND                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Application not found                                            */
 /*                                                                   */
 dcl CO_E_APPNOTFOUND                 fixed bin(31) value('800401F5'xn);

 /*                                                                   */
 /* MessageId: CO_E_APPSINGLEUSE                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Application cannot be run more than once                         */
 /*                                                                   */
 dcl CO_E_APPSINGLEUSE                fixed bin(31) value('800401F6'xn);

 /*                                                                   */
 /* MessageId: CO_E_ERRORINAPP                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Some error in application program                                */
 /*                                                                   */
 dcl CO_E_ERRORINAPP                  fixed bin(31) value('800401F7'xn);

 /*                                                                   */
 /* MessageId: CO_E_DLLNOTFOUND                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DLL for class not found                                          */
 /*                                                                   */
 dcl CO_E_DLLNOTFOUND                 fixed bin(31) value('800401F8'xn);

 /*                                                                   */
 /* MessageId: CO_E_ERRORINDLL                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Error in the DLL                                                 */
 /*                                                                   */
 dcl CO_E_ERRORINDLL                  fixed bin(31) value('800401F9'xn);

 /*                                                                   */
 /* MessageId: CO_E_WRONGOSFORAPP                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Wrong OS or OS version for application                           */
 /*                                                                   */
 dcl CO_E_WRONGOSFORAPP               fixed bin(31) value('800401FA'xn);

 /*                                                                   */
 /* MessageId: CO_E_OBJNOTREG                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Object is not registered                                         */
 /*                                                                   */
 dcl CO_E_OBJNOTREG                   fixed bin(31) value('800401FB'xn);

 /*                                                                   */
 /* MessageId: CO_E_OBJISREG                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Object is already registered                                     */
 /*                                                                   */
 dcl CO_E_OBJISREG                    fixed bin(31) value('800401FC'xn);

 /*                                                                   */
 /* MessageId: CO_E_OBJNOTCONNECTED                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Object is not connected to server                                */
 /*                                                                   */
 dcl CO_E_OBJNOTCONNECTED             fixed bin(31) value('800401FD'xn);

 /*                                                                   */
 /* MessageId: CO_E_APPDIDNTREG                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Application was launched but it didn't register a class factory  */
 /*                                                                   */
 dcl CO_E_APPDIDNTREG                 fixed bin(31) value('800401FE'xn);

 /*                                                                   */
 /* MessageId: CO_E_RELEASED                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Object has been released                                         */
 /*                                                                   */
 dcl CO_E_RELEASED                    fixed bin(31) value('800401FF'xn);

 /*                                                                   */
 /* MessageId: CO_E_FAILEDTOIMPERSONATE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to impersonate DCOM client                                */
 /*                                                                   */
 dcl CO_E_FAILEDTOIMPERSONATE         fixed bin(31) value('80040200'xn);

 /*                                                                   */
 /* MessageId: CO_E_FAILEDTOGETSECCTX                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to obtain server's security context                       */
 /*                                                                   */
 dcl CO_E_FAILEDTOGETSECCTX           fixed bin(31) value('80040201'xn);

 /*                                                                   */
 /* MessageId: CO_E_FAILEDTOOPENTHREADTOKEN                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to open the access token of the current thread            */
 /*                                                                   */
 dcl CO_E_FAILEDTOOPENTHREADTOKEN     fixed bin(31) value('80040202'xn);

 /*                                                                   */
 /* MessageId: CO_E_FAILEDTOGETTOKENINFO                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to obtain user info from an access token                  */
 /*                                                                   */
 dcl CO_E_FAILEDTOGETTOKENINFO        fixed bin(31) value('80040203'xn);

 /*                                                                   */
 /* MessageId: CO_E_TRUSTEEDOESNTMATCHCLIENT                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The client who called IAccessControl::IsAccessPermitted was the  */
 /*  trustee provided tot he method                                   */
 /*                                                                   */
 dcl CO_E_TRUSTEEDOESNTMATCHCLIENT    fixed bin(31) value('80040204'xn);

 /*                                                                   */
 /* MessageId: CO_E_FAILEDTOQUERYCLIENTBLANKET                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to obtain the client's security blanket                   */
 /*                                                                   */
 dcl CO_E_FAILEDTOQUERYCLIENTBLANKET  fixed bin(31) value('80040205'xn);

 /*                                                                   */
 /* MessageId: CO_E_FAILEDTOSETDACL                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to set a discretionary ACL into a security descriptor     */
 /*                                                                   */
 dcl CO_E_FAILEDTOSETDACL             fixed bin(31) value('80040206'xn);

 /*                                                                   */
 /* MessageId: CO_E_ACCESSCHECKFAILED                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system function, AccessCheck, returned false                 */
 /*                                                                   */
 dcl CO_E_ACCESSCHECKFAILED           fixed bin(31) value('80040207'xn);

 /*                                                                   */
 /* MessageId: CO_E_NETACCESSAPIFAILED                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Either NetAccessDel or NetAccessAdd returned an error code.      */
 /*                                                                   */
 dcl CO_E_NETACCESSAPIFAILED          fixed bin(31) value('80040208'xn);

 /*                                                                   */
 /* MessageId: CO_E_WRONGTRUSTEENAMESYNTAX                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  One of the trustee strings provided by the user did not conform  */
 /*  to the <Domain>\<Name> syntax and it was not the "*" string      */
 /*                                                                   */
 dcl CO_E_WRONGTRUSTEENAMESYNTAX      fixed bin(31) value('80040209'xn);

 /*                                                                   */
 /* MessageId: CO_E_INVALIDSID                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  One of the security identifiers provided by the user was invalid */
 /*                                                                   */
 dcl CO_E_INVALIDSID                  fixed bin(31) value('8004020A'xn);

 /*                                                                   */
 /* MessageId: CO_E_CONVERSIONFAILED                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to convert a wide character trustee string to a multibyte */
 /*  trustee string                                                   */
 /*                                                                   */
 dcl CO_E_CONVERSIONFAILED            fixed bin(31) value('8004020B'xn);

 /*                                                                   */
 /* MessageId: CO_E_NOMATCHINGSIDFOUND                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to find a security identifier that corresponds to a       */
 /*  trustee string provided by the user                              */
 /*                                                                   */
 dcl CO_E_NOMATCHINGSIDFOUND          fixed bin(31) value('8004020C'xn);

 /*                                                                   */
 /* MessageId: CO_E_LOOKUPACCSIDFAILED                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system function, LookupAccountSID, failed                    */
 /*                                                                   */
 dcl CO_E_LOOKUPACCSIDFAILED          fixed bin(31) value('8004020D'xn);

 /*                                                                   */
 /* MessageId: CO_E_NOMATCHINGNAMEFOUND                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to find a trustee name that corresponds to a security     */
 /*  identifier provided by the user                                  */
 /*                                                                   */
 dcl CO_E_NOMATCHINGNAMEFOUND         fixed bin(31) value('8004020E'xn);

 /*                                                                   */
 /* MessageId: CO_E_LOOKUPACCNAMEFAILED                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system function, LookupAccountName, failed                   */
 /*                                                                   */
 dcl CO_E_LOOKUPACCNAMEFAILED         fixed bin(31) value('8004020F'xn);

 /*                                                                   */
 /* MessageId: CO_E_SETSERLHNDLFAILED                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to set or reset a serialization handle                    */
 /*                                                                   */
 dcl CO_E_SETSERLHNDLFAILED           fixed bin(31) value('80040210'xn);

 /*                                                                   */
 /* MessageId: CO_E_FAILEDTOGETWINDIR                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to obtain the Windows directory                           */
 /*                                                                   */
 dcl CO_E_FAILEDTOGETWINDIR           fixed bin(31) value('80040211'xn);

 /*                                                                   */
 /* MessageId: CO_E_PATHTOOLONG                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Path too long                                                    */
 /*                                                                   */
 dcl CO_E_PATHTOOLONG                 fixed bin(31) value('80040212'xn);

 /*                                                                   */
 /* MessageId: CO_E_FAILEDTOGENUUID                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to generate a uuid.                                       */
 /*                                                                   */
 dcl CO_E_FAILEDTOGENUUID             fixed bin(31) value('80040213'xn);

 /*                                                                   */
 /* MessageId: CO_E_FAILEDTOCREATEFILE                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to create file                                            */
 /*                                                                   */
 dcl CO_E_FAILEDTOCREATEFILE          fixed bin(31) value('80040214'xn);

 /*                                                                   */
 /* MessageId: CO_E_FAILEDTOCLOSEHANDLE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to close a serialization handle or a file handle.         */
 /*                                                                   */
 dcl CO_E_FAILEDTOCLOSEHANDLE         fixed bin(31) value('80040215'xn);

 /*                                                                   */
 /* MessageId: CO_E_EXCEEDSYSACLLIMIT                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The number of ACEs in an ACL exceeds the system limit            */
 /*                                                                   */
 dcl CO_E_EXCEEDSYSACLLIMIT           fixed bin(31) value('80040216'xn);

 /*                                                                   */
 /* MessageId: CO_E_ACESINWRONGORDER                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Not all the DENY_ACCESS ACEs are arranged in front of the        */
 /*  GRANT_ACCESS ACEs in the stream                                  */
 /*                                                                   */
 dcl CO_E_ACESINWRONGORDER            fixed bin(31) value('80040217'xn);

 /*                                                                   */
 /* MessageId: CO_E_INCOMPATIBLESTREAMVERSION                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The version of ACL format in the stream is not supported by this */
 /*  implementation of IAccessControl                                 */
 /*                                                                   */
 dcl CO_E_INCOMPATIBLESTREAMVERSION   fixed bin(31) value('80040218'xn);

 /*                                                                   */
 /* MessageId: CO_E_FAILEDTOOPENPROCESSTOKEN                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to open the access token of the server process            */
 /*                                                                   */
 dcl CO_E_FAILEDTOOPENPROCESSTOKEN    fixed bin(31) value('80040219'xn);

 /*                                                                   */
 /* MessageId: CO_E_DECODEFAILED                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to decode the ACL in the stream provided by the user      */
 /*                                                                   */
 dcl CO_E_DECODEFAILED                fixed bin(31) value('8004021A'xn);

 /*                                                                   */
 /* MessageId: CO_E_ACNOTINITIALIZED                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The COM IAccessControl object is not initialized                 */
 /*                                                                   */
 dcl CO_E_ACNOTINITIALIZED            fixed bin(31) value('8004021B'xn);

 /*                                                                   */
 /* Old OLE Success Codes                                             */
 /*                                                                   */
 /*                                                                   */
 /* MessageId: OLE_S_USEREG                                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Use the registry database to provide the requested information   */
 /*                                                                   */
 dcl OLE_S_USEREG                     fixed bin(31) value('00040000'xn);

 /*                                                                   */
 /* MessageId: OLE_S_STATIC                                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Success, but static                                              */
 /*                                                                   */
 dcl OLE_S_STATIC                     fixed bin(31) value('00040001'xn);

 /*                                                                   */
 /* MessageId: OLE_S_MAC_CLIPFORMAT                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Macintosh clipboard format                                       */
 /*                                                                   */
 dcl OLE_S_MAC_CLIPFORMAT             fixed bin(31) value('00040002'xn);

 /*                                                                   */
 /* MessageId: DRAGDROP_S_DROP                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Successful drop took place                                       */
 /*                                                                   */
 dcl DRAGDROP_S_DROP                  fixed bin(31) value('00040100'xn);

 /*                                                                   */
 /* MessageId: DRAGDROP_S_CANCEL                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Drag-drop operation canceled                                     */
 /*                                                                   */
 dcl DRAGDROP_S_CANCEL                fixed bin(31) value('00040101'xn);

 /*                                                                   */
 /* MessageId: DRAGDROP_S_USEDEFAULTCURSORS                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Use the default cursor                                           */
 /*                                                                   */
 dcl DRAGDROP_S_USEDEFAULTCURSORS     fixed bin(31) value('00040102'xn);

 /*                                                                   */
 /* MessageId: DATA_S_SAMEFORMATETC                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Data has same FORMATETC                                          */
 /*                                                                   */
 dcl DATA_S_SAMEFORMATETC             fixed bin(31) value('00040130'xn);

 /*                                                                   */
 /* MessageId: VIEW_S_ALREADY_FROZEN                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  View is already frozen                                           */
 /*                                                                   */
 dcl VIEW_S_ALREADY_FROZEN            fixed bin(31) value('00040140'xn);

 /*                                                                   */
 /* MessageId: CACHE_S_FORMATETC_NOTSUPPORTED                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  FORMATETC not supported                                          */
 /*                                                                   */
 dcl CACHE_S_FORMATETC_NOTSUPPORTED   fixed bin(31) value('00040170'xn);

 /*                                                                   */
 /* MessageId: CACHE_S_SAMECACHE                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Same cache                                                       */
 /*                                                                   */
 dcl CACHE_S_SAMECACHE                fixed bin(31) value('00040171'xn);

 /*                                                                   */
 /* MessageId: CACHE_S_SOMECACHES_NOTUPDATED                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Some cache(s) not updated                                        */
 /*                                                                   */
 dcl CACHE_S_SOMECACHES_NOTUPDATED    fixed bin(31) value('00040172'xn);

 /*                                                                   */
 /* MessageId: OLEOBJ_S_INVALIDVERB                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid verb for OLE object                                      */
 /*                                                                   */
 dcl OLEOBJ_S_INVALIDVERB             fixed bin(31) value('00040180'xn);

 /*                                                                   */
 /* MessageId: OLEOBJ_S_CANNOT_DOVERB_NOW                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Verb number is valid but verb cannot be done now                 */
 /*                                                                   */
 dcl OLEOBJ_S_CANNOT_DOVERB_NOW       fixed bin(31) value('00040181'xn);

 /*                                                                   */
 /* MessageId: OLEOBJ_S_INVALIDHWND                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid window handle passed                                     */
 /*                                                                   */
 dcl OLEOBJ_S_INVALIDHWND             fixed bin(31) value('00040182'xn);

 /*                                                                   */
 /* MessageId: INPLACE_S_TRUNCATED                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Message is too long; some of it had                              */
 /*  to be truncated before displaying                                */
 /*                                                                   */
 dcl INPLACE_S_TRUNCATED              fixed bin(31) value('000401A0'xn);

 /*                                                                   */
 /* MessageId: CONVERT10_S_NO_PRESENTATION                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to convert OLESTREAM to IStorage                          */
 /*                                                                   */
 dcl CONVERT10_S_NO_PRESENTATION      fixed bin(31) value('000401C0'xn);

 /*                                                                   */
 /* MessageId: MK_S_REDUCED_TO_SELF                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Moniker reduced to itself                                        */
 /*                                                                   */
 dcl MK_S_REDUCED_TO_SELF             fixed bin(31) value('000401E2'xn);

 /*                                                                   */
 /* MessageId: MK_S_ME                                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Common prefix is this moniker                                    */
 /*                                                                   */
 dcl MK_S_ME                          fixed bin(31) value('000401E4'xn);

 /*                                                                   */
 /* MessageId: MK_S_HIM                                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Common prefix is input moniker                                   */
 /*                                                                   */
 dcl MK_S_HIM                         fixed bin(31) value('000401E5'xn);

 /*                                                                   */
 /* MessageId: MK_S_US                                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Common prefix is both monikers                                   */
 /*                                                                   */
 dcl MK_S_US                          fixed bin(31) value('000401E6'xn);

 /*                                                                   */
 /* MessageId: MK_S_MONIKERALREADYREGISTERED                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Moniker is already registered in running object table            */
 /*                                                                   */
 dcl MK_S_MONIKERALREADYREGISTERED    fixed bin(31) value('000401E7'xn);

 /* *******************************************************************/
 /*                                                                   */
 /* FACILITY_WINDOWS                                                  */
 /*                                                                   */
 /* *******************************************************************/
 /*                                                                   */
 /* Codes 0x0-0x01ff are reserved for the OLE group of                */
 /* interfaces.                                                       */
 /*                                                                   */
 /*                                                                   */
 /* MessageId: CO_E_CLASS_CREATE_FAILED                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Attempt to create a class object failed                          */
 /*                                                                   */
 dcl CO_E_CLASS_CREATE_FAILED         fixed bin(31) value('80080001'xn);

 /*                                                                   */
 /* MessageId: CO_E_SCM_ERROR                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OLE service could not bind object                                */
 /*                                                                   */
 dcl CO_E_SCM_ERROR                   fixed bin(31) value('80080002'xn);

 /*                                                                   */
 /* MessageId: CO_E_SCM_RPC_FAILURE                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  RPC communication failed with OLE service                        */
 /*                                                                   */
 dcl CO_E_SCM_RPC_FAILURE             fixed bin(31) value('80080003'xn);

 /*                                                                   */
 /* MessageId: CO_E_BAD_PATH                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Bad path to object                                               */
 /*                                                                   */
 dcl CO_E_BAD_PATH                    fixed bin(31) value('80080004'xn);

 /*                                                                   */
 /* MessageId: CO_E_SERVER_EXEC_FAILURE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Server execution failed                                          */
 /*                                                                   */
 dcl CO_E_SERVER_EXEC_FAILURE         fixed bin(31) value('80080005'xn);

 /*                                                                   */
 /* MessageId: CO_E_OBJSRV_RPC_FAILURE                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OLE service could not communicate with the object server         */
 /*                                                                   */
 dcl CO_E_OBJSRV_RPC_FAILURE          fixed bin(31) value('80080006'xn);

 /*                                                                   */
 /* MessageId: MK_E_NO_NORMALIZED                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Moniker path could not be normalized                             */
 /*                                                                   */
 dcl MK_E_NO_NORMALIZED               fixed bin(31) value('80080007'xn);

 /*                                                                   */
 /* MessageId: CO_E_SERVER_STOPPING                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Object server is stopping when OLE service contacts it           */
 /*                                                                   */
 dcl CO_E_SERVER_STOPPING             fixed bin(31) value('80080008'xn);

 /*                                                                   */
 /* MessageId: MEM_E_INVALID_ROOT                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An invalid root block pointer was specified                      */
 /*                                                                   */
 dcl MEM_E_INVALID_ROOT               fixed bin(31) value('80080009'xn);

 /*                                                                   */
 /* MessageId: MEM_E_INVALID_LINK                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An allocation chain contained an invalid link pointer            */
 /*                                                                   */
 dcl MEM_E_INVALID_LINK               fixed bin(31) value('80080010'xn);

 /*                                                                   */
 /* MessageId: MEM_E_INVALID_SIZE                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested allocation size was too large                      */
 /*                                                                   */
 dcl MEM_E_INVALID_SIZE               fixed bin(31) value('80080011'xn);

 /*                                                                   */
 /* MessageId: CO_S_NOTALLINTERFACES                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Not all the requested interfaces were available                  */
 /*                                                                   */
 dcl CO_S_NOTALLINTERFACES            fixed bin(31) value('00080012'xn);

 /*********************************************************************/
 /*                                                                   */
 /* FACILITY_DISPATCH                                                 */
 /*                                                                   */
 /*********************************************************************/
 /*                                                                   */
 /* MessageId: DISP_E_UNKNOWNINTERFACE                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unknown interface.                                               */
 /*                                                                   */
 dcl DISP_E_UNKNOWNINTERFACE          fixed bin(31) value('80020001'xn);

 /*                                                                   */
 /* MessageId: DISP_E_MEMBERNOTFOUND                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Member not found.                                                */
 /*                                                                   */
 dcl DISP_E_MEMBERNOTFOUND            fixed bin(31) value('80020003'xn);

 /*                                                                   */
 /* MessageId: DISP_E_PARAMNOTFOUND                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Parameter not found.                                             */
 /*                                                                   */
 dcl DISP_E_PARAMNOTFOUND             fixed bin(31) value('80020004'xn);

 /*                                                                   */
 /* MessageId: DISP_E_TYPEMISMATCH                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Type mismatch.                                                   */
 /*                                                                   */
 dcl DISP_E_TYPEMISMATCH              fixed bin(31) value('80020005'xn);

 /*                                                                   */
 /* MessageId: DISP_E_UNKNOWNNAME                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unknown name.                                                    */
 /*                                                                   */
 dcl DISP_E_UNKNOWNNAME               fixed bin(31) value('80020006'xn);

 /*                                                                   */
 /* MessageId: DISP_E_NONAMEDARGS                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No named arguments.                                              */
 /*                                                                   */
 dcl DISP_E_NONAMEDARGS               fixed bin(31) value('80020007'xn);

 /*                                                                   */
 /* MessageId: DISP_E_BADVARTYPE                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Bad variable type.                                               */
 /*                                                                   */
 dcl DISP_E_BADVARTYPE                fixed bin(31) value('80020008'xn);

 /*                                                                   */
 /* MessageId: DISP_E_EXCEPTION                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Exception occurred.                                              */
 /*                                                                   */
 dcl DISP_E_EXCEPTION                 fixed bin(31) value('80020009'xn);

 /*                                                                   */
 /* MessageId: DISP_E_OVERFLOW                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Out of present range.                                            */
 /*                                                                   */
 dcl DISP_E_OVERFLOW                  fixed bin(31) value('8002000A'xn);

 /*                                                                   */
 /* MessageId: DISP_E_BADINDEX                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid index.                                                   */
 /*                                                                   */
 dcl DISP_E_BADINDEX                  fixed bin(31) value('8002000B'xn);

 /*                                                                   */
 /* MessageId: DISP_E_UNKNOWNLCID                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unknown language.                                                */
 /*                                                                   */
 dcl DISP_E_UNKNOWNLCID               fixed bin(31) value('8002000C'xn);

 /*                                                                   */
 /* MessageId: DISP_E_ARRAYISLOCKED                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Memory is locked.                                                */
 /*                                                                   */
 dcl DISP_E_ARRAYISLOCKED             fixed bin(31) value('8002000D'xn);

 /*                                                                   */
 /* MessageId: DISP_E_BADPARAMCOUNT                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid number of parameters.                                    */
 /*                                                                   */
 dcl DISP_E_BADPARAMCOUNT             fixed bin(31) value('8002000E'xn);

 /*                                                                   */
 /* MessageId: DISP_E_PARAMNOTOPTIONAL                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Parameter not optional.                                          */
 /*                                                                   */
 dcl DISP_E_PARAMNOTOPTIONAL          fixed bin(31) value('8002000F'xn);

 /*                                                                   */
 /* MessageId: DISP_E_BADCALLEE                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid callee.                                                  */
 /*                                                                   */
 dcl DISP_E_BADCALLEE                 fixed bin(31) value('80020010'xn);

 /*                                                                   */
 /* MessageId: DISP_E_NOTACOLLECTION                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Does not support a collection.                                   */
 /*                                                                   */
 dcl DISP_E_NOTACOLLECTION            fixed bin(31) value('80020011'xn);

 /*                                                                   */
 /* MessageId: DISP_E_DIVBYZERO                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Division by zero.                                                */
 /*                                                                   */
 dcl DISP_E_DIVBYZERO                 fixed bin(31) value('80020012'xn);

 /*                                                                   */
 /* MessageId: TYPE_E_BUFFERTOOSMALL                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Buffer too small.                                                */
 /*                                                                   */
 dcl TYPE_E_BUFFERTOOSMALL            fixed bin(31) value('80028016'xn);

 /*                                                                   */
 /* MessageId: TYPE_E_FIELDNOTFOUND                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Field name not defined in the record.                            */
 /*                                                                   */
 dcl TYPE_E_FIELDNOTFOUND             fixed bin(31) value('80028017'xn);

 /*                                                                   */
 /* MessageId: TYPE_E_INVDATAREAD                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Old format or invalid type library.                              */
 /*                                                                   */
 dcl TYPE_E_INVDATAREAD               fixed bin(31) value('80028018'xn);

 /*                                                                   */
 /* MessageId: TYPE_E_UNSUPFORMAT                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Old format or invalid type library.                              */
 /*                                                                   */
 dcl TYPE_E_UNSUPFORMAT               fixed bin(31) value('80028019'xn);

 /*                                                                   */
 /* MessageId: TYPE_E_REGISTRYACCESS                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Error accessing the OLE registry.                                */
 /*                                                                   */
 dcl TYPE_E_REGISTRYACCESS            fixed bin(31) value('8002801C'xn);

 /*                                                                   */
 /* MessageId: TYPE_E_LIBNOTREGISTERED                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Library not registered.                                          */
 /*                                                                   */
 dcl TYPE_E_LIBNOTREGISTERED          fixed bin(31) value('8002801D'xn);

 /*                                                                   */
 /* MessageId: TYPE_E_UNDEFINEDTYPE                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Bound to unknown type.                                           */
 /*                                                                   */
 dcl TYPE_E_UNDEFINEDTYPE             fixed bin(31) value('80028027'xn);

 /*                                                                   */
 /* MessageId: TYPE_E_QUALIFIEDNAMEDISALLOWED                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Qualified name disallowed.                                       */
 /*                                                                   */
 dcl TYPE_E_QUALIFIEDNAMEDISALLOWED   fixed bin(31) value('80028028'xn);

 /*                                                                   */
 /* MessageId: TYPE_E_INVALIDSTATE                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid forward reference, or reference to uncompiled type.      */
 /*                                                                   */
 dcl TYPE_E_INVALIDSTATE              fixed bin(31) value('80028029'xn);

 /*                                                                   */
 /* MessageId: TYPE_E_WRONGTYPEKIND                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Type mismatch.                                                   */
 /*                                                                   */
 dcl TYPE_E_WRONGTYPEKIND             fixed bin(31) value('8002802A'xn);

 /*                                                                   */
 /* MessageId: TYPE_E_ELEMENTNOTFOUND                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Element not found.                                               */
 /*                                                                   */
 dcl TYPE_E_ELEMENTNOTFOUND           fixed bin(31) value('8002802B'xn);

 /*                                                                   */
 /* MessageId: TYPE_E_AMBIGUOUSNAME                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Ambiguous name.                                                  */
 /*                                                                   */
 dcl TYPE_E_AMBIGUOUSNAME             fixed bin(31) value('8002802C'xn);

 /*                                                                   */
 /* MessageId: TYPE_E_NAMECONFLICT                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Name already exists in the library.                              */
 /*                                                                   */
 dcl TYPE_E_NAMECONFLICT              fixed bin(31) value('8002802D'xn);

 /*                                                                   */
 /* MessageId: TYPE_E_UNKNOWNLCID                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unknown LCID.                                                    */
 /*                                                                   */
 dcl TYPE_E_UNKNOWNLCID               fixed bin(31) value('8002802E'xn);

 /*                                                                   */
 /* MessageId: TYPE_E_DLLFUNCTIONNOTFOUND                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Function not defined in specified DLL.                           */
 /*                                                                   */
 dcl TYPE_E_DLLFUNCTIONNOTFOUND       fixed bin(31) value('8002802F'xn);

 /*                                                                   */
 /* MessageId: TYPE_E_BADMODULEKIND                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Wrong module kind for the operation.                             */
 /*                                                                   */
 dcl TYPE_E_BADMODULEKIND             fixed bin(31) value('800288BD'xn);

 /*                                                                   */
 /* MessageId: TYPE_E_SIZETOOBIG                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Size may not exceed 64K.                                         */
 /*                                                                   */
 dcl TYPE_E_SIZETOOBIG                fixed bin(31) value('800288C5'xn);

 /*                                                                   */
 /* MessageId: TYPE_E_DUPLICATEID                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Duplicate ID in inheritance hierarchy.                           */
 /*                                                                   */
 dcl TYPE_E_DUPLICATEID               fixed bin(31) value('800288C6'xn);

 /*                                                                   */
 /* MessageId: TYPE_E_INVALIDID                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Incorrect inheritance depth in standard OLE hmember.             */
 /*                                                                   */
 dcl TYPE_E_INVALIDID                 fixed bin(31) value('800288CF'xn);

 /*                                                                   */
 /* MessageId: TYPE_E_TYPEMISMATCH                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Type mismatch.                                                   */
 /*                                                                   */
 dcl TYPE_E_TYPEMISMATCH              fixed bin(31) value('80028CA0'xn);

 /*                                                                   */
 /* MessageId: TYPE_E_OUTOFBOUNDS                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid number of arguments.                                     */
 /*                                                                   */
 dcl TYPE_E_OUTOFBOUNDS               fixed bin(31) value('80028CA1'xn);

 /*                                                                   */
 /* MessageId: TYPE_E_IOERROR                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  I/O Error.                                                       */
 /*                                                                   */
 dcl TYPE_E_IOERROR                   fixed bin(31) value('80028CA2'xn);

 /*                                                                   */
 /* MessageId: TYPE_E_CANTCREATETMPFILE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Error creating unique tmp file.                                  */
 /*                                                                   */
 dcl TYPE_E_CANTCREATETMPFILE         fixed bin(31) value('80028CA3'xn);

 /*                                                                   */
 /* MessageId: TYPE_E_CANTLOADLIBRARY                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Error loading type library/DLL.                                  */
 /*                                                                   */
 dcl TYPE_E_CANTLOADLIBRARY           fixed bin(31) value('80029C4A'xn);

 /*                                                                   */
 /* MessageId: TYPE_E_INCONSISTENTPROPFUNCS                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Inconsistent property functions.                                 */
 /*                                                                   */
 dcl TYPE_E_INCONSISTENTPROPFUNCS     fixed bin(31) value('80029C83'xn);

 /*                                                                   */
 /* MessageId: TYPE_E_CIRCULARTYPE                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Circular dependency between types/modules.                       */
 /*                                                                   */
 dcl TYPE_E_CIRCULARTYPE              fixed bin(31) value('80029C84'xn);

 /*********************************************************************/
 /*                                                                   */
 /* FACILITY_STORAGE                                                  */
 /*                                                                   */
 /*********************************************************************/
 /*                                                                   */
 /* MessageId: STG_E_INVALIDFUNCTION                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to perform requested operation.                           */
 /*                                                                   */
 dcl STG_E_INVALIDFUNCTION            fixed bin(31) value('80030001'xn);

 /*                                                                   */
 /* MessageId: STG_E_FILENOTFOUND                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  %1 could not be found.                                           */
 /*                                                                   */
 dcl STG_E_FILENOTFOUND               fixed bin(31) value('80030002'xn);

 /*                                                                   */
 /* MessageId: STG_E_PATHNOTFOUND                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The path %1 could not be found.                                  */
 /*                                                                   */
 dcl STG_E_PATHNOTFOUND               fixed bin(31) value('80030003'xn);

 /*                                                                   */
 /* MessageId: STG_E_TOOMANYOPENFILES                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There are insufficient resources to open another file.           */
 /*                                                                   */
 dcl STG_E_TOOMANYOPENFILES           fixed bin(31) value('80030004'xn);

 /*                                                                   */
 /* MessageId: STG_E_ACCESSDENIED                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Access Denied.                                                   */
 /*                                                                   */
 dcl STG_E_ACCESSDENIED               fixed bin(31) value('80030005'xn);

 /*                                                                   */
 /* MessageId: STG_E_INVALIDHANDLE                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Attempted an operation on an invalid object.                     */
 /*                                                                   */
 dcl STG_E_INVALIDHANDLE              fixed bin(31) value('80030006'xn);

 /*                                                                   */
 /* MessageId: STG_E_INSUFFICIENTMEMORY                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There is insufficient memory available to complete operation.    */
 /*                                                                   */
 dcl STG_E_INSUFFICIENTMEMORY         fixed bin(31) value('80030008'xn);

 /*                                                                   */
 /* MessageId: STG_E_INVALIDPOINTER                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid pointer error.                                           */
 /*                                                                   */
 dcl STG_E_INVALIDPOINTER             fixed bin(31) value('80030009'xn);

 /*                                                                   */
 /* MessageId: STG_E_NOMOREFILES                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There are no more entries to return.                             */
 /*                                                                   */
 dcl STG_E_NOMOREFILES                fixed bin(31) value('80030012'xn);

 /*                                                                   */
 /* MessageId: STG_E_DISKISWRITEPROTECTED                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Disk is write-protected.                                         */
 /*                                                                   */
 dcl STG_E_DISKISWRITEPROTECTED       fixed bin(31) value('80030013'xn);

 /*                                                                   */
 /* MessageId: STG_E_SEEKERROR                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An error occurred during a seek operation.                       */
 /*                                                                   */
 dcl STG_E_SEEKERROR                  fixed bin(31) value('80030019'xn);

 /*                                                                   */
 /* MessageId: STG_E_WRITEFAULT                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A disk error occurred during a write operation.                  */
 /*                                                                   */
 dcl STG_E_WRITEFAULT                 fixed bin(31) value('8003001D'xn);

 /*                                                                   */
 /* MessageId: STG_E_READFAULT                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A disk error occurred during a read operation.                   */
 /*                                                                   */
 dcl STG_E_READFAULT                  fixed bin(31) value('8003001E'xn);

 /*                                                                   */
 /* MessageId: STG_E_SHAREVIOLATION                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A share violation has occurred.                                  */
 /*                                                                   */
 dcl STG_E_SHAREVIOLATION             fixed bin(31) value('80030020'xn);

 /*                                                                   */
 /* MessageId: STG_E_LOCKVIOLATION                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A lock violation has occurred.                                   */
 /*                                                                   */
 dcl STG_E_LOCKVIOLATION              fixed bin(31) value('80030021'xn);

 /*                                                                   */
 /* MessageId: STG_E_FILEALREADYEXISTS                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  %1 already exists.                                               */
 /*                                                                   */
 dcl STG_E_FILEALREADYEXISTS          fixed bin(31) value('80030050'xn);

 /*                                                                   */
 /* MessageId: STG_E_INVALIDPARAMETER                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid parameter error.                                         */
 /*                                                                   */
 dcl STG_E_INVALIDPARAMETER           fixed bin(31) value('80030057'xn);

 /*                                                                   */
 /* MessageId: STG_E_MEDIUMFULL                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There is insufficient disk space to complete operation.          */
 /*                                                                   */
 dcl STG_E_MEDIUMFULL                 fixed bin(31) value('80030070'xn);

 /*                                                                   */
 /* MessageId: STG_E_PROPSETMISMATCHED                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Illegal write of non-simple property to simple property set.     */
 /*                                                                   */
 dcl STG_E_PROPSETMISMATCHED         fixed bin (31) value('800300F0'xn);

 /*                                                                   */
 /* MessageId: STG_E_ABNORMALAPIEXIT                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An API call exited abnormally.                                   */
 /*                                                                   */
 dcl STG_E_ABNORMALAPIEXIT            fixed bin(31) value('800300FA'xn);

 /*                                                                   */
 /* MessageId: STG_E_INVALIDHEADER                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file %1 is not a valid compound file.                        */
 /*                                                                   */
 dcl STG_E_INVALIDHEADER              fixed bin(31) value('800300FB'xn);

 /*                                                                   */
 /* MessageId: STG_E_INVALIDNAME                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The name %1 is not valid.                                        */
 /*                                                                   */
 dcl STG_E_INVALIDNAME                fixed bin(31) value('800300FC'xn);

 /*                                                                   */
 /* MessageId: STG_E_UNKNOWN                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An unexpected error occurred.                                    */
 /*                                                                   */
 dcl STG_E_UNKNOWN                    fixed bin(31) value('800300FD'xn);

 /*                                                                   */
 /* MessageId: STG_E_UNIMPLEMENTEDFUNCTION                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  That function is not implemented.                                */
 /*                                                                   */
 dcl STG_E_UNIMPLEMENTEDFUNCTION      fixed bin(31) value('800300FE'xn);

 /*                                                                   */
 /* MessageId: STG_E_INVALIDFLAG                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid flag error.                                              */
 /*                                                                   */
 dcl STG_E_INVALIDFLAG                fixed bin(31) value('800300FF'xn);

 /*                                                                   */
 /* MessageId: STG_E_INUSE                                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Attempted to use an object that is busy.                         */
 /*                                                                   */
 dcl STG_E_INUSE                      fixed bin(31) value('80030100'xn);

 /*                                                                   */
 /* MessageId: STG_E_NOTCURRENT                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The storage has been changed since the last commit.              */
 /*                                                                   */
 dcl STG_E_NOTCURRENT                 fixed bin(31) value('80030101'xn);

 /*                                                                   */
 /* MessageId: STG_E_REVERTED                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Attempted to use an object that has ceased to exist.             */
 /*                                                                   */
 dcl STG_E_REVERTED                   fixed bin(31) value('80030102'xn);

 /*                                                                   */
 /* MessageId: STG_E_CANTSAVE                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Can't save.                                                      */
 /*                                                                   */
 dcl STG_E_CANTSAVE                   fixed bin(31) value('80030103'xn);

 /*                                                                   */
 /* MessageId: STG_E_OLDFORMAT                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The compound file %1 was produced with an                        */
 /* incompatible version of storage.                                  */
 /*                                                                   */
 dcl STG_E_OLDFORMAT                  fixed bin(31) value('80030104'xn);

 /*                                                                   */
 /* MessageId: STG_E_OLDDLL                                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The compound file %1 was produced with a newer                   */
 /* version of storage.                                               */
 /*                                                                   */
 dcl STG_E_OLDDLL                     fixed bin(31) value('80030105'xn);

 /*                                                                   */
 /* MessageId: STG_E_SHAREREQUIRED                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Share.exe or equivalent is required for operation.               */
 /*                                                                   */
 dcl STG_E_SHAREREQUIRED              fixed bin(31) value('80030106'xn);

 /*                                                                   */
 /* MessageId: STG_E_NOTFILEBASEDSTORAGE                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Illegal operation called on non-file based storage.              */
 /*                                                                   */
 dcl STG_E_NOTFILEBASEDSTORAGE        fixed bin(31) value('80030107'xn);

 /*                                                                   */
 /* MessageId: STG_E_EXTANTMARSHALLINGS                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Illegal operation called on object with extant marshallings.     */
 /*                                                                   */
 dcl STG_E_EXTANTMARSHALLINGS         fixed bin(31) value('80030108'xn);

 /*                                                                   */
 /* MessageId: STG_E_DOCFILECORRUPT                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The docfile has been corrupted.                                  */
 /*                                                                   */
 dcl STG_E_DOCFILECORRUPT             fixed bin(31) value('80030109'xn);

 /*                                                                   */
 /* MessageId: STG_E_BADBASEADDRESS                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OLE32.DLL has been loaded at the wrong address.                  */
 /*                                                                   */
 dcl STG_E_BADBASEADDRESS             fixed bin(31) value('80030110'xn);

 /*                                                                   */
 /* MessageId: STG_E_INCOMPLETE                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file download was aborted abnormally.                        */
 /*  The file is incomplete.                                          */
 /*                                                                   */
 dcl STG_E_INCOMPLETE                 fixed bin(31) value('80030201'xn);

 /*                                                                   */
 /* MessageId: STG_E_TERMINATED                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file download has been terminated.                           */
 /*                                                                   */
 dcl STG_E_TERMINATED                 fixed bin(31) value('80030202'xn);

 /*                                                                   */
 /* MessageId: STG_S_CONVERTED                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The underlying file was converted to compound file format.       */
 /*                                                                   */
 dcl STG_S_CONVERTED                  fixed bin(31) value('00030200'xn);

 /*                                                                   */
 /* MessageId: STG_S_BLOCK                                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The storage operation should block until more data is available. */
 /*                                                                   */
 dcl STG_S_BLOCK                      fixed bin(31) value('00030201'xn);

 /*                                                                   */
 /* MessageId: STG_S_RETRYNOW                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The storage operation should retry immediately.                  */
 /*                                                                   */
 dcl STG_S_RETRYNOW                   fixed bin(31) value('00030202'xn);

 /*                                                                   */
 /* MessageId: STG_S_MONITORING                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The notified event sink will not influence                       */
 /*  the storage operation.                                           */
 /*                                                                   */
 dcl STG_S_MONITORING                 fixed bin(31) value('00030203'xn);

 /*                                                                   */
 /* MessageId: STG_S_MULTIPLEOPENS                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Multiple opens prevent consolidated. (commit succeeded).         */
 /*                                                                   */
 dcl STG_S_MULTIPLEOPENS              fixed bin(31) value('00030204'xn);

 /*                                                                   */
 /* MessageId: STG_S_CONSOLIDATIONFAILED                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Consolidation of the storage file failed. (commit succeeded).    */
 /*                                                                   */
 dcl STG_S_CONSOLIDATIONFAILED        fixed bin(31) value('00030205'xn);

 /*                                                                   */
 /* MessageId: STG_S_CANNOTCONSOLIDATE                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Consolidation of the storage file is inappropriate.              */
 /*  (commit succeeded).                                              */
 /*                                                                   */
 dcl STG_S_CANNOTCONSOLIDATE          fixed bin(31) value('00030206'xn);


 /*********************************************************************/
 /*                                                                   */
 /* FACILITY_RPC                                                      */
 /*                                                                   */
 /*********************************************************************/
 /*                                                                   */
 /* Codes 0x0-0x11 are propogated from 16 bit OLE.                    */
 /*                                                                   */

 /*                                                                   */
 /* MessageId: RPC_E_CALL_REJECTED                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Call was rejected by callee.                                     */
 /*                                                                   */
 dcl RPC_E_CALL_REJECTED              fixed bin(31) value('80010001'xn);

 /*                                                                   */
 /* MessageId: RPC_E_CALL_CANCELED                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Call was canceled by the message filter.                         */
 /*                                                                   */
 dcl RPC_E_CALL_CANCELED              fixed bin(31) value('80010002'xn);

 /*                                                                   */
 /* MessageId: RPC_E_CANTPOST_INSENDCALL                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The caller is dispatching an intertask SendMessage call and      */
 /*  cannot call out via PostMessage.                                 */
 /*                                                                   */
 dcl RPC_E_CANTPOST_INSENDCALL        fixed bin(31) value('80010003'xn);

 /*                                                                   */
 /* MessageId: RPC_E_CANTCALLOUT_INASYNCCALL                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The caller is dispatching an asynchronous call and cannot        */
 /*  make an outgoing call on behalf of this call.                    */
 /*                                                                   */
 dcl RPC_E_CANTCALLOUT_INASYNCCALL    fixed bin(31) value('80010004'xn);

 /*                                                                   */
 /* MessageId: RPC_E_CANTCALLOUT_INEXTERNALCALL                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  It is illegal to call out while inside message filter.           */
 /*                                                                   */
 dcl RPC_E_CANTCALLOU_INEXTERNALCALL  fixed bin(31) value('80010005'xn);

 /*                                                                   */
 /* MessageId: RPC_E_CONNECTION_TERMINATED                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The connection terminated or is in a bogus state and cannot      */
 /*  be used any more. Other connections are still valid.             */
 /*                                                                   */
 dcl RPC_E_CONNECTION_TERMINATED      fixed bin(31) value('80010006'xn);

 /*                                                                   */
 /* MessageId: RPC_E_SERVER_DIED                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The callee (server [not server application]) is not available    */
 /*  and disappeared; all connections are invalid.  The call may      */
 /*  have executed.                                                   */
 /*                                                                   */
 dcl RPC_E_SERVER_DIED                fixed bin(31) value('80010007'xn);

 /*                                                                   */
 /* MessageId: RPC_E_CLIENT_DIED                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The caller (client) disappeared while the callee (server) was    */
 /*  processing a call.                                               */
 /*                                                                   */
 dcl RPC_E_CLIENT_DIED                fixed bin(31) value('80010008'xn);

 /*                                                                   */
 /* MessageId: RPC_E_INVALID_DATAPACKET                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The data packet with the marshalled parameter data is incorrect. */
 /*                                                                   */
 dcl RPC_E_INVALID_DATAPACKET         fixed bin(31) value('80010009'xn);

 /*                                                                   */
 /* MessageId: RPC_E_CANTTRANSMIT_CALL                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The call was not transmitted properly; the message queue         */
 /*  was full and was not emptied after yielding.                     */
 /*                                                                   */
 dcl RPC_E_CANTTRANSMIT_CALL          fixed bin(31) value('8001000A'xn);

 /*                                                                   */
 /* MessageId: RPC_E_CLIENT_CANTMARSHAL_DATA                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The client (caller) cannot marshall the parameter                */
 /* data - low memory, etc.                                           */
 /*                                                                   */
 dcl RPC_E_CLIENT_CANTMARSHAL_DATA    fixed bin(31) value('8001000B'xn);

 /*                                                                   */
 /* MessageId: RPC_E_CLIENT_CANTUNMARSHAL_DATA                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The client (caller) cannot unmarshall the                        */
 /* return data - low memory, etc.                                    */
 /*                                                                   */
 dcl RPC_E_CLIENT_CANTUNMARSHAL_DATA  fixed bin(31) value('8001000C'xn);

 /*                                                                   */
 /* MessageId: RPC_E_SERVER_CANTMARSHAL_DATA                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The server (callee) cannot marshall the                          */
 /*return data - low memory, etc.                                     */
 /*                                                                   */
 dcl RPC_E_SERVER_CANTMARSHAL_DATA    fixed bin(31) value('8001000D'xn);

 /*                                                                   */
 /* MessageId: RPC_E_SERVER_CANTUNMARSHAL_DATA                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The server (callee) cannot unmarshall the                        */
 /*  parameter data - low memory, etc.                                */
 /*                                                                   */
 dcl RPC_E_SERVER_CANTUNMARSHAL_DATA  fixed bin(31) value('8001000E'xn);

 /*                                                                   */
 /* MessageId: RPC_E_INVALID_DATA                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Received data is invalid; could be server or client data.        */
 /*                                                                   */
 dcl RPC_E_INVALID_DATA               fixed bin(31) value('8001000F'xn);

 /*                                                                   */
 /* MessageId: RPC_E_INVALID_PARAMETER                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A particular parameter is invalid and cannot be (un)marshalled.  */
 /*                                                                   */
 dcl RPC_E_INVALID_PARAMETER          fixed bin(31) value('80010010'xn);

 /*                                                                   */
 /* MessageId: RPC_E_CANTCALLOUT_AGAIN                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There is no second outgoing call on same channel in DDE          */
 /* conversation.                                                     */
 /*                                                                   */
 dcl RPC_E_CANTCALLOUT_AGAIN          fixed bin(31) value('80010011'xn);

 /*                                                                   */
 /* MessageId: RPC_E_SERVER_DIED_DNE                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The callee (server [not server application]) is not available    */
 /*  and disappeared; all connections are invalid.                    */
 /*The call did not execute.                                          */
 /*                                                                   */
 dcl RPC_E_SERVER_DIED_DNE            fixed bin(31) value('80010012'xn);

 /*                                                                   */
 /* MessageId: RPC_E_SYS_CALL_FAILED                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  System call failed.                                              */
 /*                                                                   */
 dcl RPC_E_SYS_CALL_FAILED            fixed bin(31) value('80010100'xn);

 /*                                                                   */
 /* MessageId: RPC_E_OUT_OF_RESOURCES                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Could not allocate some required resource (memory, events, ...)  */
 /*                                                                   */
 dcl RPC_E_OUT_OF_RESOURCES           fixed bin(31) value('80010101'xn);

 /*                                                                   */
 /* MessageId: RPC_E_ATTEMPTED_MULTITHREAD                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Attempted to make calls on more than one                         */
 /* thread in single threadedmode.                                    */
 /*                                                                   */
 dcl RPC_E_ATTEMPTED_MULTITHREAD      fixed bin(31) value('80010102'xn);

 /*                                                                   */
 /* MessageId: RPC_E_NOT_REGISTERED                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested interface is not registered on the server object.  */
 /*                                                                   */
 dcl RPC_E_NOT_REGISTERED             fixed bin(31) value('80010103'xn);

 /*                                                                   */
 /* MessageId: RPC_E_FAULT                                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  RPC could not call the server or could not return                */
 /* the results of calling the server.                                */
 /*                                                                   */
 dcl RPC_E_FAULT                      fixed bin(31) value('80010104'xn);

 /*                                                                   */
 /* MessageId: RPC_E_SERVERFAULT                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The server threw an exception.                                   */
 /*                                                                   */
 dcl RPC_E_SERVERFAULT                fixed bin(31) value('80010105'xn);

 /*                                                                   */
 /* MessageId: RPC_E_CHANGED_MODE                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Cannot change thread mode after it is set.                       */
 /*                                                                   */
 dcl RPC_E_CHANGED_MODE               fixed bin(31) value('80010106'xn);

 /*                                                                   */
 /* MessageId: RPC_E_INVALIDMETHOD                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The method called does not exist on the server.                  */
 /*                                                                   */
 dcl RPC_E_INVALIDMETHOD              fixed bin(31) value('80010107'xn);

 /*                                                                   */
 /* MessageId: RPC_E_DISCONNECTED                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The object invoked has disconnected from its clients.            */
 /*                                                                   */
 dcl RPC_E_DISCONNECTED               fixed bin(31) value('80010108'xn);

 /*                                                                   */
 /* MessageId: RPC_E_RETRY                                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The object invoked chose not to process the call now.            */
 /* Try again later.                                                  */
 /*                                                                   */
 dcl RPC_E_RETRY                      fixed bin(31) value('80010109'xn);

 /*                                                                   */
 /* MessageId: RPC_E_SERVERCALL_RETRYLATER                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The message filter indicated that the application is busy.       */
 /*                                                                   */
 dcl RPC_E_SERVERCALL_RETRYLATER      fixed bin(31) value('8001010A'xn);

 /*                                                                   */
 /* MessageId: RPC_E_SERVERCALL_REJECTED                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The message filter rejected the call.                            */
 /*                                                                   */
 dcl RPC_E_SERVERCALL_REJECTED        fixed bin(31) value('8001010B'xn);

 /*                                                                   */
 /* MessageId: RPC_E_INVALID_CALLDATA                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A call control interfaces was called with invalid data.          */
 /*                                                                   */
 dcl RPC_E_INVALID_CALLDATA           fixed bin(31) value('8001010C'xn);

 /*                                                                   */
 /* MessageId: RPC_E_CANTCALLOUT_ININPUTSYNCCALL                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An outgoing call cannot be made since the                        */
 /* application is dispatching an input-synchronous call.             */
 /*                                                                   */
 dcl RPC_E_CANTCALLOUININPUTSYNCCALL  fixed bin(31) value('8001010D'xn);

 /*                                                                   */
 /* MessageId: RPC_E_WRONG_THREAD                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The application called an interface that                         */
 /* was marshalled for a different thread.                            */
 /*                                                                   */
 dcl RPC_E_WRONG_THREAD               fixed bin(31) value('8001010E'xn);

 /*                                                                   */
 /* MessageId: RPC_E_THREAD_NOT_INIT                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  CoInitialize has not been called on the current thread.          */
 /*                                                                   */
 dcl RPC_E_THREAD_NOT_INIT            fixed bin(31) value('8001010F'xn);

 /*                                                                   */
 /* MessageId: RPC_E_VERSION_MISMATCH                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The version of OLE on the client and server machines does not    */
 /*  match.                                                           */
 /*                                                                   */
 dcl RPC_E_VERSION_MISMATCH           fixed bin(31) value('80010110'xn);

 /*                                                                   */
 /* MessageId: RPC_E_INVALID_HEADER                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OLE received a packet with an invalid header.                    */
 /*                                                                   */
 dcl RPC_E_INVALID_HEADER             fixed bin(31) value('80010111'xn);

 /*                                                                   */
 /* MessageId: RPC_E_INVALID_EXTENSION                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OLE received a packet with an invalid extension.                 */
 /*                                                                   */
 dcl RPC_E_INVALID_EXTENSION          fixed bin(31) value('80010112'xn);

 /*                                                                   */
 /* MessageId: RPC_E_INVALID_IPID                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested object or interface does not exist.                */
 /*                                                                   */
 dcl RPC_E_INVALID_IPID               fixed bin(31) value('80010113'xn);

 /*                                                                   */
 /* MessageId: RPC_E_INVALID_OBJECT                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested object does not exist.                             */
 /*                                                                   */
 dcl RPC_E_INVALID_OBJECT             fixed bin(31) value('80010114'xn);

 /*                                                                   */
 /* MessageId: RPC_S_CALLPENDING                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OLE has sent a request and is waiting for a reply.               */
 /*                                                                   */
 dcl RPC_S_CALLPENDING                fixed bin(31) value('80010115'xn);

 /*                                                                   */
 /* MessageId: RPC_S_WAITONTIMER                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OLE is waiting before retrying a request.                        */
 /*                                                                   */
 dcl RPC_S_WAITONTIMER                fixed bin(31) value('80010116'xn);

 /*                                                                   */
 /* MessageId: RPC_E_CALL_COMPLETE                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Call context cannot be accessed after call completed.            */
 /*                                                                   */
 dcl RPC_E_CALL_COMPLETE              fixed bin(31) value('80010117'xn);

 /*                                                                   */
 /* MessageId: RPC_E_UNSECURE_CALL                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Impersonate on unsecure calls is not supported.                  */
 /*                                                                   */
 dcl RPC_E_UNSECURE_CALL              fixed bin(31) value('80010118'xn);

 /*                                                                   */
 /* MessageId: RPC_E_TOO_LATE                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Security must be initialized before any interfaces are marshalled*/
 /*  or unmarshalled.  It cannot be changed once initialized.         */
 /*                                                                   */
 dcl RPC_E_TOO_LATE                   fixed bin(31) value('80010119'xn);

 /*                                                                   */
 /* MessageId: RPC_E_NO_GOOD_SECURITY_PACKAGES                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No security packages are installed on this machine or the user   */
 /*  is not logged on or there are no compatible security packages    */
 /*  between the client and server.                                   */
 /*                                                                   */
 dcl RPC_E_NO_GOOD_SECURITY_PACKAGES  fixed bin(31) value('8001011A'xn);

 /*                                                                   */
 /* MessageId: RPC_E_ACCESS_DENIED                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Access is denied.                                                */
 /*                                                                   */
 dcl RPC_E_ACCESS_DENIED              fixed bin(31) value('8001011B'xn);

 /*                                                                   */
 /* MessageId: RPC_E_REMOTE_DISABLED                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Remote calls are not allowed for this process.                   */
 /*                                                                   */
 dcl RPC_E_REMOTE_DISABLED            fixed bin(31) value('8001011C'xn);

 /*                                                                   */
 /* MessageId: RPC_E_INVALID_OBJREF                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The marshaled interface data packet (OBJREF) has an invalid      */
 /*  or unknown format.                                               */
 /*                                                                   */
 dcl RPC_E_INVALID_OBJREF             fixed bin(31) value('8001011D'xn);

 /*                                                                   */
 /* MessageId: RPC_E_NO_CONTEXT                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No context is associated with this call.  This happens for some  */
 /*  custom marshalled calls and on the client side of the call.      */
 /*                                                                   */
 dcl RPC_E_NO_CONTEXT                 fixed bin(31) value('8001011E'xn);

 /*                                                                   */
 /* MessageId: RPC_E_TIMEOUT                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This operation returned because the timeout period expired.      */
 /*                                                                   */
 dcl RPC_E_TIMEOUT                    fixed bin(31) value('8001011F'xn);

 /*                                                                   */
 /* MessageId: RPC_E_NO_SYNC                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There are no synchronize objects to wait on.                     */
 /*                                                                   */
 dcl RPC_E_NO_SYNC                    fixed bin(31) value('80010120'xn);


 /*                                                                   */
 /* MessageId: RPC_E_UNEXPECTED                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An internal error occurred.                                      */
 /*                                                                   */
 dcl RPC_E_UNEXPECTED                 fixed bin(31) value('8001FFFF'xn);

 /*********************************************************************/
 /*                                                                   */
 /* FACILITY_SSPI                                                     */
 /*                                                                   */
 /*********************************************************************/

 /*                                                                   */
 /* MessageId: NTE_BAD_UID                                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Bad UID.                                                         */
 /*                                                                   */
 dcl NTE_BAD_UID                      fixed bin(31) value('80090001'xn);

 /*                                                                   */
 /* MessageId: NTE_BAD_HASH                                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Bad Hash.                                                        */
 /*                                                                   */
 dcl NTE_BAD_HASH                     fixed bin(31) value('80090002'xn);

 /*                                                                   */
 /* MessageId: NTE_BAD_KEY                                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Bad Key.                                                         */
 /*                                                                   */
 dcl NTE_BAD_KEY                      fixed bin(31) value('80090003'xn);

 /*                                                                   */
 /* MessageId: NTE_BAD_LEN                                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Bad Length.                                                      */
 /*                                                                   */
 dcl NTE_BAD_LEN                      fixed bin(31) value('80090004'xn);

 /*                                                                   */
 /* MessageId: NTE_BAD_DATA                                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Bad Data.                                                        */
 /*                                                                   */
 dcl NTE_BAD_DATA                     fixed bin(31) value('80090005'xn);

 /*                                                                   */
 /* MessageId: NTE_BAD_SIGNATURE                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid Signature.                                               */
 /*                                                                   */
 dcl NTE_BAD_SIGNATURE                fixed bin(31) value('80090006'xn);

 /*                                                                   */
 /* MessageId: NTE_BAD_VER                                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Bad Version of provider.                                         */
 /*                                                                   */
 dcl NTE_BAD_VER                      fixed bin(31) value('80090007'xn);

 /*                                                                   */
 /* MessageId: NTE_BAD_ALGID                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid algorithm specified.                                     */
 /*                                                                   */
 dcl NTE_BAD_ALGID                    fixed bin(31) value('80090008'xn);

 /*                                                                   */
 /* MessageId: NTE_BAD_FLAGS                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid flags specified.                                         */
 /*                                                                   */
 dcl NTE_BAD_FLAGS                    fixed bin(31) value('80090009'xn);

 /*                                                                   */
 /* MessageId: NTE_BAD_TYPE                                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid type specified.                                          */
 /*                                                                   */
 dcl NTE_BAD_TYPE                     fixed bin(31) value('8009000A'xn);

 /*                                                                   */
 /* MessageId: NTE_BAD_KEY_STATE                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Key not valid for use in specified state.                        */
 /*                                                                   */
 dcl NTE_BAD_KEY_STATE                fixed bin(31) value('8009000B'xn);

 /*                                                                   */
 /* MessageId: NTE_BAD_HASH_STATE                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Hash not valid for use in specified state.                       */
 /*                                                                   */
 dcl NTE_BAD_HASH_STATE               fixed bin(31) value('8009000C'xn);

 /*                                                                   */
 /* MessageId: NTE_NO_KEY                                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Key does not exist.                                              */
 /*                                                                   */
 dcl NTE_NO_KEY                       fixed bin(31) value('8009000D'xn);

 /*                                                                   */
 /* MessageId: NTE_NO_MEMORY                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Insufficient memory available for the operation.                 */
 /*                                                                   */
 dcl NTE_NO_MEMORY                    fixed bin(31) value('8009000E'xn);

 /*                                                                   */
 /* MessageId: NTE_EXISTS                                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Object already exists.                                           */
 /*                                                                   */
 dcl NTE_EXISTS                       fixed bin(31) value('8009000F'xn);

 /*                                                                   */
 /* MessageId: NTE_PERM                                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Access denied.                                                   */
 /*                                                                   */
 dcl NTE_PERM                         fixed bin(31) value('80090010'xn);

 /*                                                                   */
 /* MessageId: NTE_NOT_FOUND                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Object was not found.                                            */
 /*                                                                   */
 dcl NTE_NOT_FOUND                    fixed bin(31) value('80090011'xn);

 /*                                                                   */
 /* MessageId: NTE_DOUBLE_ENCRYPT                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Data already encrypted.                                          */
 /*                                                                   */
 dcl NTE_DOUBLE_ENCRYPT               fixed bin(31) value('80090012'xn);

 /*                                                                   */
 /* MessageId: NTE_BAD_PROVIDER                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid provider specified.                                      */
 /*                                                                   */
 dcl NTE_BAD_PROVIDER                 fixed bin(31) value('80090013'xn);

 /*                                                                   */
 /* MessageId: NTE_BAD_PROV_TYPE                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid provider type specified.                                 */
 /*                                                                   */
 dcl NTE_BAD_PROV_TYPE                fixed bin(31) value('80090014'xn);

 /*                                                                   */
 /* MessageId: NTE_BAD_PUBLIC_KEY                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Provider's public key is invalid.                                */
 /*                                                                   */
 dcl NTE_BAD_PUBLIC_KEY               fixed bin(31) value('80090015'xn);

 /*                                                                   */
 /* MessageId: NTE_BAD_KEYSET                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Keyset does not exist                                            */
 /*                                                                   */
 dcl NTE_BAD_KEYSET                   fixed bin(31) value('80090016'xn);

 /*                                                                   */
 /* MessageId: NTE_PROV_TYPE_NOT_DEF                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Provider type not defined.                                       */
 /*                                                                   */
 dcl NTE_PROV_TYPE_NOT_DEF            fixed bin(31) value('80090017'xn);

 /*                                                                   */
 /* MessageId: NTE_PROV_TYPE_ENTRY_BAD                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Provider type as registered is invalid.                          */
 /*                                                                   */
 dcl NTE_PROV_TYPE_ENTRY_BAD          fixed bin(31) value('80090018'xn);

 /*                                                                   */
 /* MessageId: NTE_KEYSET_NOT_DEF                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The keyset is not defined.                                       */
 /*                                                                   */
 dcl NTE_KEYSET_NOT_DEF               fixed bin(31) value('80090019'xn);

 /*                                                                   */
 /* MessageId: NTE_KEYSET_ENTRY_BAD                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Keyset as registered is invalid.                                 */
 /*                                                                   */
 dcl NTE_KEYSET_ENTRY_BAD             fixed bin(31) value('8009001A'xn);

 /*                                                                   */
 /* MessageId: NTE_PROV_TYPE_NO_MATCH                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Provider type does not match registered value.                   */
 /*                                                                   */
 dcl NTE_PROV_TYPE_NO_MATCH           fixed bin(31) value('8009001B'xn);

 /*                                                                   */
 /* MessageId: NTE_SIGNATURE_FILE_BAD                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The digital signature file is corrupt.                           */
 /*                                                                   */
 dcl NTE_SIGNATURE_FILE_BAD           fixed bin(31) value('8009001C'xn);

 /*                                                                   */
 /* MessageId: NTE_PROVIDER_DLL_FAIL                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Provider DLL failed to initialize correctly.                     */
 /*                                                                   */
 dcl NTE_PROVIDER_DLL_FAIL            fixed bin(31) value('8009001D'xn);

 /*                                                                   */
 /* MessageId: NTE_PROV_DLL_NOT_FOUND                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Provider DLL could not be found.                                 */
 /*                                                                   */
 dcl NTE_PROV_DLL_NOT_FOUND           fixed bin(31) value('8009001E'xn);

 /*                                                                   */
 /* MessageId: NTE_BAD_KEYSET_PARAM                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The Keyset parameter is invalid.                                 */
 /*                                                                   */
 dcl NTE_BAD_KEYSET_PARAM             fixed bin(31) value('8009001F'xn);

 /*                                                                   */
 /* MessageId: NTE_FAIL                                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An internal error occurred.                                      */
 /*                                                                   */
 dcl NTE_FAIL                         fixed bin(31) value('80090020'xn);

 /*                                                                   */
 /* MessageId: NTE_SYS_ERR                                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A base error occurred.                                           */
 /*                                                                   */
 dcl NTE_SYS_ERR                      fixed bin(31) value('80090021'xn);

 /*                                                                   */
 /* MessageId: NTE_SILENT_CONTEXT                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Provider could not perform the action since the context was      */
 /*  acquired as silent.                                              */
 /*                                                                   */
 dcl NTE_SILENT_CONTEXT               fixed bin(31) value('80090022'xn);

 /*                                                                   */
 /* MessageId: NTE_TOKEN_KEYSET_STORAGE_FULL                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The security token does not have storage space available for an  */
 /*  additional container.                                            */
 /*                                                                   */
 dcl NTE_TOKEN_KEYSET_STORAGE_FULL    fixed bin(31) value('80090023'xn);

 /*                                                                   */
 /* MessageId: NTE_TEMPORARY_PROFILE                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The profile for the user is a temporary profile.                 */
 /*                                                                   */
 dcl NTE_TEMPORARY_PROFILE            fixed bin(31) value('80090024'xn);

 /*                                                                   */
 /* MessageId: NTE_FIXEDPARAMETER                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The key parameters could not be set because the CSP uses fixed   */
 /*  parameters.                                                      */
 /*                                                                   */
 dcl NTE_FIXEDPARAMETER               fixed bin(31) value('80090025'xn);

 /*                                                                   */
 /* MessageId: SEC_E_INSUFFICIENT_MEMORY                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Not enough memory is available to complete this request          */
 /*                                                                   */
 dcl SEC_E_INSUFFICIENT_MEMORY        fixed bin(31) value('80090300'xn);

 /*                                                                   */
 /* MessageId: SEC_E_INVALID_HANDLE                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The handle specified is invalid                                  */
 /*                                                                   */
 dcl SEC_E_INVALID_HANDLE             fixed bin(31) value('80090301'xn);

 /*                                                                   */
 /* MessageId: SEC_E_UNSUPPORTED_FUNCTION                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The function requested is not supported                          */
 /*                                                                   */
 dcl SEC_E_UNSUPPORTED_FUNCTION       fixed bin(31) value('80090302'xn);

 /*                                                                   */
 /* MessageId: SEC_E_TARGET_UNKNOWN                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified target is unknown or unreachable                   */
 /*                                                                   */
 dcl SEC_E_TARGET_UNKNOWN             fixed bin(31) value('80090303'xn);

 /*                                                                   */
 /* MessageId: SEC_E_INTERNAL_ERROR                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The Local Security Authority cannot be contacted                 */
 /*                                                                   */
 dcl SEC_E_INTERNAL_ERROR             fixed bin(31) value('80090304'xn);

 /*                                                                   */
 /* MessageId: SEC_E_SECPKG_NOT_FOUND                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested security package does not exist                    */
 /*                                                                   */
 dcl SEC_E_SECPKG_NOT_FOUND           fixed bin(31) value('80090305'xn);

 /*                                                                   */
 /* MessageId: SEC_E_NOT_OWNER                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The caller is not the owner of the desired credentials           */
 /*                                                                   */
 dcl SEC_E_NOT_OWNER                  fixed bin(31) value('80090306'xn);

 /*                                                                   */
 /* MessageId: SEC_E_CANNOT_INSTALL                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The security package failed to initialize, and cannot be         */
 /* installed                                                         */
 /*                                                                   */
 dcl SEC_E_CANNOT_INSTALL             fixed bin(31) value('80090307'xn);

 /*                                                                   */
 /* MessageId: SEC_E_INVALID_TOKEN                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The token supplied to the function is invalid                    */
 /*                                                                   */
 dcl SEC_E_INVALID_TOKEN              fixed bin(31) value('80090308'xn);

 /*                                                                   */
 /* MessageId: SEC_E_CANNOT_PACK                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The security package is not able to marshall the logon buffer,   */
 /*  so the logon attempt has failed                                  */
 /*                                                                   */
 dcl SEC_E_CANNOT_PACK                fixed bin(31) value('80090309'xn);

 /*                                                                   */
 /* MessageId: SEC_E_QOP_NOT_SUPPORTED                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The per-message Quality of Protection is not supported by the    */
 /*  security package                                                 */
 /*                                                                   */
 dcl SEC_E_QOP_NOT_SUPPORTED          fixed bin(31) value('8009030A'xn);

 /*                                                                   */
 /* MessageId: SEC_E_NO_IMPERSONATION                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The security context does not allow impersonation of the client  */
 /*                                                                   */
 dcl SEC_E_NO_IMPERSONATION           fixed bin(31) value('8009030B'xn);

 /*                                                                   */
 /* MessageId: SEC_E_LOGON_DENIED                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The logon attempt failed                                         */
 /*                                                                   */
 dcl SEC_E_LOGON_DENIED               fixed bin(31) value('8009030C'xn);

 /*                                                                   */
 /* MessageId: SEC_E_UNKNOWN_CREDENTIALS                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The credentials supplied to the package were not                 */
 /*  recognized                                                       */
 /*                                                                   */
 dcl SEC_E_UNKNOWN_CREDENTIALS        fixed bin(31) value('8009030D'xn);

 /*                                                                   */
 /* MessageId: SEC_E_NO_CREDENTIALS                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No credentials are available in the security package             */
 /*                                                                   */
 dcl SEC_E_NO_CREDENTIALS             fixed bin(31) value('8009030E'xn);

 /*                                                                   */
 /* MessageId: SEC_E_MESSAGE_ALTERED                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The message or signature supplied for verification has been      */
 /*  altered                                                          */
 /*                                                                   */
 dcl SEC_E_MESSAGE_ALTERED            fixed bin(31) value('8009030F'xn);

 /*                                                                   */
 /* MessageId: SEC_E_OUT_OF_SEQUENCE                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The message supplied for verification is out of sequence         */
 /*                                                                   */
 dcl SEC_E_OUT_OF_SEQUENCE            fixed bin(31) value('80090310'xn);

 /*                                                                   */
 /* MessageId: SEC_E_NO_AUTHENTICATING_AUTHORITY                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No authority could be contacted for authentication.              */
 /*                                                                   */
 dcl SEC_E_NO_AUTHENTICATING_AUTHORITY
                                      fixed bin(31) value('80090311'xn);

 /*                                                                   */
 /* MessageId: SEC_I_CONTINUE_NEEDED                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The function completed successfully, but must be called          */
 /*  again to complete the context                                    */
 /*                                                                   */
 dcl SEC_I_CONTINUE_NEEDED            fixed bin(31) value('00090312'xn);

 /*                                                                   */
 /* MessageId: SEC_I_COMPLETE_NEEDED                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The function completed successfully, but CompleteToken           */
 /*  must be called                                                   */
 /*                                                                   */
 dcl SEC_I_COMPLETE_NEEDED            fixed bin(31) value('00090313'xn);

 /*                                                                   */
 /* MessageId: SEC_I_COMPLETE_AND_CONTINUE                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The function completed successfully, but both CompleteToken and  */
 /*  this function must be called to complete the context             */
 /*                                                                   */
 dcl SEC_I_COMPLETE_AND_CONTINUE      fixed bin(31) value('00090314'xn);

 /*                                                                   */
 /* MessageId: SEC_I_LOCAL_LOGON                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The logon was completed, but no network authority was available. */
 /*  The logon was made using locally known information               */
 /*                                                                   */
 dcl SEC_I_LOCAL_LOGON                fixed bin(31) value('00090315'xn);

 /*                                                                   */
 /* MessageId: SEC_E_BAD_PKGID                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested security package does not exist                    */
 /*                                                                   */
 dcl SEC_E_BAD_PKGID                  fixed bin(31) value('80090316'xn);

 /*                                                                   */
 /* MessageId: SEC_E_CONTEXT_EXPIRED                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The context has expired and can no longer be used.               */
 /*                                                                   */
 dcl SEC_E_CONTEXT_EXPIRED            fixed bin(31) value('80090317'xn);

 /*                                                                   */
 /* MessageId: SEC_E_INCOMPLETE_MESSAGE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The supplied message is incomplete.                              */
 /* The signature was not verified.                                   */
 /*                                                                   */
 dcl SEC_E_INCOMPLETE_MESSAGE         fixed bin(31) value('80090318'xn);

 /*                                                                   */
 /* MessageId: SEC_E_INCOMPLETE_CREDENTIALS                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The credentials supplied were not complete, and could not        */
 /*  be verified. The context could not be initialized.               */
 /*                                                                   */
 dcl SEC_E_INCOMPLETE_CREDENTIALS     fixed bin(31) value('80090320'xn);

 /*                                                                   */
 /* MessageId: SEC_E_BUFFER_TOO_SMALL                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The buffers supplied to a function was too small.                */
 /*                                                                   */
 dcl SEC_E_BUFFER_TOO_SMALL           fixed bin(31) value('80090321'xn);

 /*                                                                   */
 /* MessageId: SEC_I_INCOMPLETE_CREDENTIALS                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The credentials supplied were not complete, and could not        */
 /*  be verified. Additional information can be returned from         */
 /*  the context.                                                     */
 /*                                                                   */
 dcl SEC_I_INCOMPLETE_CREDENTIALS     fixed bin(31) value('00090320'xn);

 /*                                                                   */
 /* MessageId: SEC_I_RENEGOTIATE                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The context data must be renegotiated with the peer.             */
 /*                                                                   */
 dcl SEC_I_RENEGOTIATE                fixed bin(31) value('00090321'xn);

 /*                                                                   */
 /* MessageId: SEC_E_WRONG_PRINCIPAL                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The target principal name is incorrect.                          */
 /*                                                                   */
 dcl SEC_E_WRONG_PRINCIPAL            fixed bin(31) value('80090322'xn);

 /*                                                                   */
 /* MessageId: SEC_I_NO_LSA_CONTEXT                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There is no LSA mode context associated with this context.       */
 /*                                                                   */
 dcl SEC_I_NO_LSA_CONTEXT             fixed bin(31) value('00090323'xn);

 /*                                                                   */
 /* MessageId: SEC_E_TIME_SKEW                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The clocks on the client and server machines are skewed.         */
 /*                                                                   */
 dcl SEC_E_TIME_SKEW                  fixed bin(31) value('80090324'xn);

 /*                                                                   */
 /* MessageId: SEC_E_UNTRUSTED_ROOT                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The certificate chain was issued by an untrusted authority.      */
 /*                                                                   */
 dcl SEC_E_UNTRUSTED_ROOT             fixed bin(31) value('80090325'xn);

 /*                                                                   */
 /* MessageId: SEC_E_ILLEGAL_MESSAGE                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The message received was unexpected or badly formatted.          */
 /*                                                                   */
 dcl SEC_E_ILLEGAL_MESSAGE            fixed bin(31) value('80090326'xn);

 /*                                                                   */
 /* MessageId: SEC_E_CERT_UNKNOWN                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An unknown error occurred while processing the certificate.      */
 /*                                                                   */
 dcl SEC_E_CERT_UNKNOWN               fixed bin(31) value('80090327'xn);

 /*                                                                   */
 /* MessageId: SEC_E_CERT_EXPIRED                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The received certificate has expired.                            */
 /*                                                                   */
 dcl SEC_E_CERT_EXPIRED               fixed bin(31) value('80090328'xn);

 /*                                                                   */
 /* MessageId: SEC_E_ENCRYPT_FAILURE                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified data could not be encrypted.                       */
 /*                                                                   */
 dcl SEC_E_ENCRYPT_FAILURE            fixed bin(31) value('80090329'xn);

 /*                                                                   */
 /* MessageId: SEC_E_DECRYPT_FAILURE                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified data could not be decrypted.                       */
 /*                                                                   */
 /*                                                                   */
 dcl SEC_E_DECRYPT_FAILURE            fixed bin(31) value('80090330'xn);

 /*                                                                   */
 /* MessageId: SEC_E_ALGORITHM_MISMATCH                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The client and server cannot communicate, because they do not    */
 /*  possess a common algorithm.                                      */
 /*                                                                   */
 dcl SEC_E_ALGORITHM_MISMATCH         fixed bin(31) value('80090331'xn);

 /*                                                                   */
 /* MessageId: SEC_E_SECURITY_QOS_FAILED                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The security context could not be established due to a failure   */
 /*  in the requested quality of service (e.g. mutual authentication  */
 /*  or delegation).                                                  */
 /*                                                                   */
 dcl SEC_E_SECURITY_QOS_FAILED        fixed bin(31) value('80090332'xn);

 /*                                                                   */
 /* Provided for backwards compatibility                              */
 /*                                                                   */

 dcl SEC_E_NO_SPM       fixed bin(31) value(SEC_E_INTERNAL_ERROR);
 dcl SEC_E_NOT_SUPPORTED
                        fixed bin(31) value(SEC_E_UNSUPPORTED_FUNCTION);

 /*                                                                   */
 /* MessageId: CRYPT_E_MSG_ERROR                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An error was encountered doing a cryptographic message operation.*/
 /*                                                                   */
 dcl CRYPT_E_MSG_ERROR                fixed bin(31) value('80091001'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_UNKNOWN_ALGO                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cryptographic algorithm is unknown.                          */
 /*                                                                   */
 dcl CRYPT_E_UNKNOWN_ALGO             fixed bin(31) value('80091002'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_OID_FORMAT                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The object identifier is badly formatted.                        */
 /*                                                                   */
 dcl CRYPT_E_OID_FORMAT               fixed bin(31) value('80091003'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_INVALID_MSG_TYPE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The message type is invalid.                                     */
 /*                                                                   */
 dcl CRYPT_E_INVALID_MSG_TYPE         fixed bin(31) value('80091004'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_UNEXPECTED_ENCODING                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The message is not encoded as expected.                          */
 /*                                                                   */
 dcl CRYPT_E_UNEXPECTED_ENCODING      fixed bin(31) value('80091005'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_AUTH_ATTR_MISSING                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The message does not contain an expected authenticated attribute.*/
 /*                                                                   */
 dcl CRYPT_E_AUTH_ATTR_MISSING        fixed bin(31) value('80091006'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_HASH_VALUE                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The hash value is not correct.                                   */
 /*                                                                   */
 dcl CRYPT_E_HASH_VALUE               fixed bin(31) value('80091007'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_INVALID_INDEX                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The index value is not valid.                                    */
 /*                                                                   */
 dcl CRYPT_E_INVALID_INDEX            fixed bin(31) value('80091008'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_ALREADY_DECRYPTED                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The message content has already been decrypted.                  */
 /*                                                                   */
 dcl CRYPT_E_ALREADY_DECRYPTED        fixed bin(31) value('80091009'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_NOT_DECRYPTED                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The message content has not been decrypted yet.                  */
 /*                                                                   */
 dcl CRYPT_E_NOT_DECRYPTED            fixed bin(31) value('8009100A'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_RECIPIENT_NOT_FOUND                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The enveloped-data message does not contain the specified        */
 /*  recipient.                                                       */
 /*                                                                   */
 dcl CRYPT_E_RECIPIENT_NOT_FOUND      fixed bin(31) value('8009100B'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_CONTROL_TYPE                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The control type is not valid.                                   */
 /*                                                                   */
 dcl CRYPT_E_CONTROL_TYPE             fixed bin(31) value('8009100C'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_ISSUER_SERIALNUMBER                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The issuer and/or serial number are/is not valid.                */
 /*                                                                   */
 dcl CRYPT_E_ISSUER_SERIALNUMBER      fixed bin(31) value('8009100D'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_SIGNER_NOT_FOUND                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The original signer is not found.                                */
 /*                                                                   */
 dcl CRYPT_E_SIGNER_NOT_FOUND         fixed bin(31) value('8009100E'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_ATTRIBUTES_MISSING                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The message does not contain the requested attributes.           */
 /*                                                                   */
 dcl CRYPT_E_ATTRIBUTES_MISSING       fixed bin(31) value('8009100F'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_STREAM_MSG_NOT_READY                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The steamed message is note yet able to return the requested     */
 /*  data.                                                            */
 /*                                                                   */
 dcl CRYPT_E_STREAM_MSG_NOT_READY     fixed bin(31) value('80091010'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_STREAM_INSUFFICIENT_DATA                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The streamed message needs more data before the decode can       */
 /*  complete.                                                        */
 /*                                                                   */
 dcl CRYPT_E_STREAM_INSUFFICIENT_DATA fixed bin(31) value('80091011'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_BAD_LEN                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The length specified for the output data was insufficient.       */
 /*                                                                   */
 dcl CRYPT_E_BAD_LEN                  fixed bin(31) value('80092001'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_BAD_ENCODE                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An error was encountered while encoding or decoding.             */
 /*                                                                   */
 dcl CRYPT_E_BAD_ENCODE               fixed bin(31) value('80092002'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_FILE_ERROR                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An error occurred while reading or writing to the file           */
 /*                                                                   */
 dcl CRYPT_E_FILE_ERROR               fixed bin(31) value('80092003'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_NOT_FOUND                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The object or property wasn't found                              */
 /*                                                                   */
 dcl CRYPT_E_NOT_FOUND                fixed bin(31) value('80092004'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_EXISTS                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The object or property already exists                            */
 /*                                                                   */
 dcl CRYPT_E_EXISTS                   fixed bin(31) value('80092005'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_NO_PROVIDER                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No provider was specified for the store or object                */
 /*                                                                   */
 dcl CRYPT_E_NO_PROVIDER              fixed bin(31) value('80092006'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_SELF_SIGNED                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified certificate is self signed.                        */
 /*                                                                   */
 dcl CRYPT_E_SELF_SIGNED              fixed bin(31) value('80092007'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_DELETED_PREV                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The previous certificate or CRL context was deleted.             */
 /*                                                                   */
 dcl CRYPT_E_DELETED_PREV             fixed bin(31) value('80092008'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_NO_MATCH                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No match when trying to find the object.                         */
 /*                                                                   */
 dcl CRYPT_E_NO_MATCH                 fixed bin(31) value('80092009'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_UNEXPECTED_MSG_TYPE                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The type of the cryptographic message being decoded is different */
 /*  than what was expected.                                          */
 /*                                                                   */
 dcl CRYPT_E_UNEXPECTED_MSG_TYPE      fixed bin(31) value('8009200A'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_NO_KEY_PROPERTY                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The certificate doesn't have a private key property              */
 /*                                                                   */
 dcl CRYPT_E_NO_KEY_PROPERTY          fixed bin(31) value('8009200B'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_NO_DECRYPT_CERT                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No certificate was found having a private key property to use    */
 /*  for decrypting.                                                  */
 /*                                                                   */
 dcl CRYPT_E_NO_DECRYPT_CERT          fixed bin(31) value('8009200C'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_BAD_MSG                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Either, not a cryptographic message or incorrectly formatted.    */
 /*                                                                   */
 dcl CRYPT_E_BAD_MSG                  fixed bin(31) value('8009200D'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_NO_SIGNER                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The signed message doesn't have a signer for the specified       */
 /*  signer index                                                     */
 /*                                                                   */
 dcl CRYPT_E_NO_SIGNER                fixed bin(31) value('8009200E'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_PENDING_CLOSE                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Final closure is pending until additional frees or closes.       */
 /*                                                                   */
 dcl CRYPT_E_PENDING_CLOSE            fixed bin(31) value('8009200F'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_REVOKED                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The certificate or signature has been revoked                    */
 /*                                                                   */
 dcl CRYPT_E_REVOKED                  fixed bin(31) value('80092010'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_NO_REVOCATION_DLL                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No Dll or exported function was found to verify revocation.      */
 /*                                                                   */
 dcl CRYPT_E_NO_REVOCATION_DLL        fixed bin(31) value('80092011'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_NO_REVOCATION_CHECK                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The called function wasn't able to do a revocation check on the  */
 /*  certificate or signature.                                        */
 /*                                                                   */
 dcl CRYPT_E_NO_REVOCATION_CHECK      fixed bin(31) value('80092012'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_REVOCATION_OFFLINE                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Since the revocation server was offline, the called function     */
 /*  wasn't able to complete the revocation check.                    */
 /*                                                                   */
 dcl CRYPT_E_REVOCATION_OFFLINE       fixed bin(31) value('80092013'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_NOT_IN_REVOCATION_DATABASE                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The certificate or signature to be checked was not found in the  */
 /*  revocation servers database.                                     */
 /*                                                                   */
 dcl CRYPT_E_NOT_IN_REVOCATION_DATABASE
                                      fixed bin(31) value('80092014'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_INVALID_NUMERIC_STRING                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The string contains a non-numeric character.                     */
 /*                                                                   */
 dcl CRYPT_E_INVALID_NUMERIC_STRING   fixed bin(31) value('80092020'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_INVALID_PRINTABLE_STRING                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The string contains a non-printable character.                   */
 /*                                                                   */
 dcl CRYPT_E_INVALID_PRINTABLE_STRING fixed bin(31) value('80092021'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_INVALID_IA5_STRING                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The string contains a character not in the 7 bit ASCII character */
 /*  set.                                                             */
 /*                                                                   */
 dcl CRYPT_E_INVALID_IA5_STRING       fixed bin(31) value('80092022'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_INVALID_X500_STRING                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The string contains an invalid X500 name attribute key, oid,     */
 /*  value or delimiter.                                              */
 /*                                                                   */
 dcl CRYPT_E_INVALID_X500_STRING      fixed bin(31) value('80092023'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_NOT_CHAR_STRING                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The dwValueType for the CERT_NAME_VALUE is not one of the        */
 /*  character strings.  Most likely it is either a                   */
 /*  CERT_RDN_ENCODED_BLOB or CERT_TDN_OCTED_STRING.                  */
 /*                                                                   */
 dcl CRYPT_E_NOT_CHAR_STRING          fixed bin(31) value('80092024'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_FILERESIZED                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The Put operation can not continue.  The file needs to be        */
 /*  resized.  However, there is already a signature present.         */
 /*  A complete signing operation must be done.                       */
 /*                                                                   */
 dcl CRYPT_E_FILERESIZED              fixed bin(31) value('80092025'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_SECURITY_SETTINGS                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cryptography operation has failed due to a local security    */
 /*  option setting.                                                  */
 /*                                                                   */
 dcl CRYPT_E_SECURITY_SETTINGS        fixed bin(31) value('80092026'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_NO_VERIFY_USAGE_DLL                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No DLL or exported function was found to verify subject usage.   */
 /*                                                                   */
 dcl CRYPT_E_NO_VERIFY_USAGE_DLL      fixed bin(31) value('80092027'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_NO_VERIFY_USAGE_CHECK                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The called function wasn't able to do a usage check on the       */
 /*  subject.                                                         */
 /*                                                                   */
 dcl CRYPT_E_NO_VERIFY_USAGE_CHECK    fixed bin(31) value('80092028'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_VERIFY_USAGE_OFFLINE                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Since the server was offline, the called function wasn't able to */
 /*  complete the usage check.                                        */
 /*                                                                   */
 dcl CRYPT_E_VERIFY_USAGE_OFFLINE     fixed bin(31) value('80092029'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_NOT_IN_CTL                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The subject was not found in a Certificate Trust List (CTL).     */
 /*                                                                   */
 dcl CRYPT_E_NOT_IN_CTL               fixed bin(31) value('8009202A'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_NO_TRUSTED_SIGNER                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No trusted signer was found to verify the signature of the       */
 /* message or trust list.                                            */
 /*                                                                   */
 dcl CRYPT_E_NO_TRUSTED_SIGNER        fixed bin(31) value('8009202B'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_OSS_ERROR                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS Certificate encode/decode error code base                    */
 /*                                                                   */
 /*  See asn1code.h for a definition of the OSS runtime errors.       */
 /*  The OSS error values are offset by CRYPT_E_OSS_ERROR.            */
 /*                                                                   */
 dcl CRYPT_E_OSS_ERROR                fixed bin(31) value('80093000'xn);

 /*                                                                   */
 /* MessageId: OSS_MORE_BUF                                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Output Buffer is too small.                     */
 /*                                                                   */
 dcl OSS_MORE_BUF                     fixed bin(31) value('80093001'xn);

 /*                                                                   */
 /* MessageId: OSS_NEGATIVE_UINTEGER                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Signed integer is encoded as a unsigned integer.*/
 /*                                                                   */
 dcl OSS_NEGATIVE_UINTEGER            fixed bin(31) value('80093002'xn);

 /*                                                                   */
 /* MessageId: OSS_PDU_RANGE                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Unknown ASN.1 data type.                        */
 /*                                                                   */
 dcl OSS_PDU_RANGE                    fixed bin(31) value('80093003'xn);

 /*                                                                   */
 /* MessageId: OSS_MORE_INPUT                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Output buffer is too small, the decoded data    */
 /*  has been truncated.                                              */
 /*                                                                   */
 dcl OSS_MORE_INPUT                   fixed bin(31) value('80093004'xn);

 /*                                                                   */
 /* MessageId: OSS_DATA_ERROR                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Invalid data.                                   */
 /*                                                                   */
 dcl OSS_DATA_ERROR                   fixed bin(31) value('80093005'xn);

 /*                                                                   */
 /* MessageId: OSS_BAD_ARG                                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Invalid argument.                               */
 /*                                                                   */
 dcl OSS_BAD_ARG                      fixed bin(31) value('80093006'xn);

 /*                                                                   */
 /* MessageId: OSS_BAD_VERSION                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Encode/Decode version mismatch.                 */
 /*                                                                   */
 dcl OSS_BAD_VERSION                  fixed bin(31) value('80093007'xn);

 /*                                                                   */
 /* MessageId: OSS_OUT_MEMORY                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Out of memory.                                  */
 /*                                                                   */
 dcl OSS_OUT_MEMORY                   fixed bin(31) value('80093008'xn);

 /*                                                                   */
 /* MessageId: OSS_PDU_MISMATCH                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Encode/Decode Error.                            */
 /*                                                                   */
 dcl OSS_PDU_MISMATCH                 fixed bin(31) value('80093009'xn);

 /*                                                                   */
 /* MessageId: OSS_LIMITED                                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Internal Error.                                 */
 /*                                                                   */
 dcl OSS_LIMITED                      fixed bin(31) value('8009300A'xn);

 /*                                                                   */
 /* MessageId: OSS_BAD_PTR                                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Invalid data.                                   */
 /*                                                                   */
 dcl OSS_BAD_PTR                      fixed bin(31) value('8009300B'xn);

 /*                                                                   */
 /* MessageId: OSS_BAD_TIME                                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Invalid data.                                   */
 /*                                                                   */
 dcl OSS_BAD_TIME                     fixed bin(31) value('8009300C'xn);

 /*                                                                   */
 /* MessageId: OSS_INDEFINITE_NOT_SUPPORTED                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Unsupported BER indefinite-length encoding.     */
 /*                                                                   */
 dcl OSS_INDEFINITE_NOT_SUPPORTED     fixed bin(31) value('8009300D'xn);

 /*                                                                   */
 /* MessageId: OSS_MEM_ERROR                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Access violation.                               */
 /*                                                                   */
 dcl OSS_MEM_ERROR                    fixed bin(31) value('8009300E'xn);

 /*                                                                   */
 /* MessageId: OSS_BAD_TABLE                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Invalid data.                                   */
 /*                                                                   */
 dcl OSS_BAD_TABLE                    fixed bin(31) value('8009300F'xn);

 /*                                                                   */
 /* MessageId: OSS_TOO_LONG                                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Invalid data.                                   */
 /*                                                                   */
 dcl OSS_TOO_LONG                     fixed bin(31) value('80093010'xn);

 /*                                                                   */
 /* MessageId: OSS_CONSTRAINT_VIOLATED                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Invalid data.                                   */
 /*                                                                   */
 dcl OSS_CONSTRAINT_VIOLATED          fixed bin(31) value('80093011'xn);

 /*                                                                   */
 /* MessageId: OSS_FATAL_ERROR                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Internal Error.                                 */
 /*                                                                   */
 dcl OSS_FATAL_ERROR                  fixed bin(31) value('80093012'xn);

 /*                                                                   */
 /* MessageId: OSS_ACCESS_SERIALIZATION_ERROR                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Multi-threading conflict.                       */
 /*                                                                   */
 dcl OSS_ACCESS_SERIALIZATION_ERROR   fixed bin(31) value('80093013'xn);

 /*                                                                   */
 /* MessageId: OSS_NULL_TBL                                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Invalid data.                                   */
 /*                                                                   */
 dcl OSS_NULL_TBL                     fixed bin(31) value('80093014'xn);

 /*                                                                   */
 /* MessageId: OSS_NULL_FCN                                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Invalid data.                                   */
 /*                                                                   */
 dcl OSS_NULL_FCN                     fixed bin(31) value('80093015'xn);

 /*                                                                   */
 /* MessageId: OSS_BAD_ENCRULES                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Invalid data.                                   */
 /*                                                                   */
 dcl OSS_BAD_ENCRULES                 fixed bin(31) value('80093016'xn);

 /*                                                                   */
 /* MessageId: OSS_UNAVAIL_ENCRULES                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Encode/Decode function not implemented.         */
 /*                                                                   */
 dcl OSS_UNAVAIL_ENCRULES             fixed bin(31) value('80093017'xn);

 /*                                                                   */
 /* MessageId: OSS_CANT_OPEN_TRACE_WINDOW                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Trace file error.                               */
 /*                                                                   */
 dcl OSS_CANT_OPEN_TRACE_WINDOW       fixed bin(31) value('80093018'xn);

 /*                                                                   */
 /* MessageId: OSS_UNIMPLEMENTED                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Function not implemented.                       */
 /*                                                                   */
 dcl OSS_UNIMPLEMENTED                fixed bin(31) value('80093019'xn);

 /*                                                                   */
 /* MessageId: OSS_OID_DLL_NOT_LINKED                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Program link error.                             */
 /*                                                                   */
 dcl OSS_OID_DLL_NOT_LINKED           fixed bin(31) value('8009301A'xn);

 /*                                                                   */
 /* MessageId: OSS_CANT_OPEN_TRACE_FILE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Trace file error.                               */
 /*                                                                   */
 dcl OSS_CANT_OPEN_TRACE_FILE         fixed bin(31) value('8009301B'xn);

 /*                                                                   */
 /* MessageId: OSS_TRACE_FILE_ALREADY_OPEN                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Trace file error.                               */
 /*                                                                   */
 dcl OSS_TRACE_FILE_ALREADY_OPEN      fixed bin(31) value('8009301C'xn);

 /*                                                                   */
 /* MessageId: OSS_TABLE_MISMATCH                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Invalid data.                                   */
 /*                                                                   */
 dcl OSS_TABLE_MISMATCH               fixed bin(31) value('8009301D'xn);

 /*                                                                   */
 /* MessageId: OSS_TYPE_NOT_SUPPORTED                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Invalid data.                                   */
 /*                                                                   */
 dcl OSS_TYPE_NOT_SUPPORTED           fixed bin(31) value('8009301E'xn);

 /*                                                                   */
 /* MessageId: OSS_REAL_DLL_NOT_LINKED                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Program link error.                             */
 /*                                                                   */
 dcl OSS_REAL_DLL_NOT_LINKED          fixed bin(31) value('8009301F'xn);

 /*                                                                   */
 /* MessageId: OSS_REAL_CODE_NOT_LINKED                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Program link error.                             */
 /*                                                                   */
 dcl OSS_REAL_CODE_NOT_LINKED         fixed bin(31) value('80093020'xn);

 /*                                                                   */
 /* MessageId: OSS_OUT_OF_RANGE                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Program link error.                             */
 /*                                                                   */
 dcl OSS_OUT_OF_RANGE                 fixed bin(31) value('80093021'xn);

 /*                                                                   */
 /* MessageId: OSS_COPIER_DLL_NOT_LINKED                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Program link error.                             */
 /*                                                                   */
 dcl OSS_COPIER_DLL_NOT_LINKED        fixed bin(31) value('80093022'xn);

 /*                                                                   */
 /* MessageId: OSS_CONSTRAINT_DLL_NOT_LINKED                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Program link error.                             */
 /*                                                                   */
 dcl OSS_CONSTRAINT_DLL_NOT_LINKED    fixed bin(31) value('80093023'xn);

 /*                                                                   */
 /* MessageId: OSS_COMPARATOR_DLL_NOT_LINKED                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Program link error.                             */
 /*                                                                   */
 dcl OSS_COMPARATOR_DLL_NOT_LINKED    fixed bin(31) value('80093024'xn);

 /*                                                                   */
 /* MessageId: OSS_COMPARATOR_CODE_NOT_LINKED                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Program link error.                             */
 /*                                                                   */
 dcl OSS_COMPARATOR_CODE_NOT_LINKED   fixed bin(31) value('80093025'xn);

 /*                                                                   */
 /* MessageId: OSS_MEM_MGR_DLL_NOT_LINKED                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Program link error.                             */
 /*                                                                   */
 dcl OSS_MEM_MGR_DLL_NOT_LINKED       fixed bin(31) value('80093026'xn);

 /*                                                                   */
 /* MessageId: OSS_PDV_DLL_NOT_LINKED                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Program link error.                             */
 /*                                                                   */
 dcl OSS_PDV_DLL_NOT_LINKED           fixed bin(31) value('80093027'xn);

 /*                                                                   */
 /* MessageId: OSS_PDV_CODE_NOT_LINKED                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Program link error.                             */
 /*                                                                   */
 dcl OSS_PDV_CODE_NOT_LINKED          fixed bin(31) value('80093028'xn);

 /*                                                                   */
 /* MessageId: OSS_API_DLL_NOT_LINKED                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Program link error.                             */
 /*                                                                   */
 dcl OSS_API_DLL_NOT_LINKED           fixed bin(31) value('80093029'xn);

 /*                                                                   */
 /* MessageId: OSS_BERDER_DLL_NOT_LINKED                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Program link error.                             */
 /*                                                                   */
 dcl OSS_BERDER_DLL_NOT_LINKED        fixed bin(31) value('8009302A'xn);

 /*                                                                   */
 /* MessageId: OSS_PER_DLL_NOT_LINKED                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Program link error.                             */
 /*                                                                   */
 dcl OSS_PER_DLL_NOT_LINKED           fixed bin(31) value('8009302B'xn);

 /*                                                                   */
 /* MessageId: OSS_OPEN_TYPE_ERROR                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Program link error.                             */
 /*                                                                   */
 dcl OSS_OPEN_TYPE_ERROR              fixed bin(31) value('8009302C'xn);

 /*                                                                   */
 /* MessageId: OSS_MUTEX_NOT_CREATED                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: System resource error.                          */
 /*                                                                   */
 dcl OSS_MUTEX_NOT_CREATED            fixed bin(31) value('8009302D'xn);

 /*                                                                   */
 /* MessageId: OSS_CANT_CLOSE_TRACE_FILE                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  OSS ASN.1 Error: Trace file error.                               */
 /*                                                                   */
 dcl OSS_CANT_CLOSE_TRACE_FILE        fixed bin(31) value('8009302E'xn);

 /*                                                                   */
 /* MessageId: CRYPT_E_ASN1_ERROR                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  ASN1 Certificate encode/decode error code base.                  */
 /*                                                                   */
 /*  The ASN1 error values are offset by CRYPT_E_ASN1_ERROR.          */
 /*                                                                   */
 dcl CRYPT_E_ASN1_ERROR               fixed bin(31) value('80093100'xn);

 /*                                                                   */
 /* MessageId: CERTSRV_E_BAD_REQUESTSUBJECT                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The request subject name is invalid or too long.                 */
 /*                                                                   */
 dcl CERTSRV_E_BAD_REQUESTSUBJECT     fixed bin(31) value('80094001'xn);

 /*                                                                   */
 /* MessageId: CERTSRV_E_NO_REQUEST                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The request does not exist.                                      */
 /*                                                                   */
 dcl CERTSRV_E_NO_REQUEST             fixed bin(31) value('80094002'xn);

 /*                                                                   */
 /* MessageId: CERTSRV_E_BAD_REQUESTSTATUS                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The request's current status does not allow this operation.      */
 /*                                                                   */
 dcl CERTSRV_E_BAD_REQUESTSTATUS      fixed bin(31) value('80094003'xn);

 /*                                                                   */
 /* MessageId: CERTSRV_E_PROPERTY_EMPTY                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested property value is empty.                           */
 /*                                                                   */
 dcl CERTSRV_E_PROPERTY_EMPTY         fixed bin(31) value('80094004'xn);

 /*                                                                   */
 /* MessageId: CERTSRV_E_INVALID_CA_CERTIFICATE                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The certification authority's certificate contains invalid data. */
 /*                                                                   */
 dcl CERTSRV_E_INVALID_CA_CERTIFICATE fixed bin(31) value('80094005'xn);

 /*                                                                   */
 /* MessageId: CERTSRV_E_SERVER_SUSPENDED                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Certificate service has been suspended for a database restore    */
 /*  operation.                                                       */
 /*                                                                   */
 dcl CERTSRV_E_SERVER_SUSPENDED       fixed bin(31) value('80094006'xn);

 /*                                                                   */
 /* MessageId: CERTSRV_E_ENCODING_LENGTH                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The certificate contains an encoded length that is potentially   */
 /*  incompatible with older enrollment software.                     */
 /*                                                                   */
 dcl CERTSRV_E_ENCODING_LENGTH        fixed bin(31) value('80094007'xn);

 /*                                                                   */
 /* MessageId: CERTSRV_E_UNSUPPORTED_CERT_TYPE                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested certificate template is not supported by this CA.  */
 /*                                                                   */
 dcl CERTSRV_E_UNSUPPORTED_CERT_TYPE  fixed bin(31) value('80094800'xn);

 /*                                                                   */
 /* MessageId: CERTSRV_E_NO_CERT_TYPE                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The request contains no certificate template information.        */
 /*                                                                   */
 dcl CERTSRV_E_NO_CERT_TYPE           fixed bin(31) value('80094801'xn);

 /*                                                                   */
 /* MessageId: TRUST_E_SYSTEM_ERROR                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A system-level error occured while verifying trust.              */
 /*                                                                   */
 dcl TRUST_E_SYSTEM_ERROR             fixed bin(31) value('80096001'xn);

 /*                                                                   */
 /* MessageId: TRUST_E_NO_SIGNER_CERT                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The certificate for the signer of the message is invalid or not  */
 /*  found.                                                           */
 /*                                                                   */
 dcl TRUST_E_NO_SIGNER_CERT           fixed bin(31) value('80096002'xn);

 /*                                                                   */
 /* MessageId: TRUST_E_COUNTER_SIGNER                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  One of the counter signers was invalid.                          */
 /*                                                                   */
 dcl TRUST_E_COUNTER_SIGNER           fixed bin(31) value('80096003'xn);

 /*                                                                   */
 /* MessageId: TRUST_E_CERT_SIGNATURE                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The signature of the certificate can not be verified.            */
 /*                                                                   */
 dcl TRUST_E_CERT_SIGNATURE           fixed bin(31) value('80096004'xn);

 /*                                                                   */
 /* MessageId: TRUST_E_TIME_STAMP                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The time stamp signer and or certificate could not be verified   */
 /*  or is malformed.                                                 */
 /*                                                                   */
 dcl TRUST_E_TIME_STAMP               fixed bin(31) value('80096005'xn);

 /*                                                                   */
 /* MessageId: TRUST_E_BAD_DIGEST                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The objects digest did not verify.                               */
 /*                                                                   */
 dcl TRUST_E_BAD_DIGEST               fixed bin(31) value('80096010'xn);

 /*                                                                   */
 /* MessageId: TRUST_E_BASIC_CONSTRAINTS                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The cerficates basic constraints are invalid or missing.         */
 /*                                                                   */
 dcl TRUST_E_BASIC_CONSTRAINTS        fixed bin(31) value('80096019'xn);

 /*                                                                   */
 /* MessageId: TRUST_E_FINANCIAL_CRITERIA                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The certificate does not meet or contain the Authenticode        */
 /*  financial extensions.                                            */
 /*                                                                   */
 dcl TRUST_E_FINANCIAL_CRITERIA       fixed bin(31) value('8009601E'xn);

 /*                                                                   */
 /*  Error codes for mssipotf.dll                                     */
 /*  Most of the error codes can only occur when an error occurs      */
 /*    during font file signing                                       */
 /*                                                                   */
 /*                                                                   */
 /*                                                                   */
 /* MessageId: MSSIPOTF_E_OUTOFMEMRANGE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Tried to reference a part of the file outside the proper range.  */
 /*                                                                   */
 dcl MSSIPOTF_E_OUTOFMEMRANGE         fixed bin(31) value('80097001'xn);

 /*                                                                   */
 /* MessageId: MSSIPOTF_E_CANTGETOBJECT                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Could not retrieve an object from the file.                      */
 /*                                                                   */
 dcl MSSIPOTF_E_CANTGETOBJECT         fixed bin(31) value('80097002'xn);

 /*                                                                   */
 /* MessageId: MSSIPOTF_E_NOHEADTABLE                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Could not find the head table in the file.                       */
 /*                                                                   */
 dcl MSSIPOTF_E_NOHEADTABLE           fixed bin(31) value('80097003'xn);

 /*                                                                   */
 /* MessageId: MSSIPOTF_E_BAD_MAGICNUMBER                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The magic number in the head table is incorrect.                 */
 /*                                                                   */
 dcl MSSIPOTF_E_BAD_MAGICNUMBER       fixed bin(31) value('80097004'xn);

 /*                                                                   */
 /* MessageId: MSSIPOTF_E_BAD_OFFSET_TABLE                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The offset table has incorrect values.                           */
 /*                                                                   */
 dcl MSSIPOTF_E_BAD_OFFSET_TABLE      fixed bin(31) value('80097005'xn);

 /*                                                                   */
 /* MessageId: MSSIPOTF_E_TABLE_TAGORDER                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Duplicate table tags or tags out of alphabetical order.          */
 /*                                                                   */
 dcl MSSIPOTF_E_TABLE_TAGORDER        fixed bin(31) value('80097006'xn);

 /*                                                                   */
 /* MessageId: MSSIPOTF_E_TABLE_LONGWORD                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A table does not start on a long word boundary.                  */
 /*                                                                   */
 dcl MSSIPOTF_E_TABLE_LONGWORD        fixed bin(31) value('80097007'xn);

 /*                                                                   */
 /* MessageId: MSSIPOTF_E_BAD_FIRST_TABLE_PLACEMENT                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  First table does not appear after header information.            */
 /*                                                                   */
 dcl MSSIPOTF_E_BAD_FIRST_TABLE_PLACEMENT
                                      fixed bin(31) value('80097008'xn);

 /*                                                                   */
 /* MessageId: MSSIPOTF_E_TABLES_OVERLAP                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Two or more tables overlap.                                      */
 /*                                                                   */
 dcl MSSIPOTF_E_TABLES_OVERLAP        fixed bin(31) value('80097009'xn);

 /*                                                                   */
 /* MessageId: MSSIPOTF_E_TABLE_PADBYTES                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Too many pad bytes between tables or pad bytes are not 0.        */
 /*                                                                   */
 dcl MSSIPOTF_E_TABLE_PADBYTES        fixed bin(31) value('8009700A'xn);

 /*                                                                   */
 /* MessageId: MSSIPOTF_E_FILETOOSMALL                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  File is too small to contain the last table.                     */
 /*                                                                   */
 dcl MSSIPOTF_E_FILETOOSMALL          fixed bin(31) value('8009700B'xn);

 /*                                                                   */
 /* MessageId: MSSIPOTF_E_TABLE_CHECKSUM                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A table checksum is incorrect.                                   */
 /*                                                                   */
 dcl MSSIPOTF_E_TABLE_CHECKSUM        fixed bin(31) value('8009700C'xn);

 /*                                                                   */
 /* MessageId: MSSIPOTF_E_FILE_CHECKSUM                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file checksum is incorrect.                                  */
 /*                                                                   */
 dcl MSSIPOTF_E_FILE_CHECKSUM         fixed bin(31) value('8009700D'xn);

 /*                                                                   */
 /* MessageId: MSSIPOTF_E_FAILED_POLICY                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The signature does not have the correct attributes for the       */
 /*  policy.                                                          */
 /*                                                                   */
 dcl MSSIPOTF_E_FAILED_POLICY         fixed bin(31) value('80097010'xn);

 /*                                                                   */
 /* MessageId: MSSIPOTF_E_FAILED_HINTS_CHECK                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file did not pass the hints check.                           */
 /*                                                                   */
 dcl MSSIPOTF_E_FAILED_HINTS_CHECK    fixed bin(31) value('80097011'xn);

 /*                                                                   */
 /* MessageId: MSSIPOTF_E_NOT_OPENTYPE                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file is not an OpenType file.                                */
 /*                                                                   */
 dcl MSSIPOTF_E_NOT_OPENTYPE          fixed bin(31) value('80097012'xn);

 /*                                                                   */
 /* MessageId: MSSIPOTF_E_FILE                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Failed on a file operation (open, map, read, write).             */
 /*                                                                   */
 dcl MSSIPOTF_E_FILE                  fixed bin(31) value('80097013'xn);

 /*                                                                   */
 /* MessageId: MSSIPOTF_E_CRYPT                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A call to a CryptoAPI function failed.                           */
 /*                                                                   */
 dcl MSSIPOTF_E_CRYPT                 fixed bin(31) value('80097014'xn);

 /*                                                                   */
 /* MessageId: MSSIPOTF_E_BADVERSION                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There is a bad version number in the file.                       */
 /*                                                                   */
 dcl MSSIPOTF_E_BADVERSION            fixed bin(31) value('80097015'xn);

 /*                                                                   */
 /* MessageId: MSSIPOTF_E_DSIG_STRUCTURE                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The structure of the DSIG table is incorrect.                    */
 /*                                                                   */
 dcl MSSIPOTF_E_DSIG_STRUCTURE        fixed bin(31) value('80097016'xn);

 /*                                                                   */
 /* MessageId: MSSIPOTF_E_PCONST_CHECK                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A check failed in a partially constant table.                    */
 /*                                                                   */
 dcl MSSIPOTF_E_PCONST_CHECK          fixed bin(31) value('80097017'xn);

 /*                                                                   */
 /* MessageId: MSSIPOTF_E_STRUCTURE                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Some kind of structural error.                                   */
 /*                                                                   */
 dcl MSSIPOTF_E_STRUCTURE             fixed bin(31) value('80097018'xn);

 dcl NTE_OP_OK fixed bin (31) value (0);

 /*                                                                   */
 /* Note that additional FACILITY_SSPI errors are in issperr.cpy      */
 /*                                                                   */

 /*********************************************************************/
 /*                                                                   */
 /* FACILITY_CERT                                                     */
 /*                                                                   */
 /*********************************************************************/

 /*                                                                   */
 /* MessageId: TRUST_E_PROVIDER_UNKNOWN                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified trust provider is not known on this system.        */
 /*                                                                   */
 dcl TRUST_E_PROVIDER_UNKNOWN         fixed bin(31) value('800B0001'xn);

 /*                                                                   */
 /* MessageId: TRUST_E_ACTION_UNKNOWN                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The trust verification action specified is not supported by the  */
 /*  specified trust provider.                                        */
 /*                                                                   */
 dcl TRUST_E_ACTION_UNKNOWN           fixed bin(31) value('800B0002'xn);

 /*                                                                   */
 /* MessageId: TRUST_E_SUBJECT_FORM_UNKNOWN                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The form specified for the subject is not one supported or known */
 /*  by the specified trust provider.                                 */
 /*                                                                   */
 dcl TRUST_E_SUBJECT_FORM_UNKNOWN     fixed bin(31) value('800B0003'xn);

 /*                                                                   */
 /* MessageId: TRUST_E_SUBJECT_NOT_TRUSTED                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The subject is not trusted for the specified action.             */
 /*                                                                   */
 dcl TRUST_E_SUBJECT_NOT_TRUSTED      fixed bin(31) value('800B0004'xn);

 /*                                                                   */
 /* MessageId: DIGSIG_E_ENCODE                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Error due to problem in ASN.1 encoding process.                  */
 /*                                                                   */
 dcl DIGSIG_E_ENCODE                  fixed bin(31) value('800B0005'xn);

 /*                                                                   */
 /* MessageId: DIGSIG_E_DECODE                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Error due to problem in ASN.1 decoding process.                  */
 /*                                                                   */
 dcl DIGSIG_E_DECODE                  fixed bin(31) value('800B0006'xn);

 /*                                                                   */
 /* MessageId: DIGSIG_E_EXTENSIBILITY                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Reading / writing Extensions where Attributes are appropriate,   */
 /*  and visa versa.                                                  */
 /*                                                                   */
 dcl DIGSIG_E_EXTENSIBILITY           fixed bin(31) value('800B0007'xn);

 /*                                                                   */
 /* MessageId: DIGSIG_E_CRYPTO                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unspecified cryptographic failure.                               */
 /*                                                                   */
 dcl DIGSIG_E_CRYPTO                  fixed bin(31) value('800B0008'xn);

 /*                                                                   */
 /* MessageId: PERSIST_E_SIZEDEFINITE                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The size of the data could not be determined.                    */
 /*                                                                   */
 dcl PERSIST_E_SIZEDEFINITE           fixed bin(31) value('800B0009'xn);

 /*                                                                   */
 /* MessageId: PERSIST_E_SIZEINDEFINITE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The size of the indefinite-sized data could not be determined.   */
 /*                                                                   */
 dcl PERSIST_E_SIZEINDEFINITE         fixed bin(31) value('800B000A'xn);

 /*                                                                   */
 /* MessageId: PERSIST_E_NOTSELFSIZING                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This object does not read and write self-sizing data.            */
 /*                                                                   */
 dcl PERSIST_E_NOTSELFSIZING          fixed bin(31) value('800B000B'xn);

 /*                                                                   */
 /* MessageId: TRUST_E_NOSIGNATURE                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No signature was present in the subject.                         */
 /*                                                                   */
 dcl TRUST_E_NOSIGNATURE              fixed bin(31) value('800B0100'xn);

 /*                                                                   */
 /* MessageId: CERT_E_EXPIRED                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A required certificate is not within its validity period.        */
 /*                                                                   */
 dcl CERT_E_EXPIRED                   fixed bin(31) value('800B0101'xn);

 /*                                                                   */
 /* MessageId: CERT_E_VALIDITYPERIODNESTING                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The validity periods of the certification chain do not nest      */
 /*  correctly.                                                       */
 /*                                                                   */
 dcl CERT_E_VALIDITYPERIODNESTING     fixed bin(31) value('800B0102'xn);

 /*                                                                   */
 /* MessageId: CERT_E_ROLE                                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A certificate that can only be used as an end-entity is being    */
 /*  used as a CA or visa versa.                                      */
 /*                                                                   */
 dcl CERT_E_ROLE                      fixed bin(31) value('800B0103'xn);

 /*                                                                   */
 /* MessageId: CERT_E_PATHLENCONST                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A path length constraint in the certification chain has been     */
 /*  violated.                                                        */
 /*                                                                   */
 dcl CERT_E_PATHLENCONST              fixed bin(31) value('800B0104'xn);

 /*                                                                   */
 /* MessageId: CERT_E_CRITICAL                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An extension of unknown type that is labeled 'critical' is       */
 /*  present in a certificate.                                        */
 /*                                                                   */
 dcl CERT_E_CRITICAL                  fixed bin(31) value('800B0105'xn);

 /*                                                                   */
 /* MessageId: CERT_E_PURPOSE                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A certificate is being used for a purpose other than that for    */
 /* which it is permitted.                                            */
 /*                                                                   */
 dcl CERT_E_PURPOSE                   fixed bin(31) value('800B0106'xn);

 /*                                                                   */
 /* MessageId: CERT_E_ISSUERCHAINING                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A parent of a given certificate in fact did not issue that child */
 /*  certificate.                                                     */
 /*                                                                   */
 dcl CERT_E_ISSUERCHAINING            fixed bin(31) value('800B0107'xn);

 /*                                                                   */
 /* MessageId: CERT_E_MALFORMED                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A certificate is missing or has an empty value for an important  */
 /*  field, such as a subject or issuer name.                         */
 /*                                                                   */
 dcl CERT_E_MALFORMED                 fixed bin(31) value('800B0108'xn);

 /*                                                                   */
 /* MessageId: CERT_E_UNTRUSTEDROOT                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A certification chain processed correctly, but terminated in a   */
 /* root certificate which isn't trusted by the trust provider.       */
 /*                                                                   */
 dcl CERT_E_UNTRUSTEDROOT             fixed bin(31) value('800B0109'xn);

 /*                                                                   */
 /* MessageId: CERT_E_CHAINING                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A chain of certs didn't chain as they should in a certain        */
 /*  application of chaining.                                         */
 /*                                                                   */
 dcl CERT_E_CHAINING                  fixed bin(31) value('800B010A'xn);

 /*                                                                   */
 /* MessageId: TRUST_E_FAIL                                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Generic Trust Failure.                                           */
 /*                                                                   */
 dcl TRUST_E_FAIL                     fixed bin(31) value('800B010B'xn);

 /*                                                                   */
 /* MessageId: CERT_E_REVOKED                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A certificate was explicitly revoked by its issuer.              */
 /*                                                                   */
 dcl CERT_E_REVOKED                   fixed bin(31) value('800B010C'xn);

 /*                                                                   */
 /* MessageId: CERT_E_UNTRUSTEDTESTROOT                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The root certificate is a testing certificate and the policy     */
 /*  settings disallow test certificates.                             */
 /*                                                                   */
 dcl CERT_E_UNTRUSTEDTESTROOT         fixed bin(31) value('800B010D'xn);

 /*                                                                   */
 /* MessageId: CERT_E_REVOCATION_FAILURE                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The revocation process could not continue - the certificate(s)   */
 /*  could not be checked.                                            */
 /*                                                                   */
 dcl CERT_E_REVOCATION_FAILURE        fixed bin(31) value('800B010E'xn);

 /*                                                                   */
 /* MessageId: CERT_E_CN_NO_MATCH                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The certificate's CN name does not match the passed value.       */
 /*                                                                   */
 dcl CERT_E_CN_NO_MATCH               fixed bin(31) value('800B010F'xn);

 /*                                                                   */
 /* MessageId: CERT_E_WRONG_USAGE                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The certificate is not valid for the requested usage.            */
 /*                                                                   */
 dcl CERT_E_WRONG_USAGE               fixed bin(31) value('800B0110'xn);

 /*                                                                   */
 /* MessageId: TRUST_E_EXPLICIT_DISTRUST                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The certificate was explicitly marked as untrusted by the user.  */
 /*                                                                   */
 dcl TRUST_E_EXPLICIT_DISTRUST        fixed bin(31) value('800B0111'xn);

 /*                                                                   */
 /* MessageId: CERT_E_UNTRUSTEDCA                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A certification chain processed correctly, but one of the CA     */
 /*  certificates is not trusted by the policy provider.              */
 /*                                                                   */
 dcl CERT_E_UNTRUSTEDCA               fixed bin(31) value('800B0112'xn);

 /*********************************************************************/
 /* FACILITY_SETUPAPI                                                 */
 /*********************************************************************/


 /* Since these error codes aren't in the standard Win32 range        */
 /* (i.e., 0-64K), define a                                           */
 /* macro to map either Win32 or SetupAPI error codes into an HRESULT.*/

 HRESULT_FROM_SETUPAPI: proc (x) returns (fixed bin (31) byvalue)
                        options (inline reorder) internal;
   dcl x fixed bin (31) byvalue byvalue;
   dcl (iand, ior, raise2) builtin;

   if iand (x, ior (APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR))
    = ior (APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR) then
     return (ior (iand (x, '0000ffff'xn),
                  raise2 (FACILITY_SETUPAPI, 16),
                  '80000000'xn));
   else
     return (HRESULT_FROM_WIN32(x));
 end HRESULT_FROM_SETUPAPI;

 /*                                                                   */
 /* MessageId: SPAPI_E_EXPECTED_SECTION_NAME                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A non-empty line was encountered in the INF before the start of  */
 /*  a section.                                                       */
 /*                                                                   */
 dcl SPAPI_E_EXPECTED_SECTION_NAME    fixed bin(31) value('800F0000'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_BAD_SECTION_NAME_LINE                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A section name marker in the INF is not complete, or does not    */
 /*  exist on a line by itself.                                       */
 /*                                                                   */
 dcl SPAPI_E_BAD_SECTION_NAME_LINE    fixed bin(31) value('800F0001'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_SECTION_NAME_TOO_LONG                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An INF section was encountered whose name exceeds the maximum    */
 /*  section name length.                                             */
 /*                                                                   */
 dcl SPAPI_E_SECTION_NAME_TOO_LONG    fixed bin(31) value('800F0002'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_GENERAL_SYNTAX                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The syntax of the INF is invalid.                                */
 /*                                                                   */
 dcl SPAPI_E_GENERAL_SYNTAX           fixed bin(31) value('800F0003'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_WRONG_INF_STYLE                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The style of the INF is different than what was requested.       */
 /*                                                                   */
 dcl SPAPI_E_WRONG_INF_STYLE          fixed bin(31) value('800F0100'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_SECTION_NOT_FOUND                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The required section was not found in the INF.                   */
 /*                                                                   */
 dcl SPAPI_E_SECTION_NOT_FOUND        fixed bin(31) value('800F0101'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_LINE_NOT_FOUND                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The required line was not found in the INF.                      */
 /*                                                                   */
 dcl SPAPI_E_LINE_NOT_FOUND           fixed bin(31) value('800F0102'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_NO_BACKUP                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The files affected by the installation of this file queue have   */
 /*  not been backed up for uninstall.                                */
 /*                                                                   */
 dcl SPAPI_E_NO_BACKUP                fixed bin(31) value('800F0103'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_NO_ASSOCIATED_CLASS                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The INF or the device information set or element does not have   */
 /*  an associated install class.                                     */
 /*                                                                   */
 dcl SPAPI_E_NO_ASSOCIATED_CLASS      fixed bin(31) value('800F0200'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_CLASS_MISMATCH                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The INF or the device information set or element does not match  */
 /*  the specified install class.                                     */
 /*                                                                   */
 dcl SPAPI_E_CLASS_MISMATCH           fixed bin(31) value('800F0201'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_DUPLICATE_FOUND                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An existing device was found that is a duplicate of the device   */
 /*  being manually installed.                                        */
 /*                                                                   */
 dcl SPAPI_E_DUPLICATE_FOUND          fixed bin(31) value('800F0202'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_NO_DRIVER_SELECTED                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There is no driver selected for the device information set or    */
 /*  element.                                                         */
 /*                                                                   */
 dcl SPAPI_E_NO_DRIVER_SELECTED       fixed bin(31) value('800F0203'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_KEY_DOES_NOT_EXIST                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested device registry key does not exist.                */
 /*                                                                   */
 dcl SPAPI_E_KEY_DOES_NOT_EXIST       fixed bin(31) value('800F0204'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_INVALID_DEVINST_NAME                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The device instance name is invalid.                             */
 /*                                                                   */
 dcl SPAPI_E_INVALID_DEVINST_NAME     fixed bin(31) value('800F0205'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_INVALID_CLASS                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The install class is not present or is invalid.                  */
 /*                                                                   */
 dcl SPAPI_E_INVALID_CLASS            fixed bin(31) value('800F0206'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_DEVINST_ALREADY_EXISTS                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The device instance cannot be created because it already exists. */
 /*                                                                   */
 dcl SPAPI_E_DEVINST_ALREADY_EXISTS   fixed bin(31) value('800F0207'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_DEVINFO_NOT_REGISTERED                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operation cannot be performed on a device information        */
 /*  element that has not been registered.                            */
 /*                                                                   */
 dcl SPAPI_E_DEVINFO_NOT_REGISTERED   fixed bin(31) value('800F0208'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_INVALID_REG_PROPERTY                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The device property code is invalid.                             */
 /*                                                                   */
 dcl SPAPI_E_INVALID_REG_PROPERTY     fixed bin(31) value('800F0209'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_NO_INF                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The INF from which a driver list is to be built does not exist.  */
 /*                                                                   */
 dcl SPAPI_E_NO_INF                   fixed bin(31) value('800F020A'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_NO_SUCH_DEVINST                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The device instance does not exist in the hardware tree.         */
 /*                                                                   */
 dcl SPAPI_E_NO_SUCH_DEVINST          fixed bin(31) value('800F020B'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_CANT_LOAD_CLASS_ICON                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The icon representing this install class cannot be loaded.       */
 /*                                                                   */
 dcl SPAPI_E_CANT_LOAD_CLASS_ICON     fixed bin(31) value('800F020C'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_INVALID_CLASS_INSTALLER                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The class installer registry entry is invalid.                   */
 /*                                                                   */
 dcl SPAPI_E_INVALID_CLASS_INSTALLER  fixed bin(31) value('800F020D'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_DI_DO_DEFAULT                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The class installer has indicated that the default action should */
 /*  be performed for this installation request.                      */
 /*                                                                   */
 dcl SPAPI_E_DI_DO_DEFAULT            fixed bin(31) value('800F020E'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_DI_NOFILECOPY                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operation does not require any files to be copied.           */
 /*                                                                   */
 dcl SPAPI_E_DI_NOFILECOPY            fixed bin(31) value('800F020F'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_INVALID_HWPROFILE                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified hardware profile does not exist.                   */
 /*                                                                   */
 dcl SPAPI_E_INVALID_HWPROFILE        fixed bin(31) value('800F0210'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_NO_DEVICE_SELECTED                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There is no device information element currently selected for    */
 /*  this device information set.                                     */
 /*                                                                   */
 dcl SPAPI_E_NO_DEVICE_SELECTED       fixed bin(31) value('800F0211'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_DEVINFO_LIST_LOCKED                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operation cannot be performed because the device information */
 /*  set is locked.                                                   */
 /*                                                                   */
 dcl SPAPI_E_DEVINFO_LIST_LOCKED      fixed bin(31) value('800F0212'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_DEVINFO_DATA_LOCKED                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operation cannot be performed because the device information */
 /*  element is locked.                                               */
 /*                                                                   */
 dcl SPAPI_E_DEVINFO_DATA_LOCKED      fixed bin(31) value('800F0213'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_DI_BAD_PATH                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified path does not contain any applicable device INFs.  */
 /*                                                                   */
 dcl SPAPI_E_DI_BAD_PATH              fixed bin(31) value('800F0214'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_NO_CLASSINSTALL_PARAMS                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No class installer parameters have been set for the device       */
 /*  information set or element.                                      */
 /*                                                                   */
 dcl SPAPI_E_NO_CLASSINSTALL_PARAMS   fixed bin(31) value('800F0215'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_FILEQUEUE_LOCKED                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operation cannot be performed because the file queue is      */
 /*  locked.                                                          */
 /*                                                                   */
 dcl SPAPI_E_FILEQUEUE_LOCKED         fixed bin(31) value('800F0216'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_BAD_SERVICE_INSTALLSECT                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A service installation section in this INF is invalid.           */
 /*                                                                   */
 dcl SPAPI_E_BAD_SERVICE_INSTALLSECT  fixed bin(31) value('800F0217'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_NO_CLASS_DRIVER_LIST                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There is no class driver list for the device information element.*/
 /*                                                                   */
 dcl SPAPI_E_NO_CLASS_DRIVER_LIST     fixed bin(31) value('800F0218'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_NO_ASSOCIATED_SERVICE                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The installation failed because a function driver was not        */
 /*  specified for this device instance.                              */
 /*                                                                   */
 dcl SPAPI_E_NO_ASSOCIATED_SERVICE    fixed bin(31) value('800F0219'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_NO_DEFAULT_DEVICE_INTERFACE                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There is presently no default device interface designated for    */
 /*  this interface class.                                            */
 /*                                                                   */
 dcl SPAPI_E_NO_DEFAULT_DEVICE_INTERFACE
                                      fixed bin(31) value('800F021A'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_DEVICE_INTERFACE_ACTIVE                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operation cannot be performed because the device interface   */
 /*  is currently active.                                             */
 /*                                                                   */
 dcl SPAPI_E_DEVICE_INTERFACE_ACTIVE  fixed bin(31) value('800F021B'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_DEVICE_INTERFACE_REMOVED                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operation cannot be performed because the device interface   */
 /*  has been removed from the system.                                */
 /*                                                                   */
 dcl SPAPI_E_DEVICE_INTERFACE_REMOVED fixed bin(31) value('800F021C'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_BAD_INTERFACE_INSTALLSECT                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An interface installation section in this INF is invalid.        */
 /*                                                                   */
 dcl SPAPI_E_BAD_INTERFACE_INSTALLSECT
                                      fixed bin(31) value('800F021D'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_NO_SUCH_INTERFACE_CLASS                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This interface class does not exist in the system.               */
 /*                                                                   */
 dcl SPAPI_E_NO_SUCH_INTERFACE_CLASS  fixed bin(31) value('800F021E'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_INVALID_REFERENCE_STRING                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The reference string supplied for this interface device is       */
 /*  invalid.                                                         */
 /*                                                                   */
 dcl SPAPI_E_INVALID_REFERENCE_STRING fixed bin(31) value('800F021F'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_INVALID_MACHINENAME                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified machine name does not conform to UNC naming        */
 /*  conventions.                                                     */
 /*                                                                   */
 dcl SPAPI_E_INVALID_MACHINENAME      fixed bin(31) value('800F0220'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_REMOTE_COMM_FAILURE                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A general remote communication error occurred.                   */
 /*                                                                   */
 dcl SPAPI_E_REMOTE_COMM_FAILURE      fixed bin(31) value('800F0221'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_MACHINE_UNAVAILABLE                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The machine selected for remote communication is not available   */
 /*  at this time.                                                    */
 /*                                                                   */
 dcl SPAPI_E_MACHINE_UNAVAILABLE      fixed bin(31) value('800F0222'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_NO_CONFIGMGR_SERVICES                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The Plug and Play service is not available on the remote machine.*/
 /*                                                                   */
 dcl SPAPI_E_NO_CONFIGMGR_SERVICES    fixed bin(31) value('800F0223'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_INVALID_PROPPAGE_PROVIDER                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The property page provider registry entry is invalid.            */
 /*                                                                   */
 dcl SPAPI_E_INVALID_PROPPAGE_PROVIDER
                                      fixed bin(31) value('800F0224'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_NO_SUCH_DEVICE_INTERFACE                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested device interface is not present in the system.     */
 /*                                                                   */
 dcl SPAPI_E_NO_SUCH_DEVICE_INTERFACE fixed bin(31) value('800F0225'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_DI_POSTPROCESSING_REQUIRED                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The device's co-installer has additional work to perform after   */
 /*  installation is complete.                                        */
 /*                                                                   */
 dcl SPAPI_E_DI_POSTPROCESSING_REQUIRED
                                      fixed bin(31) value('800F0226'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_INVALID_COINSTALLER                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The device's co-installer is invalid.                            */
 /*                                                                   */
 dcl SPAPI_E_INVALID_COINSTALLER      fixed bin(31) value('800F0227'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_NO_COMPAT_DRIVERS                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There are no compatible drivers for this device.                 */
 /*                                                                   */
 dcl SPAPI_E_NO_COMPAT_DRIVERS        fixed bin(31) value('800F0228'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_NO_DEVICE_ICON                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There is no icon that represents this device or device type.     */
 /*                                                                   */
 dcl SPAPI_E_NO_DEVICE_ICON           fixed bin(31) value('800F0229'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_INVALID_INF_LOGCONFIG                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A logical configuration specified in this INF is invalid.        */
 /*                                                                   */
 dcl SPAPI_E_INVALID_INF_LOGCONFIG    fixed bin(31) value('800F022A'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_DI_DONT_INSTALL                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The class installer has denied the request to install or upgrade */
 /*  this device.                                                     */
 /*                                                                   */
 dcl SPAPI_E_DI_DONT_INSTALL          fixed bin(31) value('800F022B'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_INVALID_FILTER_DRIVER                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  One of the filter drivers installed for this device is invalid.  */
 /*                                                                   */
 dcl SPAPI_E_INVALID_FILTER_DRIVER    fixed bin(31) value('800F022C'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_NON_WINDOWS_NT_DRIVER                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The driver selected for this device does not support             */
 /*  Windows 2000.                                                    */
 dcl SPAPI_E_NON_WINDOWS_NT_DRIVER    fixed bin(31) value('800F022D'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_NON_WINDOWS_DRIVER                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The driver selected for this device does not support Windows.    */
 /*                                                                   */
 dcl SPAPI_E_NON_WINDOWS_DRIVER       fixed bin(31) value('800F022E'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_NO_CATALOG_FOR_OEM_INF                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The third-party INF does not contain digital signature           */
 /*  information.                                                     */
 /*                                                                   */
 dcl SPAPI_E_NO_CATALOG_FOR_OEM_INF   fixed bin(31) value('800F022F'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_DEVINSTALL_QUEUE_NONNATIVE                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An invalid attempt was made to use a device installation file    */
 /*  queue for verification of digital signatures relative to other   */
 /*  platforms.                                                       */
 /*                                                                   */
 dcl SPAPI_E_DEVINSTALL_QUEUE_NONNATIVE
                                      fixed bin(31) value('800F0230'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_NOT_DISABLEABLE                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The device cannot be disabled.                                   */
 /*                                                                   */
 dcl SPAPI_E_NOT_DISABLEABLE          fixed bin(31) value('800F0231'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_CANT_REMOVE_DEVINST                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The device could not be dynamically removed.                     */
 /*                                                                   */
 dcl SPAPI_E_CANT_REMOVE_DEVINST      fixed bin(31) value('800F0232'xn);

 /*                                                                   */
 /* MessageId: SPAPI_E_ERROR_NOT_INSTALLED                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No installed components were detected.                           */
 /*                                                                   */
 dcl SPAPI_E_ERROR_NOT_INSTALLED      fixed bin(31) value('800F1000'xn);


 /*********************************************************************/
 /* FACILITY_SCARD                                                    */
 /*********************************************************************/

 /* ============================= */
 /* Facility SCARD Error Messages */
 /* ============================= */

 dcl SCARD_S_SUCCESS                  fixed bin(31) value(NO_ERROR);
 /*                                                                   */
 /* MessageId: SCARD_F_INTERNAL_ERROR                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An internal consistency check failed                             */
 /*                                                                   */
 dcl SCARD_F_INTERNAL_ERROR           fixed bin(31) value('80100001'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_CANCELLED                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The action was cancelled by an SCardCancel request               */
 /*                                                                   */
 dcl SCARD_E_CANCELLED                fixed bin(31) value('80100002'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_INVALID_HANDLE                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The supplied handle was invalid                                  */
 /*                                                                   */
 dcl SCARD_E_INVALID_HANDLE           fixed bin(31) value('80100003'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_INVALID_PARAMETER                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  One or more of the supplied parameters could not be              */
 /*  properly interpreted                                             */
 /*                                                                   */
 dcl SCARD_E_INVALID_PARAMETER        fixed bin(31) value('80100004'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_INVALID_TARGET                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Registry startup information is missing or invalid               */
 /*                                                                   */
 dcl SCARD_E_INVALID_TARGET           fixed bin(31) value('80100005'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_NO_MEMORY                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Not enough memory available to complete this command             */
 /*                                                                   */
 dcl SCARD_E_NO_MEMORY                fixed bin(31) value('80100006'xn);

 /*                                                                   */
 /* MessageId: SCARD_F_WAITED_TOO_LONG                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An internal consistency timer has expired                        */
 /*                                                                   */
 dcl SCARD_F_WAITED_TOO_LONG          fixed bin(31) value('80100007'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_INSUFFICIENT_BUFFER                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The data buffer to receive returned data is too small            */
 /*  for the returned data                                            */
 /*                                                                   */
 dcl SCARD_E_INSUFFICIENT_BUFFER      fixed bin(31) value('80100008'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_UNKNOWN_READER                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified reader name is not recognized                      */
 /*                                                                   */
 dcl SCARD_E_UNKNOWN_READER           fixed bin(31) value('80100009'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_TIMEOUT                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The user-specified timeout value has expired                     */
 /*                                                                   */
 dcl SCARD_E_TIMEOUT                  fixed bin(31) value('8010000A'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_SHARING_VIOLATION                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The smart card cannot be accessed because of other connections   */
 /*  outstanding                                                      */
 /*                                                                   */
 dcl SCARD_E_SHARING_VIOLATION        fixed bin(31) value('8010000B'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_NO_SMARTCARD                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The operation requires a Smart Card, but no Smart Card is        */
 /*  currently in the device                                          */
 /*                                                                   */
 dcl SCARD_E_NO_SMARTCARD             fixed bin(31) value('8010000C'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_UNKNOWN_CARD                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified smart card name is not recognized                  */
 /*                                                                   */
 dcl SCARD_E_UNKNOWN_CARD             fixed bin(31) value('8010000D'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_CANT_DISPOSE                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system could not dispose of the media in the requested manner*/
 /*                                                                   */
 dcl SCARD_E_CANT_DISPOSE             fixed bin(31) value('8010000E'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_PROTO_MISMATCH                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested protocols are incompatible with the protocol       */
 /*  currently in use with the smart card                             */
 /*                                                                   */
 dcl SCARD_E_PROTO_MISMATCH           fixed bin(31) value('8010000F'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_NOT_READY                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The reader or smart card is not ready to accept commands         */
 /*                                                                   */
 dcl SCARD_E_NOT_READY                fixed bin(31) value('80100010'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_INVALID_VALUE                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  One or more of the supplied parameters values could not be       */
 /*  properly interpreted                                             */
 /*                                                                   */
 dcl SCARD_E_INVALID_VALUE            fixed bin(31) value('80100011'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_SYSTEM_CANCELLED                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The action was cancelled by the system, presumably to log off    */
 /*  or shut down                                                     */
 /*                                                                   */
 dcl SCARD_E_SYSTEM_CANCELLED         fixed bin(31) value('80100012'xn);

 /*                                                                   */
 /* MessageId: SCARD_F_COMM_ERROR                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An internal communications error has been detected               */
 /*                                                                   */
 dcl SCARD_F_COMM_ERROR               fixed bin(31) value('80100013'xn);

 /*                                                                   */
 /* MessageId: SCARD_F_UNKNOWN_ERROR                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An internal error has been detected, but the source is unknown   */
 /*                                                                   */
 dcl SCARD_F_UNKNOWN_ERROR            fixed bin(31) value('80100014'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_INVALID_ATR                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An ATR obtained from the registry is not a valid ATR string      */
 /*                                                                   */
 dcl SCARD_E_INVALID_ATR              fixed bin(31) value('80100015'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_NOT_TRANSACTED                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An attempt was made to end a non-existent transaction            */
 /*                                                                   */
 dcl SCARD_E_NOT_TRANSACTED           fixed bin(31) value('80100016'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_READER_UNAVAILABLE                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified reader is not currently available for use          */
 /*                                                                   */
 dcl SCARD_E_READER_UNAVAILABLE       fixed bin(31) value('80100017'xn);

 /*                                                                   */
 /* MessageId: SCARD_P_SHUTDOWN                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  PRIVATE -- Internal flag to force server termination             */
 /*                                                                   */
 dcl SCARD_P_SHUTDOWN                 fixed bin(31) value('80100018'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_PCI_TOO_SMALL                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The PCI Receive buffer was too small                             */
 /*                                                                   */
 dcl SCARD_E_PCI_TOO_SMALL            fixed bin(31) value('80100019'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_READER_UNSUPPORTED                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The reader driver does not meet minimal requirements for support */
 /*                                                                   */
 dcl SCARD_E_READER_UNSUPPORTED       fixed bin(31) value('8010001A'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_DUPLICATE_READER                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The reader driver did not produce a unique reader name           */
 /*                                                                   */
 dcl SCARD_E_DUPLICATE_READER         fixed bin(31) value('8010001B'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_CARD_UNSUPPORTED                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The smart card does not meet minimal requirements for support    */
 /*                                                                   */
 dcl SCARD_E_CARD_UNSUPPORTED         fixed bin(31) value('8010001C'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_NO_SERVICE                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The Smart card resource manager is not running                   */
 /*                                                                   */
 dcl SCARD_E_NO_SERVICE               fixed bin(31) value('8010001D'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_SERVICE_STOPPED                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The Smart card resource manager has shut down                    */
 /*                                                                   */
 dcl SCARD_E_SERVICE_STOPPED          fixed bin(31) value('8010001E'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_UNEXPECTED                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An unexpected card error has occurred                            */
 /*                                                                   */
 dcl SCARD_E_UNEXPECTED               fixed bin(31) value('8010001F'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_ICC_INSTALLATION                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No Primary Provider can be found for the smart card              */
 /*                                                                   */
 dcl SCARD_E_ICC_INSTALLATION         fixed bin(31) value('80100020'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_ICC_CREATEORDER                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested order of object creation is not supported          */
 /*                                                                   */
 dcl SCARD_E_ICC_CREATEORDER          fixed bin(31) value('80100021'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_UNSUPPORTED_FEATURE                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This smart card does not support the reqested feature            */
 /*                                                                   */
 dcl SCARD_E_UNSUPPORTED_FEATURE      fixed bin(31) value('80100022'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_DIR_NOT_FOUND                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The identified directory does not exist in the smart card        */
 /*                                                                   */
 dcl SCARD_E_DIR_NOT_FOUND            fixed bin(31) value('80100023'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_FILE_NOT_FOUND                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The identified file does not exist in the smart card             */
 /*                                                                   */
 dcl SCARD_E_FILE_NOT_FOUND           fixed bin(31) value('80100024'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_NO_DIR                                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The supplied path does not represent a smart card directory      */
 /*                                                                   */
 dcl SCARD_E_NO_DIR                   fixed bin(31) value('80100025'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_NO_FILE                                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The supplied path does not represent a smart card file           */
 /*                                                                   */
 dcl SCARD_E_NO_FILE                  fixed bin(31) value('80100026'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_NO_ACCESS                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Access is denied to this file                                    */
 /*                                                                   */
 dcl SCARD_E_NO_ACCESS                fixed bin(31) value('80100027'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_WRITE_TOO_MANY                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An attempt was made to write more data than would fit in the     */
 /*  target object                                                    */
 /*                                                                   */
 dcl SCARD_E_WRITE_TOO_MANY           fixed bin(31) value('80100028'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_BAD_SEEK                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There was an error trying to set the smart card file object      */
 /*  pointer                                                          */
 /*                                                                   */
 dcl SCARD_E_BAD_SEEK                 fixed bin(31) value('80100029'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_INVALID_CHV                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The supplied PIN is incorrect                                    */
 /*                                                                   */
 dcl SCARD_E_INVALID_CHV              fixed bin(31) value('8010002A'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_UNKNOWN_RES_MNG                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An unrecognized error code was returned from a layered component */
 /*                                                                   */
 dcl SCARD_E_UNKNOWN_RES_MNG          fixed bin(31) value('8010002B'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_NO_SUCH_CERTIFICATE                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested certificate does not exist.                        */
 /*                                                                   */
 dcl SCARD_E_NO_SUCH_CERTIFICATE      fixed bin(31) value('8010002C'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_CERTIFICATE_UNAVAILABLE                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested certificate could not be obtained.                 */
 /*                                                                   */
 dcl SCARD_E_CERTIFICATE_UNAVAILABLE  fixed bin(31) value('8010002D'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_NO_READERS_AVAILABLE                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Cannot find a smart card reader.                                 */
 /*                                                                   */
 dcl SCARD_E_NO_READERS_AVAILABLE     fixed bin(31) value('8010002E'xn);

 /*                                                                   */
 /* MessageId: SCARD_E_COMM_DATA_LOST                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A communications error with the smart card has been detected.    */
 /*  Retry the operation.                                             */
 /*                                                                   */
 dcl SCARD_E_COMM_DATA_LOST           fixed bin(31) value('8010002F'xn);

 /*                                                                   */
 /* These are warning codes.                                          */
 /*                                                                   */
 /*                                                                   */
 /* MessageId: SCARD_W_UNSUPPORTED_CARD                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The reader cannot communicate with the smart card, due to ATR    */
 /*  configuration conflicts.                                         */
 /*                                                                   */
 dcl SCARD_W_UNSUPPORTED_CARD         fixed bin(31) value('80100065'xn);

 /*                                                                   */
 /* MessageId: SCARD_W_UNRESPONSIVE_CARD                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The smart card is not responding to a reset.                     */
 /*                                                                   */
 dcl SCARD_W_UNRESPONSIVE_CARD        fixed bin(31) value('80100066'xn);

 /*                                                                   */
 /* MessageId: SCARD_W_UNPOWERED_CARD                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Power has been removed from the smart card, so that further      */
 /*  communication is not possible.                                   */
 /*                                                                   */
 dcl SCARD_W_UNPOWERED_CARD           fixed bin(31) value('80100067'xn);

 /*                                                                   */
 /* MessageId: SCARD_W_RESET_CARD                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The smart card has been reset, so any shared state information   */
 /*  is invalid.                                                      */
 /*                                                                   */
 dcl SCARD_W_RESET_CARD               fixed bin(31) value('80100068'xn);

 /*                                                                   */
 /* MessageId: SCARD_W_REMOVED_CARD                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The smart card has been removed, so that further communication   */
 /*  is not possible.                                                 */
 /*                                                                   */
 dcl SCARD_W_REMOVED_CARD             fixed bin(31) value('80100069'xn);

 /*                                                                   */
 /* MessageId: SCARD_W_SECURITY_VIOLATION                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Access was denied because of a security violation.               */
 /*                                                                   */
 dcl SCARD_W_SECURITY_VIOLATION       fixed bin(31) value('8010006A'xn);

 /*                                                                   */
 /* MessageId: SCARD_W_WRONG_CHV                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The card cannot be accessed because the wrong PIN was presented. */
 /*                                                                   */
 dcl SCARD_W_WRONG_CHV                fixed bin(31) value('8010006B'xn);

 /*                                                                   */
 /* MessageId: SCARD_W_CHV_BLOCKED                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The card cannot be accessed because the maximum number of PIN    */
 /*  entry attempts has been reached.                                 */
 /*                                                                   */
 dcl SCARD_W_CHV_BLOCKED              fixed bin(31) value('8010006C'xn);

 /*                                                                   */
 /* MessageId: SCARD_W_EOF                                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The end of the smart card file has been reached.                 */
 /*                                                                   */
 dcl SCARD_W_EOF                      fixed bin(31) value('8010006D'xn);

 /*                                                                   */
 /* MessageId: SCARD_W_CANCELLED_BY_USER                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The action was cancelled by the user.                            */
 /*                                                                   */
 dcl SCARD_W_CANCELLED_BY_USER        fixed bin(31) value('8010006E'xn);

 /*********************************************************************/
 /* FACILITY_COMPLUS                                                  */
 /*********************************************************************/

 /* =============================== */
 /* Facility COMPLUS Error Messages */
 /* =============================== */

 /*                                                                   */
 /* COMPLUS Admin errors                                              */
 /*                                                                   */
 /*                                                                   */
 /* MessageId: COMADMIN_E_OBJECTERRORS                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Errors occurred accessing one or more objects - the ErrorInfo    */
 /*  collection may have more detail                                  */
 /*                                                                   */
 dcl COMADMIN_E_OBJECTERRORS          fixed bin(31) value('80110401'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_OBJECTINVALID                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  One or more of the object's properties are missing or invalid    */
 /*                                                                   */
 dcl COMADMIN_E_OBJECTINVALID         fixed bin(31) value('80110402'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_KEYMISSING                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The object was not found in the catalog                          */
 /*                                                                   */
 dcl COMADMIN_E_KEYMISSING            fixed bin(31) value('80110403'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_ALREADYINSTALLED                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The object is already registered                                 */
 /*                                                                   */
 dcl COMADMIN_E_ALREADYINSTALLED      fixed bin(31) value('80110404'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_APP_FILE_WRITEFAIL                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Error occurred writing to the application file                   */
 /*                                                                   */
 dcl COMADMIN_E_APP_FILE_WRITEFAIL    fixed bin(31) value('80110407'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_APP_FILE_READFAIL                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Error occurred reading the application file                      */
 /*                                                                   */
 dcl COMADMIN_E_APP_FILE_READFAIL     fixed bin(31) value('80110408'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_APP_FILE_VERSION                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Invalid version number in application file                       */
 /*                                                                   */
 dcl COMADMIN_E_APP_FILE_VERSION      fixed bin(31) value('80110409'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_BADPATH                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file path is invalid                                         */
 /*                                                                   */
 dcl COMADMIN_E_BADPATH               fixed bin(31) value('8011040A'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_APPLICATIONEXISTS                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The application is already installed                             */
 /*                                                                   */
 dcl COMADMIN_E_APPLICATIONEXISTS     fixed bin(31) value('8011040B'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_ROLEEXISTS                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The role already exists                                          */
 /*                                                                   */
 dcl COMADMIN_E_ROLEEXISTS            fixed bin(31) value('8011040C'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_CANTCOPYFILE                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An error occurred copying the file                               */
 /*                                                                   */
 dcl COMADMIN_E_CANTCOPYFILE          fixed bin(31) value('8011040D'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_NOUSER                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  One or more users are not valid                                  */
 /*                                                                   */
 dcl COMADMIN_E_NOUSER                fixed bin(31) value('8011040F'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_INVALIDUSERIDS                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  One or more users in the application file are not valid          */
 /*                                                                   */
 dcl COMADMIN_E_INVALIDUSERIDS        fixed bin(31) value('80110410'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_NOREGISTRYCLSID                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The component's CLSID is missing or corrupt                      */
 /*                                                                   */
 dcl COMADMIN_E_NOREGISTRYCLSID       fixed bin(31) value('80110411'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_BADREGISTRYPROGID                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The component's progID is missing or corrupt                     */
 /*                                                                   */
 dcl COMADMIN_E_BADREGISTRYPROGID     fixed bin(31) value('80110412'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_AUTHENTICATIONLEVEL                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to set required authentication level for update request   */
 /*                                                                   */
 dcl COMADMIN_E_AUTHENTICATIONLEVEL   fixed bin(31) value('80110413'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_USERPASSWDNOTVALID                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The identity or password set on the application is not valid     */
 /*                                                                   */
 dcl COMADMIN_E_USERPASSWDNOTVALID    fixed bin(31) value('80110414'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_CLSIDORIIDMISMATCH                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Application file CLSIDs or IIDs do not match corresponding DLLs  */
 /*                                                                   */
 dcl COMADMIN_E_CLSIDORIIDMISMATCH    fixed bin(31) value('80110418'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_REMOTEINTERFACE                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Interface information is either missing or changed               */
 /*                                                                   */
 dcl COMADMIN_E_REMOTEINTERFACE       fixed bin(31) value('80110419'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_DLLREGISTERSERVER                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DllRegisterServer failed on component install                    */
 /*                                                                   */
 dcl COMADMIN_E_DLLREGISTERSERVER     fixed bin(31) value('8011041A'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_NOSERVERSHARE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No server file share available                                   */
 /*                                                                   */
 dcl COMADMIN_E_NOSERVERSHARE         fixed bin(31) value('8011041B'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_DLLLOADFAILED                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  DLL could not be loaded                                          */
 /*                                                                   */
 dcl COMADMIN_E_DLLLOADFAILED         fixed bin(31) value('8011041D'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_BADREGISTRYLIBID                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The registered TypeLib ID is not valid                           */
 /*                                                                   */
 dcl COMADMIN_E_BADREGISTRYLIBID      fixed bin(31) value('8011041E'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_APPDIRNOTFOUND                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Application install directory not found                          */
 /*                                                                   */
 dcl COMADMIN_E_APPDIRNOTFOUND        fixed bin(31) value('8011041F'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_REGISTRARFAILED                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Errors occurred while in the component registrar                 */
 /*                                                                   */
 dcl COMADMIN_E_REGISTRARFAILED       fixed bin(31) value('80110423'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_COMPFILE_DOESNOTEXIST                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file does not exist                                          */
 /*                                                                   */
 dcl COMADMIN_E_COMPFILE_DOESNOTEXIST fixed bin(31) value('80110424'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_COMPFILE_LOADDLLFAIL                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The DLL could not be loaded                                      */
 /*                                                                   */
 dcl COMADMIN_E_COMPFILE_LOADDLLFAIL  fixed bin(31) value('80110425'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_COMPFILE_GETCLASSOBJ                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  GetClassObject failed in the DLL                                 */
 /*                                                                   */
 dcl COMADMIN_E_COMPFILE_GETCLASSOBJ  fixed bin(31) value('80110426'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_COMPFILE_CLASSNOTAVAIL                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The DLL does not support the components listed in the TypeLib    */
 /*                                                                   */
 dcl COMADMIN_E_COMPFILE_CLASSNOTAVAIL
                                      fixed bin(31) value('80110427'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_COMPFILE_BADTLB                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The TypeLib could not be loaded                                  */
 /*                                                                   */
 dcl COMADMIN_E_COMPFILE_BADTLB       fixed bin(31) value('80110428'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_COMPFILE_NOTINSTALLABLE                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The file does not contain components or component information    */
 /*                                                                   */
 dcl COMADMIN_E_COMPFILE_NOTINSTALLABLE
                                      fixed bin(31) value('80110429'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_NOTCHANGEABLE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Changes to this object and its sub-objects have been disabled    */
 /*                                                                   */
 dcl COMADMIN_E_NOTCHANGEABLE         fixed bin(31) value('8011042A'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_NOTDELETEABLE                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The delete function has been disabled for this object            */
 /*                                                                   */
 dcl COMADMIN_E_NOTDELETEABLE         fixed bin(31) value('8011042B'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_SESSION                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The server catalog version is not supported                      */
 /*                                                                   */
 dcl COMADMIN_E_SESSION               fixed bin(31) value('8011042C'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_COMP_MOVE_LOCKED                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The component move was disallowed, because the source or         */
 /*  destination application is either a system application or        */
 /*  currently locked against changes                                 */
 /*                                                                   */
 dcl COMADMIN_E_COMP_MOVE_LOCKED      fixed bin(31) value('8011042D'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_COMP_MOVE_BAD_DEST                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The component move failed because the destination application    */
 /*  no longer exists                                                 */
 /*                                                                   */
 dcl COMADMIN_E_COMP_MOVE_BAD_DEST    fixed bin(31) value('8011042E'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_REGISTERTLB                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The system was unable to register the TypeLib                    */
 /*                                                                   */
 dcl COMADMIN_E_REGISTERTLB           fixed bin(31) value('80110430'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_SYSTEMAPP                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This operation can not be performed on the system application    */
 /*                                                                   */
 dcl COMADMIN_E_SYSTEMAPP             fixed bin(31) value('80110433'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_COMPFILE_NOREGISTRAR                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The component registrar referenced in this file is not available */
 /*                                                                   */
 dcl COMADMIN_E_COMPFILE_NOREGISTRAR  fixed bin(31) value('80110434'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_COREQCOMPINSTALLED                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A component in the same DLL is already installed                 */
 /*                                                                   */
 dcl COMADMIN_E_COREQCOMPINSTALLED    fixed bin(31) value('80110435'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_SERVICENOTINSTALLED                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The service is not installed                                     */
 /*                                                                   */
 dcl COMADMIN_E_SERVICENOTINSTALLED   fixed bin(31) value('80110436'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_PROPERTYSAVEFAILED                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  One or more property settings are either invalid or in conflict  */
 /*  with each other                                                  */
 /*                                                                   */
 dcl COMADMIN_E_PROPERTYSAVEFAILED    fixed bin(31) value('80110437'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_OBJECTEXISTS                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The object you are attempting to add or rename already exists    */
 /*                                                                   */
 dcl COMADMIN_E_OBJECTEXISTS          fixed bin(31) value('80110438'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_REGFILE_CORRUPT                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The registration file is corrupt                                 */
 /*                                                                   */
 dcl COMADMIN_E_REGFILE_CORRUPT       fixed bin(31) value('8011043B'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_PROPERTY_OVERFLOW                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The property value is too large                                  */
 /*                                                                   */
 dcl COMADMIN_E_PROPERTY_OVERFLOW     fixed bin(31) value('8011043C'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_NOTINREGISTRY                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Object was not found in registry                                 */
 /*                                                                   */
 dcl COMADMIN_E_NOTINREGISTRY         fixed bin(31) value('8011043E'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_OBJECTNOTPOOLABLE                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This object is not poolable                                      */
 /*                                                                   */
 dcl COMADMIN_E_OBJECTNOTPOOLABLE     fixed bin(31) value('8011043F'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_APPLID_MATCHES_CLSID                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A CLSID with the same GUID as the new application ID is already  */
 /*  installed on this machine                                        */
 /*                                                                   */
 dcl COMADMIN_E_APPLID_MATCHES_CLSID  fixed bin(31) value('80110446'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_ROLE_DOES_NOT_EXIST                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A role assigned to a component, interface, or method did not     */
 /*  exist in the application                                         */
 /*                                                                   */
 dcl COMADMIN_E_ROLE_DOES_NOT_EXIST   fixed bin(31) value('80110447'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_START_APP_NEEDS_COMPONENTS                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  You must have components in an application in order to start     */
 /*  the application                                                  */
 /*                                                                   */
 dcl COMADMIN_E_START_APP_NEEDS_COMPONENTS
                                      fixed bin(31) value('80110448'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_REQUIRES_DIFFERENT_PLATFORM                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  This operation is not enabled on this platform                   */
 /*                                                                   */
 dcl COMADMIN_E_REQUIRES_DIFFERENT_PLATFORM
                                      fixed bin(31) value('80110449'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_CAN_NOT_EXPORT_APP_PROXY                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Application Proxy is not exportable                              */
 /*                                                                   */
 dcl COMADMIN_E_CAN_NOT_EXPORT_APP_PROXY
                                      fixed bin(31) value('8011044A'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_CAN_NOT_START_APP                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Failed to start application because it is either a library       */
 /*  application or an application proxy                              */
 /*                                                                   */
 dcl COMADMIN_E_CAN_NOT_START_APP     fixed bin(31) value('8011044B'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_CAN_NOT_EXPORT_SYS_APP                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  System application is not exportable                             */
 /*                                                                   */
 dcl COMADMIN_E_CAN_NOT_EXPORT_SYS_APP
                                      fixed bin(31) value('8011044C'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_CANT_SUBSCRIBE_TO_COMPONENT                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Can not subscribe to this component (the component may have      */
 /*  been imported)                                                   */
 /*                                                                   */
 dcl COMADMIN_E_CANT_SUBSCRIBE_TO_COMPONENT
                                      fixed bin(31) value('8011044D'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_OBJECT_PARENT_MISSING                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  One of the objects being inserted or updated does not belong to  */
 /*  a valid parent collection                                        */
 /*                                                                   */
 dcl COMADMIN_E_OBJECT_PARENT_MISSING fixed bin(31) value('80110808'xn);

 /*                                                                   */
 /* MessageId: COMADMIN_E_OBJECT_DOES_NOT_EXIST                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  One of the specified objects cannot be found                     */
 /*                                                                   */
 dcl COMADMIN_E_OBJECT_DOES_NOT_EXIST fixed bin(31) value('80110809'xn);

 /*                                                                   */
 /* COMPLUS Queued component errors                                   */
 /*                                                                   */
 /*                                                                   */
 /* MessageId: COMQC_E_APPLICATION_NOT_QUEUED                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Only COM+ applications marked "queued" can be created using      */
 /*  the "queue" moniker.                                             */
 /*                                                                   */
 dcl COMQC_E_APPLICATION_NOT_QUEUED   fixed bin(31) value('80110600'xn);

 /*                                                                   */
 /* MessageId: COMQC_E_NO_QUEUEABLE_INTERFACES                        */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  At least one interface must be marked 'queued" in order to       */
 /*  create a queued component instance with the "queue" moniker.     */
 /*                                                                   */
 dcl COMQC_E_NO_QUEUEABLE_INTERFACES  fixed bin(31) value('80110601'xn);

 /*                                                                   */
 /* MessageId: COMQC_E_QUEUING_SERVICE_NOT_AVAILABLE                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  MSMQ, which is required for the requested operation,             */
 /*  is not installed.                                                */
 /*                                                                   */
 dcl COMQC_E_QUEUING_SERVICE_NOT_AVAILABLE
                                      fixed bin(31) value('80110602'xn);

 %end; /* #WINERROR_ */
